// ApercuProjet.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "ApercuProjet.h"
#include "constante.h"
#include "MainFrm.h"

#include <gdiplus.h>
using namespace Gdiplus;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CApercuProjet

IMPLEMENT_DYNAMIC(CApercuProjet, CDialog)
CApercuProjet::CApercuProjet(CWnd* pParent /*=NULL*/)
	: CDialog(CApercuProjet::IDD, pParent)
{
	
}

CApercuProjet::~CApercuProjet()
{

}



void CApercuProjet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_VIGN_PROJ, m_ListThumbnail);
}


BEGIN_MESSAGE_MAP(CApercuProjet, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DOC_SUIV, OnBnClickedButtonDocSuiv)
	ON_BN_CLICKED(IDC_BUTTON_DOC_PREC, OnBnClickedButtonDocPrec)
	ON_NOTIFY(NM_CLICK, IDC_LIST_VIGN_PROJ, OnClickListThumb)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST_VIGN_PROJ, OnKeydownListThumb)
END_MESSAGE_MAP()


// Gestionnaires de messages CApercuProjet

BOOL CApercuProjet::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_ImageListThumb.Create(THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, ILC_COLOR24, 0, 1);
	m_ListThumbnail.SetImageList(&m_ImageListThumb, LVSIL_NORMAL);
	m_nSelectedItem = 0;
	projEnCours = 0;

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CApercuProjet::Charger()
{
	//vide ce qu'il y avait avant :
	Decharger();

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	projEnCours = typeLabo;

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeDocsLaboProj();
		break;
	default :
		AfxMessageBox("Image loading error.");
		break;
	}

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	m_strImageDir = pAppTemp->projet->getParamProj()->getM_repOuvrage();

	// validate image directory
	if (m_strImageDir.IsEmpty())
	{
		AfxMessageBox("The folder of the work is not specified.");
		return;
	}

	// show hour glass cursor
	BeginWaitCursor();

	// get the names of bitmap files
	if ( !GetImageFileNames(liste) )
	{
		EndWaitCursor();
		return;
	}

	// draw thumbnail images in list control
	DrawThumbnails();

	// draw the selected image in its full size
	DrawSelectedImage();

	// set focus and select the first thumbnail in the list control
	m_ListThumbnail.SetFocus();
	m_ListThumbnail.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);	
	EndWaitCursor();

}

void CApercuProjet::Decharger()
{
	m_strImageDir.Empty();

	m_VectorImageNames.clear();

	m_ListThumbnail.DeleteAllItems();

	m_ImageListThumb.SetImageCount(0);

	m_nSelectedItem = 0;

	projEnCours = 0;

}

void CApercuProjet::OnClickListThumb(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// retrieve message info.
	LPNMITEMACTIVATE pItemAct = (LPNMITEMACTIVATE)pNMHDR;

	// determine which item receives the click
	LVHITTESTINFO  hitTest;
	ZeroMemory(&hitTest, sizeof(LVHITTESTINFO));
	hitTest.pt = pItemAct->ptAction;
	m_ListThumbnail.SendMessage(LVM_SUBITEMHITTEST, 0, (LPARAM)&hitTest);

	// draw the selected image
	if (hitTest.iItem != m_nSelectedItem && hitTest.iItem >= 0)
	{
		m_nSelectedItem = hitTest.iItem;

		DrawSelectedImage();

	}

	// select the item clicked
	*pResult = 0;
}

void CApercuProjet::DrawSelectedImage()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	if (projEnCours != 0)
	{
		CObList * liste;
		CString legendeItemSel;
		legendeItemSel = m_ListThumbnail.GetItemText(m_nSelectedItem,0);
		//legendeItemSel = legendeItemSel.Left(legendeItemSel.ReverseFind('.'));

		switch (projEnCours)
		{
		case LABOTRAIT :
			liste = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
			break;
		case LABOCLASSIF :
			liste = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
			break;
		case LABOPROJET :
			liste = pAppTemp->projet->getLaboProj()->getListeDocsLaboProj();
			break;
		default :
			AfxMessageBox("Image loading error");
			break;
		}


		POSITION posDoc = liste->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)liste->GetNext(posDoc);
			if (pDoc->m_nom == legendeItemSel)
			{
				POSITION posView = pDoc->GetFirstViewPosition();
				CMyAppView* pViewTemp = (CMyAppView*)pDoc->GetNextView(posView);
				ASSERT(pViewTemp);

				//permet de charger/decharger les images contenues en mmoire
				//selon la selection
				pAppTemp->ChargerDoc(pDoc);
				
				pViewTemp->GetParentFrame()->ActivateFrame(SW_SHOWMAXIMIZED);
				pViewTemp->Invalidate(true);
			}
		}
		m_ListThumbnail.SetFocus();
		m_ListThumbnail.SetItemState(m_nSelectedItem, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);

		switch (projEnCours)
		{
		case LABOTRAIT :
			pAppTemp->projet->getLaboTrait()->RendreLeFocusALImageActive();
			break;
		case LABOCLASSIF :
			pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
			break;
		case LABOPROJET :
			pAppTemp->projet->getLaboProj()->RendreLeFocusALImageActive();
			break;
		default :
			AfxMessageBox("Loading image error");
			break;
		}

	}
}

void CApercuProjet::OnKeydownListThumb(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

	if (pLVKeyDow->wVKey == VK_LEFT || pLVKeyDow->wVKey == VK_RIGHT)
	{	
		// get total number of items in the list
		int nTotal = m_ListThumbnail.GetItemCount();

		// rule out the situation of an empty list
		if (nTotal == 0)
		{
			*pResult = 1; // current record stays selected
			return;
		}
    
		// reset selected item index
		int  nNewItem = -1;

		// set the selection
		if (pLVKeyDow->wVKey == VK_LEFT)	// left arrow
		{
			if (m_nSelectedItem > 0)
				nNewItem = m_nSelectedItem - 1;
		}
		else	// right arrow
		{
			if (m_nSelectedItem < nTotal-1)
				nNewItem = m_nSelectedItem + 1;
		}

		// update the selection
		if (nNewItem != -1)
		{
			// update the selected item index
			m_nSelectedItem = nNewItem;

			DrawSelectedImage();
		}	 
	}
	
	// high-light the selected item
	*pResult = 0;
}

BOOL  CApercuProjet::GetImageFileNames(CObList* listeDocs)
{			
	std::vector<CString>	VectorImageNames;
	CString strName;

	if (!listeDocs->IsEmpty())
	{
		POSITION posDocs = listeDocs->GetHeadPosition();
		while(posDocs)
		{
			strName.Empty();
			CMyAppDoc* pDoc = (CMyAppDoc*)listeDocs->GetNext(posDocs);
			strName.Format("%s.%s", pDoc->m_nom, pDoc->m_extension);
			// save the image file name
			VectorImageNames.push_back(strName);
		}
	}

	// update the names, if any
	if ( !VectorImageNames.empty() )
	{
		// reset the image name vector
		m_VectorImageNames.clear();
		m_VectorImageNames = VectorImageNames;
		return TRUE;
	}

	return FALSE;
}

void  CApercuProjet::DrawThumbnails()
{
	CBitmap*    pImage = NULL;
	HBITMAP		hBmp = NULL;
	POINT		pt;
	CString		strPath;
	int			i;

	// no images
	if (m_VectorImageNames.empty())
		return;

	// set the length of the space between thumbnails
	// you can also calculate and set it based on the length of your list control
	int nGap = 6;

	// hold the window update to avoid flicking
	m_ListThumbnail.SetRedraw(FALSE);

	// reset our image list
	for (i = 0; i<m_ImageListThumb.GetImageCount(); i++)
		m_ImageListThumb.Remove(i);	

	// remove all items from list view
	if (m_ListThumbnail.GetItemCount() != 0)
		m_ListThumbnail.DeleteAllItems();

	// set the size of the image list
	m_ImageListThumb.SetImageCount(m_VectorImageNames.size());
	i = 0;

	// draw the thumbnails
	std::vector<CString>::iterator	iter;
	for (iter = m_VectorImageNames.begin(); iter != m_VectorImageNames.end(); iter++)
	{		
		// load the bitmap
		strPath.Format( TEXT("%s\\%s"), m_strImageDir, *iter );

		USES_CONVERSION;
		Bitmap img( A2W(strPath) );
		Bitmap* pThumbnail = static_cast<Bitmap*>(img.GetThumbnailImage(THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, NULL, NULL));
		
		// attach the thumbnail bitmap handle to an CBitmap object
		pThumbnail->GetHBITMAP(NULL, &hBmp);
		pImage = new CBitmap();		 
		pImage->Attach(hBmp);

		// add bitmap to our image list
		m_ImageListThumb.Replace(i, pImage, NULL);

		// put item to display
		// set the image file name as item text
		m_ListThumbnail.InsertItem(i, m_VectorImageNames[i].Left(m_VectorImageNames[i].ReverseFind('.')), i);

		// get current item position	 
		m_ListThumbnail.GetItemPosition(i, &pt);	 
	  
		// shift the thumbnail to desired position
		pt.x = nGap + i*(THUMBNAIL_WIDTH + nGap);
		m_ListThumbnail.SetItemPosition(i, pt);
		i++;
			
		delete pImage;
		delete pThumbnail;
	}

	// let's show the new thumbnails
	m_ListThumbnail.SetRedraw(); 
}

void CApercuProjet::SupprimerDoc(CMyAppDoc *pDoc)
{
	int nItem;
	for (int i = 0; i < m_ListThumbnail.GetItemCount() ; i++)
	{
		if (m_ListThumbnail.GetItemText(i,0) == pDoc->m_nom)
			nItem = i;
		else
			nItem = -1;
	}
	if (nItem != -1)
	{
		m_ListThumbnail.DeleteItem(nItem);
		m_ListThumbnail.SetRedraw(); 
	}

}

//************************************************
//fonction utilise lorsqu'un calcul a t effectu sur plusieurs documents et donc le doc qui t affich avant
//le calcul n'est plus en mmoire, donc on le recharge
//************************************************
void CApercuProjet::RafficherDocSelectionne()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	if (projEnCours != 0)
	{
		CObList * liste;
		CString legendeItemSel;
		legendeItemSel = m_ListThumbnail.GetItemText(m_nSelectedItem,0);
		//legendeItemSel = legendeItemSel.Left(legendeItemSel.ReverseFind('.'));

		switch (projEnCours)
		{
		case LABOTRAIT :
			liste = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
			break;
		case LABOCLASSIF :
			liste = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
			break;
		case LABOPROJET :
			liste = pAppTemp->projet->getLaboProj()->getListeDocsLaboProj();
			break;
		default :
			AfxMessageBox("Image loading error");
			break;
		}


		POSITION posDoc = liste->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)liste->GetNext(posDoc);
			if (pDoc->m_nom == legendeItemSel)
			{
				POSITION posView = pDoc->GetFirstViewPosition();
				CMyAppView* pViewTemp = (CMyAppView*)pDoc->GetNextView(posView);
				ASSERT(pViewTemp);

				//permet de charger/decharger les images contenues en mmoire
				//selon la selection
				pAppTemp->ChargerDoc(pDoc);
				
				pViewTemp->GetParentFrame()->ActivateFrame(SW_SHOWMAXIMIZED);
				pViewTemp->Invalidate(true);
			}
		}
	}
}

void CApercuProjet::OnBnClickedButtonDocSuiv()
{
	//recupere un pointeur sur le projet
	CProjet* pProjTemp = ((CMyAppApp*)AfxGetApp())->projet;

	int typeLabo = 0;
	typeLabo = pProjTemp->QuelLaboEnCours();
	
	switch (typeLabo)
	{
	case LABOTRAIT :
		pProjTemp->getLaboTrait()->AfficherDocSuivant();
		break;
	case LABOCLASSIF :
		pProjTemp->getLaboClassif()->AfficherDocSuivant();
		break;
	case LABOPROJET :
		pProjTemp->getLaboProj()->AfficherDocSuivant();
		break;
	default :
		AfxMessageBox("Image path error");
		break;
	}
}

void CApercuProjet::OnBnClickedButtonDocPrec()
{
	//recupere un pointeur sur le projet
	CProjet* pProjTemp = ((CMyAppApp*)AfxGetApp())->projet;

	int typeLabo = 0;
	typeLabo = pProjTemp->QuelLaboEnCours();
	
	switch (typeLabo)
	{
	case LABOTRAIT :
		pProjTemp->getLaboTrait()->AfficherDocPrecedent();
		break;
	case LABOCLASSIF :
		pProjTemp->getLaboClassif()->AfficherDocPrecedent();
		break;
	case LABOPROJET :
		pProjTemp->getLaboProj()->AfficherDocPrecedent();
		break;
	default :
		AfxMessageBox("Image path definition error");
		break;
	}
}
