/****************************************************************/
// BinDlg.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "MyApp.h"
#include "BinDlg.h"
#include "MyAppDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CBinDlg dialog
/****************************************************************/

CBinDlg::CBinDlg(CWnd* pParent /*=NULL*/,CRect r)
	: CDialog(CBinDlg::IDD, pParent)
{
	
	pView = (CView *)pParent;
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);
	
	org =new CImage();
	dest =new CImage();

	r.NormalizeRect();
	if (r.IsRectNull()!=0 || r.BottomRight()==r.TopLeft())
	{
		Beep(1000,100);
		r.SetRect(0,0,pDoc->atelier->getImageCourante()->getLargeur(),pDoc->atelier->getImageCourante()->getHauteur());
	}

	rect = new CRect(r);

	rect->NormalizeRect();

	//{{AFX_DATA_INIT(CBinDlg)
	m_seuilbin = 200;
	//}}AFX_DATA_INIT
}


BOOL CBinDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	

	conteneur1=(CStatic *)GetDlgItem(IDC_IMAGE1);
	conteneur2=(CStatic *)GetDlgItem(IDC_IMAGE2);

	conteneur1->GetClientRect(rect1);
	conteneur2->GetClientRect(rect2);

	zoom_coeff_x = (double)rect1.Width()/(double)rect->Width();
	zoom_coeff_y =  (double)rect1.Height()/(double)rect->Height();

	if (zoom_coeff_x < zoom_coeff_y) zoom_coeff = zoom_coeff_x;
	else zoom_coeff =  zoom_coeff_y;

	CSliderCtrl *pSlide = (CSliderCtrl *)GetDlgItem(IDC_SLIDER);
	pSlide->SetRange(0,255,true);
	pSlide->SetPos(200);
	
	
		PLFilterCrop filtre(rect->TopLeft().x,rect->TopLeft().y,rect->BottomRight().x,rect->BottomRight().y);
		
		try
		{
			filtre.Apply(pDoc->atelier->getImageCourante()->getPointeur(),org->getPointeur());
			filtre.Apply(pDoc->atelier->getImageCourante()->getPointeur(),dest->getPointeur());
		}
		catch(PLTextException e)
		{
			CString message;
			message.Format("Filter application error");
			AfxMessageBox(message);
			
		}


	org->setTailleLxH(rect->Width(),rect->Height());
	dest->setTailleLxH(rect->Width(),rect->Height());


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBinDlg)
	DDX_Text(pDX, IDC_SEUILBIN, m_seuilbin);
	DDV_MinMaxInt(pDX, m_seuilbin, 0, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBinDlg, CDialog)
	//{{AFX_MSG_MAP(CBinDlg)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/****************************************************************/
// CBinDlg message handlers
/****************************************************************/

void CBinDlg::OnPaint() 
{
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);


	CWnd * pWnd1 = GetDlgItem(IDC_IMAGE1);
	CWnd * pWnd2 = GetDlgItem(IDC_IMAGE2);
	CDC * pDC1 = pWnd1->GetDC();
	CDC * pDC2 = pWnd2->GetDC();

	org->Afficher(pDC1,zoom_coeff);
	dest->Afficher(pDC2,zoom_coeff);
	
	pWnd1->ReleaseDC(pDC1);
	pWnd2->ReleaseDC(pDC2);
	
}


void CBinDlg::OnOK() 
{
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	UpdateData(true);

	CRegleBin *r1=new CRegleBin(m_seuilbin);
	//s'enregistre dans le scnarioTrait car cette boite de dialogue n'est accessible qu' partir 
	//du menu Traitements->Binarisation.
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	delete org;
	delete dest;
	CDialog::OnOK();
}

void CBinDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CSliderCtrl *pSlide = (CSliderCtrl *)pScrollBar;

	org->Binariser(pSlide->GetPos(),dest);	

	m_seuilbin=pSlide->GetPos();
	UpdateData(false);UpdateWindow();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	
}
