/****************************************************************/
// Bloc.cpp: implementation of the CBloc class.
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "MyAppDoc.h"
#include "Bloc.h"
#include "MyAppView.h"
#include <iostream>
#include <fstream>
#include <direct.h>

using namespace std;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

int CBloc::cpt = 0;
int CBloc::table[200][200]; 
/****************************************************************/
// Construction/Destruction
/****************************************************************/

CBloc::CBloc(CObList* liste)
{
	/***************/
	/* PFE 2006 deb
	/***************/
	decompositionEnLigneEffectue = false;	// permet de savoir si la decomposition en ligne
											// a t lanc sur ce bloc
	/***************/
	/* PFE 2006 Fin
	/***************/

	POSITION p1;

	liste_lignes = new CObList(10);

	// on stocke dans liste_elements toutes les CC de la zone considre
	liste_elements = new CObList(liste->GetCount());
	for (p1 = liste->GetHeadPosition ();p1 != NULL;)
	{
		CElement *e = (CElement *)(liste->GetNext (p1));
		liste_elements->AddTail (e);
	}
}

CBloc::~CBloc()
{
	POSITION p1;
	for (p1 = liste_lignes->GetHeadPosition();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext(p1));
		delete l;
	}
	liste_lignes->RemoveAll();
	delete liste_lignes;

	// on detruit la liste mais pas les Elements
	liste_elements->RemoveAll();
	delete liste_elements;
}



void CBloc::Ordonner_lignes ()
{
	// reordonne liste_lignes dans l'ordre logique de lecture

	int min;
	POSITION p1,p2,pmin;
	CObList *prov = new CObList (10);

	while (!liste_lignes->IsEmpty ())
	{
		min = 10000;

		for (p1 = liste_lignes->GetHeadPosition (); p1 != NULL;)
		{
			p2 = p1;
			CLigne *l = (CLigne *)liste_lignes->GetNext (p1);
			if (l->get_y_cdg_moyen () < min)
			{
				min = l->get_y_cdg_moyen ();
				pmin = p2;
			}
		}
		prov->AddTail (liste_lignes->GetAt (pmin));
		liste_lignes->RemoveAt (pmin);
	}
	liste_lignes->AddTail (prov);
	prov->RemoveAll();
	delete prov;
}

void CBloc::Supprimer_CC_indesirables ()
{
	// supprime les CC qui sont des accents ou des points sur les "i", "j", ""...

	POSITION p1;

	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		l->Supprimer_accentuation ();
	}
}

void CBloc::Creer_structure_XML (CRect* rect_bloc, CDocument* pDoc,
								 CString type_zone)
{

	// ################ creation of the xml and the comparison of the connected components
	// creation des fichiers XML + comparaison des CC entre elles

	POSITION p1,p2,p3;
	CString fichier;
	FILE *fp;
	int fichier_CC = 0;

	fichier.Format ("%s\\%s_FIN", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(), type_zone);
	_mkdir (fichier);
	fichier.Format ("%s\\%s_FIN\\Blocs", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(), type_zone);
	_mkdir (fichier);
	fichier.Format ("%s\\%s_FIN\\Formes", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(), type_zone);
	_mkdir (fichier);

	cpt++;
	fichier.Format ("%s\\%s_FIN\\Blocs\\bloc%d.xml", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(),
													type_zone, cpt);
	fp = fopen (fichier, "w");
	fprintf (fp, "<bloc name=\"%s\" coord=\"%d,%d,%d,%d\">\n",
														((CMyAppDoc *)pDoc)->m_nom_complet,
														rect_bloc->left,
														rect_bloc->top,
														rect_bloc->right,
														rect_bloc->bottom);

	// ################ here XML is generated with the tags bloc ligne mot and the values stored are top left right bottom cordi
	/*
	for (p1 = liste_lignes->GetHeadPosition (); p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		fprintf (fp, "\t<ligne>\n");
		for (p3 = l->get_liste_mots ()->GetHeadPosition (); p3 != NULL;)
		{
			CMot *m = (CMot *)(l->get_liste_mots ()->GetNext (p3));
			fprintf (fp, "\t\t<mot>\n");
			for (p2 = m->get_liste_elements ()->GetHeadPosition (); p2 != NULL;)
			{
				CElement *e = (CElement *)(m->get_liste_elements ()->GetNext (p2));
				fichier_CC = ((CMyAppApp*)(AfxGetApp()))->projet->getLaboProj()->liste_permanente->Similaire (e, pDoc);
				fprintf (fp, "\t\t\t<cc value=\"%d\">%d,%d,%d,%d</cc>\n", fichier_CC,
															e->getRect()->left,
															e->getRect()->top,
															e->getRect()->right,
															e->getRect()->bottom);
				fichier_CC++;
			}
			fprintf (fp, "\t\t</mot>\n");
		}
		fprintf (fp, "\t</ligne>\n");
	}
	fprintf (fp, "</bloc>");
	fclose(fp);

	*/
	for (p1 = liste_lignes->GetHeadPosition (); p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		fprintf (fp, "\t<ligne>\n");
		for (p2 = l->get_liste_elements ()->GetHeadPosition (); p2 != NULL;)
		{
			fprintf (fp, "\t\t<mot>\n");
			int flag = 0;
			while(p2 != NULL && flag == 0)
			{
				CElement *e = (CElement *)(l->get_liste_elements ()->GetNext (p2));
				fichier_CC = ((CMyAppApp*)(AfxGetApp()))->projet->getLaboProj()->liste_permanente->Similaire (e, pDoc);
/*				fprintf (fp, "\t\t\t<cc value=\"%d\">%d,%d,%d,%d</cc>\n", fichier_CC,
															e->getRect()->left,
															e->getRect()->top,
															e->getRect()->right,
															e->getRect()->bottom);
*/
				fprintf (fp, "\t\t\t<cc value=\"%d\">%d,%d,%d,%d,%d,%d,%d</cc>\n", fichier_CC,
															e->getRect()->left,
															e->getRect()->top,
															e->getRect()->right,
															e->getRect()->bottom,
															e->GetClassNumber(),
															e->GetXLM(),
															e->GetXRM()
															);
				// if we want we can add the information of line number word number char number class etc as well
				fichier_CC++;
				if(p2 != NULL)
				{
					CElement *e_next = (CElement *)(l->get_liste_elements ()->GetAt (p2));
					if(e->GetWordNumber() != e_next->GetWordNumber() )
					{
						flag = 1;
					}
				}
			}
			fprintf (fp, "\t\t</mot>\n");
		}
		fprintf (fp, "\t</ligne>\n");
	}
	fprintf (fp, "</bloc>");
	fclose(fp);
	

}


CObList* CBloc::get_liste_lignes ()
{
	return liste_lignes;
}







/*************************************************************************************************/
/* PFE 2006
/*************************************************************************************************/



/********************************************************************/
/* Nom mthode : Decomposer_en_lignes
/*                                                                  
/* Fonction : permet pour une zone donne, de placer ses lments dans
/*            une ligne
/*            
/********************************************************************/

void CBloc::Decomposer_en_lignes ()
{
	//AfxMessageBox("Decomposer_en_lignes Starts!");
	POSITION p1,p2,p3,p4,p5,p6,p7,p8,PositionAjout,PositionRetrait,PositionDernier,PositionDernier2;
	//POSITION p1,p2;
	int CdgMoyen = 0;
	int CdgEcartType = 0;
	int yCdg = 0;
	int xCdg = 0;
	int yHaut = 0;
	int yBas = 0;
	int yMinLigne = 0;
	int yMaxLigne = 0;
	int	xMinLigne = 0;
	int	xMaxLigne = 0;
	int yMinVirtuelLigne = 0;
	int yMaxVirtuelLigne = 0;
	int	xMinVirtuelLigne = 0;
	int	xMaxVirtuelLigne = 0;
	int distance = 0;
	int distanceMoy = 0;
	int distanceMin = 0;
	double ecartTypeDistanceCdg = 0;
	bool ElementAjouter = true;
	bool ElementEnleverListe = false;
	bool ZoneVirtuelleExiste = false;
	int taille_zone_virtuelle = 15; // en composantes connexes
	int allongement_zone_virtuelle =60; // en pixel
	int allongement_zone_reelle = 60; // en pixel
	int distanceOrdonnee = 0;
	int distanceOrdonneeMax = 0;
	POSITION ligneOrdoMax;
	CElement * element_avant_dernier_fin_ligne;
	CElement * element_avant_avant_dernier_fin_ligne;
	int nbElementLigne = 0;
	int nbElementTotal = 0;
	int nbElementMoyenParLigne = 0;

	//ofstream of;
	//of.open("rachit.txt",ios_base::app); //	app or out
	//of <<"rachit"<<"\n";
	//of.close();

	////////////////
	// version 3
	////////////////

	// Effectue un tri du bloc dans le sens des abscisses croissant
	// cela permet d'viter d'incrmenter l'abscisse et de rechercher
	// dans la liste les lment aillant cette abscisse
	int min;
	POSITION pmin;
	CObList *blocTemporaire = new CObList();

	// ######### here we are traveeling the whole list and are trying to arrange everything in the order of the left x cordinate

	while (!liste_elements->IsEmpty ())
	{
		min = 1000000;

		for (p1 = liste_elements->GetHeadPosition (); p1 != NULL;)
		{
			p2 = p1;
			CElement *e = (CElement *)liste_elements->GetNext (p1);
			if (e->getRect()->left < min)
			{
				min = e->getRect()->left;
				pmin = p2;
			}
		}
		blocTemporaire->AddTail (liste_elements->GetAt (pmin));
		liste_elements->RemoveAt (pmin);
	}
	liste_elements->AddTail (blocTemporaire);
	blocTemporaire->RemoveAll();
	delete blocTemporaire;

/******************************************************* Rachit Agrawal 2009 ***********************************************************/

	// initializing the array to zero

	int pixelCount[5000];
	for (int i = 0 ; i < 5000 ; i++)
	{
		pixelCount[i] = 0;
	}

	// finding the maximum and minimum y co ordinate in the zone
	int min_y = 1000000, max_y = 0;
	for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		if( e->getRect()->top < min_y)
		{
			min_y = e->getRect()->top;
		}
		if( e->getRect()->bottom > max_y)
		{
			max_y = e->getRect()->bottom;
		}
	}

	//	of<<"miny = "<< min_y<<" maxy = "<< max_y<<"\n";
	int no_of_elements_in_zone = 0;
	// now we are calculating the count of black pixels
	for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		int thick = ( e->getRect()->right ) - ( e->getRect()->left );
		for ( int i = e->getRect()->top  ; i < e->getRect()->bottom  ; i++)
		{
			pixelCount[i] += thick;  // or we can subtract the lowest Y to make the height 0
		}
		no_of_elements_in_zone++;
	}
	
	//	of<<"no_of_elements_in_zone "<<no_of_elements_in_zone<<"\n"; // it counts the number of elements in a zone
	int val = 0, flag=0;
	int no_of_lines_in_zone = 0; // it counts the number of line in a zone
	int line_height[50];
	int line_start[50];
	int line_end[50];
	// we are making these arrays to store the starting ending points of line and height
	for (int i = 0; i < 50; i++)
	{
		line_height[i] = 0;
		line_start[i] = 0;
		line_end[i] = 0;
	}

	int j=0, count = 0;
	for (int i = 0 ; i < max_y+2 /* 2000 */ ; i++)
	{
		val = pixelCount[i];
		if( val > 0 )
		{
			if(count == 0)
			{
				line_start[j] = i ;
			}
			flag = 1;
			count++;
		}
		if( val == 0 && flag ==1)
		{
			no_of_lines_in_zone++;
			flag =0;

			line_end[j] = i ;
			line_height[j] = count;
			count = 0;
			j++;
		}
	//	of <<"i = "<<i<<"pixels = "<<pixelCount[i]<<"\n";
	}
	//	of<<"no_of_lines_in_zone "<<no_of_lines_in_zone<<"\n"; 
	//	of<<"no_of_elements_per_line "<<(no_of_elements_in_zone/no_of_lines_in_zone)<<"\n";
	int sum =0;
	
	for ( int i =0; i < j; i++)
	{
		sum += line_height[i];
	}
	sum = sum/j;


	//	we will try to calculate the median of the height
	//	sort the array 
	for ( int i =0; i < j; i++)
	{
		for ( int k =i; k < j; k++)
		{
			if (line_height[i] > line_height[k]) 
			{
				int temp = line_height[i];
				line_height[i] = line_height[k];
				line_height[k] = temp;
			}
		}
	}
	// now we are fixing the threshold for the segmentation

	int threshold_height = line_height[j/2];
	int low_cut = threshold_height - (threshold_height/2);  // we discussed it to h/3 but it seems to be to less so i am using h/2
	int high_cut = threshold_height + (threshold_height/2);
	int below_cut = 0.2*threshold_height;
	int noisy_line = 0;

	// now we see which line is a normal line and which is not
	int initial_lines = j;
	for ( int i=0; i<initial_lines; i++ )
	{
		if(line_end[i] - line_start[i] >= low_cut && line_end[i] - line_start[i] <= high_cut)
		{
//			of<<"Line "<<i+1<<" is Normal Line "<<"\n";
		}
		else if(line_end[i] - line_start[i] < low_cut) // here we need to handle those
		{
			if(line_end[i] - line_start[i] < below_cut)
			{
				noisy_line++;
				line_start[i] = 10000;
				line_end[i] = 10000;
			//	of<<"Line "<<i+1<<" is Under Size Problematic Noisy Line "<<"\n";
			}
			//else
			//{
			//	of<<"Line "<<i+1<<" is Under Size Problematic Line "<<"\n";  // here we will write the code to handle it
			//}
		}
		else
		{
			//of<<"Line "<<i+1<<" is Over Size Problematic Line "<<"\n";	  // here we will write the code to handle it
			
			double number_of_lines_touched =  (double)(line_end[i] - line_start[i]) / (double)threshold_height ;
			int lines_touched =  (line_end[i] - line_start[i]) / threshold_height ;
			if(number_of_lines_touched - lines_touched > 0.5)
			{
				lines_touched++;
			}
			// now we suppose that a total of lines_touched lines are there
			int global_max = 0;
			for( int k=line_start[i]; k<line_end[i]; k++ )
			{
				if(pixelCount[k] > global_max)
				{
					global_max = pixelCount[k];
				}
			}
			// global max is the highest no of black pixel in a line
			// now we fix over threshold at 66%
			int threshold_line_div_up = global_max - (global_max/3);
			int threshold_line_div_down = global_max - (2*global_max/3);
			// now we note the points where the sign changes with this 
			int counter1 = 0, counter2 =0;
			int store_check_point_up[100];  // i have taken it of size 100 as we are not supposed to have line more than 50
			int store_check_point_down[100];
			for(int z = 0; z<100;z++)
			{
				store_check_point_up[z] = 0;
				store_check_point_down[z] = 0;
			}
		
			for( int k=line_start[i]; k<line_end[i]-1; k++ )
			{
				if((pixelCount[k] <= threshold_line_div_up && pixelCount[k+1] > threshold_line_div_up) ||(pixelCount[k] >= threshold_line_div_up && pixelCount[k+1] < threshold_line_div_up))
				{
					store_check_point_up[counter1] = k; // we can add 1 more condition that 2 points are not very near 
					counter1++;	
				}
				if((pixelCount[k] <= threshold_line_div_down && pixelCount[k+1] > threshold_line_div_down) ||(pixelCount[k] >= threshold_line_div_down && pixelCount[k+1] < threshold_line_div_down))
				{
					store_check_point_down[counter2] = k;
					counter2++;	
				}
				
			}
			// now we have 2 options either counter will be greater than 2 or equal to 2
			// i am writing the code considering that counter1 == counter2 without using counter2
//			for(int k=0;k<counter1;k++)
//			{
//				of<<"store check points up = "<<store_check_point_up[k]<<"\n";
//			}
//			for(int k=0;k<counter1;k++)
//			{
//				of<<"store check points down = "<<store_check_point_down[k]<<"\n";
//			}
			if(counter1 >= counter2 )
			{
				if(counter1 > 2)
				{
					for(int k = 1; k < counter1-1; k= k+2)
					{
						int get_min_break_point =0;
						int get_min_count = 1000;
						for(int z = store_check_point_up[k]; z < store_check_point_up[k+1] ;z++)
						{
							if(pixelCount[z] < get_min_count)
							{
								get_min_count = pixelCount[z];
								get_min_break_point = z;
							}
							// this Z is supposed to be the line break point
							// so here i should make 1 more array to update the details of the line
						}
					  
						line_start[j] = get_min_break_point + 1;
						line_end[j] = get_min_break_point ;// we can sort these array in increasing order
						j++;
					}
				}
				//else
				//{
					// this is 1 line which is very thick
				//	of<<"This seems to be one very thick line"<<"\n";
				//}
			}
			else
			{
				if(counter2 > 2)
				{
					for(int k = 1; k < counter2-1; k= k+2)
					{
						int get_min_break_point =0;
						int get_min_count = 1000;
						for(int z = store_check_point_down[k]; z < store_check_point_down[k+1] ;z++)
						{
							if(pixelCount[z] < get_min_count)
							{
								get_min_count = pixelCount[z];
								get_min_break_point = z;
							}
							// this Z is supposed to be the line break point
							// so here i should make 1 more array to update the details of the line
						}
					  
						line_start[j] = get_min_break_point + 1;
						line_end[j] = get_min_break_point ;// we can sort these array in increasing order
						j++;
					}
				}
				//else
				//{
					// this is 1 line which is very thick
				//	of<<"This seems to be one very thick line"<<"\n";
				//}
			}

		}
	}		
	//of<<"Noisy lines = "<<noisy_line<<"\n";
	// code to sort the 2 arrays line_start and line_end
	for (int x = 0 ; x < j ; x++ )
	{
		for (int y = x ; y < j ; y++ )
		{
			if (line_start[x] > line_start[y]) 
			{
				int temp = line_start[x];
				line_start[x] = line_start[y];
				line_start[y] = temp;
			}
			if (line_end[x] > line_end[y]) 
			{
				int temp = line_end[x];
				line_end[x] = line_end[y];
				line_end[y] = temp;
			}
		}
	}
	// the 2 arrays are sorted and hopefully line segmentation would be successfull
	//for (int x = 0 ; x < j ; x++)
//	for (int x = 0 ; x < j - noisy_line ; x++)
//	{
//		of<<"Final Lines :- Line Number "<<x+1<<" starting point "<<line_start[x]<<" ending point "<<line_end[x]<<"\n";
//	}
//	of<<"Total number of lines = "<<j-noisy_line<<"\n";	

	// now as we hope line segmentation is over we can try putting line number on each CC
	// so will travel whole link list and try to assign line number :)
	// we are removing the comment from here
//	AfxMessageBox("Hi !");
	for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		e->SetLineNumber(0);  // can give -1 as well
		e->SetClassNumber(0);
	}
	// now after segmentation we are assigning line number and class number to CC

	for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		//for (int i = 0 ; i <j ; i++ )
		for (int i = 0 ; i < j - noisy_line ; i++)
		{
			if( e->getRect()->top >= (line_start[i]-2) && e->getRect()->bottom <= (line_end[i]+2) )
			//if( e->getRect()->top >= line_start[i] && e->getRect()->bottom <= line_end[i] )
			{
				e->SetLineNumber(i+1);
				e->SetClassNumber(1); // normal character
				if( e->getRect()->top >= line_start[i] + 0.5*(line_end[i] - line_start[i]) )
				{
					e->SetClassNumber(4); // punctuation
				}
				else if(  e->getRect()->bottom <= line_start[i] + 0.5*(line_end[i] - line_start[i]) )
				{
					e->SetClassNumber(3); // accent
				}
				break;
			}
			else if( e->getRect()->top <= line_start[i] && e->getRect()->bottom > line_end[i] )
			{
				e->SetLineNumber(i+1); // if we want we can assign it the line number as well for now it gets the line number of lower line
				//e->SetClassNumber(2); // problematic character
				e->SetClassNumber(2);
				break;
			}
			else if( e->getRect()->top <= line_start[i] && e->getRect()->bottom <= line_end[i] && e->getRect()->bottom >= line_start[i])
			{
				// if it is below half of both line it belongs to lower line 
				// reverse it belongs to upper line 
				// else problematic
				if(i>0)
				{
					if( e->getRect()->top > line_start[i-1] + (line_end[i-1] - line_start[i-1] )/2 && e->getRect()->bottom > line_start[i] + (line_end[i] - line_start[i] )/2 )
					{
						e->SetLineNumber(i+1);
						e->SetClassNumber(5); // it is also a type of problematic character
					}
					else if( e->getRect()->top < line_start[i-1] + (line_end[i-1] - line_start[i-1] )/2 && e->getRect()->bottom < line_start[i] + (line_end[i] - line_start[i] )/2 )
					{
						e->SetLineNumber(i);
						e->SetClassNumber(5); // it is also a type of problematic character
					}
					else
					{
						e->SetLineNumber(i+1);
						//e->SetClassNumber(2);
						e->SetClassNumber(2);
					}
				}
				else
				{
					e->SetLineNumber(i+1);
					//e->SetClassNumber(2);
					e->SetClassNumber(2);
				}	
				break;
			}
			else if( e->getRect()->top >= line_start[i] && e->getRect()->bottom >= line_end[i] && e->getRect()->top <= line_end[i])
			{
				
				// if it is below half of both line it belongs to lower line 
				// reverse it belongs to upper line 
				// else problematic
				//if(i< j-1)
				if(i< j-1-noisy_line)
				{
					if( e->getRect()->top > line_start[i] + (line_end[i] - line_start[i] )/2 && e->getRect()->bottom > line_start[i+1] + (line_end[i+1] - line_start[i+1] )/2 )
					{
						e->SetLineNumber(i+2);
						e->SetClassNumber(5); // it is also a type of problematic character
					}
					else if( e->getRect()->top < line_start[i] + (line_end[i] - line_start[i] )/2 && e->getRect()->bottom < line_start[i+1] + (line_end[i+1] - line_start[i+1] )/2 )
					{
						e->SetLineNumber(i+1);
						e->SetClassNumber(5); // it is also a type of problematic character
					}
					else
					{
						e->SetLineNumber(i+2);
						//e->SetClassNumber(2);
						e->SetClassNumber(2);
					}
				}
				else
				{
					e->SetLineNumber(i+1);
					//e->SetClassNumber(2);
					e->SetClassNumber(2);
				}
				break;
			}
		}
	}
	// now if some character doesnt get any line number its a problematic character
	// i think at this position we are completely done with the line number and class to which it belongs

	// now we need to form lines based on line number and to return the list of lines
	//	AfxMessageBox("Rachit Agrawal !");
	int m=1;
	for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
	{
			CElement *e = (CElement *)liste_elements->GetNext(p1);
	//		of<<m<<" "<<e->GetLineNumber()<<"\n";
			m++;
	}
	// we have done with line segmentation and detection and class detection and sorting of lines
	// now we are implementing sorting within a line


	CElement *s = new CElement();
	//for (int i = 1 ; i < j+1 ;i++ )
	for (int i = 1 ; i < j+1-noisy_line ;i++ )
	{
		CLigne* ligne = new CLigne (); // do we need to create j lines??
		for (p1 = liste_elements->GetHeadPosition(); p1 != NULL; )
		{
			CElement *e = (CElement *)liste_elements->GetNext(p1);
			if(e->GetLineNumber() == i)
			{
				ligne->get_liste_elements ()->AddTail(e);
			}
		}
		// now we will add the code of sorting within a line and then will form the list of line
		POSITION p9;
		CLigne *l2 = new CLigne () ;
		int counter =0;
		while(ligne->get_liste_elements()->GetCount() != counter) 
		{
			counter++;
			int min = 10000;
			for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
			{
				CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
				// need to travel the list find min leftx insert and remove from list 
				// continue till list is ended
				if(e->getRect()->left < min && e->GetCharNumber()== 0)
				{
					min = e->getRect()->left;
					s = e;
					p9 =p2;
				}
			}
			s->SetCharNumber(-1);
			l2->get_liste_elements()->AddTail(s);  // now we need to have l2 in the main line instead of ligne which is now empty
		}
		if(l2->get_liste_elements()->GetCount()>0)
		{
			liste_lignes->AddTail(l2);
		}
		ligne->get_liste_elements()->RemoveAll();
		delete ligne;
	}
	s = NULL;
	delete s;
	
	// at this point we are done with the formation of lines 
	// the lines are in sorted order and the char within a line are also in sorted order

	// now we need to assign char_number within a line

	
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		int k = 1;
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			e->SetCharNumber(k);
			k++;
		}
	}

	// here is the code to display the work done in the file
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
		//	of<<"line no = "<<e->GetLineNumber()<<"char no = "<<e->GetCharNumber()<<"class no = "<<e->GetClassNumber()<<"\n";
		}
	}

	decompositionEnLigneEffectue = true;
	//of.close();

//	AfxMessageBox("Decomposer_en_lignes Finishs!");
//	AfxMessageBox("Bye !");
	
	// i just feel that we have finished 
	// line segmentation 
	// sorting of lines
	// sorting of char within a line
	// assigning class line_number and char_number
						

/********************************************************* Rachit Agrawal 2009 **************************************************************/

	// Recherche l'abscisse minimale de tous les elements du bloc
/*	int min = 1000000;
	int x_gauche;

	for (p1 = liste_elements->GetHeadPosition();p1 != NULL;)
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		x_gauche = e->getRect()->left;

		if (min > x_gauche)
			min = x_gauche;
	}

	int abscisse_minimale_zone = min;

	// Recherche l'abscisse maximale de tous les elements du bloc
	int max = 0;	
	int x_droite;

	for (p1 = liste_elements->GetHeadPosition();p1 != NULL;)
	{
		CElement *e = (CElement *)liste_elements->GetNext(p1);
		x_droite = e->getRect ()->right;

		if (max < x_droite)
			max = x_droite;
	}

	int abscisse_maximale_zone = max;
*/


		
// ######## One knows the minimum abscissa abscissa and maximum can be a kind
// ########Scan line to find the elements of the list and place them in rows

	// On connait l'abscisse minimale et l'abscisse maximale, on peut faire une sorte 
	// de scan line pour trouver les elements de la liste et les placer dans des lignes
	
//	int abscisse = abscisse_minimale_zone;
/*
	while (!liste_elements->IsEmpty () )//&& abscisse != abscisse_maximale_zone) 
	{

		// Pour chaque element de la liste d'element de la zone
		for (p2 = liste_elements->GetHeadPosition (); p2 != NULL ;)
		{
			p4 = p2; // pointeur sur l'element en cours
			CElement *element_encours = (CElement *)(liste_elements->GetNext (p2));
			ElementEnleverListe = false;


				
			// ############ Check if the coordinate of the left side of the element
			// ################ Corresponds with the horizontal axis that is is being treated 

			// On regarde si la coordonne du cot gauche de l'lment
			// correspond avec l'abscisse que l'on est entrain de traiter
			//if( element_encours->getRect()->left == abscisse )
			//{
				if(!liste_lignes->IsEmpty()) // test si il existe au moins une ligne
				{
					for( p3 = liste_lignes->GetHeadPosition(); (p3 != NULL && ElementEnleverListe != true) ;) // pour chaques lignes
					{
						ZoneVirtuelleExiste = false; // on repasse la valeur  faux pour la prochaine ligne						

	
// #############	It retrieves the last element of the line and test if it has
// #############	A vertical axis with the common element in progress,
// #############	If the test is positive then add the item at the end
// #############	Of the line and withdraw from the list liste_elements

						// On recupre le dernier element de la ligne et on test si elle possede
						// une ordonne commune avec l'element en cours,
						// si le test est positif alors on ajoute l'lement en cours  la fin
						// de la ligne et on le retire de la liste liste_elements
						p5 = p3;
						CLigne *l = (CLigne *)(liste_lignes->GetNext (p3));
						CElement * element_fin_ligne = (CElement *)(l->get_liste_elements()->GetTail());
						
// ###########  It retrieves the penultimate element of the line and before the penultimate
// ###########  Element when available

						// On recupre l'avant dernier lment de la ligne et l'avant avant dernier
						// element lorsqu'ils existent
						PositionDernier = l->get_liste_elements()->GetTailPosition();
						(CElement *)(l->get_liste_elements()->GetPrev(PositionDernier)); // dernier


						//######### trying to get the last 2nd element 
			
						if(l->get_liste_elements()->GetCount() >2)
						{	// On test pour savoir si il existe un avant dernier
							element_avant_dernier_fin_ligne = (CElement *)(l->get_liste_elements()->GetPrev(PositionDernier)); // avant dernier
						}

						// ######### trying to get the last 3rd element 

						if(l->get_liste_elements()->GetCount() >3)
						{	// On test pour savoir si il existe un avant avant dernier
							element_avant_avant_dernier_fin_ligne = (CElement *)(l->get_liste_elements()->GetPrev(PositionDernier)); // avant avant dernier
						}


						// ############## here we are checking min max cordi n the count of elements 

						// On test si l'lment n'a pas dj sont centre de gravit compris
						// dans le rectangle englobant d'une ligne, dans ce cas on l'ajoute
						// a cette ligne mais en debut de ligne pour qu'il ne gne pas les
						// recherche suivante, la plus part du temps a sera des accents
							
						// On recupre les COORDONNEES DU CDG DE L'ELEMENT
						yCdg = element_encours->getCdg()->y;
						xCdg = element_encours->getCdg()->x;

						// On recupre les COORDONNEES HAUT ET BAS DU RECTANGLE ENGLOBANT REEL
						yHaut = element_encours->getRect()->bottom;
						yBas = element_encours->getRect()->top;

						// On rcupre les BORNES du rectangle englobant REEL de la ligne
						yMinLigne = l->get_ordonnee_minimale();
						yMaxLigne = l->get_ordonnee_maximale();
						xMinLigne = l->get_abscisse_minimale();
						xMaxLigne = l->get_abscisse_maximale();
						xMaxLigne = xMaxLigne + allongement_zone_reelle;

						// On rcupre les BORNES du rectangle englobant VIRTUEL de la ligne
						// cette zone virtuelle n'est utiliser que lorsque le nombre de 
						// composante devient plus grand que taille_zone_virtuelle

						
						// ############## if the count is more we switch one the boolean value 

						if(l->get_liste_elements()->GetCount() >= taille_zone_virtuelle )
						{
							yMinVirtuelLigne = l->get_ordonnee_minimale_virtuel(taille_zone_virtuelle);
							yMaxVirtuelLigne = l->get_ordonnee_maximale_virtuel(taille_zone_virtuelle);
							xMinVirtuelLigne = l->get_abscisse_minimale_virtuel(taille_zone_virtuelle);
							xMaxVirtuelLigne = l->get_abscisse_maximale_virtuel(taille_zone_virtuelle);
							xMaxVirtuelLigne = xMaxVirtuelLigne + allongement_zone_virtuelle;
							ZoneVirtuelleExiste = true;
						}

						// ##############  here we are trying to see if the two lines have something common

						// On test si on a une ORDONNEE COMMUNE avec le dernier element des lignes
						if( element_fin_ligne->Possedent_une_ordonnee_commune(element_encours) )
						{
							// On regarde si la distance ordonne commune est la plus grande ou non
							// si c'est la plus grande alors on met l'element dans la ligne sinon
							// on ne fait rien

						// ############# here we are trying to calculate maximum distance

							distanceOrdonneeMax = 0;
							for(  p6 = liste_lignes->GetHeadPosition(); (p6 != NULL) ;)
							{	
								p7 = p6;
								CLigne *l2 = (CLigne *)(liste_lignes->GetNext(p6));
								CElement * element_fin_ligne2 = (CElement *)(l2->get_liste_elements()->GetTail());
								distanceOrdonnee = element_fin_ligne2->Distance_ordonnee_commune(element_encours);

								if( distanceOrdonnee > distanceOrdonneeMax)
								{
									distanceOrdonneeMax = distanceOrdonnee;
									ligneOrdoMax = p7;
								}
							}


							// On test pour savoir si la ligne ayant la distance ordonne max est celle
							// qui est en cours ou non
							if( p5 == ligneOrdoMax )
							{
								l->get_liste_elements()->AddTail(element_encours); // on place en fin de liste

// ######### this function will calcutae the min max cordi n other parameter of the line

								l->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

								liste_elements->RemoveAt(p4);
								ElementEnleverListe = true; // vite de vouloir enlever 2 fois le mme element
															// ce qui peut arriver si ordonne commune avec 2 lignes
							}
						}

// ############### this is when count is greater than 2

						// On test si on a une ORDONNEE COMMUNE avec l'avant dernier element des lignes
						if(l->get_liste_elements()->GetCount() >2 && ElementEnleverListe != true)
						{	// On test pour savoir si il existe un avant dernier
							if( element_avant_dernier_fin_ligne->Possedent_une_ordonnee_commune(element_encours) )
							{
								// On regarde si la distance ordonne commune est la plus grande ou non
								// si c'est la plus grande alors on met l'element dans la ligne sinon
								// on ne fait rien
								distanceOrdonneeMax = 0;
								for(  p6 = liste_lignes->GetHeadPosition(); (p6 != NULL) ;)
								{	
									p7 = p6;
									CLigne *l2 = (CLigne *)(liste_lignes->GetNext(p6));
									if(l2->get_liste_elements()->GetCount() >2)
									{
										PositionDernier2 = l2->get_liste_elements()->GetTailPosition();
										(CElement *)(l2->get_liste_elements()->GetPrev(PositionDernier2)); // dernier
										CElement * element_avant_dernier_fin_ligne2 = (CElement *)(l2->get_liste_elements()->GetPrev(PositionDernier2)); // avant dernier

										distanceOrdonnee = element_avant_dernier_fin_ligne2->Distance_ordonnee_commune(element_encours);

										if( distanceOrdonnee > distanceOrdonneeMax)
										{
											distanceOrdonneeMax = distanceOrdonnee;
											ligneOrdoMax = p7;
										}
									}
								}
								// On test pour savoir si la ligne ayant la distance ordonne max est celle
								// qui est en cours ou non
								if( p5 == ligneOrdoMax )
								{
									l->get_liste_elements()->AddTail(element_encours); // on place en fin de liste

									l->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

									liste_elements->RemoveAt(p4);
									ElementEnleverListe = true; // vite de vouloir enlever 2 fois le mme element
																// ce qui peut arriver si ordonne commune avec 2 lignes
								}
							}
						}

// ############### this is when count is greater than 3

						// On test si on a une ORDONNEE COMMUNE avec l'avant avant dernier element des lignes
						if(l->get_liste_elements()->GetCount() >3 && ElementEnleverListe != true)
						{	// On test pour savoir si il existe un avant dernier
							if( element_avant_avant_dernier_fin_ligne->Possedent_une_ordonnee_commune(element_encours) )
							{
								// On regarde si la distance ordonne commune est la plus grande ou non
								// si c'est la plus grande alors on met l'element dans la ligne sinon
								// on ne fait rien
								distanceOrdonneeMax = 0;
								for(  p6 = liste_lignes->GetHeadPosition(); (p6 != NULL) ;)
								{	
									p7 = p6;
									CLigne *l2 = (CLigne *)(liste_lignes->GetNext(p6));
									if(l2->get_liste_elements()->GetCount() >2)
									{
										PositionDernier2 = l2->get_liste_elements()->GetTailPosition();
										(CElement *)(l2->get_liste_elements()->GetPrev(PositionDernier2)); // dernier
										(CElement *)(l2->get_liste_elements()->GetPrev(PositionDernier2)); // avant dernier
										CElement * element_avant_avant_dernier_fin_ligne2 = (CElement *)(l2->get_liste_elements()->GetPrev(PositionDernier2)); // avant avant dernier

										distanceOrdonnee = element_avant_avant_dernier_fin_ligne2->Distance_ordonnee_commune(element_encours);

										if( distanceOrdonnee > distanceOrdonneeMax)
										{
											distanceOrdonneeMax = distanceOrdonnee;
											ligneOrdoMax = p7;
										}
									}
								}
								// On test pour savoir si la ligne ayant la distance ordonne max est celle
								// qui est en cours ou non
								if( p5 == ligneOrdoMax )
								{
									l->get_liste_elements()->AddTail(element_encours); // on place en fin de liste

									l->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

									liste_elements->RemoveAt(p4);
									ElementEnleverListe = true; // vite de vouloir enlever 2 fois le mme element
																// ce qui peut arriver si ordonne commune avec 2 lignes
								}
							}
						}

//###########" here we are testing whether centre of gravity is calculated or not with real rectangle of lines

						// On test si l'lment n'a pas dj sont CENTRE DE GRAVITE COMPRIS
						// dans le rectangle englobant REEL d'une des lignes 
						if (	yCdg > yMinLigne && yCdg < yMaxLigne 
							 && xCdg > xMinLigne && xCdg < xMaxLigne
							 && ElementEnleverListe != true && ZoneVirtuelleExiste == false)
						{
							l->get_liste_elements()->AddHead(element_encours);	// on place au debut de liste
																				// pour ne pas gener la suite 
																				// de la detection
							l->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

							liste_elements->RemoveAt(p4);
							ElementEnleverListe = true; // vite de vouloir enlever 2 fois le mme element
														// ce qui peut arriver si ordonne commune avec 2 lignes
						}
//###########" here we are testing whether centre of gravity is calculated or not with virtual rectangle of lines

						// On test si l'lment n'a pas dj sont CENTRE DE GRAVITE COMPRIS
						// dans le rectangle englobant VIRTUELLE d'une des lignes 
						if (	yCdg > yMinVirtuelLigne && yCdg < yMaxVirtuelLigne 
							 && xCdg > xMinVirtuelLigne && xCdg < xMaxVirtuelLigne
							 && ElementEnleverListe != true && ZoneVirtuelleExiste == true)
						{
							l->get_liste_elements()->AddHead(element_encours);	// on place au debut de liste
																				// pour ne pas gener la suite 
																				// de la detection
							l->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

							liste_elements->RemoveAt(p4);
							ElementEnleverListe = true; // vite de vouloir enlever 2 fois le mme element
														// ce qui peut arriver si ordonne commune avec 2 lignes
						}

					}


					if( ElementEnleverListe == false )
					{
						// L'lment en cours n'appartient a aucune des lignes donc on le place dans 
						// une nouvelle ligne
						CLigne* ligne = new CLigne (); // cration nouvelle ligne
						ligne->get_liste_elements ()->AddTail(element_encours); // ajout  la ligne

						ligne->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

						liste_elements->RemoveAt(p4); // retrait dans la liste_elements
						liste_lignes->AddTail(ligne); // ajout de la ligne  la liste des lignes

					}
				}
				else
				{
					// il existe aucune ligne on insere l'lment dans une nouvelle ligne
					CLigne* ligne = new CLigne (); // cration nouvelle ligne
					PositionAjout = p4;	// position de l'lment  ajouter
					PositionRetrait = p4; // position de l'lment  retirer

					CElement* element_encours2 = (CElement *)(liste_elements->GetNext(p4)); // rcupration de l'lment
					ligne->get_liste_elements ()->AddTail(element_encours2); // ajout  la ligne
					
					ligne->MettreAJourParametreLigne(); // mise  jour des paramtres de la ligne

					liste_elements->RemoveAt(PositionRetrait); // retrait dans la liste_elements
					liste_lignes->AddTail(ligne); // ajout de la ligne  la liste des lignes
				}

			//}

		}
		
		//abscisse++;

	}
//	It presents updated all the settings for each line

	// On remet  jour tout les paramtres de chaque ligne 
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		l->MettreAJourParametreLigne();
	}


		
// It seeks the average element that contains each line
// To use this setting for the merging of lines having
// Can with that element in many

	// On cherche le nombre moyen d'element que contient chaque ligne
	// afin d'utiliser ce paramtre pour le fusion des lignes ayant
	// peut d'element avec celle qui en ont beaucoup

	for (p1 = liste_lignes->GetHeadPosition (); p1 != NULL;)
	{
		p5 = p1;
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		nbElementLigne = l->get_liste_elements()->GetCount();
		nbElementTotal = nbElementTotal + nbElementLigne;
		nbElementLigne = 0;
	}
	
	nbElementMoyenParLigne = nbElementTotal / (liste_lignes->GetCount());


// It takes all the lines and that with only few elements
// We try to put their items in the other lines of large

	// On reprend toutes les lignes et pour celle qui ne disposent que de peu d'lements
	// on essaye de replacer leur lements dans les autres lignes de grande taille
	int t=liste_lignes->GetCount();
	if( t>1)
	{
		for (p1 = liste_lignes->GetHeadPosition (); p1 != NULL;)
		{
			p5 = p1;
			CLigne *l = (CLigne *)(liste_lignes->GetAt (p1)); // on incrmente pas p1 pour eviter
															  // de pointer sur une ligne que l'on
															  // va enlever

			// On test si le nombre d'lment de la ligne est dans la norme, si c'est le cas
			// on essaye de replacer ses lments dans une ligne plus longue

// ################ why is it divided by 6 ????

			if(l->get_liste_elements()->GetCount() <= (nbElementMoyenParLigne/6) ) //3
			{
				for(p2 = l->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
				{
					// On rcupre l'lment de la ligne et les coordonnes de son cdg			
					p4 = p2;	// pointeur sur l'lment en cours
					CElement *element_encours = (CElement *) (l->get_liste_elements()->GetNext(p2));
					yCdg = element_encours->getCdg()->y;
					xCdg = element_encours->getCdg()->x;
					ElementEnleverListe = false;

					for( p3 = liste_lignes->GetHeadPosition(); (p3 != NULL && ElementEnleverListe != true);)
					{
						p6 = p3;
						CLigne *l2 = (CLigne *)(liste_lignes->GetAt (p3));

						if(p6 != p5) // on ne reprend pas la mme ligne
						{
							// Si la ligne possde plus de la moiti du nombre moyen d'lement
							// par ligne elle peut contenir l'lment que l'on veut replacer

// ################ why is it divided by 2 ????

							if(l2->get_liste_elements()->GetCount() > (nbElementMoyenParLigne/2)) //5
							{
								// On recupre les coordonnes du rectangle englobant de la ligne
								yMinLigne = l2->get_ordonnee_minimale();
								yMaxLigne = l2->get_ordonnee_maximale();
								xMinLigne = l2->get_abscisse_minimale();
								xMaxLigne = l2->get_abscisse_maximale();

								// On test si le cdg de l'element en cours est situ dans le rectangle
								// englobant d'une autre ligne qui possde plus de 2 lments
								if (	yCdg > yMinLigne && yCdg < yMaxLigne 
									 && xCdg > xMinLigne && xCdg < xMaxLigne )
								{
									l2->get_liste_elements()->AddHead(element_encours);
									l->get_liste_elements()->RemoveAt(p4);
									//if(l->get_liste_elements()->GetCount() == 0)
									//{
									//	liste_lignes->RemoveAt(p5);
									//}

									ElementEnleverListe = true;

								}
							}
						}

						(CLigne *)(liste_lignes->GetNext(p3));

					} // fin for liste_lignes

				} // fin for liste_elements

			}
			(CLigne *)(liste_lignes->GetNext (p1)); // on incrmente p1
		}
	}

	// ######## i am not sure what is the purpose of this? 

	// Permet de supprimer les lignes vides
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		p5=p1;
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		if(l->get_liste_elements()->GetCount() == 0)
		{
			liste_lignes->RemoveAt(p5);
		}
	}	


	// On remet  jour tout les paramtres de chaque ligne 
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		l->MettreAJourParametreLigne();
	}

	// On regarde si les element d'une ligne ont tous leur cdg dans une autre, si c le cas
	// on fusionne les elements de ces deux lignes
	// Arrive tres rarement, mais j'ai rencontr ce phnomne une fois !
	bool continu = false;

	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		p8 = p1;

		CLigne *l = (CLigne *)(liste_lignes->GetAt(p1)); // on incrmente p1 qu' la fin
														 // sinon p1 pourrai pointer sur une
														 // ligne que l'on va enlever
		yMinLigne = l->get_ordonnee_minimale();
		yMaxLigne = l->get_ordonnee_maximale();
		xMinLigne = l->get_abscisse_minimale();
		xMaxLigne = l->get_abscisse_maximale();
		

		for (p3 = liste_lignes->GetHeadPosition ();p3 != NULL;)
		{
			p5 = p3;
			CLigne *l2 = (CLigne *)(liste_lignes->GetNext (p3));
			continu = true;

			for(p2 = l2->get_liste_elements()->GetHeadPosition(); (p2 != NULL && continu != false);)
			{
				p4 = p2;	// pointeur sur l'lment en cours
				CElement *element_encours = (CElement *) (l2->get_liste_elements()->GetNext(p2));
				yCdg = element_encours->getCdg()->y;
				xCdg = element_encours->getCdg()->x;
				if (	yCdg > yMinLigne && yCdg < yMaxLigne 
					 && xCdg > xMinLigne && xCdg < xMaxLigne )
				{
					continu = true;
				}
				else
				{
					continu = false;
				}
			}

			if(continu == true)
			{
				// on recopie toute la ligne l2 dans l'autre ligne l
				for(p2 = l2->get_liste_elements()->GetHeadPosition(); (p2 != NULL);)
				{
					p4 = p2;	// pointeur sur l'lment en cours
					CElement *element_encours = (CElement *) (l2->get_liste_elements()->GetNext(p2));
					l->get_liste_elements()->AddHead(element_encours);
					l2->get_liste_elements()->RemoveAt(p4);
					if(l2->get_liste_elements()->GetCount() == 0)
					{
						liste_lignes->RemoveAt(p5);
					}
				}
			}
		}
		
		(CLigne *)(liste_lignes->GetNext(p1)); // incrmente p1
	}
	

	// On remet  jour tout les paramtres de chaque ligne 
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		l->MettreAJourParametreLigne();
	}

	// On lance sur chaque ligne l'algo permettant d'ordonner les 
	// lments qui la compose dans le sens logique de lecture
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *l = (CLigne *)(liste_lignes->GetNext (p1));
		l->Ordonner_elements_sens_lecture ();
	}

	decompositionEnLigneEffectue = true;
*/
	////////////////
	// version 3 fin
	////////////////
}



/********************************************************************/
/* Nom mthode : getDecomposition_En_Ligne_Effectue
/*                                                                  
/* Fonction : permet de savoir si l'algo de decomposition en ligne a
/*            dj t lanc
/*            
/********************************************************************/
bool CBloc::getDecomposition_En_Ligne_Effectue()
{
	return decompositionEnLigneEffectue;

}

void CBloc::Rachit1()
{
	//AfxMessageBox("Rachit1 Starts  !");
	// we already know the accents, now we need to merge the accent to the normal character
	POSITION p1,p2,p3,p_back = NULL;
	int rmin,lmax,rmax,lmin,common,ltop,rbottom,flag;
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			p3 = p2;
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			flag = 0;
			if (e->GetClassNumber()== 3) // that is accent
			{
				// now let us compare with i-1
				if (p_back != NULL)
				{
				//	AfxMessageBox("Debug  !");
					CElement *e_next = (CElement *)ligne->get_liste_elements()->GetAt (p_back); // here e_next = prev
				//	AfxMessageBox("Debug2  !");
					if(e_next->GetClassNumber()== 1 || e_next->GetClassNumber()== 2 || e_next->GetClassNumber() == 3|| e_next->GetClassNumber() == 4|| e_next->GetClassNumber() == 5)
					{
						// we check i is above i-1
						if(e_next->getRect()->top >= e->getRect()->bottom)
						{
							// now we need to check for 100% overlap
							if(e_next->getRect()->left <= e->getRect()->left &&e_next->getRect()->right >= e->getRect()->right)
							{
								// update p_back and remove p3;
								if(e_next->getRect()->left <= e->getRect()->left)
								{
									lmin = e_next->getRect()->left;
								}
								else
								{
									lmin = e->getRect()->left;
								}
								if(e_next->getRect()->right <= e->getRect()->right)
								{
									rmax = e->getRect()->right;
								}
								else
								{
									rmax = e_next->getRect()->right;
								}
								if(e_next->getRect()->top <= e->getRect()->top)
								{
									ltop = e_next->getRect()->top;
								}
								else
								{
									ltop = e->getRect()->top;
								}
								if(e_next->getRect()->bottom <= e->getRect()->bottom)
								{
									rbottom = e->getRect()->bottom;
								}
								else
								{
									rbottom = e_next->getRect()->bottom;
								}
								e_next->SetRect(lmin,ltop,rmax,rbottom);
								flag = 1;
								e_next->SetClassNumber(6);
								e->SetClassNumber(7);
					//			AfxMessageBox("Yes 1 !");
								//ligne->get_liste_elements()->RemoveAt(p3);
							}
							// if they overlap by 50%
							else
							{
								if(e_next->getRect()->left <= e->getRect()->left)
								{
									lmax = e->getRect()->left;
									lmin = e_next->getRect()->left;
								}
								else
								{
									lmin = e->getRect()->left;
									lmax = e_next->getRect()->left;
								}
								if(e_next->getRect()->right <= e->getRect()->right)
								{
									rmin = e_next->getRect()->right;
									rmax = e->getRect()->right;
								}
								else
								{
									rmax = e_next->getRect()->right;
									rmin = e->getRect()->right;
								}
								int count = 10 * ((double)rmin - (double)lmax) / ((double)rmax - (double)lmin);
								if(count>= 2 ) // 50 %overlap ........... this can be changed
								{
									// update p_back and remove p3;
									if(e_next->getRect()->left <= e->getRect()->left)
									{
										lmin = e_next->getRect()->left;
									}
									else
									{
										lmin = e->getRect()->left;
									}
									if(e_next->getRect()->right <= e->getRect()->right)
									{
										rmax = e->getRect()->right;
									}
									else
									{
										rmax = e_next->getRect()->right;
									}
									if(e_next->getRect()->top <= e->getRect()->top)
									{
										ltop = e_next->getRect()->top;
									}
									else
									{
										ltop = e->getRect()->top;
									}
									if(e_next->getRect()->bottom <= e->getRect()->bottom)
									{
										rbottom = e->getRect()->bottom;
									}
									else
									{
										rbottom = e_next->getRect()->bottom;
									}
									e_next->SetRect(lmin,ltop,rmax,rbottom);
									flag = 1;
									e_next->SetClassNumber(6);
									e->SetClassNumber(7);
								//	AfxMessageBox("Yes 2 !");
								//	ligne->get_liste_elements()->RemoveAt(p3);
								}
							}
						}
					}
				}
				// let us compare with i+1 first
				if (p2 != NULL && flag ==0)
				{
				//	AfxMessageBox("Debug3  !");
					CElement *e_next = (CElement *)ligne->get_liste_elements()->GetAt (p2);
				//	AfxMessageBox("Debug4  !");
					//if(e_next->GetClassNumber() == 1 || e_next->GetClassNumber() == 2 || e_next->GetClassNumber() == 4)
					if(e_next->GetClassNumber()== 1 || e_next->GetClassNumber()== 2 || e_next->GetClassNumber() == 3|| e_next->GetClassNumber() == 4|| e_next->GetClassNumber() == 5)
					{
						if(e_next->getRect()->top >= e->getRect()->bottom)
						{
							// now we need to check for 100% overlap
							if(e_next->getRect()->left <= e->getRect()->left &&e_next->getRect()->right >= e->getRect()->right)
							{
								// update p2 and remove p3;
								if(e_next->getRect()->left <= e->getRect()->left)
								{
									lmin = e_next->getRect()->left;
								}
								else
								{
									lmin = e->getRect()->left;
								}
								if(e_next->getRect()->right <= e->getRect()->right)
								{
									rmax = e->getRect()->right;
								}
								else
								{
									rmax = e_next->getRect()->right;
								}
								if(e_next->getRect()->top <= e->getRect()->top)
								{
									ltop = e_next->getRect()->top;
								}
								else
								{
									ltop = e->getRect()->top;
								}
								if(e_next->getRect()->bottom <= e->getRect()->bottom)
								{
									rbottom = e->getRect()->bottom;
								}
								else
								{
									rbottom = e_next->getRect()->bottom;
								}
								e_next->SetRect(lmin,ltop,rmax,rbottom);
								flag = 1;
								e_next->SetClassNumber(6);
								e->SetClassNumber(7);
					//			AfxMessageBox("Yes 3 !");
							//	ligne->get_liste_elements()->RemoveAt(p3);
							}
							// if they overlap by 50%
							
							else
							{
								if(e_next->getRect()->left <= e->getRect()->left)
								{
									lmax = e->getRect()->left;
									lmin = e_next->getRect()->left;
								}
								else
								{
									lmin = e->getRect()->left;
									lmax = e_next->getRect()->left;
								}
								if(e_next->getRect()->right <= e->getRect()->right)
								{
									rmin = e_next->getRect()->right;
									rmax = e->getRect()->right;
								}
								else
								{
									rmax = e_next->getRect()->right;
									rmin = e->getRect()->right;
								}
								int count = 10 * ((double)rmin - (double)lmax) / ((double)rmax - (double)lmin);
								if(count>= 2 ) // 50 %overlap ........... this can be changed
								{
									// update p2 and remove p3;
									if(e_next->getRect()->left <= e->getRect()->left)
									{
										lmin = e_next->getRect()->left;
									}
									else
									{
										lmin = e->getRect()->left;
									}
									if(e_next->getRect()->right <= e->getRect()->right)
									{
										rmax = e->getRect()->right;
									}
									else
									{
										rmax = e_next->getRect()->right;
									}
									if(e_next->getRect()->top <= e->getRect()->top)
									{
										ltop = e_next->getRect()->top;
									}
									else
									{
										ltop = e->getRect()->top;
									}
									if(e_next->getRect()->bottom <= e->getRect()->bottom)
									{
										rbottom = e->getRect()->bottom;
									}
									else
									{
										rbottom = e_next->getRect()->bottom;
									}
									e_next->SetRect(lmin,ltop,rmax,rbottom);
									flag = 1;
									e_next->SetClassNumber(6);
									e->SetClassNumber(7);
								//	AfxMessageBox("Yes 4 !");
								//	ligne->get_liste_elements()->RemoveAt(p3);
								}
							}
						}
					}
				}
			}
			//if(flag != 1)
			//{
			p_back = p3;
			flag = 0;
			//}
		}
	}

	// now we have finished the merging of the accents

	//AfxMessageBox("Rachit !");
	//now we need to remove those accents which are merged with the characters with class number = 7
	/*
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
	//	for(p2 = liste_elements->GetHeadPosition(); p2 != NULL;)
		{
			p3 = p2;
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
	//		CElement *e = (CElement *)liste_elements->GetNext(p2);
			flag = 0;
			if (e->GetClassNumber()== 7) // that is accent
			{
				ligne->get_liste_elements()->RemoveAt(p3);
				liste_elements->RemoveAt(p3);
			}
		}
	}
	*/
	//AfxMessageBox("Rachit1 Finishs!");
}

void CBloc::Rachit2(CDocument* pDoc)
{

	// calculating the xl_mid and xr_mid
	//AfxMessageBox("Rachit2 Starts!");
	// before word segmentation we need to calculate the gap length 1 and gap length 2

	POSITION p1,p2;
	int flag=0,y=0;
	//CImage *img = new CImage();
	//ofstream of;
	//of.open("rachit.txt",ios_base::app); //	app or out
	
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);	
			y = (e->getRect()->top + e->getRect()->bottom)/2;

			flag =0;
			CImage *img = new CImage (e->getRect()->Width(), e->getRect()->Height(), 8);
			e->ExtraireElement (((CMyAppDoc *)pDoc)->atelier->getImageBinarisee(), img);

			for (int i= 0 ; i< e->getRect()->right - e->getRect()->left; i++)
			{
				//of<<"i = "<<i<<"y = "<<y-e->getRect()->top<<"pixel = "<<img-> getPixel(i,y - e->getRect()->top )<<"\n";
				if(img->getPixel(i,y - e->getRect()->top )== 0) // pixel == black I hope this should work
				{
					flag = 1;
					e->SetXLM(i + e->getRect()->left);
					break;
				}
			}

			if(flag == 0)
			{
				e->SetXLM((e->getRect()->left + e->getRect()->right)/2); // this is centre we can change it 
			}
			flag =0;
			for (int i= e->getRect()->right - e->getRect()->left; i>0 ; i--)
			{
				//of<<"i = "<<i<<"y = "<<y<<"pixel = "<<img-> getPixel(i,y - e->getRect()->top)<<"\n";
				if(img->getPixel(i,y - e->getRect()->top )== 0) // pixel == black I hope this should work
				{
					flag = 1;
					e->SetXRM(i + e->getRect()->left);
					break;
				}
			}
			if(flag == 0)
			{
				e->SetXRM((e->getRect()->left + e->getRect()->right)/2); // this is centre we can change it 
			}
			delete img;
		}
	}
	
	// now we need to calculate the average
	// we have 2 options either we can calculate per page basis or per line basis
	// i am writing code taking per line basis.
	// now we start the word segmentation
	POSITION p3=NULL,p4;
	int total = 0, count =1;
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		total = 0;
		count = 1;
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;) // we need to chnage here
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			if(p2 == NULL)
			{
				break;
			}
			CElement *e_next = (CElement *)ligne->get_liste_elements()->GetAt(p2);
			if((e_next->getRect()->left - e->getRect()->right) >0) 
			{
				total += e_next->getRect()->left - e->getRect()->right;
				count++;
			}
		}
		double average = 0.0;
		average = (double)total /(double)count;
		int threshold = (int) 1.9 * average; // can make it 1.6 or 1.7 times as well for better result

		// now we have calculated the threshold value
		// now we need to analyse the gap between the 2 consecutive chars

		int wordcount = 1;
		int gap1 = 0, gap2 = 0;
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			p4 = p2;
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			if(p2 == NULL)
			{
			//	AfxMessageBox("1 !");
				e->SetWordNumber(wordcount);
				e->SetXLM(0);
				e->SetXRM(0);
				break;
			}
			CElement *e_next = (CElement *)ligne->get_liste_elements()->GetAt(p2);
			// apply rules
			gap1 = (e_next->getRect()->left) - (e->getRect()->right) ;
			gap2 = e_next->GetXLM() - e->GetXRM() ;
		
			if(e_next->GetClassNumber() == 4) // for punctuation
			{
			//	AfxMessageBox("2 !");
				e->SetWordNumber(wordcount);
				wordcount++;
			}

			else if(e->GetClassNumber() == 4) // for punctuation_
			{
				e->SetWordNumber(wordcount);
				wordcount++;
			}

			else
			{
				if(e->GetClassNumber() == 7)
				{
					if(p3 != NULL)
					{
						CElement *e_prev = (CElement *)ligne->get_liste_elements()->GetAt(p3);
						gap1 = (e_next->getRect()->left) - (e_prev->getRect()->right) ;
						gap2 = e_next->GetXLM() - e_prev->GetXRM() ; 
					}
				}
				if(gap1 > threshold && gap2 > threshold)
				{
			//		AfxMessageBox("3 !");
					e->SetWordNumber(wordcount);
					wordcount++;
				}
			//	else if(gap1 <= threshold && gap1 >= 0.5*threshold && gap2 >= 2*threshold) // we can change this threshold
			//	{
				//	AfxMessageBox("4 !");
			//		e->SetWordNumber(wordcount);
			//		wordcount++;
			//	}
				else
				{
			//		AfxMessageBox("5 !");
					e->SetWordNumber(wordcount);
				}
			}
			p3 = p4;
			e->SetXLM(gap1);
			e->SetXRM(gap2);
		}
	}
	//AfxMessageBox("TRY !");
	// now we can try building the list of words
/*
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			CMot* mot = new CMot ();
			mot->get_liste_elements ()->AddTail (e);
			//ligne->get_liste_mots()->AddTail (mot);
			
			CElement *e_prev;
			int flag =0;
			e_prev = e;

			while(p2!= NULL && flag == 0)
			{
				CElement *e = (CElement *)ligne->get_liste_elements()->GetAt(p2);
				if(e->GetWordNumber() != e_prev->GetWordNumber())
				{
					flag = 1;
				}
				else
				{
					mot->get_liste_elements ()->AddTail (e);
					e_prev = e;
					(CElement *)ligne->get_liste_elements()->GetNext(p2);
				}
			}
		}
	}
	*/
	//AfxMessageBox("Good Work !");
	// i think now we are done with line-number , class-number, char-number and word-number :D:D:D:D
	// liste_lignes contains the link list of line 
	// liste_mots contains the link list of words
	// liste_elements contains the link list of characters
	/*

	// now we are trying to update the class number for those CC in which there is some extra portion of other characters
	// using flood fill algorithm
	int x=0,xmax=0,ymax=0;
	y=0;
	flag=0;
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
			CImage *img = new CImage (e->getRect()->Width(), e->getRect()->Height(), 8);
			e->ExtraireElement (((CMyAppDoc *)pDoc)->atelier->getImageBinarisee(), img);
			xmax = e->getRect()->right - e->getRect()->left ;
			ymax = e->getRect()->bottom - e->getRect()->top;
			for(int i = 0;i<200;i++)
			{
				for(int j = 0;j<200;j++)
				{
					table[i][j] = 0;
				}
			}
			for(int i = 0;i<ymax; i++)
			{
				for(int j = 0; j <xmax; j++)
				{
					if(img->getPixel(j,i) == 0)
					{
						table[i][j] = 1;
					}
					else
					{
						table[i][j] = 0;
					}
				}
			}
			for(int i = 0;i<ymax; i++)
			{
				for(int j = 0; j <xmax; j++)
				{
					if(img->getPixel(j,i) == 0)
					{
						flag = 1;
						x = j;
						y = i;
						break;
					}
				}
				if(flag == 1)
					break;
			}
			//AfxMessageBox("Flood!");
			floodfill(x,y,xmax,ymax);
			//AfxMessageBox("fill!");
			flag = 0;
			for(int i = 0;i<ymax; i++)
			{
				for(int j = 0; j <xmax; j++)
				{
					if(table[i][j] == 1)
					{
						flag = 1;
						e->SetClassNumber(e->GetClassNumber() + 10);
						break;
					}
				}
				if(flag == 1)
					break;
			}
		}
	}
	AfxMessageBox("Rachit2 Finishes!");
	*/
	/*
	for (p1 = liste_lignes->GetHeadPosition ();p1 != NULL;)
	{
		CLigne *ligne = (CLigne *)(liste_lignes->GetNext(p1));
		for(p2 = ligne->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
		{
			CElement *e = (CElement *)ligne->get_liste_elements()->GetNext(p2);
		//	of<<"line no = "<<e->GetLineNumber()<<"char no = "<<e->GetCharNumber()<<"word no = "<<e->GetWordNumber()<<"class no = "<<e->GetClassNumber()<<" top = "<<e->getRect()->top<<" bottom = "<<e->getRect()->bottom<<" left = "<<e->getRect()->left<<" right = "<<e->getRect()->right<<"\n";
			//of<<e->getRect()->top<<"\n";
			//of<<e->getRect()->bottom<<"\n";
		}
	}
	//AfxMessageBox("Rachit2 Finishes!");
	*/
}


void CBloc::floodfill(int x, int y,int xmax, int ymax)
{
	// AfxMessageBox("Rachit2 Finishes!");
	// This is the flood fill function used for floodfill algorithm
	if(table[y][x] != 1)
		return;
	table[y][x] = 3;
	if(x>0 && y>0 && table[y-1][x-1] == 1)
		floodfill(x-1,y-1,xmax,ymax);
	if(x>0 && table[y][x-1] == 1)
		floodfill(x-1,y,xmax,ymax);
	if(x>0 && y<ymax && table[y+1][x-1] == 1)
		floodfill(x-1,y+1,xmax,ymax);
	if(y>0  && table[y-1][x] == 1)
		floodfill(x,y-1,xmax,ymax);
	if(y<ymax && table[y+1][x] == 1)
		floodfill(x,y+1,xmax,ymax);
	if(x<xmax && y>0 && table[y-1][x+1] == 1)
		floodfill(x+1,y-1,xmax,ymax);
	if(x<xmax && table[y][x+1] == 1)
		floodfill(x+1,y,xmax,ymax);
	if(x<xmax && y<ymax && table[y+1][x+1] == 1)
		floodfill(x+1,y+1,xmax,ymax);
	return;
	
}