

#include "stdafx.h"
#include "MyApp.h"
#include "MyAppDoc.h"
#include "CaracCC.h"
#include "Zone.h"

//class CZone;

CCaracCC::CCaracCC(void)
{
	rapportLsurH = 0;
	nbElements = 0;
	rapportHsurHmoyCC = 0;
	largeurZone = 0;
	hauteurZone = 0;
	densitePixBlanc = 0;
	densiteNdgSurNbPix = 0;
}

CCaracCC::~CCaracCC(void)
{
}


void CCaracCC::CalculerToutesLesCaracCC(CZone *zoneACalculer)
{

	rapportLsurH = CalculerRapportLsurH(zoneACalculer);

	nbElements = zoneACalculer->getNbElements();

	rapportHsurHmoyCC = CalculerRapportHsurHmoyCC(zoneACalculer);

	largeurZone = zoneACalculer->getRect()->Width();

	hauteurZone = zoneACalculer->getRect()->Height();

	CMyAppDoc *pDocTemp = (CMyAppDoc*)zoneACalculer->m_DocContenant;
	densitePixBlanc = zoneACalculer->CalculDensite(pDocTemp->atelier->getImageCourante());

	CMyAppDoc *pDocTemp2 = (CMyAppDoc*)zoneACalculer->m_DocContenant;
	CImage *imageTemp = pDocTemp2->atelier->getImageOrigine();
	CRect *contourZone = zoneACalculer->getRect();
	int densiteNdG = 0;
	int sommeValeurAllPixels = 0;
	int nbPixels = 0;
	for( int i = contourZone->TopLeft().x ; i <= contourZone->BottomRight().x ; i++)
	{
		for( int j = contourZone->TopLeft().y ; j <= contourZone->BottomRight().y ; j++)
		{
			sommeValeurAllPixels += imageTemp->getPixel(i,j);
			nbPixels++;
		}
	}
	densiteNdgSurNbPix = sommeValeurAllPixels/nbPixels;
	
}


double CCaracCC::CalculerRapportLsurH(CZone *zoneACalculer)
{
	double rLH;
	int L,H;
	L = zoneACalculer->getRect()->Width();
	H = zoneACalculer->getRect()->Height();
	if (L > H)
	{
		rLH = (double)((H)*100)/(L);
	}else
	{
		rLH = (double)((L)*100)/(H);
	}
	return rLH;
}


double CCaracCC::CalculerRapportHsurHmoyCC(CZone *zoneACalculer)
{
	double rHHm;
	int H,Hm;
	H = zoneACalculer->getRect()->Height();
	Hm = zoneACalculer->get_hauteur_moyenne();
	if (H > Hm)
	{
		rHHm = (double)((Hm)*100)/(H);
	}else
	{
		rHHm = (double)((H)*100)/(Hm);
	}
	return rHHm;
}