

#include "stdafx.h"
#include "MyApp.h"
#include "MyAppDoc.h"
#include "CaracCG.h"



CCaracCG::CCaracCG(void)
{
	degreGauche = 0;
	degreDroite = 0;
	degreHaut = 0;
	degreBas = 0;
	degreInclusion = 0;
	ratio = 0;
}

CCaracCG::~CCaracCG(void)
{
}

/********************************************************************/
/* Nom mthode : CalculerToutesLesCaracCG                                     
/*                                                                  
/* Fonction : on attribue un degr d'appartenance aux directions principales
/*                                                             
/* 
/*                                                           
/********************************************************************/
void CCaracCG::CalculerToutesLesCaracCG(CZone *zoneACalculer)
{
	CMyAppDoc *pDocTemp = (CMyAppDoc*)zoneACalculer->m_DocContenant;
	CImage *imageTemp = pDocTemp->atelier->getImageCourante();
	

	int largeur = imageTemp->getLargeur();
	int hauteur = imageTemp->getHauteur();
	int xCdg;
	int yCdg;

	xCdg = zoneACalculer->getCdg()->x;
	yCdg = zoneACalculer->getCdg()->y;
		

	if ( xCdg<largeur/2 ) degreGauche = 1 - ((double)xCdg / (largeur/2));

	if ( xCdg>largeur/2 ) degreDroite = 1 - ((double)(largeur - xCdg) / (double)(largeur/2));

	if ( yCdg<hauteur/2 ) degreHaut = 1 - ((double)yCdg / (hauteur/2));

	if ( yCdg>hauteur/2 ) degreBas = 1 - ((double)(hauteur - yCdg) / (double)(hauteur/2));

}