


#include "stdafx.h"
#include "MyApp.h"
#include "ClassifAuto.h"
//#include "MyAppDoc.h" //a commenter si il y a un CMyAppDoc dans le .h
//#include "MyAppView.h"
#include "ListeZones.h"

#include "MainFrm.h"
#include "constante.h"
#include "TypeClasse.h"



CClassifAuto::CClassifAuto(void)
{	
	listeZonesSelectionnees = new CObList(10);


	listeParamCarac = new CObList(10);

	paramRapportLsurH = new CParamCarac("RapportLsurH", RAPPORTLSURH);
	listeParamCarac->AddTail(paramRapportLsurH);

	paramNbElements = new CParamCarac("NbElements", NBELEMENTS);
	listeParamCarac->AddTail(paramNbElements);

	paramRapportHsurHmoyCC = new CParamCarac("RapportHsurHmoyCC", RAPPORTHSURHMOYCC);
	listeParamCarac->AddTail(paramRapportHsurHmoyCC);

	paramLargeurZone = new CParamCarac("LargeurZone", LARGEURZONE);
	listeParamCarac->AddTail(paramLargeurZone);

	paramHauteurZone = new CParamCarac("HauteurZone", HAUTEURZONE);
	listeParamCarac->AddTail(paramHauteurZone);

	paramDensitePixBlanc = new CParamCarac("DensitePixBlanc", DENSITEPIXBLANC);
	listeParamCarac->AddTail(paramDensitePixBlanc);

	paramDensiteNdgSurNbPix = new CParamCarac("DensiteNdgSurNbPix", DENSITENDGSURNBPIX);
	listeParamCarac->AddTail(paramDensiteNdgSurNbPix);

	paramDegreGauche = new CParamCarac("DegreGauche", DEGREGAUCHE);
	listeParamCarac->AddTail(paramDegreGauche);

	paramDegreDroite = new CParamCarac("DegreDroite", DEGREDROITE);
	listeParamCarac->AddTail(paramDegreDroite);

	paramDegreHaut = new CParamCarac("DegreHaut", DEGREHAUT);
	listeParamCarac->AddTail(paramDegreHaut);

	paramDegreBas = new CParamCarac("DegreBas", DEGREBAS);
	listeParamCarac->AddTail(paramDegreBas);

	paramDegreCentreP = new CParamCarac("DegreCentrePage", DEGRECENTREP);
	listeParamCarac->AddTail(paramDegreCentreP);

	paramDegreCentreL = new CParamCarac("DegreCentreLargeur", DEGRECENTREL);
	listeParamCarac->AddTail(paramDegreCentreL);

	paramDegreCentreH = new CParamCarac("DegreCentreHauteur", DEGRECENTREH);
	listeParamCarac->AddTail(paramDegreCentreH);


	listeParamClasses = new CObList(10);

	paramClasse = new CParamClasse("Classe", CLASSE);
	listeParamClasses->AddTail(paramClasse);

	paramVoisinGauche = new CParamClasse("VoisinGauche", VOISINGAUCHE);
	listeParamClasses->AddTail(paramVoisinGauche);

	paramVoisinDroite = new CParamClasse("VoisinDroite", VOISINDROITE);
	listeParamClasses->AddTail(paramVoisinDroite);

	paramVoisinHaut = new CParamClasse("VoisinHaut", VOISINHAUT);
	listeParamClasses->AddTail(paramVoisinHaut);

	paramVoisinBas = new CParamClasse("VoisinBas", VOISINBAS);
	listeParamClasses->AddTail(paramVoisinBas);

	paramVoisinInclusDans = new CParamClasse("VoisinInclusDans", VOISININCLUSDANS);
	listeParamClasses->AddTail(paramVoisinInclusDans);

	export = new CExportResultats();
	donnees = new CClassifAutoDonnees();

	zoneSel = NULL;

	color = 0;

	listeTypesClasse =new CObList (10);
}

CClassifAuto::~CClassifAuto(void)
{
	delete listeZonesSelectionnees;

	delete listeParamCarac;
	delete paramRapportLsurH;
	delete paramNbElements;
	delete paramRapportHsurHmoyCC;
	delete paramLargeurZone;
	delete paramHauteurZone;
	delete paramDensitePixBlanc;
	delete paramDensiteNdgSurNbPix;
	delete paramDegreGauche;
	delete paramDegreDroite;
	delete paramDegreHaut;
	delete paramDegreBas;
	delete paramDegreCentreP;
	delete paramDegreCentreL;
	delete paramDegreCentreH;


	delete paramClasse;
	delete paramVoisinGauche;
	delete paramVoisinDroite;
	delete paramVoisinHaut;
	delete paramVoisinBas;
	delete paramVoisinInclusDans;

	delete export;
	delete donnees;

	delete listeTypesClasse;
	delete listeParamClasses;
}

void CClassifAuto::getCopieDonnees(CClassifAutoDonnees *donneesIn)
{
	//remplir donneesIn avec donnees

	POSITION posMin = donnees->getListeMin()->GetHeadPosition();
	while (posMin)
	{
		donneesIn->getListeMin()->AddTail((double)donnees->getListeMin()->GetNext(posMin));
	}

	POSITION posMax = donnees->getListeMax()->GetHeadPosition();
	while (posMax)
	{
		donneesIn->getListeMax()->AddTail((double)donnees->getListeMax()->GetNext(posMax));
	}

	POSITION posBInf = donnees->getListeBorneInf()->GetHeadPosition();
	while (posBInf)
	{
		donneesIn->getListeBorneInf()->AddTail((double)donnees->getListeBorneInf()->GetNext(posBInf));
	}

	POSITION posBSup = donnees->getListeBorneSup()->GetHeadPosition();
	while (posBSup)
	{
		donneesIn->getListeBorneSup()->AddTail((double)donnees->getListeBorneSup()->GetNext(posBSup));
	}

	POSITION posVar = donnees->getListeVariance()->GetHeadPosition();
	while (posVar)
	{
		donneesIn->getListeVariance()->AddTail((double)donnees->getListeVariance()->GetNext(posVar));
	}

	POSITION posEType = donnees->getListeEcartType()->GetHeadPosition();
	while (posEType)
	{
		donneesIn->getListeEcartType()->AddTail((double)donnees->getListeEcartType()->GetNext(posEType));
	}

	POSITION posMoy = donnees->getListeMoyenne()->GetHeadPosition();
	while (posMoy)
	{
		donneesIn->getListeMoyenne()->AddTail((double)donnees->getListeMoyenne()->GetNext(posMoy));
	}

	POSITION posMed = donnees->getListeMediane()->GetHeadPosition();
	while (posMed)
	{
		donneesIn->getListeMediane()->AddTail((double)donnees->getListeMediane()->GetNext(posMed));
	}

	POSITION posValCaracMin = donnees->getListeValCaracMin()->GetHeadPosition();
	while (posValCaracMin)
	{
		donneesIn->getListeValCaracMin()->AddTail((double)donnees->getListeValCaracMin()->GetNext(posValCaracMin));
	}

	POSITION posValCaracMax = donnees->getListeValCaracMax()->GetHeadPosition();
	while (posValCaracMax)
	{
		donneesIn->getListeValCaracMax()->AddTail((double)donnees->getListeValCaracMax()->GetNext(posValCaracMax));
	}

	POSITION posValGeo = donnees->getListeValGeo()->GetHeadPosition();
	while (posValGeo)
	{
		donneesIn->getListeValGeo()->AddTail((double)donnees->getListeValGeo()->GetNext(posValGeo));
	}

	POSITION posValVois = donnees->getListeValVois()->GetHeadPosition();
	while (posValVois)
	{
		donneesIn->getListeValVois()->AddTail((CTypeClasse*)donnees->getListeValVois()->GetNext(posValVois));
	}

	POSITION posETCarac = donnees->getListeEcartTypeCarac()->GetHeadPosition();
	while (posETCarac)
	{
		donneesIn->getListeEcartTypeCarac()->AddTail((double)donnees->getListeEcartTypeCarac()->GetNext(posETCarac));
	}

	POSITION posETGeo = donnees->getListeEcartTypeGeo()->GetHeadPosition();
	while (posETGeo)
	{
		donneesIn->getListeEcartTypeGeo()->AddTail((double)donnees->getListeEcartTypeGeo()->GetNext(posETGeo));
	}

	POSITION posETVois = donnees->getListeEcartTypeVois()->GetHeadPosition();
	while (posETVois)
	{
		donneesIn->getListeEcartTypeVois()->AddTail((double)donnees->getListeEcartTypeVois()->GetNext(posETVois));
	}

	POSITION posETNonIndep = donnees->getListeEcartTypeNonIndep()->GetHeadPosition();
	while (posETNonIndep)
	{
		donneesIn->getListeEcartTypeNonIndep()->AddTail((double)donnees->getListeEcartTypeNonIndep()->GetNext(posETNonIndep));
	}

	POSITION posETMoyNonIndep = donnees->getListeEcartTypeMoyNonIndep()->GetHeadPosition();
	while (posETMoyNonIndep)
	{
		donneesIn->getListeEcartTypeMoyNonIndep()->AddTail((double)donnees->getListeEcartTypeMoyNonIndep()->GetNext(posETMoyNonIndep));
	}


	donneesIn->getScenarAuto()->AjouterScenario(donnees->getScenarAuto());

	donneesIn->setTypeOrg(donnees->getTypeOrg());
	donneesIn->setTypeDest(donnees->getTypeDest());
	donneesIn->setColorDest(donnees->getColorDest());

	donneesIn->setNbZones(donnees->getNbZones());

	donneesIn->setPourcentageCaracMoy(donnees->getPourcentageCaracMoy());
	donneesIn->setIsReglesNonIndep(donnees->isReglesNonIndep());
	donneesIn->setIsValsMoyCarac(donnees->isValsMoyCarac());
	donneesIn->setIsValsMoyGeo(donnees->isValsMoyGeo());

	//donneesIn->setNbGlobalRegIndep(donnees->getNbGlobalRegIndep());
	//donneesIn->setNbGlobalRegNonIndep(donnees->getNbGlobalRegNonIndep());
	//donneesIn->setNbCaracReg(donnees->getNbCaracReg());
	//donneesIn->setNbVoisReg(donnees->getNbVoisReg());
	donneesIn->setTolGlobalRegIndep(donnees->getTolGlobalRegIndep());
	donneesIn->setTolGlobalRegNonIndep(donnees->getTolGlobalRegNonIndep());
	donneesIn->setTolCaracReg(donnees->getTolCaracReg());
	donneesIn->setTolVoisReg(donnees->getTolVoisReg());

	donneesIn->setNbMaxCaracReg(donnees->getNbMaxCaracReg());
	donneesIn->setNbMaxGeoReg(donnees->getNbMaxGeoReg());
	donneesIn->setNbMaxVoisReg(donnees->getNbMaxVoisReg());
	donneesIn->setNbMaxGlobalRegIndep(donnees->getNbMaxGlobalRegIndep());
	donneesIn->setNbMaxGlobalRegNonIndep(donnees->getNbMaxGlobalRegNonIndep());
	
	donneesIn->setTabPosETGlobalIndep(donnees->getTabPosETGlobalIndep());
	donneesIn->setTabPosETGlobalNonIndep(donnees->getTabPosETGlobalNonIndep());
	donneesIn->setTabPosETCarac(donnees->getTabPosETCarac());
	donneesIn->setTabPosETGeo(donnees->getTabPosETGeo());
	donneesIn->setTabPosETVois(donnees->getTabPosETVois());
}

void CClassifAuto::setCopieDonnees(CClassifAutoDonnees *donneesIn)
{
	//remplir donnees avec donneesIn
	POSITION posMin = donneesIn->getListeMin()->GetHeadPosition();
	while (posMin)
	{
		donnees->getListeMin()->AddTail((double)donneesIn->getListeMin()->GetNext(posMin));
	}

	POSITION posMax = donneesIn->getListeMax()->GetHeadPosition();
	while (posMax)
	{
		donnees->getListeMax()->AddTail((double)donneesIn->getListeMax()->GetNext(posMax));
	}

	POSITION posBInf = donneesIn->getListeBorneInf()->GetHeadPosition();
	while (posBInf)
	{
		donnees->getListeBorneInf()->AddTail((double)donneesIn->getListeBorneInf()->GetNext(posBInf));
	}

	POSITION posBSup = donneesIn->getListeBorneSup()->GetHeadPosition();
	while (posBSup)
	{
		donnees->getListeBorneSup()->AddTail((double)donneesIn->getListeBorneSup()->GetNext(posBSup));
	}

	POSITION posVar = donneesIn->getListeVariance()->GetHeadPosition();
	while (posVar)
	{
		donnees->getListeVariance()->AddTail((double)donneesIn->getListeVariance()->GetNext(posVar));
	}

	POSITION posEType = donneesIn->getListeEcartType()->GetHeadPosition();
	while (posEType)
	{
		donnees->getListeEcartType()->AddTail((double)donneesIn->getListeEcartType()->GetNext(posEType));
	}

	POSITION posMoy = donneesIn->getListeMoyenne()->GetHeadPosition();
	while (posMoy)
	{
		donnees->getListeMoyenne()->AddTail((double)donneesIn->getListeMoyenne()->GetNext(posMoy));
	}

	POSITION posMed = donneesIn->getListeMediane()->GetHeadPosition();
	while (posMed)
	{
		donnees->getListeMediane()->AddTail((double)donneesIn->getListeMediane()->GetNext(posMed));
	}

	POSITION posValCaracMin = donneesIn->getListeValCaracMin()->GetHeadPosition();
	while (posValCaracMin)
	{
		donnees->getListeValCaracMin()->AddTail((double)donneesIn->getListeValCaracMin()->GetNext(posValCaracMin));
	}

	POSITION posValCaracMax = donneesIn->getListeValCaracMax()->GetHeadPosition();
	while (posValCaracMax)
	{
		donnees->getListeValCaracMax()->AddTail((double)donneesIn->getListeValCaracMax()->GetNext(posValCaracMax));
	}

	POSITION posValGeo = donneesIn->getListeValGeo()->GetHeadPosition();
	while (posValGeo)
	{
		donnees->getListeValGeo()->AddTail((double)donneesIn->getListeValGeo()->GetNext(posValGeo));
	}

	POSITION posValVois = donneesIn->getListeValVois()->GetHeadPosition();
	while (posValVois)
	{
		donnees->getListeValVois()->AddTail((CTypeClasse*)donneesIn->getListeValVois()->GetNext(posValVois));
	}

	POSITION posETCarac = donneesIn->getListeEcartTypeCarac()->GetHeadPosition();
	while (posETCarac)
	{
		donnees->getListeEcartTypeCarac()->AddTail((double)donneesIn->getListeEcartTypeCarac()->GetNext(posETCarac));
	}

	POSITION posETGeo = donneesIn->getListeEcartTypeGeo()->GetHeadPosition();
	while (posETGeo)
	{
		donnees->getListeEcartTypeGeo()->AddTail((double)donneesIn->getListeEcartTypeGeo()->GetNext(posETGeo));
	}

	POSITION posETVois = donneesIn->getListeEcartTypeVois()->GetHeadPosition();
	while (posETVois)
	{
		donnees->getListeEcartTypeVois()->AddTail((double)donneesIn->getListeEcartTypeVois()->GetNext(posETVois));
	}

	POSITION posETNonIndep = donneesIn->getListeEcartTypeNonIndep()->GetHeadPosition();
	while (posETNonIndep)
	{
		donnees->getListeEcartTypeNonIndep()->AddTail((double)donneesIn->getListeEcartTypeNonIndep()->GetNext(posETNonIndep));
	}

	POSITION posETMoyNonIndep = donneesIn->getListeEcartTypeMoyNonIndep()->GetHeadPosition();
	while (posETMoyNonIndep)
	{
		donnees->getListeEcartTypeMoyNonIndep()->AddTail((double)donneesIn->getListeEcartTypeMoyNonIndep()->GetNext(posETMoyNonIndep));
	}

	donnees->getScenarAuto()->AjouterScenario(donneesIn->getScenarAuto());

	donnees->setTypeOrg(donneesIn->getTypeOrg());
	donnees->setTypeDest(donneesIn->getTypeDest());
	donnees->setColorDest(donneesIn->getColorDest());

	donnees->setNbZones(donneesIn->getNbZones());

	donnees->setPourcentageCaracMoy(donneesIn->getPourcentageCaracMoy());
	donnees->setIsReglesNonIndep(donneesIn->isReglesNonIndep());
	donnees->setIsValsMoyCarac(donneesIn->isValsMoyCarac());
	donnees->setIsValsMoyGeo(donneesIn->isValsMoyGeo());

	//donnees->setNbGlobalRegIndep(donneesIn->getNbGlobalRegIndep());
	//donnees->setNbGlobalRegNonIndep(donneesIn->getNbGlobalRegNonIndep());
	//donnees->setNbCaracReg(donneesIn->getNbCaracReg());
	//donnees->setNbVoisReg(donneesIn->getNbVoisReg());
	donnees->setTolGlobalRegIndep(donneesIn->getTolGlobalRegIndep());
	donnees->setTolGlobalRegNonIndep(donneesIn->getTolGlobalRegNonIndep());
	donnees->setTolCaracReg(donneesIn->getTolCaracReg());
	donnees->setTolVoisReg(donneesIn->getTolVoisReg());

	donnees->setNbMaxCaracReg(donneesIn->getNbMaxCaracReg());
	donnees->setNbMaxGeoReg(donneesIn->getNbMaxGeoReg());
	donnees->setNbMaxVoisReg(donneesIn->getNbMaxVoisReg());
	donnees->setNbMaxGlobalRegIndep(donneesIn->getNbMaxGlobalRegIndep());
	donnees->setNbMaxGlobalRegNonIndep(donneesIn->getNbMaxGlobalRegNonIndep());
	
	donnees->setTabPosETGlobalIndep(donneesIn->getTabPosETGlobalIndep());
	donnees->setTabPosETGlobalNonIndep(donneesIn->getTabPosETGlobalNonIndep());
	donnees->setTabPosETCarac(donneesIn->getTabPosETCarac());
	donnees->setTabPosETGeo(donneesIn->getTabPosETGeo());
	donnees->setTabPosETVois(donneesIn->getTabPosETVois());
}


bool CClassifAuto::findElemListeTypesClasse(CString nom)
{
	if (!listeTypesClasse->IsEmpty())
	{
		POSITION pos = listeTypesClasse->GetHeadPosition();
		while (pos)
		{
			CTypeClasse *t = (CTypeClasse *)listeTypesClasse->GetNext(pos);

			if (t->getNomClasse() == nom)
			{
				return true;
			}
		}
	}
	return false;
}

void CClassifAuto::CalculerCaracteristique(CString etiquetteSaisie)
{
	double nul = 0;
	if (!listeZonesSelectionnees->IsEmpty())
	{
		POSITION posTemp = listeZonesSelectionnees->GetHeadPosition();
		while (posTemp)
		{

			CZone* zoneTemp = (CZone*)listeZonesSelectionnees->GetNext(posTemp);
			ASSERT_VALID(zoneTemp);

			CMyAppDoc* pDocTemp = (CMyAppDoc*)zoneTemp->m_DocContenant;
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);

	/*TEMP*/CList<CString,CString&> *listeCarac = new CList<CString,CString&>();

			CString strRapportLsurH, strNbElements, strRapportHsurHmoyCC, strLargeurZone, strHauteurZone, strDensitePixBlanc, strDensiteNdgSurNbPix;
			CString strDegreGauche, strDegreDroite, strDegreHaut, strDegreBas, strDegreCentreP, strDegreCentreL, strDegreCentreH;
			CString strClasse;
			CString strVoisinGauche, strVoisinDroite, strVoisinHaut, strVoisinBas, strVoisinInclusDans;

			
			paramRapportLsurH->addValeur(zoneTemp->getCaracCC()->getRapportLsurH());
			strRapportLsurH = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getRapportLsurH());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"RapportLsurH",strRapportLsurH);

			paramNbElements->addValeur((double)zoneTemp->getCaracCC()->getNbElements());
			strNbElements = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getNbElements());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"NbElements",strNbElements);

			paramRapportHsurHmoyCC->addValeur(zoneTemp->getCaracCC()->getRapportHsurHmoyCC());
			strRapportHsurHmoyCC = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getRapportHsurHmoyCC());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"RapportHsurHmoyCC",strRapportHsurHmoyCC);

			paramLargeurZone->addValeur((double)zoneTemp->getCaracCC()->getLargeurZone());
			strLargeurZone = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getLargeurZone());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"LargeurZone",strLargeurZone);

			paramHauteurZone->addValeur((double)zoneTemp->getCaracCC()->getHauteurZone());
			strHauteurZone = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getHauteurZone());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"HauteurZone",strHauteurZone);

			paramDensitePixBlanc->addValeur(zoneTemp->getCaracCC()->getDensitePixBlanc());
			strDensitePixBlanc = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getDensitePixBlanc());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DensitePixBlanc",strDensitePixBlanc);

			paramDensiteNdgSurNbPix->addValeur((double)zoneTemp->getCaracCC()->getDensiteNdgSurNbPix());
			strDensiteNdgSurNbPix = export->ConvertirCaracEnString(zoneTemp->getCaracCC()->getDensiteNdgSurNbPix());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DensiteNdgSurNbPix",strDensiteNdgSurNbPix);

			paramDegreGauche->addValeur(zoneTemp->getCaracCG()->getDegreGauche());
			strDegreGauche = export->ConvertirCaracEnString(zoneTemp->getCaracCG()->getDegreGauche());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreGauche",strDegreGauche);

			paramDegreDroite->addValeur(zoneTemp->getCaracCG()->getDegreDroite());
			strDegreDroite = export->ConvertirCaracEnString(zoneTemp->getCaracCG()->getDegreDroite());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreDroite",strDegreDroite);

			paramDegreHaut->addValeur(zoneTemp->getCaracCG()->getDegreHaut());
			strDegreHaut = export->ConvertirCaracEnString(zoneTemp->getCaracCG()->getDegreHaut());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreHaut",strDegreHaut);

			paramDegreBas->addValeur(zoneTemp->getCaracCG()->getDegreBas());
			strDegreBas = export->ConvertirCaracEnString(zoneTemp->getCaracCG()->getDegreBas());
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreBas",strDegreBas);

			//calcul du critere de regleCG sur le centre de la page
			CList<double> *listeDegCentreP = new CList<double>();
			double valDegCentreP = 0;
			listeDegCentreP->AddTail(zoneTemp->getCaracCG()->getDegreGauche());
			listeDegCentreP->AddTail(zoneTemp->getCaracCG()->getDegreDroite());
			listeDegCentreP->AddTail(zoneTemp->getCaracCG()->getDegreHaut());
			listeDegCentreP->AddTail(zoneTemp->getCaracCG()->getDegreBas());
			if (listeDegCentreP->Find(nul) == NULL)//aucune valeur nulle de trouve
				valDegCentreP = donnees->CalculerMoyenne(listeDegCentreP);
			//sinon valDegCentreP reste  0
			paramDegreCentreP->addValeur(valDegCentreP);
			strDegreCentreP = export->ConvertirCaracEnString(valDegCentreP);
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreCentrePage",strDegreCentreP);
			delete listeDegCentreP;

			//calcul du critere de regleCG sur le centre de la largeur
			CList<double> *listeDegCentreL = new CList<double>();
			double valDegCentreL = 0;
			listeDegCentreL->AddTail(zoneTemp->getCaracCG()->getDegreGauche());
			listeDegCentreL->AddTail(zoneTemp->getCaracCG()->getDegreDroite());
			if (listeDegCentreL->Find(nul) == NULL)//aucune valeur nulle de trouve
				valDegCentreL = donnees->CalculerMoyenne(listeDegCentreL);
			//sinon valDegCentreL reste  0
			paramDegreCentreL->addValeur(valDegCentreL);
			strDegreCentreL = export->ConvertirCaracEnString(valDegCentreL);
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreCentreLargeur",strDegreCentreL);
			delete listeDegCentreL;

			//calcul du critere de regleCG sur le centre de la hauteur
			CList<double> *listeDegCentreH = new CList<double>();
			double valDegCentreH = 0;
			listeDegCentreH->AddTail(zoneTemp->getCaracCG()->getDegreHaut());
			listeDegCentreH->AddTail(zoneTemp->getCaracCG()->getDegreBas());
			if (listeDegCentreH->Find(nul) == NULL)//aucune valeur nulle de trouve
				valDegCentreH = donnees->CalculerMoyenne(listeDegCentreH);
			//sinon valDegCentreP reste  0
			paramDegreCentreH->addValeur(valDegCentreH);
			strDegreCentreH = export->ConvertirCaracEnString(valDegCentreH);
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"DegreCentreHauteur",strDegreCentreH);
			delete listeDegCentreH;



			int numClasseTemp0 = TrouverNumClasse(zoneTemp->getClasse()->getNomClasse());
			paramClasse->addValeur(numClasseTemp0);
			strClasse = zoneTemp->getClasse()->getNomClasse();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"Classe",strClasse);

			int numClasseTemp3 = TrouverNumClasse(zoneTemp->getCaracCV()->getClasseVoisinHaut());
			paramVoisinHaut->addValeur(numClasseTemp3);
			strVoisinHaut = zoneTemp->getCaracCV()->getClasseVoisinHaut();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"VoisinHaut",strVoisinHaut);

			int numClasseTemp1 = TrouverNumClasse(zoneTemp->getCaracCV()->getClasseVoisinGauche());
			paramVoisinGauche->addValeur(numClasseTemp1);
			strVoisinGauche = zoneTemp->getCaracCV()->getClasseVoisinGauche();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"VoisinGauche",strVoisinGauche);

			int numClasseTemp4 = TrouverNumClasse(zoneTemp->getCaracCV()->getClasseVoisinBas());
			paramVoisinBas->addValeur(numClasseTemp4);
			strVoisinBas = zoneTemp->getCaracCV()->getClasseVoisinBas();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"VoisinBas",strVoisinBas);

			int numClasseTemp2 = TrouverNumClasse(zoneTemp->getCaracCV()->getClasseVoisinDroite());
			paramVoisinDroite->addValeur(numClasseTemp2);
			strVoisinDroite = zoneTemp->getCaracCV()->getClasseVoisinDroite();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"VoisinDroite",strVoisinDroite);

			int numClasseTemp5 = TrouverNumClasse(zoneTemp->getCaracCV()->getClasseVoisinInclusDans());
			paramVoisinInclusDans->addValeur(numClasseTemp5);
			strVoisinInclusDans = zoneTemp->getCaracCV()->getClasseVoisinInclusDans();
	/*TEMP*/export->EcrireChaqueCaracParFichier(etiquetteSaisie,pDocTemp->m_nom,"VoisinInclusDans",strVoisinInclusDans);




			//******************* TEMPORAIRE ********************
			listeCarac->AddTail(strRapportLsurH);
			listeCarac->AddTail(strNbElements);
			listeCarac->AddTail(strRapportHsurHmoyCC);
			listeCarac->AddTail(strLargeurZone);
			listeCarac->AddTail(strHauteurZone);
			listeCarac->AddTail(strDensitePixBlanc);
			listeCarac->AddTail(strDensiteNdgSurNbPix);
			listeCarac->AddTail(strDegreGauche);
			listeCarac->AddTail(strDegreDroite);
			listeCarac->AddTail(strDegreHaut);
			listeCarac->AddTail(strDegreBas);
			listeCarac->AddTail(strDegreCentreP);
			listeCarac->AddTail(strDegreCentreL);
			listeCarac->AddTail(strDegreCentreH);
			listeCarac->AddTail(strClasse);
			listeCarac->AddTail(strVoisinHaut);
			listeCarac->AddTail(strVoisinGauche);
			listeCarac->AddTail(strVoisinBas);
			listeCarac->AddTail(strVoisinDroite);
			listeCarac->AddTail(strVoisinInclusDans);
			export->EcrireToutesCaracGroupees(etiquetteSaisie,pDocTemp->m_nom,listeCarac);

			
			delete listeCarac;
			pDocTemp->DeleteContents();
			//***************************************************

		}
	}

}

int CClassifAuto::TrouverNumClasse(CString nomClasse)
{
	int numClasseTrouve = -1;

	if (nomClasse == "NULL")
	{
		return numClasseTrouve;
	}

	

	POSITION posClasse = listeTypesClasse->GetHeadPosition();
	while(posClasse)
	{
		CTypeClasse *classeTemp = (CTypeClasse *)listeTypesClasse->GetNext(posClasse);
		if (classeTemp->getNomClasse() == nomClasse)
		{
			numClasseTrouve = classeTemp->getNumClasse();
			return numClasseTrouve;
		}
	}
	return numClasseTrouve;
}

void CClassifAuto::ClasserAuto(CString etiquetteSaisie,UINT couleur)
{
	//afecte la couleur choisie
	donnees->setColorDest(couleur);
	//recopie la liste des types de classe dans celle de la classif auto
	listeTypesClasse->RemoveAll();
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getCopieListeTypesClasse(listeTypesClasse);
	//remize a zero du scenarioAuto :
	donnees->getScenarAuto()->EffacerTout();
	//Calculs
	CalculerCaracteristique(etiquetteSaisie);
	CalculerBornes();
	DeterminerClasse();
	//maj des donnees:
	donnees->setTypeDest(etiquetteSaisie);
	donnees->setTypeOrg(classeSynthetisee->getNomClasse());
	//Recalculs
	CalculerParametres();
	TrierEcartsType(etiquetteSaisie,couleur);
}

void CClassifAuto::TrierEcartsType(CString etiquetteSaisie,UINT couleur)
{
	donnees->CalculerAll(listeParamCarac,listeParamClasses);

	int nb = 0;
	int i=0,j=0,k=0;

	if (donnees->isReglesNonIndep())
	{
		//rgles lies
		//grouper les val par regle
		nb = donnees->getNbMaxGlobalRegNonIndep();
		for (i=0 ; i<nb ; i++)
		{
			int numeroReg = (donnees->getTabPosETGlobalNonIndep())[i];

			//creation de regle
			DeterminerRegleNonIndep(etiquetteSaisie, couleur, numeroReg);

			//ajout de la regle de calcul des caractristiques apres chaque regle auto
			CRegleCarac *r1=new CRegleCarac();
			donnees->getScenarAuto()->Ajouter(r1);
		}
		
	}else
	{
		//rgles indpendantes
		nb = donnees->getNbMaxGlobalRegIndep();
		//cration des regles
		for (i=0 ; i<nb ; i++)
		{

			int numeroCarac = (donnees->getTabPosETGlobalIndep())[i];

			DeterminerRegleIndep(etiquetteSaisie, couleur, numeroCarac);

			//ajout de la regle de calcul des caractristiques apres chaque regle auto
			CRegleCarac *r1=new CRegleCarac();
			donnees->getScenarAuto()->Ajouter(r1);

		}
	}

	ExporterListes(etiquetteSaisie);
}

void CClassifAuto::DeterminerRegleIndep(CString etiquetteSaisie,UINT couleur,int numeroCarac)
{
	//creation de la classe de destination si elle n'existe pas
	bool typeSiExiste = findElemListeTypesClasse(etiquetteSaisie);
	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(etiquetteSaisie,couleur);
		donnees->getScenarAuto()->Ajouter(r1);
		//on ne l'execute pas car toutes les regles de la classif auto
		//sont executes dans DlgAssist3
		//par contre on doit savoir ici que le nouveau a t ajout:
		int num = listeTypesClasse->GetCount();
		CTypeClasse* newType = new CTypeClasse(etiquetteSaisie,couleur,num);
		listeTypesClasse->AddTail(newType);
	}

	CString etiquetteOrg = classeSynthetisee->getNomClasse();
	UINT couleurOrg = classeSynthetisee->getColor();
	double val = -1;
	double valMin = -1;
	double valMax = -1;
	CString voisStr = "NULL";
	CList<CString,CString> *listeVoisins = new CList<CString,CString>();
	CList<CString,CString> *listeVide = new CList<CString,CString>();
	CRegleCC *a;
	CRegleCG *b;
	CRegleCV *c;

	listeVoisins->RemoveAll();
	listeVide->RemoveAll();

	switch (numeroCarac)
	{
		//regleCC
	case RAPPORTLSURH :
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),RAPPORTLSURH_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),RAPPORTLSURH_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,valMin,valMax,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case NBELEMENTS :
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),NBELEMENTS_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),NBELEMENTS_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,(int)valMin,(int)valMax,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case RAPPORTHSURHMOYCC :
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),RAPPORTHSURHMOYCC_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),RAPPORTHSURHMOYCC_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,-1,-1,valMin,valMax,-1,-1,-1,-1,-1,-1,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case LARGEURZONE : 
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),LARGEURZONE_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),LARGEURZONE_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,-1,-1,-1,-1,(int)valMin,(int)valMax,-1,-1,-1,-1,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case HAUTEURZONE : 
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),HAUTEURZONE_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),HAUTEURZONE_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,-1,-1,-1,-1,-1,-1,(int)valMin,(int)valMax,-1,-1,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case DENSITEPIXBLANC :
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),DENSITEPIXBLANC_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),DENSITEPIXBLANC_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,valMin,valMax,-1,-1);
		donnees->getScenarAuto()->Ajouter(a);
		break;
	case DENSITENDGSURNBPIX :
		valMin = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),DENSITENDGSURNBPIX_BIS);
		valMax = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),DENSITENDGSURNBPIX_BIS);
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,(int)valMin,(int)valMax);
		donnees->getScenarAuto()->Ajouter(a);
		break;

		//regleCG
	case DEGREGAUCHE :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGREGAUCHE_BIS);
		b = new CRegleCG(etiquetteOrg,'G',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGREDROITE :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGREDROITE_BIS);
		b = new CRegleCG(etiquetteOrg,'D',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGREHAUT :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGREHAUT_BIS);
		b = new CRegleCG(etiquetteOrg,'H',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGREBAS :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGREBAS_BIS);
		b = new CRegleCG(etiquetteOrg,'B',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGRECENTREP :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGRECENTREP_BIS);
		b = new CRegleCG(etiquetteOrg,'C',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGRECENTREL :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGRECENTREL_BIS);
		b = new CRegleCG(etiquetteOrg,'O',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;
	case DEGRECENTREH :
		val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),DEGRECENTREH_BIS);
		b = new CRegleCG(etiquetteOrg,'E',(int)val,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(b);
		break;

		//regleCV
	case VOISINHAUT :
		voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),VOISINHAUT_BIS);
		if (voisStr != "NULL")
			listeVoisins->AddTail(voisStr);
		c = new CRegleCV(etiquetteOrg,listeVide,listeVide,listeVoisins,listeVide,listeVide,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;
	case VOISINGAUCHE :
		voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),VOISINGAUCHE_BIS);
		if (voisStr != "NULL")
			listeVoisins->AddTail(voisStr);
		c = new CRegleCV(etiquetteOrg,listeVoisins,listeVide,listeVide,listeVide,listeVide,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;
	case VOISINBAS :
		voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),VOISINBAS_BIS);
		if (voisStr != "NULL")
			listeVoisins->AddTail(voisStr);
		c = new CRegleCV(etiquetteOrg,listeVide,listeVide,listeVide,listeVoisins,listeVide,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;
	case VOISINDROITE :
		voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),VOISINDROITE_BIS);
		if (voisStr != "NULL")
			listeVoisins->AddTail(voisStr);
		c = new CRegleCV(etiquetteOrg,listeVide,listeVoisins,listeVide,listeVide,listeVide,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;
	case VOISININCLUSDANS :
		voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),VOISININCLUSDANS_BIS);
		if (voisStr != "NULL")
			listeVoisins->AddTail(voisStr);
		c = new CRegleCV(etiquetteOrg,listeVide,listeVide,listeVide,listeVide,listeVoisins,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;

	default :
		break;
	}
}

void CClassifAuto::DeterminerRegleNonIndep(CString etiquetteSaisie,UINT couleur,int numeroReg)
{
	//creation de la classe de destination si elle n'existe pas
	bool typeSiExiste = findElemListeTypesClasse(etiquetteSaisie);
	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(etiquetteSaisie,couleur);
		donnees->getScenarAuto()->Ajouter(r1);
		//on ne l'execute pas car toutes les regles de la classif auto
		//sont executes dans DlgAssist3
		//par contre on doit savoir ici que le nouveau a t ajout:
		int num = listeTypesClasse->GetCount();
		CTypeClasse* newType = new CTypeClasse(etiquetteSaisie,couleur,num);
		listeTypesClasse->AddTail(newType);
	}

	CString etiquetteOrg = classeSynthetisee->getNomClasse();
	UINT couleurOrg = classeSynthetisee->getColor();
	double val = -1;
	CString voisStr = "NULL";
	double valMin0 = -1,valMin1 = -1,valMin2 = -1,valMin3 = -1,valMin4 = -1,valMin5 = -1,valMin6 = -1;
	double valMax0 = -1,valMax1 = -1,valMax2 = -1,valMax3 = -1,valMax4 = -1,valMax5 = -1,valMax6 = -1;
	int nb = 0, i=0;
	CList<CString,CString> *listeVH,*listeVG,*listeVB,*listeVD,*listeVI;
	listeVH	= new CList<CString,CString>();
	listeVG	= new CList<CString,CString>();
	listeVB	= new CList<CString,CString>();
	listeVD	= new CList<CString,CString>();
	listeVI	= new CList<CString,CString>();
	CRegleCC *a;
	CRegleCG *b;
	CRegleCV *c;

	switch (numeroReg)
	{
		//regleCC
	case REGCARAC_BIS :
		nb = donnees->getNbMaxCaracReg();
		for (i=0 ; i<nb ; i++)
		{
			int numeroCarac = (donnees->getTabPosETCarac())[i];

			if (numeroCarac == RAPPORTLSURH_BIS)
			{
				valMin0 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax0 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == NBELEMENTS_BIS)
			{
				valMin1 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax1 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == RAPPORTHSURHMOYCC_BIS)
			{
				valMin2 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax2 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == LARGEURZONE_BIS)
			{
				valMin3 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax3 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == HAUTEURZONE_BIS)
			{
				valMin4 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax4 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == DENSITEPIXBLANC_BIS)
			{
				valMin5 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax5 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}
			if (numeroCarac == DENSITENDGSURNBPIX_BIS)
			{
				valMin6 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMin(),numeroCarac);
				valMax6 = donnees->GetValListeDoubleAt(donnees->getListeValCaracMax(),numeroCarac);
			}

		}
		a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,valMin0,valMax0,(int)valMin1,(int)valMax1,valMin2,valMax2,(int)valMin3,(int)valMax3,(int)valMin4,(int)valMax4,valMin5,valMax5,(int)valMin6,(int)valMax6);
		donnees->getScenarAuto()->Ajouter(a);
		break;

		//regleCG
	case REGGEO_BIS :
		//pour la classif geo, une seule regle est cre (ici : en mode non indep)
		nb = donnees->getNbMaxGeoReg();
		for (i=0 ; i<nb ; i++)
		{
			
			int numeroCarac = (donnees->getTabPosETGeo())[i];
			if (numeroCarac == DEGREGAUCHE_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'G',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGREDROITE_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'D',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGREHAUT_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'H',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGREBAS_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'B',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGRECENTREP_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'C',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGRECENTREL_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'O',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			if (numeroCarac == DEGRECENTREH_BIS)
			{
				val = donnees->GetValListeDoubleAt(donnees->getListeValGeo(),numeroCarac);
				//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
				if (val != 0) val += 1; 
				b = new CRegleCG(etiquetteOrg,'E',(int)val,etiquetteSaisie,etiquetteOrg);
			}
			
		}
		donnees->getScenarAuto()->Ajouter(b);
		break;

		//regleCV
	case REGVOIS_BIS :
		nb = donnees->getNbMaxVoisReg();
		for (i=0 ; i<nb ; i++)
		{
			int numeroCarac = (donnees->getTabPosETVois())[i];

			if (numeroCarac == VOISINHAUT_BIS)
			{
				voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),numeroCarac);
				if (voisStr != "NULL")
					listeVH->AddTail(voisStr);
			}
			if (numeroCarac == VOISINGAUCHE_BIS)
			{
				voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),numeroCarac);
				if (voisStr != "NULL")
					listeVG->AddTail(voisStr);
			}
			if (numeroCarac == VOISINBAS_BIS)
			{
				voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),numeroCarac);
				if (voisStr != "NULL")
					listeVB->AddTail(voisStr);
			}
			if (numeroCarac == VOISINDROITE_BIS)
			{
				voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),numeroCarac);
				if (voisStr != "NULL")
					listeVD->AddTail(voisStr);
			}
			if (numeroCarac == VOISININCLUSDANS_BIS)
			{
				voisStr = donnees->GetValListeCTypeClasseAt(donnees->getListeValVois(),numeroCarac);
				if (voisStr != "NULL")
					listeVI->AddTail(voisStr);
			}
			
		}
		c = new CRegleCV(etiquetteOrg,listeVG,listeVD,listeVH,listeVB,listeVI,etiquetteSaisie,etiquetteOrg);
		donnees->getScenarAuto()->Ajouter(c);
		break;

	default :
		break;
	}
}

void CClassifAuto::ExporterListes(CString etiquetteSaisie)
{
	//******************* TEMPORAIRE ********************
	export->EcrireCalculs(etiquetteSaisie,donnees->getListeBorneInf(),
		donnees->getListeBorneSup(),
		donnees->getListeMin(),
		donnees->getListeMax(),
		donnees->getListeVariance(),
		donnees->getListeEcartType(),
		donnees->getListeMoyenne(),
		donnees->getListeMediane());
	//***************************************************

	POSITION posClasses = listeParamClasses->GetHeadPosition();
	while (posClasses)
	{
		CParamClasse * paramClasseTemp = (CParamClasse *)listeParamClasses->GetNext(posClasses);

		if (paramClasseTemp->getClasseChoisie() != NULL)
		{
			switch (paramClasseTemp->getNumCarac())
			{
				case CLASSE : cl = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				case VOISINHAUT : clVH = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				case VOISINGAUCHE : clVG = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				case VOISINBAS : clVB = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				case VOISINDROITE : clVD = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				case VOISININCLUSDANS : clVI = paramClasseTemp->getClasseChoisie()->getNomClasse(); break;
				default : 
					cl = "ERROR"; clVG = "ERROR"; clVD = "ERROR"; clVH = "ERROR"; clVB = "ERROR"; clVI = "ERROR";
					break;
			}
		}else
		{
			switch (paramClasseTemp->getNumCarac())
			{
				case CLASSE : cl = "NULL"; break;
				case VOISINHAUT : clVH = "NULL"; break;
				case VOISINGAUCHE : clVG = "NULL"; break;
				case VOISINBAS : clVB = "NULL"; break;
				case VOISINDROITE : clVD = "NULL"; break;
				case VOISININCLUSDANS : clVI = "NULL"; break;
				default : 
					cl = "ERROR"; clVG = "ERROR"; clVD = "ERROR"; clVH = "ERROR"; clVB = "ERROR"; clVI = "ERROR";
					break;
			}
		}
		
	}
	//******************* TEMPORAIRE ********************
	export->EcrireCalculsClasses(etiquetteSaisie,cl,clVG,clVD,clVH,clVB,clVI);
	//***************************************************
}



void CClassifAuto::DeterminerClasse()
{
	int numClasse;
	paramClasse->ToutCalculer(listeTypesClasse);

	classeSynthetisee = paramClasse->getClasseChoisie();
}



void CClassifAuto::CalculerBornes()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CObList *liste_docs;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_docs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		break;
	case LABOCLASSIF :
		liste_docs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		break;
	case LABOPROJET :
		liste_docs = pAppTemp->projet->getLaboProj()->getListeDocsLaboProj();
		break;
	default :
		AfxMessageBox("Error while loading clusters for bound computing process.");
		break;
	}

	POSITION posClasse = listeTypesClasse->GetHeadPosition();
	while(posClasse)
	{
		CTypeClasse *classeTemp = (CTypeClasse *)listeTypesClasse->GetNext(posClasse);

		CList<int> *listeNbElementsTemp = new CList<int>();
		CList<int> *listeLargeurZoneTemp = new CList<int>();
		CList<int> *listeHauteurZoneTemp = new CList<int>();

		int *nbElementsBornesTemp = new int[2];
		int *largeurZoneBornesTemp = new int[2];
		int *hauteurZoneBornesTemp = new int[2];

		POSITION posDoc = liste_docs->GetHeadPosition();
		while(posDoc)
		{
			CMyAppDoc *pDocTemp = (CMyAppDoc *)liste_docs->GetNext(posDoc);

			POSITION posZone = pDocTemp->atelier->liste_de_zones->liste->GetHeadPosition();
			while(posZone)
			{
				CZone *pZoneTemp = (CZone *)pDocTemp->atelier->liste_de_zones->liste->GetNext(posZone);
				if (pZoneTemp->getClasse()->getNomClasse() == classeTemp->getNomClasse())
				{
					listeNbElementsTemp->AddTail(pZoneTemp->getCaracCC()->getNbElements());
					listeLargeurZoneTemp->AddTail(pZoneTemp->getCaracCC()->getLargeurZone());
					listeHauteurZoneTemp->AddTail(pZoneTemp->getCaracCC()->getHauteurZone());
				}
			}
		}
		nbElementsBornesTemp[0] = CalculerMIN(listeNbElementsTemp);
		nbElementsBornesTemp[1] = CalculerMAX(listeNbElementsTemp);
		largeurZoneBornesTemp[0] = CalculerMIN(listeLargeurZoneTemp);
		largeurZoneBornesTemp[1] = CalculerMAX(listeLargeurZoneTemp);
		hauteurZoneBornesTemp[0] = CalculerMIN(listeHauteurZoneTemp);
		hauteurZoneBornesTemp[1] = CalculerMAX(listeHauteurZoneTemp);

		classeTemp->setNbElementsBornes(nbElementsBornesTemp[0],nbElementsBornesTemp[1]);
		classeTemp->setLargeurZoneBornes(largeurZoneBornesTemp[0],largeurZoneBornesTemp[1]);
		classeTemp->setHauteurZoneBornes(hauteurZoneBornesTemp[0],hauteurZoneBornesTemp[1]);

		delete listeNbElementsTemp;
		delete listeLargeurZoneTemp;
		delete listeHauteurZoneTemp;

		delete nbElementsBornesTemp;
		delete largeurZoneBornesTemp;
		delete hauteurZoneBornesTemp;
	}
}

int CClassifAuto::CalculerMIN(CList<int> *listeACalculer)
{
	int mini = 0;
	if (!listeACalculer->IsEmpty())
	{
		POSITION posMini = listeACalculer->GetHeadPosition();
		mini = 10000000000;
		while(posMini)
		{
			int temp = (int)listeACalculer->GetNext(posMini);
			if (temp < mini) mini = temp;
		}
	}else
	{
		mini = 0;
	}
	return mini;
}

int CClassifAuto::CalculerMAX(CList<int> *listeACalculer)
{
	int maxi = 0;
	if (!listeACalculer->IsEmpty())
	{
		POSITION posMaxi = listeACalculer->GetHeadPosition();
		maxi = -10000000000;
		while(posMaxi)
		{
			int temp = (int)listeACalculer->GetNext(posMaxi);
			if (temp > maxi) maxi = temp;
		}
	}else
	{
		maxi = 0;
	}
	return maxi;
}

void CClassifAuto::CalculerParametres()
{
	paramRapportLsurH->ToutCalculer();
	paramNbElements->ToutCalculer();
	paramRapportHsurHmoyCC->ToutCalculer();
	paramLargeurZone->ToutCalculer();
	paramHauteurZone->ToutCalculer();
	paramDensitePixBlanc->ToutCalculer();
	paramDensiteNdgSurNbPix->ToutCalculer();

	paramDegreGauche->ToutCalculer();
	paramDegreDroite->ToutCalculer();
	paramDegreHaut->ToutCalculer();
	paramDegreBas->ToutCalculer();
	paramDegreCentreP->ToutCalculer();
	paramDegreCentreL->ToutCalculer();
	paramDegreCentreH->ToutCalculer();
	
	paramVoisinHaut->ToutCalculer(listeTypesClasse);
	paramVoisinGauche->ToutCalculer(listeTypesClasse);
	paramVoisinBas->ToutCalculer(listeTypesClasse);
	paramVoisinDroite->ToutCalculer(listeTypesClasse);
	paramVoisinInclusDans->ToutCalculer(listeTypesClasse);
}




void CClassifAuto::RAZListeZonesSelectionnees()
{
	listeZonesSelectionnees->RemoveAll();
}


int CClassifAuto::FiltrerListeZoneSel(CListBox* listTemp, CString &nomImZoneSel)
{
	int numZoneSel = 0;

	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
	if (listTemp->GetCount() != 0)
	{
		int indexLigneSel = listTemp->GetCurSel();
		if(indexLigneSel != LB_ERR)
		{
			CString texteLigneSel = "";
			listTemp->GetText(indexLigneSel,texteLigneSel);


			CString strCopie=texteLigneSel;
			char *pWord = strtok(strCopie.GetBuffer(0), " ");
			int cpt = 0;

			while( pWord != NULL )
			{
				CString strTemp;
				strTemp = pWord;
				if ((strTemp != "sur") && (cpt == 1))
				{
					numZoneSel = strtod( strTemp, NULL );
				}
				if ((strTemp != "sur") && (cpt != 0))
				{
					nomImZoneSel = strTemp;
				}

				pWord = strtok( NULL, " " );
				cpt ++;
			} 
			strCopie.ReleaseBuffer();
		}
	}
	return numZoneSel;
}

CMyAppDoc* CClassifAuto::TrouverDocAvecImg(CString nomImZoneSel)
{
	CMyAppDoc* pDoc;
	POSITION posTemp = listeZonesSelectionnees->GetHeadPosition();
	while (posTemp) {
		POSITION posZoneSelASuppr = posTemp;
		CZone* zoneSelASuppr = (CZone*)listeZonesSelectionnees->GetNext(posTemp);
		CMyAppDoc *pDocContenantZoneSel = (CMyAppDoc *)zoneSelASuppr->m_DocContenant;
		POSITION posView = pDocContenantZoneSel->GetFirstViewPosition();
		CMyAppView* pViewTemp = (CMyAppView*)pDocContenantZoneSel->GetNextView(posView);
		ASSERT(pViewTemp);
		if (pDocContenantZoneSel->m_nom == nomImZoneSel)
		{   
			pDoc = pDocContenantZoneSel;
		}
	}

	if (pDoc) return pDoc;
	else return NULL;
}

CZone* CClassifAuto::TrouverZoneAvecDoc(CMyAppDoc* pDoc, int numZoneSel)
{
	CZone* pZone;
	POSITION posTemp = listeZonesSelectionnees->GetHeadPosition();
	while (posTemp) {
		CZone* zoneSelASurl = (CZone*)listeZonesSelectionnees->GetNext(posTemp);
		if (zoneSelASurl->m_DocContenant == pDoc)
		{
			if (zoneSelASurl->getZone() == numZoneSel)
			{
				pZone = zoneSelASurl;
			}
		}
	}

	if (pZone) return pZone;
	else return NULL;
}

void CClassifAuto::SurlignerZoneSel(CMyAppView* pViewAssociee)
{
	CPoint *offset=new CPoint(pViewAssociee->GetScrollPosition());
	if (zoneSel)
		if (pViewAssociee->GetDocument() == (CMyAppDoc*)zoneSel->m_DocContenant)
			zoneSel->SurlignerZone(pViewAssociee->GetDC(),pViewAssociee->m_zoomcoeff,RGB(200,100,255),offset);
}

void CClassifAuto::SupprimerZoneSel(CZone* pZoneASuppr)
{
	POSITION posTemp = listeZonesSelectionnees->GetHeadPosition();
	while (posTemp) {
		POSITION posZoneSelASuppr = posTemp;
		CZone* zoneTemp = (CZone*)listeZonesSelectionnees->GetNext(posTemp);
		if (zoneTemp == pZoneASuppr)
		{
			listeZonesSelectionnees->RemoveAt(posZoneSelASuppr);
		}
	}
}

void CClassifAuto::EffacerZonesSelAvecDoc(CMyAppDoc* pDoc)
{
	CObList* listeZones = pDoc->atelier->liste_de_zones->liste;
	POSITION posDocZone = listeZones->GetHeadPosition();
	while (posDocZone)
	{
		CZone* zoneDoc = (CZone*)listeZones->GetNext(posDocZone);

		POSITION posTemp = listeZonesSelectionnees->GetHeadPosition();
		while (posTemp) {
			POSITION posZoneSelASuppr = posTemp;
			CZone* zoneSel = (CZone*)listeZonesSelectionnees->GetNext(posTemp);
			if (zoneSel == zoneDoc)
			{
				listeZonesSelectionnees->RemoveAt(posZoneSelASuppr);
			}
		}
	}
}

void CClassifAuto::EffacerListeZonesSelAvecDoc(CListBox* listTemp, CMyAppDoc* pDoc)
{
	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();

	int maxListe, i, j, k;
	int tabZoneAEff[256];
	maxListe = listTemp->GetCount();

	k = 0;
	if (maxListe != 0)
	{
		for (i = 0 ; i < maxListe ; i++)
		{
			CString nomImZoneSel = "";
			CString texteLigneSel = "";
			listTemp->GetText(i,texteLigneSel);

			CString strCopie=texteLigneSel;
			char *pWord = strtok(strCopie.GetBuffer(0), " ");
			int cpt = 0;

			while( pWord != NULL )
			{
				CString strTemp;
				strTemp = pWord;
				if ((strTemp != "sur") && (cpt == 1))
				{
					//rien a faire
				}
				if ((strTemp != "sur") && (cpt != 0))
				{
					nomImZoneSel = strTemp;
				}

				pWord = strtok( NULL, " " );
				cpt ++;
			} 
			strCopie.ReleaseBuffer();

			if (nomImZoneSel == pDoc->m_nom)
			{
				tabZoneAEff[k] = i;
				k++;
			}
		}
		for (j = 0 ; j < k ; j++)
		{
			if (tabZoneAEff[j] != LB_ERR)
				listTemp->DeleteString(tabZoneAEff[j]);
		}
		listTemp->RedrawWindow();
	}
}

void CClassifAuto::RAZDonnees()
{
	delete donnees;
	donnees = new CClassifAutoDonnees();
}