

#pragma once

#include "MyApp.h"
#include "MyAppDoc.h"
#include "MyAppView.h"
#include "CaracCC.h"
#include "CaracCG.h"
#include "CaracCV.h"
#include "ParamCarac.h"
#include <afxtempl.h>
#include "TypeClasse.h"
#include "ParamClasse.h"
#include "ExportResultats.h"
#include "ClassifAutoDonnees.h"


class CClassifAuto
{

private:

	CObList* listeZonesSelectionnees;

	CTypeClasse *classeSynthetisee;
	CTypeClasse *classeAAttribuer;
public:
	CObList* listeParamCarac;
	CObList* listeParamClasses;

	CParamCarac *paramRapportLsurH, *paramNbElements, *paramRapportHsurHmoyCC, *paramLargeurZone, *paramHauteurZone, *paramDensitePixBlanc, *paramDensiteNdgSurNbPix;
	CParamCarac *paramDegreGauche, *paramDegreDroite, *paramDegreHaut, *paramDegreBas, *paramDegreCentreP, *paramDegreCentreL, *paramDegreCentreH;
	CParamClasse *paramClasse;
	CParamClasse *paramVoisinGauche, *paramVoisinDroite, *paramVoisinHaut, *paramVoisinBas, *paramVoisinInclusDans;
private:
	CString cl, clVG, clVD, clVH, clVB, clVI;

	CZone* zoneSel;

	CExportResultats *export;
	CClassifAutoDonnees *donnees;

	UINT color;

	CObList *listeTypesClasse;

public:

	
	void CalculerCaracteristique(CString etiquetteSaisie);

	void InitParam(CString nomDuParam);
	void CalculerParametres();
	
	void ExporterListes(CString etiquetteSaisie);
	int TrouverNumClasse(CString nomClasse);
	void DeterminerClasse();
	void CalculerBornes();
	int CalculerMAX(CList<int> *listeACalculer);
	int CalculerMIN(CList<int> *listeACalculer);

	bool findElemListeTypesClasse(CString nom);

	

	void RAZListeZonesSelectionnees();
	int FiltrerListeZoneSel(CListBox* listTemp, CString &nomImZoneSel);
	CZone* TrouverZoneAvecDoc(CMyAppDoc* pDoc, int numZoneSel);
	CMyAppDoc* TrouverDocAvecImg(CString nomImZoneSel);
	void SurlignerZoneSel(CMyAppView* pViewAssociee);
	void SupprimerZoneSel(CZone* pZoneASuppr);
	void EffacerZonesSelAvecDoc(CMyAppDoc* pDoc);
	void EffacerListeZonesSelAvecDoc(CListBox* listTemp, CMyAppDoc* pDoc);

	CObList* getListeZonesSelectionnees(){return listeZonesSelectionnees;}
	void setZoneSel(CZone* pZoneASurl){zoneSel = pZoneASurl;}
	CTypeClasse* getClasseSynthetisee(){return classeSynthetisee;}
	CTypeClasse* getClasseAAttribuer(){return classeAAttribuer;}
	CClassifAutoDonnees* getDonnees(){return donnees;}
	void getCopieDonnees(CClassifAutoDonnees *donneesIn);
	void setCopieDonnees(CClassifAutoDonnees *donneesIn);
	void RAZDonnees();
	
	void TrierEcartsType(CString etiquetteSaisie,UINT couleur);
	void DeterminerRegleIndep(CString etiquetteSaisie,UINT couleur,int numeroCarac);
	void DeterminerRegleNonIndep(CString etiquetteSaisie,UINT couleur,int numeroReg);

	void ClasserAuto(CString etiquetteSaisie,UINT couleur);

	


	CClassifAuto(void);
	~CClassifAuto(void);
};
