


#include "stdafx.h"
#include "MyApp.h"
#include "ClassifAutoDonnees.h"
//#include "MyAppDoc.h" //a commenter si il y a un CMyAppDoc dans le .h
//#include "MyAppView.h"
#include "ListeZones.h"

#include "MainFrm.h"
#include "constante.h"
#include "TypeClasse.h"



CClassifAutoDonnees::CClassifAutoDonnees(void)
{	
	listeMin = new CList<double>();
	listeMax = new CList<double>();
	listeBorneInf = new CList<double>();
	listeBorneSup = new CList<double>();
	listeVariance = new CList<double>();
	listeEcartType = new CList<double>();
	listeMoyenne = new CList<double>();
	listeMediane = new CList<double>();

	listeEcartTypeCarac = new CList<double>();
	listeEcartTypeGeo = new CList<double>();
	listeEcartTypeVois = new CList<double>();
	listeEcartTypeNonIndep = new CList<double>();
	listeEcartTypeMoyNonIndep = new CList<double>();

	listeValCaracMin = new CList<double>();
	listeValCaracMax = new CList<double>();
	listeValGeo = new CList<double>();
	listeValVois = new CObList(10); //liste de CTypeClasse

	reglesNonIndep = true;
	valsMoyCarac = true;
	valsMoyGeo = true;
	pourcentageCaracMoy = 20;	//valeurs min et max autour de la moy  20% ici
	pourcentageClasse = 70;		//seuil de prise en compte d'un voisin ou non (voisin gauche TEXTE  80% -> accept)
	//nbGlobalRegIndep = 2;
	//nbGlobalRegNonIndep = 2;
	//nbCaracReg = 4;
	//nbVoisReg = 3;
	tolGlobalRegIndep = 30;		//seuil maximum de l'ecart type
	tolGlobalRegNonIndep = 30;
	tolCaracReg = 30;
	tolVoisReg = 30;

	nbMaxCaracReg = 7;
	nbMaxGeoReg = 7;
	nbMaxVoisReg = 5;
	nbMaxGlobalRegIndep = 19;
	nbMaxGlobalRegNonIndep = 3;

	scenarAuto = new CScenario();

	nbZones = 0;
}

CClassifAutoDonnees::~CClassifAutoDonnees(void)
{
	delete listeMin;
	delete listeMax;
	delete listeBorneInf;
	delete listeBorneSup;
	delete listeVariance;
	delete listeEcartType;
	delete listeMoyenne;
	delete listeMediane;

	delete listeEcartTypeCarac;
	delete listeEcartTypeGeo;
	delete listeEcartTypeVois;
	delete listeEcartTypeNonIndep;
	delete listeEcartTypeMoyNonIndep;

	delete listeValCaracMin;
	delete listeValCaracMax;
	delete listeValGeo;
	delete listeValVois;

	delete scenarAuto;
	/*delete tabPosETGlobalIndep;
	delete tabPosETGlobalNonIndep;
	delete tabPosETCarac;
	delete tabPosETGeo;
	delete tabPosETVois;*/
}

void CClassifAutoDonnees::SupprimerValTab(int *tabIn, int position, int tailleTab)
{ 
	for (int i=0; i <tailleTab ; i++) 
	{
		if (i == position)
		{
			int tabTmp[20];
			for (int j=0 ; j< (tailleTab-(position+1)) ; j++)
			{
				tabTmp[j] = tabIn[position+1+j];
			}
			for (int k = i ; k<tailleTab-1 ; k++)
			{
				tabIn[k] = tabTmp[k-position];
			}
		}
	}
}

void CClassifAutoDonnees::CalculerListes(CObList* listeParamCarac, CObList* listeParamClasses)
{
	listeBorneInf->RemoveAll();
	listeBorneSup->RemoveAll();
	listeMin->RemoveAll();
	listeMax->RemoveAll();
	listeVariance->RemoveAll();
	listeEcartType->RemoveAll();
	listeMoyenne->RemoveAll();
	listeMediane->RemoveAll();
	listeEcartTypeNonIndep->RemoveAll();
	listeEcartTypeMoyNonIndep->RemoveAll();
	listeEcartTypeCarac->RemoveAll();
	listeEcartTypeGeo->RemoveAll();
	listeEcartTypeVois->RemoveAll();

	//listeParamCarac remplie (avec des pointeurs) dans le constructeur de ClassifAuto
	POSITION posParamCarac = listeParamCarac->GetHeadPosition();
	while(posParamCarac)
	{
		CParamCarac *paramTemp = (CParamCarac*)listeParamCarac->GetNext(posParamCarac);
		listeBorneInf->AddTail(paramTemp->getBorneInf());
		listeBorneSup->AddTail(paramTemp->getBorneSup());
		listeMin->AddTail(paramTemp->getMini());
		listeMax->AddTail(paramTemp->getMaxi());
		listeVariance->AddTail(paramTemp->getVariance());
		listeEcartType->AddTail(paramTemp->getEcartType());
		listeMoyenne->AddTail(paramTemp->getMoyenne());
		listeMediane->AddTail(paramTemp->getMediane());

		if (paramTemp->getNumCarac() < DEGREGAUCHE) listeEcartTypeCarac->AddTail(paramTemp->getEcartType());

		if (paramTemp->getNumCarac() > DENSITENDGSURNBPIX) listeEcartTypeGeo->AddTail(paramTemp->getEcartType());
	}

	double nul = 0;
	double cent = 100;
	POSITION posParamClasse = listeParamClasses->GetHeadPosition();
	while(posParamClasse)
	{
		CParamClasse *paramTemp = (CParamClasse*)listeParamClasses->GetNext(posParamClasse);
		if (paramTemp->getNumCarac() != CLASSE)
		{
			listeBorneInf->AddTail(nul);
			listeBorneSup->AddTail(nul);
			listeMin->AddTail(nul);
			listeMax->AddTail(cent);//100 car max est le critere de non prise en compte d'une caracteristique (si tout est nul)
			listeVariance->AddTail(nul);
			listeEcartType->AddTail(abs((paramTemp->getPourcentageClasse())-100));
			listeMoyenne->AddTail(nul);
			listeMediane->AddTail(nul);

			listeEcartTypeVois->AddTail(abs((paramTemp->getPourcentageClasse())-100));
		}
	}

	
}

void CClassifAutoDonnees::CalculerListeETNonIndep()
{
	listeEcartTypeMoyNonIndep->RemoveAll();
	listeEcartTypeNonIndep->RemoveAll();
	int i=0;

	//calcul de la liste des ET moyens de chacune des 3 regles non indep
	double eTMoyCarac, eTMoyGeo, eTMoyVois, eTVarCarac, eTVarGeo, eTVarVois, eTETCarac, eTETGeo, eTETVois;
	CList<double> *listeTemp = new CList<double>();
	if (nbMaxCaracReg > 0)
	{
		for (i=0 ; i<nbMaxCaracReg ; i++)
		{
			listeTemp->AddTail(GetValListeDoubleAt(listeEcartTypeCarac,tabPosETCarac[i]));
		}
		eTMoyCarac = CalculerMoyenne(listeTemp);
		eTVarCarac = CalculerVariance(listeTemp,eTMoyCarac);
		eTETCarac = CalculerEcartType(eTVarCarac);
	}else
	{
		eTMoyCarac = -1;
		eTVarCarac = -1;
		eTETCarac = -1;
	}

	listeTemp->RemoveAll();
	if (nbMaxGeoReg > 0)
	{
		for (i=0 ; i<nbMaxGeoReg ; i++)
		{
			listeTemp->AddTail(GetValListeDoubleAt(listeEcartTypeGeo,tabPosETGeo[i]));
		}
		eTMoyGeo = CalculerMoyenne(listeTemp);
		eTVarGeo = CalculerVariance(listeTemp,eTMoyGeo);
		eTETGeo = CalculerEcartType(eTVarGeo);
	}else
	{
		eTMoyGeo = -1;
		eTVarGeo = -1;
		eTETGeo = -1;
	}

	listeTemp->RemoveAll();
	if (nbMaxVoisReg > 0)
	{
		for (i=0 ; i<nbMaxVoisReg ; i++)
		{
			listeTemp->AddTail(GetValListeDoubleAt(listeEcartTypeVois,tabPosETVois[i]));
		}
		eTMoyVois = CalculerMoyenne(listeTemp);
		eTVarVois = CalculerVariance(listeTemp,eTMoyVois);
		eTETVois = CalculerEcartType(eTVarVois);
	}else
	{
		eTMoyVois = -1;
		eTVarVois = -1;
		eTETVois = -1;
	}
	
	//liste des ecart type moyens
	listeEcartTypeMoyNonIndep->AddTail(eTMoyCarac);
	listeEcartTypeMoyNonIndep->AddTail(eTMoyGeo);
	listeEcartTypeMoyNonIndep->AddTail(eTMoyVois);

	//liste des ecart type des ecart type (!!)
	listeEcartTypeNonIndep->AddTail(eTETCarac);
	listeEcartTypeNonIndep->AddTail(eTETGeo);
	listeEcartTypeNonIndep->AddTail(eTETVois);
}

double CClassifAutoDonnees::GetValListeDoubleAt(CList<double> *listeIn, int position)
{
	int nb = 0;
	double val = 0;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			val = (double)listeIn->GetAt(posOK);
			return val;
		}
		nb++;
	}
	return val;
}

void CClassifAutoDonnees::SetValListeDoubleAt(CList<double> *listeIn, int position, double val)
{
	int nb = 0;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			listeIn->SetAt(posOK,val);
		}
		nb++;
	}
}

CString CClassifAutoDonnees::GetValListeCStringAt(CList<CString,CString> *listeIn, int position)
{
	int nb = 0;
	CString val;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			val = (CString)listeIn->GetAt(posOK);
			return val;
		}
		nb++;
	}
	return val;
}

void CClassifAutoDonnees::SetValListeCStringAt(CList<CString,CString> *listeIn, int position, CString val)
{
	int nb = 0;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			listeIn->SetAt(posOK,val);
		}
		nb++;
	}
}

CString CClassifAutoDonnees::GetValListeCTypeClasseAt(CObList *listeIn, int position)
{
	int nb = 0;
	CString val;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			CTypeClasse *clTmp = (CTypeClasse*)listeIn->GetAt(posOK);
			if (clTmp != NULL)
				val = clTmp->getNomClasse();
			else
				val = "NULL";
			return val;
		}
		nb++;
	}
	return val;
}

void CClassifAutoDonnees::SetValListeCTypeClasseAt(CObList *listeIn, int position, CString valStr)
{
	int nb = 0;
	CString val;
	POSITION pos = listeIn->GetHeadPosition();
	while (pos)
	{
		POSITION posOK = pos;
		listeIn->GetNext(pos);
		if (nb == position)
		{
			CTypeClasse *clTmp = (CTypeClasse*)listeIn->GetAt(posOK);
			if (clTmp != NULL)
			{
				clTmp->setNomClasse(valStr);
				listeIn->SetAt(posOK,clTmp);
			}
		}
		nb++;
	}
}

void CClassifAutoDonnees::EliminerMauvaisesVals(int numeroReg)
{
	int nb = 0;
	int i=0,j=0;

	switch (numeroReg)
	{
		//regleCC
	case REGCARAC :
		nb = listeEcartTypeCarac->GetCount();
		nbMaxCaracReg = nb;

		//suppression des valeurs dont le max est nul
		for (i=0 ; i<nb ; i++)
		{
			//ne prendre que les regles dont le maximum n'est pas nul
			int numeroCarac = tabPosETCarac[i];
			double maximum = TrouverMaxCC(numeroCarac);
			if (maximum > 0)
			{
				//OK mais :
				//si la valeur de l'ecart type concerne est infrieure au seuil fix
				if (GetValListeDoubleAt(listeEcartTypeCarac,numeroCarac) > (tolCaracReg))
				{
					//on enleve cette caracteristique car trop faible
					int nbTmp = nbMaxCaracReg;
					SupprimerValTab(tabPosETCarac,i,nbTmp);
					nbTmp--;
					nbMaxCaracReg = nbTmp;
					nb = nbTmp;
					i--;
				}
			}else
			{
				//on enleve cette caracteristique car nulle
				int nbTmp = nbMaxCaracReg;
				SupprimerValTab(tabPosETCarac,i,nbTmp);
				nbTmp--;
				nbMaxCaracReg = nbTmp;
				nb = nbTmp;
				i--;
			}
		}
		break;

		//regleCG
	case REGGEO :
		nb = listeEcartTypeGeo->GetCount();
		nbMaxGeoReg = nb;

		//suppression des valeurs dont le max est nul
		for (i=0 ; i<nb ; i++)
		{
			//ne prendre que les regles dont le maximum n'est pas nul
			int numeroCarac = tabPosETGeo[i];
			double maximum = TrouverMaxCG(numeroCarac);
			if (maximum > 0)
			{
				//il ne faut pas faire cet enlvement car un EcartType peut etre nul si toute les valeurs sont les memes
				//if (GetValListeDoubleAt(listeValGeo,numeroCarac) == 0)
				//{
				//	//on enleve cette caracteristique car valeur nulle
				//	int nbTmp = nbMaxGeoReg;
				//	SupprimerValTab(tabPosETGeo,i,nbTmp);
				//	nbTmp--;
				//	nbMaxGeoReg = nbTmp;
				//	nb = nbTmp;
				//	i--;
				//}

				//OK mais on ne garde qu'une seule regles pour geo
				if (j > 0)
				{
					//on enleve cette caracteristique
					int nbTmp = nbMaxGeoReg;
					SupprimerValTab(tabPosETGeo,i,nbTmp);
					nbTmp--;
					nbMaxGeoReg = nbTmp;
					nb = nbTmp;
					i--;
					
				}
				j++;
			}else
			{
				//on enleve cette caracteristique car nulle
				int nbTmp = nbMaxGeoReg;
				SupprimerValTab(tabPosETGeo,i,nbTmp);
				nbTmp--;
				nbMaxGeoReg = nbTmp;
				nb = nbTmp;
				i--;
			}
		}
		break;

		//regleCV
	case REGVOIS :
		nb = listeEcartTypeVois->GetCount();
		nbMaxVoisReg = nb;

		//suppression des valeurs dont le max est nul
		for (i=0 ; i<nb ; i++)
		{
			//ne prendre que les regles dont le maximum n'est pas nul
			int numeroCarac = tabPosETVois[i];
			double maximum = TrouverMaxCV(numeroCarac);
			if (maximum > 0)
			{
				//OK mais :
				//si la valeur de l'ecart type concerne est infrieure au seuil fix
				if (GetValListeDoubleAt(listeEcartTypeVois,numeroCarac) > (tolVoisReg))
				{
					//on enleve cette caracteristique car trop faible
					int nbTmp = nbMaxVoisReg;
					SupprimerValTab(tabPosETVois,i,nbTmp);
					nbTmp--;
					nbMaxVoisReg = nbTmp;
					nb = nbTmp;
					i--;
				}
			}else
			{
				//on enleve cette caracteristique car nulle
				int nbTmp = nbMaxVoisReg;
				SupprimerValTab(tabPosETVois,i,nbTmp);
				nbTmp--;
				nbMaxVoisReg = nbTmp;
				nb = nbTmp;
				i--;
			}
		}
		break;

		//Global Indep
	case REGGLOBALINDEP :
		nb = listeEcartType->GetCount();
		nbMaxGlobalRegIndep = nb;

		//suppression des valeurs dont le max est nul
		for (i=0 ; i<nb ; i++)
		{
			//ne prendre que les regles dont le maximum n'est pas nul
			int numeroCarac = tabPosETGlobalIndep[i];
			double maximum = TrouverMax(numeroCarac);
			if (maximum > 0)
			{
				//OK mais :
				//si la valeur de l'ecart type concerne est infrieure au seuil fix
				if (GetValListeDoubleAt(listeEcartType,numeroCarac) > (tolGlobalRegIndep))
				{
					//on enleve cette caracteristique car trop faible
					int nbTmp = nbMaxGlobalRegIndep;
					SupprimerValTab(tabPosETGlobalIndep,i,nbTmp);
					nbTmp--;
					nbMaxGlobalRegIndep = nbTmp;
					nb = nbTmp;
					i--;
				}
			}else
			{
				//on enleve cette caracteristique car nulle
				int nbTmp = nbMaxGlobalRegIndep;
				SupprimerValTab(tabPosETGlobalIndep,i,nbTmp);
				nbTmp--;
				nbMaxGlobalRegIndep = nbTmp;
				nb = nbTmp;
				i--;
			}
		}
		break;

		//Global Non Indep
	case REGGLOBALNONINDEP :
		nb = listeEcartTypeNonIndep->GetCount();
		nbMaxGlobalRegNonIndep = nb;

		//suppression des valeurs dont le max est nul
		for (i=0 ; i<nb ; i++)
		{
			//ne prendre que le groupe de regles dont l'ecart type "moyen" n'est pas egal  100;
			int numeroRegSpec = tabPosETGlobalNonIndep[i];

			double eTMoy = TrouverETMoy(numeroRegSpec);
			if ((eTMoy == 100)||(eTMoy == -1))
			{
				//on enleve cette caracteristique car nulle
				int nbTmp = nbMaxGlobalRegNonIndep;
				SupprimerValTab(tabPosETGlobalNonIndep,i,nbTmp);
				nbTmp--;
				nbMaxGlobalRegNonIndep = nbTmp;
				nb = nbTmp;
				i--;
			}else
			{
				//OK mais :
				//si la valeur de l'ecart type concerne est infrieure au seuil fix

				if (GetValListeDoubleAt(listeEcartTypeNonIndep,numeroRegSpec) > (tolGlobalRegNonIndep))
				{
					//on enleve cette caracteristique car trop faible
					int nbTmp = nbMaxGlobalRegNonIndep;
					SupprimerValTab(tabPosETGlobalNonIndep,i,nbTmp);
					nbTmp--;
					nbMaxGlobalRegNonIndep = nbTmp;
					nb = nbTmp;
					i--;
				}
			}
		}
		break;

	default :
		break;
	}
}

double CClassifAutoDonnees::TrouverETMoy(int numeroRegSpec)
{
	//numeroRegSpec=0 : regleCC
	//numeroRegSpec=1 : regleCG
	//numeroRegSpec=2 : regleCV
	double eTMoy = 0;

	eTMoy = GetValListeDoubleAt(listeEcartTypeMoyNonIndep,numeroRegSpec);

	return eTMoy;
}
double CClassifAutoDonnees::TrouverMax(int numeroCarac)
{
	double max = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	switch (numeroCarac)
	{
		//regleCC
	case RAPPORTLSURH :
		max = classifAutoTmp->paramRapportLsurH->getMaxi();
		break;
	case NBELEMENTS :
		max = classifAutoTmp->paramNbElements->getMaxi();
		break;
	case RAPPORTHSURHMOYCC :
		max = classifAutoTmp->paramRapportHsurHmoyCC->getMaxi();
		break;
	case LARGEURZONE : 
		max = classifAutoTmp->paramLargeurZone->getMaxi();
		break;
	case HAUTEURZONE : 
		max = classifAutoTmp->paramHauteurZone->getMaxi();
		break;
	case DENSITEPIXBLANC :
		max = classifAutoTmp->paramDensitePixBlanc->getMaxi();
		break;
	case DENSITENDGSURNBPIX :
		max = classifAutoTmp->paramDensiteNdgSurNbPix->getMaxi();
		break;

		//regleCG
	case DEGREGAUCHE :
		max = classifAutoTmp->paramDegreGauche->getMaxi();
		break;
	case DEGREDROITE :
		max = classifAutoTmp->paramDegreDroite->getMaxi();
		break;
	case DEGREHAUT :
		max = classifAutoTmp->paramDegreHaut->getMaxi();
		break;
	case DEGREBAS :
		max = classifAutoTmp->paramDegreBas->getMaxi();
		break;
	case DEGRECENTREP :
		max = classifAutoTmp->paramDegreCentreP->getMaxi();
		break;
	case DEGRECENTREL :
		max = classifAutoTmp->paramDegreCentreL->getMaxi();
		break;
	case DEGRECENTREH :
		max = classifAutoTmp->paramDegreCentreH->getMaxi();
		break;

		//regleCV
	case VOISINHAUT :
		if (classifAutoTmp->paramVoisinHaut->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINGAUCHE :
		if (classifAutoTmp->paramVoisinGauche->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINBAS :
		if (classifAutoTmp->paramVoisinBas->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINDROITE :
		if (classifAutoTmp->paramVoisinDroite->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISININCLUSDANS :
		if (classifAutoTmp->paramVoisinInclusDans->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;

	default :
		break;
	}

	return max;
}


double CClassifAutoDonnees::TrouverMaxCC(int numeroCarac)
{
	double max = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	switch (numeroCarac)
	{
		//regleCC
	case RAPPORTLSURH_BIS :
		max = classifAutoTmp->paramRapportLsurH->getMaxi();
		break;
	case NBELEMENTS_BIS :
		max = classifAutoTmp->paramNbElements->getMaxi();
		break;
	case RAPPORTHSURHMOYCC_BIS :
		max = classifAutoTmp->paramRapportHsurHmoyCC->getMaxi();
		break;
	case LARGEURZONE_BIS : 
		max = classifAutoTmp->paramLargeurZone->getMaxi();
		break;
	case HAUTEURZONE_BIS : 
		max = classifAutoTmp->paramHauteurZone->getMaxi();
		break;
	case DENSITEPIXBLANC_BIS :
		max = classifAutoTmp->paramDensitePixBlanc->getMaxi();
		break;
	case DENSITENDGSURNBPIX_BIS :
		max = classifAutoTmp->paramDensiteNdgSurNbPix->getMaxi();
		break;

	default :
		break;
	}

	return max;
}

double CClassifAutoDonnees::TrouverMaxCG(int numeroCarac)
{
	double max = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	switch (numeroCarac)
	{
		//regleCG
	case DEGREGAUCHE_BIS :
		max = classifAutoTmp->paramDegreGauche->getMaxi();
		break;
	case DEGREDROITE_BIS :
		max = classifAutoTmp->paramDegreDroite->getMaxi();
		break;
	case DEGREHAUT_BIS :
		max = classifAutoTmp->paramDegreHaut->getMaxi();
		break;
	case DEGREBAS_BIS :
		max = classifAutoTmp->paramDegreBas->getMaxi();
		break;
	case DEGRECENTREP_BIS :
		max = classifAutoTmp->paramDegreCentreP->getMaxi();
		break;
	case DEGRECENTREL_BIS :
		max = classifAutoTmp->paramDegreCentreL->getMaxi();
		break;
	case DEGRECENTREH_BIS :
		max = classifAutoTmp->paramDegreCentreH->getMaxi();
		break;

	default :
		break;
	}

	return max;
}

double CClassifAutoDonnees::TrouverMaxCV(int numeroCarac)
{
	double max = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	switch (numeroCarac)
	{
		//regleCV
	case VOISINHAUT_BIS :
		if (classifAutoTmp->paramVoisinHaut->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINGAUCHE_BIS :
		if (classifAutoTmp->paramVoisinGauche->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINBAS_BIS :
		if (classifAutoTmp->paramVoisinBas->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISINDROITE_BIS :
		if (classifAutoTmp->paramVoisinDroite->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;
	case VOISININCLUSDANS_BIS :
		if (classifAutoTmp->paramVoisinInclusDans->getPourcentageClasse() > pourcentageClasse)
			max = 100; //valeur arbitraire suprieure  0
		break;

	default :
		break;
	}

	return max;
}

void CClassifAutoDonnees::TrierListes()
{
	TrierListe(listeEcartType, REGGLOBALINDEP);
	TrierListe(listeEcartTypeCarac, REGCARAC);
	TrierListe(listeEcartTypeGeo, REGGEO);
	TrierListe(listeEcartTypeVois, REGVOIS);
}

void CClassifAutoDonnees::CalculerAll(CObList* listeParamCarac, CObList* listeParamClasses)
{
	CalculerListes(listeParamCarac,listeParamClasses);

	CalculerSuite();
}

void CClassifAutoDonnees::CalculerSuite()
{
	scenarAuto->EffacerTout();

	TrierListes();

	EliminerMauvaisesVals(REGCARAC);
	EliminerMauvaisesVals(REGGEO);
	EliminerMauvaisesVals(REGVOIS);
	EliminerMauvaisesVals(REGGLOBALINDEP);

	//le calcul de la liste Non Indep ne se fait qu'aprs avoir limin les mauvaises regles
	CalculerListeETNonIndep();
	TrierListe(listeEcartTypeNonIndep, REGGLOBALNONINDEP);
	EliminerMauvaisesVals(REGGLOBALNONINDEP);

	CalculerValeurs();
}

void CClassifAutoDonnees::CalculerValeurs()
{
	listeValCaracMin->RemoveAll();
	listeValCaracMax->RemoveAll();
	listeValGeo->RemoveAll();
	listeValVois->RemoveAll();

	CalculerValsCarac();
	CalculerValsGeo();
	CalculerValsVois();
}

void CClassifAutoDonnees::CalculerValsCarac()
{
	double valMin = -1;
	double valMax = -1;
	double moy = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();
	listeValCaracMin->RemoveAll();
	listeValCaracMax->RemoveAll();

	//RAPPORTLSURH :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramRapportLsurH->getMoyenne();
	else
		moy = classifAutoTmp->paramRapportLsurH->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramRapportLsurH->getBorneInf()) valMin = classifAutoTmp->paramRapportLsurH->getBorneInf();
	if (valMax > classifAutoTmp->paramRapportLsurH->getBorneSup()) valMax = classifAutoTmp->paramRapportLsurH->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//NBELEMENTS :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramNbElements->getMoyenne();
	else
		moy = classifAutoTmp->paramNbElements->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramNbElements->getBorneInf()) valMin = classifAutoTmp->paramNbElements->getBorneInf();
	if (valMax > classifAutoTmp->paramNbElements->getBorneSup()) valMax = classifAutoTmp->paramNbElements->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//RAPPORTHSURHMOYCC :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramRapportHsurHmoyCC->getMoyenne();
	else
		moy = classifAutoTmp->paramRapportHsurHmoyCC->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramRapportHsurHmoyCC->getBorneInf()) valMin = classifAutoTmp->paramRapportHsurHmoyCC->getBorneInf();
	if (valMax > classifAutoTmp->paramRapportHsurHmoyCC->getBorneSup()) valMax = classifAutoTmp->paramRapportHsurHmoyCC->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//LARGEURZONE :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramLargeurZone->getMoyenne();
	else
		moy = classifAutoTmp->paramLargeurZone->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramLargeurZone->getBorneInf()) valMin = classifAutoTmp->paramLargeurZone->getBorneInf();
	if (valMax > classifAutoTmp->paramLargeurZone->getBorneSup()) valMax = classifAutoTmp->paramLargeurZone->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//HAUTEURZONE :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramHauteurZone->getMoyenne();
	else
		moy = classifAutoTmp->paramHauteurZone->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramHauteurZone->getBorneInf()) valMin = classifAutoTmp->paramHauteurZone->getBorneInf();
	if (valMax > classifAutoTmp->paramHauteurZone->getBorneSup()) valMax = classifAutoTmp->paramHauteurZone->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//DENSITEPIXBLANC :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramDensitePixBlanc->getMoyenne();
	else
		moy = classifAutoTmp->paramDensitePixBlanc->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramDensitePixBlanc->getBorneInf()) valMin = classifAutoTmp->paramDensitePixBlanc->getBorneInf();
	if (valMax > classifAutoTmp->paramDensitePixBlanc->getBorneSup()) valMax = classifAutoTmp->paramDensitePixBlanc->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);

	//DENSITENDGSURNBPIX :
	if (valsMoyCarac)
		moy = classifAutoTmp->paramDensiteNdgSurNbPix->getMoyenne();
	else
		moy = classifAutoTmp->paramDensiteNdgSurNbPix->getMediane();
	valMin = (moy-(moy*pourcentageCaracMoy/100));
	valMax = (moy+(moy*pourcentageCaracMoy/100));
	if (valMin < classifAutoTmp->paramDensiteNdgSurNbPix->getBorneInf()) valMin = classifAutoTmp->paramDensiteNdgSurNbPix->getBorneInf();
	if (valMax > classifAutoTmp->paramDensiteNdgSurNbPix->getBorneSup()) valMax = classifAutoTmp->paramDensiteNdgSurNbPix->getBorneSup();
	listeValCaracMin->AddTail(valMin);
	listeValCaracMax->AddTail(valMax);
}

void CClassifAutoDonnees::CalculerValsGeo()
{
	double val = -1;
	double moy = 0;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();
	listeValGeo->RemoveAll();

	//DEGREGAUCHE
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreGauche->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreGauche->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGREDROITE
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreDroite->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreDroite->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGREHAUT
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreHaut->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreHaut->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGREBAS
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreBas->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreBas->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGRECENTREP
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreCentreP->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreCentreP->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGRECENTREL
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreCentreL->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreCentreL->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);

	//DEGRECENTREH
	if (valsMoyGeo)
		moy = classifAutoTmp->paramDegreCentreH->getMoyenne();
	else
		moy = classifAutoTmp->paramDegreCentreH->getMediane();
	if (moy > 0.3)
	{
		val = 50.0*(1.0-moy);
		//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
		val += 1; 
	}
	else
		val = 0;
	listeValGeo->AddTail(val);
}

void CClassifAutoDonnees::CalculerValsVois()
{
	CTypeClasse *val;
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();
	listeValVois->RemoveAll();

	//VOISINHAUT
	val = classifAutoTmp->paramVoisinHaut->getClasseChoisie();
	listeValVois->AddTail(val);

	//VOISINGAUCHE
	val = classifAutoTmp->paramVoisinGauche->getClasseChoisie();
	listeValVois->AddTail(val);

	//VOISINBAS
	val = classifAutoTmp->paramVoisinBas->getClasseChoisie();
	listeValVois->AddTail(val);

	//VOISINDROITE
	val = classifAutoTmp->paramVoisinDroite->getClasseChoisie();
	listeValVois->AddTail(val);

	//VOISININCLUSDANS
	val = classifAutoTmp->paramVoisinInclusDans->getClasseChoisie();
	listeValVois->AddTail(val);
}

double CClassifAutoDonnees::CalculerMoyenne(CList<double> *listeACalculer)
{
	double moy;
	if (!listeACalculer->IsEmpty())
	{
		double nb = (double)listeACalculer->GetCount();
		double somme = 0;
		POSITION posMoyenne = listeACalculer->GetHeadPosition();
		while(posMoyenne)
		{
			double temp = (double)listeACalculer->GetNext(posMoyenne);
			somme += temp;
		}
		moy = somme / nb;
	}else
	{
		moy = 0;
	}
	return moy;
}

double CClassifAutoDonnees::CalculerVariance(CList<double> *listeACalculer, double moyCalculee)
{
	double var;
	if (!listeACalculer->IsEmpty())
	{
		double nb = (double)listeACalculer->GetCount();
		double somme = 0;
		POSITION posVariance = listeACalculer->GetHeadPosition();
		while(posVariance)
		{
			double temp = (double)listeACalculer->GetNext(posVariance);
			double calcul = (temp - moyCalculee)*(temp - moyCalculee);
			somme += calcul;
		}
		var = somme / nb;
	}else
	{
		var = 0;
	}
	return var;
}

double CClassifAutoDonnees::CalculerEcartType(double varianceCalculee)
{
	double eT;
	if (varianceCalculee != 0)
	{
		eT = sqrt(varianceCalculee);
	}else
	{
		eT = 0;
	}
	return eT;
}

void CClassifAutoDonnees::TrierListe(CList<double> *listeIn, int numeroReg)
{
	//trier par ordre croissant
	int nb = listeIn->GetCount();
	//on utilise un tableau car pour effectuer le tri de la liste par
	//  ordre croissant, on a besoin des indices numriques des valeurs
	//  (dans une liste, les indices sont des POSITION)
	double tabValATrier[10000];
	int tabPosATrier[10000];

	POSITION posTab1 = listeIn->GetHeadPosition();
	int i = 0, j=0;
	while(posTab1)
	{
		tabValATrier[i] = (double)listeIn->GetNext(posTab1);
		i++;
	}

	//cre un tableau de positions (0,1,2,3 .. nb)
	for (i=0 ; i<nb ; i++)
	{
		tabPosATrier[i] = i;
	}

	QuickSort(tabValATrier,tabPosATrier, 0, nb-1);

	switch (numeroReg)
	{
		//regleCC
	case REGCARAC :
		for (j=0 ; j<nb ; j++) tabPosETCarac[j] = tabPosATrier[j];
		break;

		//regleCG
	case REGGEO :
		for (j=0 ; j<nb ; j++) tabPosETGeo[j] = tabPosATrier[j];
		break;

		//regleCV
	case REGVOIS :
		for (j=0 ; j<nb ; j++) tabPosETVois[j] = tabPosATrier[j];
		break;

		//Global Indep
	case REGGLOBALINDEP :
		for (j=0 ; j<nb ; j++) tabPosETGlobalIndep[j] = tabPosATrier[j];
		break;

		//Global Non Indep
	case REGGLOBALNONINDEP :
		for (j=0 ; j<nb ; j++) tabPosETGlobalNonIndep[j] = tabPosATrier[j];
		break;

	default :
		break;
	}
}

void CClassifAutoDonnees::QuickSort(double tabValATrier[], int tabPosATrier[], int minimum, int maximum)
{
    int q;
    if(minimum<maximum)
	{
		q = Partitionner(tabValATrier, tabPosATrier, minimum, maximum);
		QuickSort(tabValATrier, tabPosATrier, minimum, q);
		QuickSort(tabValATrier, tabPosATrier, q+1, maximum);
    }
}
int CClassifAutoDonnees::Partitionner(double tabValATrier[], int tabPosATrier[], int minimum, int maximum)
{
    double pivot = tabValATrier[minimum];
	int i = minimum-1;
	int j = maximum+1;
    double temp, temp2;
    while(1) {
            do
                    j--;
            while(tabValATrier[j] > pivot);
            do
                    i++;
            while(tabValATrier[i] < pivot);
            if(i<j) {
                    temp = tabValATrier[i];
                    tabValATrier[i] = tabValATrier[j];
                    tabValATrier[j] = temp;

					temp2 = tabPosATrier[i];
					tabPosATrier[i] = tabPosATrier[j];
					tabPosATrier[j] = temp2;
            }
            else
                    return j;
    }
    return j;
 }