

#pragma once

#include "MyApp.h"
#include "MyAppDoc.h"
#include "MyAppView.h"
#include "CaracCC.h"
#include "CaracCG.h"
#include "CaracCV.h"
#include "ParamCarac.h"
#include <afxtempl.h>
#include "TypeClasse.h"
#include "ParamClasse.h"
#include "Scenario.h"


class CClassifAutoDonnees
{

private:
	CString typeOrg;
	CString typeDest;
	UINT colorDest;

	int nbZones;

	CList<double>* listeMin;
	CList<double>* listeMax;
	CList<double>* listeBorneInf;
	CList<double>* listeBorneSup;
	CList<double>* listeVariance;
	CList<double>* listeEcartType;
	CList<double>* listeMoyenne;
	CList<double>* listeMediane;

	
	CList<double>* listeEcartTypeCarac;
	CList<double>* listeEcartTypeGeo;
	CList<double>* listeEcartTypeVois;
	CList<double>* listeEcartTypeNonIndep;
	CList<double>* listeEcartTypeMoyNonIndep;

	//tableaux contenant les indices des ecarts types tris
	int tabPosETGlobalIndep[19];
	int tabPosETGlobalNonIndep[3];
	int tabPosETCarac[7];
	int tabPosETGeo[7];
	int tabPosETVois[5];


	CList<double>* listeValCaracMin;
	CList<double>* listeValCaracMax;
	CList<double>* listeValGeo;
	CObList* listeValVois; //liste de TypeClasse

	bool reglesNonIndep;
	bool valsMoyCarac;
	bool valsMoyGeo;
	int pourcentageCaracMoy;
	int pourcentageClasse;
	//int nbGlobalRegIndep;
	//int nbGlobalRegNonIndep;
	//int nbCaracReg;
	//int nbVoisReg;
	int tolGlobalRegIndep;
	int tolGlobalRegNonIndep;
	int tolCaracReg;
	int tolVoisReg;


	int nbMaxCaracReg;
	int nbMaxGeoReg;
	int nbMaxVoisReg;
	int nbMaxGlobalRegIndep;
	int nbMaxGlobalRegNonIndep;

	CScenario *scenarAuto;

public:

	CString getTypeOrg(){return typeOrg;}
	CString getTypeDest(){return typeDest;}
	UINT getColorDest(){return colorDest;}

	int getNbZones(){return nbZones;}

	CList<double>* getListeMin(){return listeMin;}
	CList<double>* getListeMax(){return listeMax;}
	CList<double>* getListeBorneInf(){return listeBorneInf;}
	CList<double>* getListeBorneSup(){return listeBorneSup;}
	CList<double>* getListeVariance(){return listeVariance;}
	CList<double>* getListeEcartType(){return listeEcartType;}
	CList<double>* getListeMoyenne(){return listeMoyenne;}
	CList<double>* getListeMediane(){return listeMediane;}

	CList<double>* getListeEcartTypeCarac(){return listeEcartTypeCarac;}
	CList<double>* getListeEcartTypeGeo(){return listeEcartTypeGeo;}
	CList<double>* getListeEcartTypeVois(){return listeEcartTypeVois;}
	CList<double>* getListeEcartTypeNonIndep(){return listeEcartTypeNonIndep;}
	CList<double>* getListeEcartTypeMoyNonIndep(){return listeEcartTypeMoyNonIndep;}

	int* getTabPosETGlobalIndep(){return tabPosETGlobalIndep;}
	int* getTabPosETGlobalNonIndep(){return tabPosETGlobalNonIndep;}
	int* getTabPosETCarac(){return tabPosETCarac;}
	int* getTabPosETGeo(){return tabPosETGeo;}
	int* getTabPosETVois(){return tabPosETVois;}

	CList<double>* getListeValCaracMin(){return listeValCaracMin;}
	CList<double>* getListeValCaracMax(){return listeValCaracMax;}
	CList<double>* getListeValGeo(){return listeValGeo;}
	CObList* getListeValVois(){return listeValVois;}

	bool isReglesNonIndep(){return reglesNonIndep;}
	bool isValsMoyCarac(){return valsMoyCarac;}
	bool isValsMoyGeo(){return valsMoyGeo;}
	int getPourcentageCaracMoy(){return pourcentageCaracMoy;}
	int getPourcentageClasse(){return pourcentageClasse;}
	//int getNbGlobalRegIndep(){return nbGlobalRegIndep;}
	//int getNbGlobalRegNonIndep(){return nbGlobalRegNonIndep;}
	//int getNbCaracReg(){return nbCaracReg;}
	//int getNbVoisReg(){return nbVoisReg;}
	int getTolGlobalRegIndep(){return tolGlobalRegIndep;}
	int getTolGlobalRegNonIndep(){return tolGlobalRegNonIndep;}
	int getTolCaracReg(){return tolCaracReg;}
	int getTolVoisReg(){return tolVoisReg;}

	int getNbMaxCaracReg(){return nbMaxCaracReg;}
	int getNbMaxGeoReg(){return nbMaxGeoReg;}
	int getNbMaxVoisReg(){return nbMaxVoisReg;}
	int getNbMaxGlobalRegIndep(){return nbMaxGlobalRegIndep;}
	int getNbMaxGlobalRegNonIndep(){return nbMaxGlobalRegNonIndep;}

	CScenario* getScenarAuto(){return scenarAuto;}

	void setTypeOrg(CString typeIn){typeOrg = typeIn;}
	void setTypeDest(CString typeIn){typeDest = typeIn;}
	void setColorDest(UINT colorIn){colorDest = colorIn;}

	void setNbZones(int nbIn){nbZones = nbIn;}

	void setTabPosETGlobalIndep(int tab[]){ for (int i=0; i<19 ; i++) tabPosETGlobalIndep[i] = tab[i];}
	void setTabPosETGlobalNonIndep(int tab[]){ for (int i=0; i<3 ; i++) tabPosETGlobalNonIndep[i] = tab[i];}
	void setTabPosETCarac(int tab[]){ for (int i=0; i<7 ; i++) tabPosETCarac[i] = tab[i];}
	void setTabPosETGeo(int tab[]){ for (int i=0; i<7 ; i++) tabPosETGeo[i] = tab[i];}
	void setTabPosETVois(int tab[]){ for (int i=0; i<5 ; i++) tabPosETVois[i] = tab[i];}

	void setIsReglesNonIndep(bool val){reglesNonIndep = val;}
	void setIsValsMoyCarac(bool val){valsMoyCarac = val;}
	void setIsValsMoyGeo(bool val){valsMoyGeo = val;}
	void setPourcentageCaracMoy(int val){ pourcentageCaracMoy = val;}
	void setPourcentageClasse(int val){ pourcentageClasse = val;}
	//void setNbGlobalRegIndep(int val){nbGlobalRegIndep = val;}
	//void setNbGlobalRegNonIndep(int val){ nbGlobalRegNonIndep = val;}
	//void setNbCaracReg(int val){ nbCaracReg = val;}
	//void setNbVoisReg(int val){ nbVoisReg = val;}
	void setTolGlobalRegIndep(int val){tolGlobalRegIndep = val;}
	void setTolGlobalRegNonIndep(int val){ tolGlobalRegNonIndep = val;}
	void setTolCaracReg(int val){ tolCaracReg = val;}
	void setTolVoisReg(int val){ tolVoisReg = val;}

	void setNbMaxCaracReg(int val){ nbMaxCaracReg = val;}
	void setNbMaxGeoReg(int val){ nbMaxGeoReg = val;}
	void setNbMaxVoisReg(int val){ nbMaxVoisReg = val;}
	void setNbMaxGlobalRegIndep(int val){ nbMaxGlobalRegIndep = val;}
	void setNbMaxGlobalRegNonIndep(int val){ nbMaxGlobalRegNonIndep = val;}

	void QuickSort(double tabValATrier[], int tabPosATrier[], int minimum, int maximum);
	int Partitionner(double tabValATrier[], int tabPosATrier[], int minimum, int maximum);
	void CalculerAll(CObList* listeParamCarac, CObList* listeParamClasses);
	void CalculerListes(CObList* listeParamCarac, CObList* listeParamClasses);
	void CalculerListeETNonIndep();
	void TrierListes();
	void TrierListe(CList<double> *listeIn, int numeroReg);
	void EliminerMauvaisesVals(int numeroReg);
	double TrouverMax(int numeroCarac);
	double TrouverMaxCC(int numeroCarac);
	double TrouverMaxCG(int numeroCarac);
	double TrouverMaxCV(int numeroCarac);
	double TrouverETMoy(int numeroRegSpec);
	void CalculerSuite();
	void CalculerValeurs();
	void CalculerValsCarac();
	void CalculerValsGeo();
	void CalculerValsVois();
	void SupprimerValTab(int *tabIn, int position, int tailleTab);
	double GetValListeDoubleAt(CList<double> *listeIn, int position);
	CString GetValListeCStringAt(CList<CString,CString> *listeIn, int position);
	CString GetValListeCTypeClasseAt(CObList *listeIn, int position);
	void SetValListeDoubleAt(CList<double> *listeIn, int position, double val);
	void SetValListeCStringAt(CList<CString,CString> *listeIn, int position, CString val);
	void SetValListeCTypeClasseAt(CObList *listeIn, int position, CString valStr);

	double CalculerMoyenne(CList<double> *listeACalculer);
	double CalculerVariance(CList<double> *listeACalculer, double moyCalculee);
	double CalculerEcartType(double varianceCalculee);

	CClassifAutoDonnees(void);
	~CClassifAutoDonnees(void);
};
