// DialogClassifChangeType.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DialogClassifChangeType.h"
#include ".\dialogclassifchangetype.h"
#include "MyAppDoc.h"
#include "regle.h"
#include "constante.h"


// Bote de dialogue CDialogClassifChangeType

IMPLEMENT_DYNAMIC(CDialogClassifChangeType, CDialog)
CDialogClassifChangeType::CDialogClassifChangeType(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogClassifChangeType::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogClassifChangeType)
	m_listeOrg = _T("");
	m_listeDest = _T("");
	m_checkSupprTypeOrg = true;
	//}}AFX_DATA_INIT
}

CDialogClassifChangeType::~CDialogClassifChangeType()
{
}

void CDialogClassifChangeType::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_SUPPR_ORG, m_checkSupprTypeOrg);
	DDX_CBString(pDX, IDC_LISTE_TYPE_ORG, m_listeOrg);
	DDX_CBString(pDX, IDC_LISTE_TYPE_DEST, m_listeDest);
}


BEGIN_MESSAGE_MAP(CDialogClassifChangeType, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_CHECK_SUPPR_ORG, OnCheckSupprTypeOrg)
END_MESSAGE_MAP()

// Gestionnaires de messages CDialogClassifChangeType

BOOL CDialogClassifChangeType::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	CComboBox *comboOrg=(CComboBox *)GetDlgItem(IDC_LISTE_TYPE_ORG);
	CComboBox *comboDest=(CComboBox *)GetDlgItem(IDC_LISTE_TYPE_DEST);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading informations");
		break;
	}

	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		comboOrg->InsertString(-1,tp->getNomClasse());
		comboDest->InsertString(-1,tp->getNomClasse());
	}

	m_checkSupprTypeOrg = true;

	return CDialog::OnInitDialog(); 

}


void CDialogClassifChangeType::OnBnClickedOk()
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CComboBox *comboOrg=(CComboBox *)GetDlgItem(IDC_LISTE_TYPE_ORG);
	
	if (!UpdateData(true)) return;
	if (m_listeOrg.IsEmpty()) {AfxMessageBox("Choose the type of origine");return;}
	if (m_listeDest.IsEmpty()) {AfxMessageBox("Choose the type of destination");return;}

	bool typeOrgExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_listeOrg);
	bool typeDestExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_listeDest);

	if (!typeOrgExiste) {AfxMessageBox("The name choosed for the original type doesn't exist.");return;}
	if (!typeDestExiste) {AfxMessageBox("The name choosed for the destination type doesn't exist.");return;}
	
	if (m_checkSupprTypeOrg && (comboOrg->GetCount()<2)) {AfxMessageBox("Impossible to erase the original type because only one type is in the list.");return;}

	if (m_listeOrg == m_listeDest) {AfxMessageBox("Please choose a different name for each type.");return;}

	//ajout de la regle en question
	CRegleChangeType *r3 = new CRegleChangeType(m_listeOrg,m_listeDest,m_checkSupprTypeOrg);
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r3);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r3->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}
	
	OnOK();
}

void CDialogClassifChangeType::OnCheckSupprTypeOrg() 
{
	m_checkSupprTypeOrg=!m_checkSupprTypeOrg;	
}
