/****************************************************************/
// DialogClassifGeo.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include <afxdlgs.h>
#include "myapp.h"
#include "DialogClassifGeo.h"
#include "MyAppDoc.h"
#include "constante.h"

#include "regletype.h"
#include "reglecg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogClassifGeo dialog
/****************************************************************/

CDialogClassifGeo::CDialogClassifGeo(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogClassifGeo::IDD, pParent)
{
	pView = (CView *)pParent;
	color_si = 0;
	color_sinon = 0;
	
	//{{AFX_DATA_INIT(CDialogClassifGeo)
	m_gauche = -1;
	m_edit_si = _T("");
	m_edit_sinon = _T("");
	m_liste = _T("");
	m_valeur = 0;
	//}}AFX_DATA_INIT
}


void CDialogClassifGeo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogClassifGeo)
	DDX_Radio(pDX, IDC_GAUCHE, m_gauche);
	DDX_CBString(pDX, IDC_LISTE_SI2, m_edit_si);
	DDX_CBString(pDX, IDC_LISTE_SINON2, m_edit_sinon);
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	DDX_Text(pDX, IDC_SLIDER_VALUE, m_valeur);
	DDV_MinMaxInt(pDX, m_valeur, 0, 50);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogClassifGeo, CDialog)
	//{{AFX_MSG_MAP(CDialogClassifGeo)
	ON_BN_CLICKED(IDC_CLASSER, OnClasser)
	ON_BN_CLICKED(IDC_COLOR3, OnColorSi)
	ON_BN_CLICKED(IDC_COLOR_SINON, OnColorSinon)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogClassifGeo message handlers
/****************************************************************/

BOOL CDialogClassifGeo::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	m_gauche=0;
	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CComboBox *combo_si=(CComboBox *)GetDlgItem(IDC_LISTE_SI2);
	CComboBox *combo_sinon=(CComboBox *)GetDlgItem(IDC_LISTE_SINON2);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading the types liste for geographic classification.");
		break;
	}


	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		combo->InsertString(-1,tp->getNomClasse());
		combo_si->InsertString(-1,tp->getNomClasse());
		combo_sinon->InsertString(-1,tp->getNomClasse());
	}

	m_valeur = 25;

	CSliderCtrl *slider = (CSliderCtrl *)GetDlgItem(IDC_SLIDER);
	slider->SetRange(0,50,true);
	slider->SetTicFreq(5);
	slider->SetPos(25);
	
	return CDialog::OnInitDialog(); 
}

void CDialogClassifGeo::OnClasser() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	if (!UpdateData(true)) return;
	if (m_liste.IsEmpty()) {AfxMessageBox("Choose the type of zone concerned");return;}
	if (m_edit_si.IsEmpty()) {AfxMessageBox("Please choose the name of a destination type");return;}
	if (m_edit_sinon.IsEmpty()) {AfxMessageBox("Please choose a name in case of failure");return;}

	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);
	

	char c;
	if (m_gauche==0) c='G';
	if (m_gauche==1) c='D';
	if (m_gauche==2) c='H';
	if (m_gauche==3) c='B';
	if (m_gauche==4) c='C';
	if (m_gauche==5) c='O';
	if (m_gauche==6) c='E';

	//va chercher directement dans le labo Classif car cette boite de dialogue n'est accessible 
	//qu' partir du menu Classification->ClassifGeographique
	bool typeSiExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_edit_si);
	bool typeSinonExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_edit_sinon);

	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(m_edit_si,color_si);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}

	if (!typeSinonExiste)
	{
		CRegleType *r2=new CRegleType(m_edit_sinon,color_sinon);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r2);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r2->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}
	
	CRegleCG *r3 = new CRegleCG(m_liste,c,m_valeur,m_edit_si,m_edit_sinon);
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r3);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r3->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}
	
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	OnOK();

}



void CDialogClassifGeo::OnColorSi() 
{
	CColorDialog * colordialog = new CColorDialog();
	colordialog->DoModal();	
	color_si = colordialog->GetColor();
}
	

void CDialogClassifGeo::OnColorSinon() 
{
	CColorDialog * colordialog = new CColorDialog();
	colordialog->DoModal();	
	color_sinon = colordialog->GetColor();
}
	

void CDialogClassifGeo::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	UpdateData(true);
	CSliderCtrl *pSlide = (CSliderCtrl *)pScrollBar;

	
	m_valeur=pSlide->GetPos();
	UpdateData(false);UpdateWindow();
	
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
	
}
