/****************************************************************/
// DialogClassifVoisin.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "DialogClassifVoisin.h"
#include "MyAppDoc.h"
#include <afxtempl.h>
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogClassifVoisin dialog
/****************************************************************/

CDialogClassifVoisin::CDialogClassifVoisin(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogClassifVoisin::IDD, pParent)
{
	pView = (CView *)pParent;
	color_si = 0;
	color_sinon = 0;
	//{{AFX_DATA_INIT(CDialogClassifVoisin)
	m_liste = _T("");
	m_liste_si = _T("");
	m_liste_sinon = _T("");
	//}}AFX_DATA_INIT
}


void CDialogClassifVoisin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogClassifVoisin)
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	DDX_CBString(pDX, IDC_LISTE_SI, m_liste_si);
	DDX_CBString(pDX, IDC_LISTE_SINON, m_liste_sinon);
	//}}AFX_DATA_MAP
}

BOOL CDialogClassifVoisin::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CComboBox *combo_si=(CComboBox *)GetDlgItem(IDC_LISTE_SI);
	CComboBox *combo_sinon=(CComboBox *)GetDlgItem(IDC_LISTE_SINON);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}

	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);

	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		combo->InsertString(-1,tp->getNomClasse());
		combo_si->InsertString(-1,tp->getNomClasse());
		combo_sinon->InsertString(-1,tp->getNomClasse());
		listeg->InsertString(-1,tp->getNomClasse());
		listed->InsertString(-1,tp->getNomClasse());
		listeh->InsertString(-1,tp->getNomClasse());
		listeb->InsertString(-1,tp->getNomClasse());
		listei->InsertString(-1,tp->getNomClasse());
	}

	listeg->InsertString(-1,"RIEN");
	listed->InsertString(-1,"RIEN");
	listeh->InsertString(-1,"RIEN");
	listeb->InsertString(-1,"RIEN");
	listei->InsertString(-1,"RIEN");
	


	return CDialog::OnInitDialog(); 
}

BEGIN_MESSAGE_MAP(CDialogClassifVoisin, CDialog)
	//{{AFX_MSG_MAP(CDialogClassifVoisin)
	ON_BN_CLICKED(IDC_CLASS_VOIS, OnClasser)
	ON_BN_CLICKED(IDC_COLOR2, OnColor)
	ON_BN_CLICKED(IDC_COLOR3, OnColorSinon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogClassifVoisin message handlers
/****************************************************************/

void CDialogClassifVoisin::OnClasser() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	//mise  jour des donnes de la fentre dans les variables associes
	if (!UpdateData(true)) return;
	if (m_liste.IsEmpty()) {AfxMessageBox("Choose the types concerned");return;}
	if (m_liste_si.IsEmpty()) {AfxMessageBox("Choose the destination type");return;}
	if (m_liste_sinon.IsEmpty()) {AfxMessageBox("Choose the type if an error occured");return;}

	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	//va chercher directement dans le labo Classif car cette boite de dialogue n'est accessible 
	//qu' partir du menu Classification->ClassifVoisinage
	bool typeSiExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_liste_si);
	bool typeSinonExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_liste_sinon);

	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(m_liste_si,color_si);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}
	
	if (!typeSinonExiste)
	{
		CRegleType *r2=new CRegleType(m_liste_sinon,color_sinon);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r2);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r2->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}
	

		
	//rcupration de pointeurs sur les listes de l'interface graphique
	//pour pouvoir les manipuler
	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);
	//cration de 5 listes d'entiers reprsentant les index de la liste de
	//types de voisins accepts en tant que voisin dans chaque direction
	int *liste_voisins_gauche = new int[listeg->GetCount()];
	int *liste_voisins_droite = new int[listed->GetCount()];
	int *liste_voisins_haut = new int[listeh->GetCount()];
	int *liste_voisins_bas = new int[listeb->GetCount()];
	int *liste_voisins_inclus = new int[listei->GetCount()];
	//on ajoute dans ces listes les lments qui ont t selectionns
	//dans l'interface graphique
	listeg->GetSelItems(listeg->GetSelCount(),liste_voisins_gauche);
	listed->GetSelItems(listed->GetSelCount(),liste_voisins_droite);
	listeh->GetSelItems(listeh->GetSelCount(),liste_voisins_haut);
	listeb->GetSelItems(listeb->GetSelCount(),liste_voisins_bas);
	listei->GetSelItems(listei->GetSelCount(),liste_voisins_inclus);
	//transformation en type CList
	int i;
	CList<CString,CString> *lg = new CList<CString,CString>();
	CList<CString,CString> *ld = new CList<CString,CString>();
	CList<CString,CString> *lh = new CList<CString,CString>();
	CList<CString,CString> *lb = new CList<CString,CString>();
	CList<CString,CString> *li = new CList<CString,CString>();
	

	for (i=0;i<listeg->GetSelCount();i++) 
	{
		CString t;
		listeg->GetText(liste_voisins_gauche[i],t);
		lg->AddTail(t);
		
	}
	
	for (i=0;i<listed->GetSelCount();i++) 
	{
		CString t;
		listed->GetText(liste_voisins_droite[i],t);
		ld->AddTail(t);
	
	}
	
	for (i=0;i<listeh->GetSelCount();i++) 
	{
		CString t;
		listeh->GetText(liste_voisins_haut[i],t);
		lh->AddTail(t);
	
	}
	
	for (i=0;i<listeb->GetSelCount();i++) 
	{
		CString t;
		listeb->GetText(liste_voisins_bas[i],t);
		lb->AddTail(t);
	
	}
	
	for (i=0;i<listei->GetSelCount();i++) 
	{
		CString t;
		listei->GetText(liste_voisins_inclus[i],t);
		li->AddTail(t);
	
	}
	


	CRegleCV *r3=new CRegleCV(m_liste,lg,ld,lh,lb,li,m_liste_si,m_liste_sinon);
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r3);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r3->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//nettoyage
	delete liste_voisins_gauche;
	delete liste_voisins_droite;
	delete liste_voisins_haut;
	delete liste_voisins_bas;
	delete liste_voisins_inclus;


	OnOK();
}

void CDialogClassifVoisin::OnColor() 
{
	CColorDialog * colordialog = new CColorDialog(color_si);
	colordialog->DoModal();	
	color_si = colordialog->GetColor();
}

void CDialogClassifVoisin::OnColorSinon() 
{
	CColorDialog * colordialog = new CColorDialog(color_sinon);
	colordialog->DoModal();	
	color_sinon = colordialog->GetColor();
}
