/****************************************************************/
// DialogFusion.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "DialogFusion.h"
#include "MyAppDoc.h"
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogFusion dialog
/****************************************************************/

CDialogFusion::CDialogFusion(CWnd* pParent /*=NULL*/, CString text, int valeur)
	: CDialog(CDialogFusion::IDD, pParent)
{
	pView = (CView *)pParent;

	//{{AFX_DATA_INIT(CDialogFusion)
	m_edit = valeur;
	m_pos = valeur;
	m_text = _T(text);
	m_liste = _T("");
	//}}AFX_DATA_INIT
}

void CDialogFusion::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogFusion)
	DDX_Text(pDX, IDC_EDIT, m_edit);
	DDX_Slider(pDX, IDC_POS, m_pos);
	DDX_Text(pDX, IDC_TEXT, m_text);
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogFusion, CDialog)
	//{{AFX_MSG_MAP(CDialogFusion)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_EDIT, OnChangeEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogFusion message handlers
/****************************************************************/

void CDialogFusion::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CSliderCtrl *curseur = (CSliderCtrl*)pScrollBar;
	CString text;
	text.Format("%d",curseur->GetPos());
	SetDlgItemText(IDC_EDIT,text);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CDialogFusion::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	CDialog::OnInitDialog();
	CSliderCtrl *curseur = (CSliderCtrl*)GetDlgItem(IDC_POS);
	curseur->SetRange(0,5000);
	curseur->SetTicFreq(500);
	curseur->SetPos(m_edit);
	

	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Erreur lors du chargement de la liste\n des types de Classe pour la fusion.");
		break;
	}


	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		int a=combo->InsertString(-1,tp->getNomClasse());
	}
	return TRUE;  
}



void CDialogFusion::OnChangeEdit() 
{
	UpdateData(TRUE);
	CSliderCtrl *curseur = (CSliderCtrl*)GetDlgItem(IDC_POS);
	curseur->SetPos(m_edit);
}


void CDialogFusion::OnOK() 
{
	UpdateData(TRUE);
	if (m_liste.IsEmpty()) {AfxMessageBox("choisissez le type des zones concernes");return;}
	CDialog::OnOK();
}
