// DialogParamProjet.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DialogParamProjet.h"
#include ".\dialogparamprojet.h"
#include "MainFrm.h"


// Bote de dialogue CDialogParamProjet

IMPLEMENT_DYNAMIC(CDialogParamProjet, CDialog)
CDialogParamProjet::CDialogParamProjet(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogParamProjet::IDD, pParent)
{
	//m_param->MajChamps();
}

CDialogParamProjet::~CDialogParamProjet()
{
}

void CDialogParamProjet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB_PARAM_PROJ, c_tabCtrl);
}


BEGIN_MESSAGE_MAP(CDialogParamProjet, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// Gestionnaires de messages CDialogParamProjet

BOOL CDialogParamProjet::OnInitDialog()
{
	CDialog::OnInitDialog();

    if (!UpdateData(FALSE))
    {
       TRACE0("Warning: UpdateData failed during dialog init.\n");
    }

	c_tabCtrl.SetAutoSizePannel(); // retaille automatiquement les panneaux clients.

	//++++++++ les 2 onglets chargs ds l'initialisation
	m_rep=new CRepertoires(this);
	m_rep->Create(IDD_REPERTOIRES, &c_tabCtrl);
	c_tabCtrl.AddTab(m_rep, "Rpertoires", 0);

	m_param=new CParamDlg(this);
	m_param->Create(IDD_PARAM, &c_tabCtrl);
	c_tabCtrl.AddTab(m_param, "Paramtres", 1);
	
	//remplit les champs en fonction du fichier XML
	m_param->MajChamps();

	//+++++++++++++++++++++++ customizing the tab control +++++++++++++++++++++++
	//c_tabCtrl.SetDisabledColor(RGB(255, 0, 0));
	//c_tabCtrl.SetBackGroundColor(RGB(193, 193, 255));
	//c_tabCtrl.SetSelectedColor(RGB(0, 0, 255));
	//c_tabCtrl.SetMouseOverColor(RGB(255, 0, 0));
	//SetDialogBkColor(RGB(193, 193, 255));

	return TRUE;
}

void CDialogParamProjet::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

	}
	else
	{
		CDialog::OnPaint();
	}
}

void CDialogParamProjet::OnBnClickedOk()
{
	CProjetParam* pParamProjetTemp = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj();
	//sauvegarde des repertoires dans les variables
	CString repOuvrage, repResultats;

	m_rep->GetDlgItemText(IDC_CHEM_REP_OUVR,repOuvrage);
	m_rep->GetDlgItemText(IDC_CHEM_REP_RES,repResultats);

	pParamProjetTemp->setM_repOuvrage(repOuvrage);
	pParamProjetTemp->setM_repResultats(repResultats);

	//sauvegarde des valeurs dans les variables
	CString strSeuilBin, strGdeCcLarg, strGdeCcHaut, strPteCcLarg, strPteCcHaut;
	CString strSeuilH, strSeuilV, strRappMapp, strDeltaDecoup;

	m_param->GetDlgItemText(IDC_SEUILBIN,strSeuilBin);
	m_param->GetDlgItemText(IDC_GDECCX,strGdeCcLarg);
	m_param->GetDlgItemText(IDC_GDECCY,strGdeCcHaut);
	m_param->GetDlgItemText(IDC_PTECCX,strPteCcLarg);
	m_param->GetDlgItemText(IDC_PTECCY,strPteCcHaut);
	m_param->GetDlgItemText(IDC_SEUILH,strSeuilH);
	m_param->GetDlgItemText(IDC_SEUILV,strSeuilV);
	m_param->GetDlgItemText(IDC_MAPPAGE,strRappMapp);
	m_param->GetDlgItemText(IDC_DELTAPIX,strDeltaDecoup);

	pParamProjetTemp->setM_seuilBinarisation(atoi(strSeuilBin));
	pParamProjetTemp->setM_binAuto((bool)m_param->m_checkAuto);
	pParamProjetTemp->setM_gdeCcLarg(atoi(strGdeCcLarg));
	pParamProjetTemp->setM_gdeCcHaut(atoi(strGdeCcHaut));
	pParamProjetTemp->setM_pteCcLarg(atoi(strPteCcLarg));
	pParamProjetTemp->setM_pteCcHaut(atoi(strPteCcHaut));
	pParamProjetTemp->setM_seuilH(atoi(strSeuilH));
	pParamProjetTemp->setM_seuilV(atoi(strSeuilV));
	pParamProjetTemp->setM_rapportMappage(atoi(strRappMapp));
	pParamProjetTemp->setM_deltaDecoup(atoi(strDeltaDecoup));
	pParamProjetTemp->setM_traitTexte((bool)m_param->m_checkSeg);

	if (strcmp(repOuvrage,"Non spcifi") == -1)
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist1()->m_ctrlAssist1BtnEtpSuiv.ShowWindow(SW_SHOW);

	OnOK();
}
