/****************************************************************/
// DialogParamTAO.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "MyAppDoc.h"
#include "DialogParamTAO.h"
#include "Regle.h"
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogParamTAO dialog
/****************************************************************/

CDialogParamTAO::CDialogParamTAO(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogParamTAO::IDD, pParent)
{
	pView = (CView *)pParent;
	//{{AFX_DATA_INIT(CDialogParamTAO)
	m_check2 = FALSE;
	m_combo1 = _T("");
	m_seuil_dico = 0.15;
	m_CheckAnalyseFine = FALSE;
	//}}AFX_DATA_INIT
}


void CDialogParamTAO::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogParamTAO)
	DDX_Check(pDX, IDC_CHECK2, m_check2);
	DDX_CBString(pDX, IDC_COMBO1, m_combo1);
	DDX_Text(pDX, IDC_SEUIL_DICO, m_seuil_dico);
	DDX_Check(pDX, IDC_CHECKANALYSEFINE, m_CheckAnalyseFine);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogParamTAO, CDialog)
	//{{AFX_MSG_MAP(CDialogParamTAO)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_TAO, OnTao)
	ON_BN_CLICKED(IDC_CHECKANALYSEFINE, OnCheckanalysefine)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogParamTAO message handlers
/****************************************************************/

BOOL CDialogParamTAO::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_COMBO1);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}
	


	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		combo->InsertString(-1,tp->getNomClasse());
	}

	m_check2=false;
	m_CheckAnalyseFine=false;


	//GetDlgItem(IDC_CHECKANALYSEFINE)->EnableWindow(false);	// Checkbox non valide tant que TEXTE
															// non selectionn

	return CDialog::OnInitDialog(); 

}

void CDialogParamTAO::OnCheck2() 
{
	//m_check2 =! m_check2;	
	if(m_check2 == 1)
	{
		m_check2 = 0;
	}
	else
	{
		m_check2 = 1;
	}
}

void CDialogParamTAO::OnTao() 
{
	if (!UpdateData(true)) return;
	if (m_combo1.IsEmpty()) {AfxMessageBox("please choose the zone concerned");return;}
	

	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	if (m_check2 == 1 && m_CheckAnalyseFine == 0) // TAO seul coch
	{
		CRegleTAO *r1 = new CRegleTAO (m_combo1, m_seuil_dico);
		//s'enregistre dans le scnarioProj car cette boite de dialogue n'est accessible qu' partir 
		//du menu Outils->Gnrer XML.
		((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj()->Ajouter(r1);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getListeDocsLaboProj();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
		OnOK();

	}

	if(m_CheckAnalyseFine == 1 && m_check2 == 1)	// Analyse fine et TAO coch
	{

		if(m_combo1 =="TEXTE")
		{
			CRegleTAO *r1 = new CRegleTAO (m_combo1, m_seuil_dico);
			CRegleAnalyseFine *r8=new CRegleAnalyseFine(m_combo1);
			((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj()->Ajouter(r1);
			//teste si le scenario ne contient pas deja cette regle
			if (!(((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj()->regleDejaPresente("RAF")))
				((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj()->Ajouter(r8);
			CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getListeDocsLaboProj();
			POSITION posDoc = listDocs->GetHeadPosition();
			while (posDoc)
			{
				r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
				//teste si le scenario ne contient pas deja cette regle
				if (!(((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj()->regleDejaPresente("RAF")))
					r8->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
			}
			OnOK();
		}
		else
		{
			AfxMessageBox("Only on text zones");
			return;
		}

	}

	if(m_CheckAnalyseFine == 1 && m_check2 == 0)
	{

		AfxMessageBox("Please select the creation of a dictionary before");
		return;

	}

}


/********************************************************************/
/* Nom mthode : OnCheckanalysefine
/*                                                                  
/* Fonction : action associ  la checkbox analyse fine
/*            
/*            
/********************************************************************/
void CDialogParamTAO::OnCheckanalysefine() 
{
	
	if(m_CheckAnalyseFine == 1)
	{
		m_CheckAnalyseFine = 0;
	}
	else
	{
		m_CheckAnalyseFine = 1;
	}

}


