// DialogSelFichiers.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DialogSelFichiers.h"
#include ".\dialogselfichiers.h"

#include "plwinbmp.h"

#include <gdiplus.h>
using namespace Gdiplus;


// Bote de dialogue CDialogSelFichiers

IMPLEMENT_DYNAMIC(CDialogSelFichiers, CDialog)
CDialogSelFichiers::CDialogSelFichiers(bool unExOuVingtEx /*=true (un exemple)*/, CWnd* pParent /*=NULL*/)
	: CDialog(CDialogSelFichiers::IDD, pParent)
{
	m_unExOuVingtEx = unExOuVingtEx;
	m_listeNbEx = _T("");
}

CDialogSelFichiers::~CDialogSelFichiers()
{
	delete m_listeCheckedItems;
	delete m_listeCheckedItemsNums;
}

void CDialogSelFichiers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_NOM_FIC, m_list);
	DDX_Control(pDX, IDC_STATIC_TIT_1EX, m_labelTitre1Ex);
	DDX_Control(pDX, IDC_STATIC_TIT_MULTIEXA, m_labelTitreMultiExA);
	DDX_Control(pDX, IDC_STATIC_TIT_MULTIEXB, m_labelTitreMultiExB);
	DDX_CBString(pDX, IDC_LISTE_NB_EX, m_listeNbEx);
	DDX_Control(pDX, IDC_IMAGE_AP_FIC_SEL, m_imgApercu);
}


BEGIN_MESSAGE_MAP(CDialogSelFichiers, CDialog)
	ON_NOTIFY(NM_CLICK, IDC_LIST_NOM_FIC, OnNMClickListNomFic)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST_NOM_FIC, OnLvnKeydownListNomFic)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_NOM_FIC, OnItemchangedList)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// Gestionnaires de messages CDialogSelFichiers

BOOL CDialogSelFichiers::OnInitDialog()
{
	CDialog::OnInitDialog();

	CComboBox *m_comboNbEx=(CComboBox *)GetDlgItem(IDC_LISTE_NB_EX);

	if (m_unExOuVingtEx)
	{
		m_labelTitre1Ex.ShowWindow(true);
		m_labelTitreMultiExA.ShowWindow(false);
		m_labelTitreMultiExB.ShowWindow(false);
		m_comboNbEx->ShowWindow(false);
	}else
	{
		m_labelTitre1Ex.ShowWindow(false);
		m_labelTitreMultiExA.ShowWindow(true);
		m_labelTitreMultiExB.ShowWindow(true);
		m_comboNbEx->ShowWindow(true);

		m_comboNbEx->InsertString(0,"10");
		m_comboNbEx->InsertString(1,"20");
		m_comboNbEx->InsertString(2,"30");
		m_comboNbEx->InsertString(3,"50");
		m_comboNbEx->InsertString(4,"70");
		m_comboNbEx->InsertString(5,"100");

		m_comboNbEx->SelectString(0,"20");
		m_listeNbEx = "20";
		
	}

	m_repAAfficher = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_repOuvrage();
	m_nSelectedItem = 0;
	m_checkedItem = -1;
	m_listeCheckedItems = new CList<CString,CString>();
	m_listeCheckedItemsNums = new CList<int>();
	
	m_list.SetExtendedStyle(m_list.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_CHECKBOXES);

	RECT		clRect;
	m_list.GetClientRect(&clRect);
	int largeurCol = clRect.right - clRect.left - 17;

	m_list.InsertColumn(0, _T("Image"), LVCFMT_LEFT, largeurCol);

	//UpdateData(TRUE);

	// validate image directory
	if (m_repAAfficher.IsEmpty())
	{
		AfxMessageBox("This folder is empty.\n");
		return false;
	}

	// show hour glass cursor
	BeginWaitCursor();

	// get the names of bitmap files
	if ( !GetImageFileNames() )
	{
		EndWaitCursor();
		return false;
	}

	// list images in list control
	ChargerListe();

	// draw the selected image in its full size
	DrawSelectedImage();

	// set focus and select the first thumbnail in the list control
	m_list.SetFocus();
	//m_list.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);

	EndWaitCursor();
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL  CDialogSelFichiers::GetImageFileNames()
{			
	CString	strExt;
	CString	strName;
	CString	strPattern;
	BOOL	bRC = TRUE;
	
	HANDLE					hFind = NULL;
	WIN32_FIND_DATA			FindFileData;
	std::vector<CString>	VectorImageNames;

	if ( m_repAAfficher[m_repAAfficher.GetLength() - 1] == TCHAR('\\') )	
		strPattern.Format( TEXT("%s*.*"), m_repAAfficher );
	else
		strPattern.Format( TEXT("%s\\*.*"), m_repAAfficher );

	hFind = ::FindFirstFile(strPattern, &FindFileData);	// strat search	
	if (hFind == INVALID_HANDLE_VALUE)
	{
		LPVOID  msg;
		::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, 
					    NULL, 
						GetLastError(), 
					    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                        (LPTSTR)&msg, 
						0, 
						NULL);
		AfxMessageBox("Error while opening folder");
		::LocalFree(msg);
		return FALSE;
	}

	// filter off the system files and directories
	if (!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)  &&
	    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)     &&
	    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)     &&
	    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY))
	{  	  
		// test file extension
		strName = FindFileData.cFileName;
		strExt = strName.Right(3);

		if ( (strExt.CompareNoCase( TEXT("bmp") ) == 0) ||
			 (strExt.CompareNoCase( TEXT("jpg") ) == 0) ||
			 (strExt.CompareNoCase( TEXT("gif") ) == 0) ||
			 (strExt.CompareNoCase( TEXT("tif") ) == 0) ||
			 (strExt.CompareNoCase( TEXT("png") ) == 0) )
		{
			// save the image file name
			VectorImageNames.push_back(strName);
		}
	}  

	// loop through to add all of them to our vector	
	while (bRC)
	{
		bRC = ::FindNextFile(hFind, &FindFileData);
		if (bRC)
		{
			// filter off the system files and directories
			if (!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)  &&
			    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)     &&
			    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)     &&
			    !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY))
			{
				// test file extension
				strName = FindFileData.cFileName;
				strExt = strName.Right(3);

				if ( (strExt.CompareNoCase( TEXT("bmp") ) == 0) ||
					 (strExt.CompareNoCase( TEXT("jpg") ) == 0) ||
					 (strExt.CompareNoCase( TEXT("gif") ) == 0) ||
					 (strExt.CompareNoCase( TEXT("tif") ) == 0) ||
					 (strExt.CompareNoCase( TEXT("png") ) == 0) )
				{
					// save the image file name
					VectorImageNames.push_back(strName);
				}
			}
		}  
		else
		{
			DWORD err = ::GetLastError();
			if (err !=  ERROR_NO_MORE_FILES)
			{
				LPVOID msg;
				::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, 
								NULL, err, 
								MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
								(LPTSTR)&msg, 0, NULL);
				AfxMessageBox("Error while opening folder");
				::LocalFree(msg);
				::FindClose(hFind);
				return FALSE;
			}
		}
	} // end of while loop

	// close the search handle
	::FindClose(hFind);

	// update the names, if any
	if ( !VectorImageNames.empty() )
	{
		// reset the image name vector
		m_VectorImageNames.clear();
		m_VectorImageNames = VectorImageNames;
		return TRUE;
	}

	return FALSE;
}

void CDialogSelFichiers::ChargerListe()
{
	CString		strPath;
	int			i;

	// no images
	if (m_VectorImageNames.empty())
		return;


	// hold the window update to avoid flicking
	m_list.SetRedraw(FALSE);

	// remove all items from list view
	if (m_list.GetItemCount() != 0)
		m_list.DeleteAllItems();

	i = 0;

	// draw the thumbnails
	std::vector<CString>::iterator	iter;
	for (iter = m_VectorImageNames.begin(); iter != m_VectorImageNames.end(); iter++)
	{		
		// load the bitmap
		strPath.Format( TEXT("%s\\%s"), m_repAAfficher, *iter );

		// put item to display
		// set the image file name as item text
		m_list.InsertItem(i, m_VectorImageNames[i]);
		//m_list.InsertItem(LVIF_TEXT|LVIF_STATE, i, m_VectorImageNames[i],(i%2)==0?LVIS_SELECTED : 0, LVIS_SELECTED,0, 0);

		//m_list.SetItemText(i, 1, m_VectorImageNames[i]);
		//AfxMessageBox(strPath + "\n" + m_VectorImageNames[i]);
		i++;

	}

	// let's show the new thumbnails
	m_list.SetRedraw(); 
}

void  CDialogSelFichiers::DrawSelectedImage()
{
	CString		strPath;
	Rect		DesRect;
	RECT		clRect;

	// read the image file
	if (m_repAAfficher.Right(1) == TEXT("\\") )
		strPath.Format( TEXT("%s%s"), m_repAAfficher, m_VectorImageNames[m_nSelectedItem] );
	else
		strPath.Format( TEXT("%s\\%s"), m_repAAfficher, m_VectorImageNames[m_nSelectedItem] );


	// get destination rectangle
	m_imgApercu.GetClientRect(&clRect);
	DesRect.X = clRect.left;
	DesRect.Y = clRect.top;
	DesRect.Width = clRect.right - clRect.left;
	DesRect.Height = clRect.bottom - clRect.top;


	PLWinBmp *m_pImage;
	PLBmp *m_pImBin;
	m_pImage = new PLWinBmp;

	PLAnyPicDecoder m_Decoder;
	m_Decoder.MakeBmpFromFile(strPath,m_pImage);
	//m_pImage->SetGrayPalette();

	m_pImage->StretchDraw(m_imgApercu.GetDC()->GetSafeHdc(),0,0,DesRect.Width,DesRect.Height);
	delete m_pImage;
}

void CDialogSelFichiers::OnNMClickListNomFic(NMHDR *pNMHDR, LRESULT *pResult)
{
	// retrieve message info.
	LPNMITEMACTIVATE pItemAct = (LPNMITEMACTIVATE)pNMHDR;

	// determine which item receives the click
	LVHITTESTINFO  hitTest;
	ZeroMemory(&hitTest, sizeof(LVHITTESTINFO));
	hitTest.pt = pItemAct->ptAction;
	m_list.SendMessage(LVM_SUBITEMHITTEST, 0, (LPARAM)&hitTest);

	// draw the selected image
	if (hitTest.iItem != m_nSelectedItem && hitTest.iItem >= 0)
	{
		m_nSelectedItem = hitTest.iItem;
		DrawSelectedImage();
	}

	if (hitTest.iItem == m_nSelectedItem && m_nSelectedItem == 0)
	{
		//permet de redessiner la premiere image de la liste (lors du initdialog)
		DrawSelectedImage();
	}

	// select the item clicked
	*pResult = 0;
}

void CDialogSelFichiers::OnLvnKeydownListNomFic(NMHDR *pNMHDR, LRESULT *pResult)
{
	//LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here

	if (pLVKeyDow->wVKey == VK_UP || pLVKeyDow->wVKey == VK_DOWN)
	{	
		// get total number of items in the list
		int nTotal = m_list.GetItemCount();

		// rule out the situation of an empty list
		if (nTotal == 0)
		{
			*pResult = 1; // current record stays selected
			return;
		}
    
		// reset selected item index
		int  nNewItem = -1;

		// set the selection
		if (pLVKeyDow->wVKey == VK_UP)	// up arrow
		{
			if (m_nSelectedItem > 0)
				nNewItem = m_nSelectedItem - 1;
		}
		else	// down arrow
		{
			if (m_nSelectedItem < nTotal-1)
				nNewItem = m_nSelectedItem + 1;
		}

		// update the selection
		if (nNewItem != -1)
		{
			// update the selected item index
			m_nSelectedItem = nNewItem;

			// draw the selected image
			DrawSelectedImage();
		}	 
	}
	
	// high-light the selected item
	*pResult = 0;
}

void CDialogSelFichiers::OnItemchangedList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here         
	
    *pResult = 0;

    if (!pNMListView->uOldState && !pNMListView->uNewState) return;    // pas de changement

    // ancien etat de la check
    BOOL bPrevState=(BOOL)(((pNMListView->uOldState & LVIS_STATEIMAGEMASK)>>12)-1);  
    if(bPrevState<0) bPrevState = 0;  // au depart pas d'ancien etat on met false (unchecked)
        
    // nouvel etat.
    BOOL bChecked =(BOOL)(((pNMListView->uNewState & LVIS_STATEIMAGEMASK)>>12)-1); 
    if(bChecked<0) bChecked = 0; 

    if (bPrevState==bChecked) return;  

	m_nSelectedItem = pNMListView->iItem;

    if (m_unExOuVingtEx)
	{
		//boite de dialogue pour la slection d'un seul lment
		int newCheckedItem = pNMListView->iItem;
		if (bPrevState == false)
		{
			if (newCheckedItem != m_checkedItem)
			{
				if (m_checkedItem != -1)
				{
					int oldCheckedItem = m_checkedItem;
					m_checkedItem = newCheckedItem;
					SetLstCtrlCheck(m_list,oldCheckedItem,false);
				}else
				{
					m_checkedItem = newCheckedItem;
				}
			}
		}else
		{
			//aucun element checked
			if (newCheckedItem == m_checkedItem)
			{
				m_checkedItem = -1;
			}
		}
		//selectionne l'lment en bleu
		m_list.SetHotItem(m_checkedItem);
	}else
	{
		//boite de dialogue pour la slection de 20 lments MAX
		//la gestion du nb max est faite lors de l'appui sur OK
	}
}

void CDialogSelFichiers::SetLstCtrlCheck (CListCtrl &rListCtrl,WPARAM nItemIndex, BOOL bCheck)
{
     ListView_SetCheckState(rListCtrl. GetSafeHwnd( ), nItemIndex, bCheck);
} 

BOOL CDialogSelFichiers::GetLstCtrlCheck (CListCtrl &rListCtrl,WPARAM nItemIndex)
{    
    return (ListView_GetCheckState(rListCtrl. GetSafeHwnd( ), nItemIndex)); 
} 

bool CDialogSelFichiers::RecupererListeCheckedItems()
{
	int nTotal, i;

	UpdateData(true);UpdateWindow();

	nTotal = m_list.GetItemCount();

	m_listeCheckedItems->RemoveAll();
	m_listeCheckedItemsNums->RemoveAll();

	// rule out the situation of an empty list ou nbre sup  20 images
	if (nTotal != 0)
	{
		for (i=0 ; i<nTotal ; i++)
		{
			if (GetLstCtrlCheck(m_list,i))
			{
				CString nomItemTemp = m_list.GetItemText(i,0);
				m_listeCheckedItems->AddTail(nomItemTemp);
				m_listeCheckedItemsNums->AddTail(i);
			}
		}
		int nbMax = StrToInt(m_listeNbEx);

		if (m_listeCheckedItems->GetCount() < nbMax+1)
		{
			return true;
		}else
		{
			return false;
		}
	}else
	{
		return false;
	}
}

void CDialogSelFichiers::OnBnClickedOk()
{
	if (m_unExOuVingtEx)
	{
		//boite de dialogue pour la slection d'un seul lment
		if (m_checkedItem != -1)
		{
			CString imSel = m_list.GetItemText(m_checkedItem,0);
			//AfxMessageBox(imSel);
			((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_imLaboTrait(imSel);
			OnOK();
		}else
		{
			AfxMessageBox("Please select at least one image");
		}
	}else
	{
		//boite de dialogue pour la slection de 20 lments MAX
		if (RecupererListeCheckedItems())
		{
			if (!m_listeCheckedItems->IsEmpty())
			{
				((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_listeImageClassif(m_listeCheckedItems);
				OnOK();
			}else
			{
				AfxMessageBox("Please select at least one image");
			}
		}else
		{
			AfxMessageBox("Please select a maximum of "+m_listeNbEx+" images.");
		}
	}
}
