/****************************************************************/
// Element.cpp: implementation of the CElement class.
//
// Cette classe est destine  dcrire une composante connexe et plus
// particulirement le rectangle englobant une composante dtect
//
/****************************************************************/


/***********************/
//  INCLUSION
/***********************/

#include "stdafx.h"
#include "MyApp.h"
#include "Element.h"

/***********************/
//  PRECOMPILATION
/***********************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/***********************/
//  CONSTRUCTEURS
/***********************/


/***************************************************************/ 
//constructeur de la classe CElement
/***************************************************************/

CElement::CElement()
{
	
	rect=new CRect();
	cdg = new CPoint();
	densite = 0;

/*********************************/
/*	Rachit Agrawal 2009 */
/*********************************/

	 line_number = 0;
	 word_number = 0;
	 char_number = 0;
	 class_number = 0;
	 xl_mid = 0;
	 xr_mid = 0;


/*********************************/
/*	Rachit Agrawal 2009 */
/*********************************/




	/**************/
	/* PFE 2006 Deb
	/**************/
	classeE = 0;
	/**************/
	/* PFE 2006 Fin
	/**************/

}


/***************************************************************/ 
//constructeur de la classe CElement avec paramtres de construction
//xi : abscisse du point haut gauche
//yi : ordonne du point haut gauche
//xf : abscisse du point bas droite
//yf : ordonne du point bas droite
/***************************************************************/

CElement::CElement(int xi, int yi, int xf, int yf)
{
	
	rect=new CRect(xi,yi,xf,yf);
	rect->NormalizeRect();

	cdg = new CPoint(rect->CenterPoint());
	densite = 0;

	
/*********************************/
/*	Rachit Agrawal 2009 */
/*********************************/

	 line_number = 0;
	 word_number = 0;
	 char_number = 0;
	 class_number = 0;
	 xl_mid = 0;
	 xr_mid = 0;

/*********************************/
/*	Rachit Agrawal 2009 */
/*********************************/


	/**************/
	/* PFE 2006 Deb
	/**************/
	classeE = 0;
	/**************/
	/* PFE 2006 Fin
	/**************/
}


/***************************************************************/ 
//constructeur de recopie de la classe CElement
/***************************************************************/

CElement::CElement(CElement *e)
{

	rect = new CRect(e->rect);
	rect->NormalizeRect();
	cdg = new CPoint(rect->CenterPoint());
	densite = e->densite;




	
	/*********************************/
	/*	Rachit Agrawal 2009 */
	/*********************************/

		 line_number = e->line_number;
		 word_number = e->word_number;
		 char_number = e->char_number;
		 class_number = e->class_number;
		 xl_mid = e->xl_mid;
		 xr_mid = e->xr_mid;

	/*********************************/
	/*	Rachit Agrawal 2009 */
	/*********************************/


	/**************/
	/* PFE 2006 Deb
	/**************/
	classeE = e->classeE;
	/**************/
	/* PFE 2006 Fin
	/**************/

}

/***********************/
//  DESTRUCTEUR
/***********************/

/***************************************************************/ 
//destructeur de la classe CElement
/***************************************************************/

CElement::~CElement()
{

	delete rect;
	delete cdg;

}


/***********************/
//  METHODES
/***********************/

/****************************************************************/
/* Nom mthode : getCdg                                         */
/*                                                              */  
/* Fonction : retourne le centre de gravit de l'lment        */
/*                                                              */
/*                                                              */  
/****************************************************************/
CPoint * CElement::getCdg()
{

	return cdg;

}



/****************************************************************/
/* Nom mthode : getRect                                        */
/*                                                              */  
/* Fonction : retourne le rectangle englobant de l'lment      */
/*                                                              */
/*                                                              */  
/****************************************************************/
CRect * CElement::getRect()
{
	
	return rect;

}

void CElement::SetRect(int l,int t,int r,int b)
{
	rect->SetRect(l,t,r,b);
}


/****************************************************************/
/* Nom mthode : Afficher                                       */
/*                                                              */  
/* Fonction : affiche l'lment sur l'cran en fonction de la   */
/*            valeur de zoom = zoomcoeff                        */
/*                                                              */  
/****************************************************************/
void CElement::Afficher(CDC *ecran, double zoomcoeff)
{
	


	int x1,y1,xf,yf;
	x1=rect->TopLeft().x;	// rcupre la coord x en haut  gauche
	y1=rect->TopLeft().y;	// rcupre la coord y en haut  gauche

	xf=rect->BottomRight().x;	// rcupre la coord x en bas  droite
	yf=rect->BottomRight().y;	// rcupre la coord y en bas  droite

	x1=floor((double)x1*zoomcoeff);	// prise en compte du facteur de zoom sur chaque point coord
	y1=floor((double)y1*zoomcoeff);
	xf=ceil((double)xf*zoomcoeff);
	yf=ceil((double)yf*zoomcoeff);

	CRect r(x1,y1,xf,yf);	// dfinition d'un rectangle possdant les coordones

	//CBrush *brush=new CBrush(HS_DIAGCROSS,RGB(10,0,0));
	
	ecran->Draw3dRect(r,RGB(255,0,0),RGB(255,0,0));	// affichage sur l'cran du rectangle coorespondant  l'lment
	//ecran->FillRect(r,brush);
	//ecran->DrawEdge(r,BDR_SUNKENINNER,BF_RECT);
	//ecran->Rectangle(x1,y1,xf,yf);
	//delete brush;

}



/********************************************************************/
/* Nom mthode : ExtraireElement                                    */
/*                                                                  */
/* Fonction : dessine les pixels contenus dans l'lement de l'image */    
/*            d'origine sur l'image de destination                  */
/*                                                                  */
/* dest : image sur laquelle on dessine l'element                   */
/* origine : image sur laquelle on prlve les pixels               */
/*                                                                  */
/********************************************************************/
void CElement::ExtraireElement(CImage *origine, CImage *dest)
{
	
	for(int y=0;y<rect->Height();y++)
			for(int x=0;x<rect->Width();x++)
				dest->setPixel(x, y, origine->getPixel (rect->left+x,rect->top+y));

}



/********************************************************************/
/* Nom mthode : Colorier                                           */
/*                                                                  */
/* Fonction : colorie le contenu de l'element avec la valeur        */    
/*            de niveau de gris c                                   */
/*                                                                  */
/* dest : image sur laquele on colorie                              */
/* c : valeur de ndg utilise pour colorier                         */
/*                                                                  */
/********************************************************************/
void CElement::Colorier(CImage *dest, int c)
{
	
	int x,y;

	for(y=rect->top;y<=rect->bottom;y++)
		for(x=rect->left;x<=rect->right;x++)		
			dest->setPixel(x,y,c);
	
}



/********************************************************************/
/* Nom mthode : setDensite                                         */
/*                                                                  */
/* Fonction :                                                       */    
/*                                                                  */
/*                                                                  */
/*                                                                  */
/*                                                                  */
/*                                                                  */
/********************************************************************/
void CElement::setDensite(double d)
{
	
	densite = d;

}



/********************************************************************/
/* Nom mthode : getDensite                                         */
/*                                                                  */
/* Fonction :                                                       */    
/*                                                                  */
/*                                                                  */
/*                                                                  */
/*                                                                  */
/*                                                                  */
/********************************************************************/
double CElement::getDensite()
{

	return densite;

}



/********************************************************************/
/* Nom mthode : Possedent_une_ordonnee_commune                     */
/*                                                                  */
/* Fonction : Permet de dterminer si les rectangles englobant 2    */    
/*            elements distincts ont au moins un point commun au    */
/*            niveau ordonne                                       */
/*                                                                  */
/* e : element avec lequel on fait la comparaison                   */
/*                                                                  */
/* Sortie : vrai, si ils possdent une ordonne communes            */
/*          faux, sinon                                             */
/*                                                                  */
/********************************************************************/
bool CElement::Possedent_une_ordonnee_commune (CElement *e)
{
	
	int y_haut1, y_bas1;
	int y_haut2, y_bas2;

	y_haut1 = this->getRect ()->top;
	y_bas1 = this->getRect ()->bottom;
	y_haut2 = e->getRect ()->top;
	y_bas2 = e->getRect ()->bottom;

	if (y_haut2 >= y_haut1 && y_haut2 <= y_bas1)
		return true;

	if (y_bas2 >= y_haut1 && y_bas2 <= y_bas1)
		return true;

	if (y_haut1 >= y_haut2 && y_haut1 <= y_bas2)
		return true;

	if (y_bas1 >= y_haut2 && y_bas1 <= y_bas2)
		return true;

	return false;

}








/*************************************************************************************************/
/* PFE 2006
/*************************************************************************************************/



/********************************************************************/
/* Nom mthode : SetClasse
/*                                                                  
/* Fonction : permet de spcifier la classe  laquelle appartient l'lment
/*            
/*            
/********************************************************************/
void CElement::SetClasse(int Classe)
{

	classeE = Classe ;

}



/********************************************************************/
/* Nom mthode : SetClasse
/*                                                                  
/* Fonction : permet de rcuperer la classe  laquelle appartient l'lment
/*            
/*            
/********************************************************************/
int CElement::GetClasse()
{

	return classeE;

}
/***************************************** Rachit Agrawal 2009 **********************/
void CElement::SetLineNumber(int ln)
{

	line_number = ln ;

}
int CElement::GetLineNumber()
{

	return line_number;

}
void CElement::SetWordNumber(int wn)
{

	word_number = wn ;

}
int CElement::GetWordNumber()
{

	return word_number;

}
void CElement::SetCharNumber(int chn)
{

	char_number = chn ;

}
int CElement::GetCharNumber()
{

	return char_number;

}
void CElement::SetClassNumber(int cn)
{

	class_number = cn ;

}
int CElement::GetClassNumber()
{

	return class_number;

}
void CElement::SetXLM(int ln)
{

	xl_mid = ln ;

}
int CElement::GetXLM()
{

	return xl_mid;

}
void CElement::SetXRM(int ln)
{

	xr_mid = ln ;

}
int CElement::GetXRM()
{

	return xr_mid;

}

/***************************************** Rachit Agrawal 2009 **********************/


/********************************************************************/
/* Nom mthode : Distance_entre_cdg_element
/*                                                                  
/* Fonction : calcul la distance entre les centres de gravit des 2
/*            element
/*
/* e : element avec lequel on compare
/*
/* Sortie : vaeur de la distance           
/*
/********************************************************************/
int CElement::Distance_entre_cdg_element (CElement *e)
{
	
	int cdg_this_x, cdg_this_y;
	int cdg_e_x, cdg_e_y;
	int resultat;

	cdg_this_x	= this->getCdg()->x;
	cdg_this_y	= this->getCdg()->y;
	cdg_e_x		= e->getCdg()->x;
	cdg_e_y		=  e->getCdg()->y;

	resultat = sqrt( (double)((cdg_this_x - cdg_e_x)^2) + (double)((cdg_this_y - cdg_e_y)^2) );

	return (resultat);

}



/********************************************************************/
/* Nom mthode : Possedent_une_abscisse_commune                     */
/*                                                                  */
/* Fonction : Permet de dterminer si les rectangles englobant 2    */    
/*            elements distincts ont au moins un point commun au    */
/*            niveau abscisse                                       */
/*                                                                  */
/* e : element avec lequel on fait la comparaison                   */
/*                                                                  */
/* Sortie : vrai, si ils possdent une abscisse communes            */
/*          faux, sinon                                             */
/*                                                                  */
/********************************************************************/
bool CElement::Possedent_une_abscisse_commune (CElement *e)
{
	
	int y_gauche1, y_droite1;
	int y_gauche2, y_droite2;

	y_gauche1 = this->getRect ()->left;
	y_droite1 = this->getRect ()->right;
	y_gauche2 = e->getRect ()->left;
	y_droite2 = e->getRect ()->right;

	if (y_gauche2 >= y_gauche1 && y_gauche2 <= y_droite1)
		return true;

	if (y_droite2 >= y_gauche1 && y_droite2 <= y_droite1)
		return true;

	if (y_gauche1 >= y_gauche2 && y_gauche1 <= y_droite2)
		return true;

	if (y_droite1 >= y_gauche2 && y_droite1 <= y_droite2)
		return true;

	return false;

}



/********************************************************************/
/* Nom mthode : Distance_ordonnee_commune                          */
/*                                                                  */
/* Fonction : Permet de dterminer si les rectangles englobant 2    */    
/*            elements distincts ont au moins un point commun au    */
/*            niveau ordonne                                       */
/*                                                                  */
/* e : element avec lequel on fait la comparaison                   */
/*                                                                  */
/* Sortie : vrai, si ils possdent une ordonne communes            */
/*          faux, sinon                                             */
/*                                                                  */
/********************************************************************/
int CElement::Distance_ordonnee_commune (CElement *e)
{
	
	int y_haut1, y_bas1;
	int y_haut2, y_bas2;
	int resultat = 0;

	y_haut1 = this->getRect ()->top;
	y_bas1 = this->getRect ()->bottom;
	y_haut2 = e->getRect ()->top;
	y_bas2 = e->getRect ()->bottom;

	if (y_haut2 >= y_haut1 && y_haut2 <= y_bas1)
	{	
		if((y_bas2 - y_bas1) >= 0)
		{
			resultat = (y_bas2 - y_haut2) -	(y_bas2 - y_bas1);		
		}
		else
		{
			resultat = (y_bas2 - y_haut2);
		}

		return resultat;
	}

	if (y_bas2 >= y_haut1 && y_bas2 <= y_bas1)
	{
		if((y_haut1 - y_haut2) >= 0)
		{
			resultat = (y_bas2 - y_haut2) - ( y_haut1 - y_haut2);
		}
		else
		{
			resultat = (y_bas2 - y_haut2);
		}
		return resultat;
	}

	if (y_haut1 >= y_haut2 && y_haut1 <= y_bas2)
	{
		if((y_bas1 - y_bas2) >= 0)
		{
			resultat = (y_bas1 - y_haut1) -	(y_bas1 - y_bas2);		
		}
		else
		{
			resultat = (y_bas1 - y_haut1);
		}
		return resultat;
	}

	if (y_bas1 >= y_haut2 && y_bas1 <= y_bas2)
	{
		if((y_haut2 - y_haut1) >= 0)
		{
			resultat = (y_bas1 - y_haut1) - ( y_haut2 - y_haut1);
		}
		else
		{
			resultat = (y_bas1 - y_haut1);
		}
		return resultat;
	}

	return(0);
}