/*******************************************************************/
// Element.h: interface for the CElement class.
//
// Cette classe est destine  dcrire une composante connexe et plus
// particulirement le rectangle englobant une composante dtect
//
/*******************************************************************/

#if !defined(AFX_ELEMENT_H__C50003E2_678D_473E_8C43_B8B196767C8B__INCLUDED_)
#define AFX_ELEMENT_H__C50003E2_678D_473E_8C43_B8B196767C8B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



/***********************/
//  INCLUSION
/***********************/

#include "plwinbmp.h"
#include "image.h"

/***********************/
//  CLASSE
/***********************/

class CElement : public CObject 
{

private:

	CRect *rect;
	CPoint *cdg;
	double densite;

	/**************/
	/* Rachit Agrawal 2009
	/**************/
	int line_number;
	int word_number;
	int char_number;
	int class_number;
	int xl_mid;
	int xr_mid;

	/**************/
	/* Rachit Agrawal 2009
	/**************/

	/**************/
	/* PFE 2006 Deb
	/**************/

	int classeE;	// 1= CC plus haute et plus basse que la moyenne : f manuscrit et autres
					// 2= CC plus haute que la moyenne : t,b,l,k,f
					// 3= CC plus basse que la moyenne : p,q,g
					// 4= CC moyenne : a,c,s,u,o
					// 5= CC plus haute et plus large que la moyenne (Majuscule)
					// 6= Anomalie : tout le reste et toutes les CC qui se recouvrent

	/**************/
	/* PFE 2006 Fin
	/**************/
	
public:

	double getDensite();
	void setDensite(double d);
	CRect * getRect();
	CPoint * getCdg();
	/******************* Rachit Agrawal 2009 **********************************/
	void CElement::SetRect(int l,int t,int r,int b);

	void SetLineNumber(int ln);
	int GetLineNumber();
	void SetWordNumber(int wn);
	int GetWordNumber();
	void SetCharNumber(int chn);
	int GetCharNumber();
	void SetClassNumber(int cn);
	int GetClassNumber();
	void SetXLM(int ln);
	int GetXLM();
	void SetXRM(int cn);
	int GetXRM();
	/******************* Rachit Agrawal 2009 **********************************/
	void Afficher(CDC *ecran, double zoomcoeff);
	void ExtraireElement(CImage *origine, CImage *dest);
	void Colorier(CImage *dest, int c);
	bool Possedent_une_ordonnee_commune (CElement *e);
	CElement();
	CElement(int xi,int yi,int xf,int yf);
	CElement(CElement *);
	virtual ~CElement();

	/**************/
	/* PFE 2006 Deb
	/**************/

	void SetClasse(int Classe);
	int GetClasse();
	int Distance_entre_cdg_element (CElement *e);
	bool Possedent_une_abscisse_commune (CElement *e);
	int Distance_ordonnee_commune (CElement *e);

	/**************/
	/* PFE 2006 Fin
	/**************/


};



#endif // !defined(AFX_ELEMENT_H__C50003E2_678D_473E_8C43_B8B196767C8B__INCLUDED_)
