

#include "stdafx.h"
#include "MyApp.h"
#include "ExportResultats.h"
#include <fstream>
#include <io.h>
#include <direct.h>

CExportResultats::CExportResultats(void)
{
}

CExportResultats::~CExportResultats(void)
{
}


void CExportResultats::EcrireToutesCaracGroupees(CString nomDeLEtiquette, CString nomDuDocument, CList<CString,CString&>* listeCarac)
{
	CString sCheminFic = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats();
	CString sNomRep = sCheminFic + "\\tests\\" ;

	if (!PathFileExists(sNomRep)) _mkdir(sNomRep);

	sNomRep += nomDeLEtiquette ;

	CString sNomFic = sNomRep + "\\" + "ToutesLesCarac" + ".txt";

	if ((_access(sNomFic, 0))!= -1)
	{
		//le fichier existe deja
		CStdioFile fichiertest (sNomFic,CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText) ;
		fichiertest.SeekToEnd();
		fichiertest.WriteString(nomDuDocument);
		POSITION posListeCarac = listeCarac->GetHeadPosition();
		while(posListeCarac)
		{
			fichiertest.WriteString("\t\t" + listeCarac->GetNext(posListeCarac));
		}
		fichiertest.WriteString("\n");
		fichiertest.Close();
	}else
	{
		//le fichier n'existe pas
		CStdioFile fichiertest (sNomFic,CFile::modeCreate | CFile::modeWrite | CFile::typeText) ;
		fichiertest.WriteString("NomDuDocument\t\tRapportLsurH\t\tNbElements\tRapportHsurHmoyCC\tLargeurZone\tHauteurZone\tDensitePixBlanc\t\tDensiteNdg\tDegreGauche\t\tDegreDroite\t\tDegreHaut\t\tDegreBas\t\tDegreCentreP\t\tDegreCentreL\t\tDegreCentreH\t\tClasse\t\tVoisinHaut\tVoisinGauche\tVoisinBas\tVoisinDroite\tVoisinInclus\n");
		fichiertest.WriteString(nomDuDocument);
		POSITION posListeCarac = listeCarac->GetHeadPosition();
		while(posListeCarac)
		{
			fichiertest.WriteString("\t\t" + listeCarac->GetNext(posListeCarac));
		}
		fichiertest.WriteString("\n");
		fichiertest.Close();
	}
		
	
}


void CExportResultats::EcrireChaqueCaracParFichier(CString nomDeLEtiquette, CString nomDuDocument, CString nomDeLaCaracteristique, CString valeurDeLaCaracteristique)
{

	CString sCheminFic = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats();
	CString sNomRep = sCheminFic + "\\tests\\" ;

	if (!PathFileExists(sNomRep)) _mkdir(sNomRep);

	sNomRep += nomDeLEtiquette ;

	if ((_access(sNomRep, 0))== -1)
	{
		//le repertoire n'existe pas
		_mkdir(sNomRep);
	}

	CString sNomFic = sNomRep + "\\" + nomDeLaCaracteristique + ".txt";

	if ((_access(sNomFic, 0))!= -1)
	{
		//le fichier existe deja
		CStdioFile fichiertest (sNomFic,CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText) ;
		fichiertest.SeekToEnd();
		fichiertest.WriteString(nomDuDocument + "\t" + valeurDeLaCaracteristique + "\n");
		fichiertest.Close();
	}else
	{
		//le fichier n'existe pas
		CStdioFile fichiertest (sNomFic,CFile::modeCreate | CFile::modeWrite | CFile::typeText) ;
		fichiertest.WriteString(nomDuDocument + "\t" + valeurDeLaCaracteristique + "\n");
		fichiertest.Close();
	}
		
	
}



void CExportResultats::EcrireCalculs(CString nomDeLEtiquette, CList<double>* listeBorneInf, CList<double>* listeBorneSup, CList<double>* listeMin, CList<double>* listeMax, CList<double>* listeVariance, CList<double>* listeEcartType, CList<double>* listeMoyenne, CList<double>* listeMediane)
{
	CString sCheminFic = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats();
	CString sNomRep = sCheminFic + "\\tests\\" ;

	if (!PathFileExists(sNomRep)) _mkdir(sNomRep);

	sNomRep += nomDeLEtiquette ;

	CString sNomFic = sNomRep + "\\" + "Calculs" + ".txt";

	//si le fichier existe ou n'existe pas on rcrit par dessus
	CStdioFile fichiertest (sNomFic,CFile::modeCreate | CFile::modeWrite | CFile::typeText) ;
	fichiertest.WriteString("Calculs\t\tRapportLsurH\t\tNbElements\t\tRapportHsurHmoyCC\tLargeurZone\t\tHauteurZone\t\tDensitePixBlanc\t\tDensiteNdg\t\tDegreGauche\t\tDegreDroite\t\tDegreHaut\t\tDegreBas\t\tDegreCentreP\t\tDegreCentreL\t\tDegreCentreH\t\tVoisinHaut\t\tVoisinGauche\t\tVoisinBas\t\tVoisinDroite\t\tVoisinInclusDans\n");
	fichiertest.WriteString("bInf");
	POSITION posListeBorneInf = listeBorneInf->GetHeadPosition();
	while(posListeBorneInf)
	{
		CString resTemp = ConvertirCaracEnString(listeBorneInf->GetNext(posListeBorneInf));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("bSup");
	POSITION posListeBorneSup = listeBorneSup->GetHeadPosition();
	while(posListeBorneSup)
	{
		CString resTemp = ConvertirCaracEnString(listeBorneSup->GetNext(posListeBorneSup));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("min");
	POSITION posListeMin = listeMin->GetHeadPosition();
	while(posListeMin)
	{
		CString resTemp = ConvertirCaracEnString(listeMin->GetNext(posListeMin));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("max");
	POSITION posListeMax = listeMax->GetHeadPosition();
	while(posListeMax)
	{
		CString resTemp = ConvertirCaracEnString(listeMax->GetNext(posListeMax));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("var");
	POSITION posListeVariance = listeVariance->GetHeadPosition();
	while(posListeVariance)
	{
		CString resTemp = ConvertirCaracEnString(listeVariance->GetNext(posListeVariance));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("eTyp");
	POSITION posListeEcartType = listeEcartType->GetHeadPosition();
	while(posListeEcartType)
	{
		CString resTemp = ConvertirCaracEnString(listeEcartType->GetNext(posListeEcartType));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("moy");
	POSITION posListeMoyenne = listeMoyenne->GetHeadPosition();
	while(posListeMoyenne)
	{
		CString resTemp = ConvertirCaracEnString(listeMoyenne->GetNext(posListeMoyenne));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.WriteString("med");
	POSITION posListeMediane = listeMediane->GetHeadPosition();
	while(posListeMediane)
	{
		CString resTemp = ConvertirCaracEnString(listeMediane->GetNext(posListeMediane));
		fichiertest.WriteString("\t\t" + resTemp);
	}
	fichiertest.WriteString("\n");
	fichiertest.Close();
	
}

void CExportResultats::EcrireCalculsClasses(CString nomDeLEtiquette, CString classeSelection, CString classeVG, CString classeVD, CString classeVH, CString classeVB, CString classeVI)
{
	CString sCheminFic = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats();
	CString sNomRep = sCheminFic + "\\tests\\" ;

	if (!PathFileExists(sNomRep)) _mkdir(sNomRep);

	sNomRep += nomDeLEtiquette ;


	CString sNomFic = sNomRep + "\\" + "Calculs-Classes" + ".txt";

	//si le fichier existe ou n'existe pas on rcrit par dessus
	CStdioFile fichiertest (sNomFic,CFile::modeCreate | CFile::modeWrite | CFile::typeText) ;
	
	fichiertest.WriteString("Classe\t\t" + classeSelection + "\n");
	fichiertest.WriteString("VGauche\t\t" + classeVG + "\n");
	fichiertest.WriteString("VDroite\t\t" + classeVD + "\n");
	fichiertest.WriteString("VHaut\t\t" + classeVH + "\n");
	fichiertest.WriteString("VBas\t\t" + classeVB + "\n");
	fichiertest.WriteString("VInclus\t\t" + classeVI + "\n");
	fichiertest.Close();
	
}


CString CExportResultats::ConvertirCaracEnString(int valeurDeLaCaracteristique)
{
	CString sValeurCarac;
	sValeurCarac.Format(_T("%d"), valeurDeLaCaracteristique);

	return sValeurCarac;
}

CString CExportResultats::ConvertirCaracEnString(double valeurDeLaCaracteristique)
{
	CString sValeurCarac;
	sValeurCarac.Format(_T("%f"), valeurDeLaCaracteristique);
	
	return sValeurCarac;
}

CString CExportResultats::ConvertirCaracEnString(LONG valeurDeLaCaracteristique)
{
	CString sValeurCarac;
	sValeurCarac.Format(_T("%d"), valeurDeLaCaracteristique);
	
	return sValeurCarac;
}

CString CExportResultats::ConvertirCaracEnString(CPoint* valeurDeLaCaracteristique)
{
	CString sValeurCarac;
	sValeurCarac.Format(_T("%d %d"), (int)valeurDeLaCaracteristique->x, (int)valeurDeLaCaracteristique->y);
	
	return sValeurCarac;
}
