/************************************************************************/
// Image.h: interface for the CImage class.
//
// Regroupe toutes les actions qu'il est possible d'effectuer sur une image
//
/************************************************************************/

#if !defined(AFX_IMAGE_H__597ADABB_2E53_4DEB_8FF8_722C3D442167__INCLUDED_)
#define AFX_IMAGE_H__597ADABB_2E53_4DEB_8FF8_722C3D442167__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/***********************/
//  INCLUSION
/***********************/

#include "plbitmap.h"
#include "plwinbmp.h"

#include "pljpegenc.h"
#include "pltiffenc.h"
#include "plpngenc.h"
#include "plbmpenc.h"

#include "planydec.h"

#include "plexcept.h"
#include "plpixel8.h"
#include "plfiltercrop.h"
#include "plfiltergrayscale.h"


/***********************/
//  CLASSE
/***********************/

class CImage  
{

public :

	PLWinBmp *m_pImage;
	CString nomCompletImg;

private:

//////////////
// attributs
//////////////

	int bpp;		// nombre de bits par pixel
	int hauteur;	// hauteur de l'image
	int largeur;	// largeur de l'image
 
	bool binarisee; // l'image est elle binarise ou non
	bool ndgrisee;	// l'image a t elle t convertie en niveaux de gris

public:

///////////////////////////////
// constructeur et destructeur
///////////////////////////////

	CImage();
	CImage(int,int,int);
	virtual ~CImage();

////////////
//mthodes
////////////

	void setTailleLxH(int L, int H);
	
	void Fermeture();
	void Ouverture();
	void EffacerBords();
	void Afficher(CDC* ecran, double zoom_coeff);

	int getHauteur();
	int getLargeur();
	int getNbBitsParPixel();

	void setBinarisee (bool b);

	int setPixel(int x,int y,int val);
	int getPixel(int x, int y);

	void Dilater();
	void Eroder();
	void Binariser(int seuil,CImage *im=NULL);
	int Binariser_Niblack(bool juste_valeur);
	void Inverser();
	void ConvertirNdg();

	void Copier(CImage *org);
	void Copier32(CImage *org);
	
	void Sauvegarder(CString type,CString nom);
	bool Charger(CString);
	void DeCharger(CString path);
	void ReCharger();

	CSize getTaille();

	PLWinBmp * getPointeur();

	bool Comparer (CImage *img, double seuil);
	bool Comparer_Lebourg (CImage *img, CImage *img_dilatee, CImage* dilatee, double seuil);



};




#endif // !defined(AFX_IMAGE_H__597ADABB_2E53_4DEB_8FF8_722C3D442167__INCLUDED_)
