
#include "stdafx.h"
#include "MyApp.h"
#include ".\laboclassif.h"
#include "TypeClasse.h"
#include "MainFrm.h"
#include "constante.h"


CLaboClassif::CLaboClassif(void)
{
	listeDocsLaboClassif = new CObList(10);
	listeTypesClasse = new CObList(10);
	classifAuto = new CClassifAuto();
	scenarioClassif = new CScenario();
}

CLaboClassif::~CLaboClassif(void)
{
	delete listeDocsLaboClassif;
	delete listeTypesClasse;
	delete classifAuto;
	delete scenarioClassif;
}

void CLaboClassif::RazClassifAuto()
{
	delete classifAuto;
	classifAuto = new CClassifAuto();
}

void CLaboClassif::setScenarioClassif(CScenario* scenarIn)
{
	//recopier le scnarIn dans scenarioClassif, regle par regle
	POSITION posReg = scenarIn->getListeRegles()->GetHeadPosition();
	while (posReg)
	{
		CRegle* newReg = (CRegle*)scenarIn->getListeRegles()->GetNext(posReg);
		CString bal = newReg->getBalise();
		CRegle* a;

		if (bal == "TYPE")
		{

			a = (CRegleType*)newReg;

		}

		if (bal == "RCG")
		{

			a = (CRegleCG*)newReg;

		}

		if (bal == "RCV")
		{

			a = (CRegleCV*)newReg;

		}

		if (bal == "RCC")
		{

			a = (CRegleCC*)newReg;

		}

		if (bal == "FUS")
		{

			a = (CRegleFusion*)newReg;

		}

		if (bal == "RST")
		{

			a = (CRegleSupType*)newReg;

		}

		if (bal == "RBI")
		{

			a = (CRegleBin*)newReg;

		}

		if (bal == "RMO")
		{

			a = (CRegleMorph*)newReg;

		}

		if (bal == "RCO")
		{

			a = (CRegleContour*)newReg;

		}

		if (bal == "RIN")
		{

			a = (CRegleIntersection*)newReg;

		}

		if (bal == "RPL")
		{

			a = (CReglePlage*)newReg;

		}

		if (bal == "RPO")
		{

			a = (CReglePost*)newReg;

		}

		if (bal == "RSR")
		{

			a = (CRegleSR*)newReg;

		}

		if (bal == "TAO")
		{

			a = (CRegleTAO*)newReg;

		}

		if (bal == "RAF")
		{

			a = (CRegleAnalyseFine*)newReg;

		}

		if (bal == "RCAR")
		{

			a = (CRegleCarac*)newReg;

		}

		if (bal == "RCT")
		{

			a = (CRegleChangeType*)newReg;

		}

		scenarioClassif->Ajouter(a);
	}
}

void CLaboClassif::setListeDocuments(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeDocsLaboClassif->AddTail(listeIn->GetNext(posTemp));
	}
}

void CLaboClassif::getCopieListeTypesClasse(CObList* listeIn)
{
	POSITION posTemp = listeTypesClasse->GetHeadPosition();
	while (posTemp)
	{
		listeIn->AddTail(listeTypesClasse->GetNext(posTemp));
	}
}


void CLaboClassif::addElemListeDocuments(CMyAppDoc* docIn)
{
	listeDocsLaboClassif->AddTail(docIn);
}

bool CLaboClassif::supprElemListeDocuments(CMyAppDoc* docIn)
{
	LVFINDINFO pFindInfo;
	pFindInfo.flags = LVFI_PARTIAL|LVFI_STRING;
	pFindInfo.psz = docIn->m_nom;
	int numPos = 0;
	numPos = ((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->m_ListThumbnail.FindItem(&pFindInfo);


	POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CMyAppDoc* docTmp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
		if (docTmp == docIn)
		{
			if (numPos != -1)
			{
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->m_ListThumbnail.DeleteItem(numPos);
			}
			listeDocsLaboClassif->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboClassif::supprAllListeDocuments()
{
	listeDocsLaboClassif->RemoveAll();
}

void CLaboClassif::setListeTypesClasse(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeTypesClasse->AddTail(listeIn->GetNext(posTemp));
	}
}


void CLaboClassif::addElemListeTypesClasse(CTypeClasse* typeIn)
{
	listeTypesClasse->AddTail(typeIn);
}

bool CLaboClassif::findElemListeTypesClasse(CString nom)
{
	if (!listeTypesClasse->IsEmpty())
	{
		POSITION pos = listeTypesClasse->GetHeadPosition();
		while (pos)
		{
			CTypeClasse *t = (CTypeClasse *)listeTypesClasse->GetNext(pos);

			if (t->getNomClasse() == nom)
			{
				return true;
			}
		}
	}
	return false;
}

bool CLaboClassif::supprElemListeTypesClasse(CTypeClasse* typeIn)
{
	POSITION posTemp = listeTypesClasse->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CTypeClasse* typeTmp = (CTypeClasse*)listeTypesClasse->GetNext(posTemp);
		if (typeTmp == typeIn)
		{
			listeTypesClasse->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboClassif::supprAllListeTypesClasse()
{
	listeTypesClasse->RemoveAll();
}

void CLaboClassif::ModeSelection()
{
	if (!listeDocsLaboClassif->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pViewTemp->m_selectionmode=!pViewTemp->m_selectionmode;
			pViewTemp->m_zoommode = false;
			//a commenter:
			//pViewTemp->Invalidate(true);


			pDocTemp->DeleteContents();

		}
	}
}

void CLaboClassif::UpdateModeSelection(CCmdUI* pCmdUI)
{
	//CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	if (!listeDocsLaboClassif->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pCmdUI->SetCheck(pViewTemp->m_selectionmode);
			//((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist33()->m_ctrlAssist3BtnLabelC.SetState(pViewTemp->m_selectionmode);


			pDocTemp->DeleteContents();

		}
	}
}


void CLaboClassif::ModeZoom()
{
	if (!listeDocsLaboClassif->IsEmpty())
	{

		POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pViewTemp->m_zoommode=!pViewTemp->m_zoommode;
			pViewTemp->m_selectionmode = false;
			pViewTemp->Invalidate(true);
			


			pDocTemp->DeleteContents();

		}
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_modeSelection = false;
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_ctrlAssist3BtnLabelC.SetState(false);
	}
}

void CLaboClassif::UpdateModeZoom(CCmdUI* pCmdUI)
{
	if (!listeDocsLaboClassif->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pCmdUI->SetCheck(pViewTemp->m_zoommode);

			pDocTemp->DeleteContents();

		}
	}
}

void CLaboClassif::AfficherDocSuivant()
{
	if (!listeDocsLaboClassif->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboClassif::AfficherDocPrecedent()
{
	if (!listeDocsLaboClassif->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIPrev();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboClassif::RendreLeFocusALImageActive()
{
	CMDIChildWnd * pChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pChild->SetFocus();
}

void CLaboClassif::MajMenu()
{
	if (!listeDocsLaboClassif->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);

			pViewTemp->GriserMenuTrait();
			pViewTemp->DeGriserMenuClassif();
			pViewTemp->GriserMenuProj();

		}
	}
}

void CLaboClassif::OuvrirImagesLaboClassif()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CProjetParam *pPramProjTemp = pAppTemp->projet->getParamProj();
	CMyAppDoc *pDocCur, *pDocAAfficher;

	POSITION posDocs = pPramProjTemp->getM_listeImageClassif()->GetHeadPosition();
	while (posDocs)
	{
		CString nomIm;
		nomIm.Format("%s\\%s",pPramProjTemp->getM_repOuvrage(),pPramProjTemp->getM_listeImageClassif()->GetNext(posDocs));
		if (!listeDocsLaboClassif->IsEmpty())
		{
			pDocCur = (CMyAppDoc*)listeDocsLaboClassif->GetTail();
			pAppTemp->DechargerDoc(pDocCur);
		}
		pAppTemp->OuvrirDocument(nomIm,LABOCLASSIF);
	}

	//decharger le dernier document ouvert
	pDocCur = (CMyAppDoc*)listeDocsLaboClassif->GetTail();
	pAppTemp->DechargerDoc(pDocCur);
	
	//charger le premier document de la liste
	pAppTemp->docCharge = false;
	pDocAAfficher = (CMyAppDoc*)listeDocsLaboClassif->GetHead();
	pAppTemp->ChargerDoc(pDocAAfficher);


	pAppTemp->OnMenuAffBarreProjet();
	//affiche le scenario cr dans l'tape prcdente
	scenarioClassif->Afficher();
	//applique le scenario cr dans l'tape prcdente
	ApplicationScenarioStartup();
}

void CLaboClassif::ApplicationScenarioStartup()
{

	POSITION posTemp = listeDocsLaboClassif->GetHeadPosition();
	while (posTemp!=NULL) {

		CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboClassif->GetNext(posTemp);
		ASSERT_VALID(pDocTemp);
		if (pDocTemp->atelier->liste_de_zones->liste->IsEmpty())
		{
			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);
			
			scenarioClassif->Executer(pDocTemp);

			//n'affiche pas les CC (bouton dsenfonc)
			pViewTemp->affiche_cc = false;
			pViewTemp->affiche_zone = true;
		}
		pDocTemp->DeleteContents();
	}
}

void CLaboClassif::ViderLabo()
{
	scenarioClassif->EffacerTout();
	scenarioClassif->Afficher();
	listeDocsLaboClassif->RemoveAll();
	listeTypesClasse->RemoveAll();
	delete classifAuto;
	classifAuto = new CClassifAuto();
}
