
#include "stdafx.h"
#include "MyApp.h"
#include ".\laboprojet.h"
#include "TypeClasse.h"
#include "MainFrm.h"
#include "constante.h"


CLaboProjet::CLaboProjet(void)
{
	listeDocsLaboProj = new CObList(10);
	listeTypesClasse = new CObList(10);
	scenarioProj = new CScenario();
	liste_permanente = new CListeCC ();
	appliOuvrDone = false;
	exportDone = false;
}

CLaboProjet::~CLaboProjet(void)
{
	delete listeDocsLaboProj;
	delete listeTypesClasse;
	delete scenarioProj;
	delete liste_permanente;
}

void CLaboProjet::setScenarioProj(CScenario* scenarIn)
{
	//recopier le scnarIn dans scenarioProj, regle par regle
	POSITION posReg = scenarIn->getListeRegles()->GetHeadPosition();
	while (posReg)
	{
		CRegle* newReg = (CRegle*)scenarIn->getListeRegles()->GetNext(posReg);
		CString bal = newReg->getBalise();
		CRegle* a;

		if (bal == "TYPE")
		{

			a = (CRegleType*)newReg;

		}

		if (bal == "RCG")
		{

			a = (CRegleCG*)newReg;

		}

		if (bal == "RCV")
		{

			a = (CRegleCV*)newReg;

		}

		if (bal == "RCC")
		{

			a = (CRegleCC*)newReg;

		}

		if (bal == "FUS")
		{

			a = (CRegleFusion*)newReg;

		}

		if (bal == "RST")
		{

			a = (CRegleSupType*)newReg;

		}

		if (bal == "RBI")
		{

			a = (CRegleBin*)newReg;

		}

		if (bal == "RMO")
		{

			a = (CRegleMorph*)newReg;

		}

		if (bal == "RCO")
		{

			a = (CRegleContour*)newReg;

		}

		if (bal == "RIN")
		{

			a = (CRegleIntersection*)newReg;

		}

		if (bal == "RPL")
		{

			a = (CReglePlage*)newReg;

		}

		if (bal == "RPO")
		{

			a = (CReglePost*)newReg;

		}

		if (bal == "RSR")
		{

			a = (CRegleSR*)newReg;

		}

		if (bal == "TAO")
		{

			a = (CRegleTAO*)newReg;

		}

		if (bal == "RAF")
		{

			a = (CRegleAnalyseFine*)newReg;

		}

		if (bal == "RCAR")
		{

			a = (CRegleCarac*)newReg;

		}

		if (bal == "RCT")
		{

			a = (CRegleChangeType*)newReg;

		}

		scenarioProj->Ajouter(a);
	}
}


void CLaboProjet::setListeDocuments(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeDocsLaboProj->AddTail(listeIn->GetNext(posTemp));
	}
}


void CLaboProjet::addElemListeDocuments(CMyAppDoc* docIn)
{
	listeDocsLaboProj->AddTail(docIn);
}

bool CLaboProjet::supprElemListeDocuments(CMyAppDoc* docIn)
{
	POSITION posTemp = listeDocsLaboProj->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CMyAppDoc* docTmp = (CMyAppDoc*)listeDocsLaboProj->GetNext(posTemp);
		if (docTmp == docIn)
		{
			listeDocsLaboProj->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboProjet::supprAllListeDocuments()
{
	listeDocsLaboProj->RemoveAll();
}

void CLaboProjet::setListeTypesClasse(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeTypesClasse->AddTail(listeIn->GetNext(posTemp));
	}
}


void CLaboProjet::addElemListeTypesClasse(CTypeClasse* typeIn)
{
	listeTypesClasse->AddTail(typeIn);
}

bool CLaboProjet::findElemListeTypesClasse(CString nom)
{
	if (!listeTypesClasse->IsEmpty())
	{
		POSITION pos = listeTypesClasse->GetHeadPosition();
		while (pos)
		{
			CTypeClasse *t = (CTypeClasse *)listeTypesClasse->GetNext(pos);

			if (t->getNomClasse() == nom)
			{
				return true;
			}
		}
	}
	return false;
}

bool CLaboProjet::supprElemListeTypesClasse(CTypeClasse* typeIn)
{
	POSITION posTemp = listeTypesClasse->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CTypeClasse* typeTmp = (CTypeClasse*)listeTypesClasse->GetNext(posTemp);
		if (typeTmp == typeIn)
		{
			listeTypesClasse->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboProjet::supprAllListeTypesClasse()
{
	listeTypesClasse->RemoveAll();
}

void CLaboProjet::ModeZoom()
{
	if (!listeDocsLaboProj->IsEmpty())
	{

		POSITION posTemp = listeDocsLaboProj->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboProj->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pViewTemp->m_zoommode=!pViewTemp->m_zoommode;
			pViewTemp->m_selectionmode = false;
			pViewTemp->Invalidate(true);
			


			pDocTemp->DeleteContents();

		}
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_modeSelection = false;
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_ctrlAssist3BtnLabelC.SetState(false);
	}
}

void CLaboProjet::UpdateModeZoom(CCmdUI* pCmdUI)
{
	if (!listeDocsLaboProj->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboProj->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboProj->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pCmdUI->SetCheck(pViewTemp->m_zoommode);

			pDocTemp->DeleteContents();

		}
	}
}

void CLaboProjet::AfficherDocSuivant()
{
	if (!listeDocsLaboProj->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboProjet::AfficherDocPrecedent()
{
	if (!listeDocsLaboProj->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIPrev();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboProjet::RendreLeFocusALImageActive()
{
	CMDIChildWnd * pChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pChild->SetFocus();
}

void CLaboProjet::MajMenu()
{
	if (!listeDocsLaboProj->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboProj->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboProj->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);

			pViewTemp->GriserMenuTrait();
			pViewTemp->GriserMenuClassif();
			pViewTemp->DeGriserMenuProj();

		}
	}
}

void CLaboProjet::OuvrirTousDocsOuvrage()
{
	//ouvrir tous les docs contenus dans le rep de l'ouvrage
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CProjetParam *pParamProjTemp = pAppTemp->projet->getParamProj();
	CString rep;
	CMyAppDoc *pDocCur, *pDocAAfficher;

	rep = pParamProjTemp->getM_repOuvrage();
	int compteur=0;
		
	char path[256];
	BOOL bWorking;
	CFileFind finder;
	CString avancement;

	for (int i=0;i<4;i++)	// On compte le nombre de fichiers  traiter pour renseigner
	{						// la barre de progression
		strcpy(path,rep);

		switch(i)
		{
			case 0:strcat(path,"\\*.jpg");break;
			case 1:strcat(path,"\\*.tif");break;
			case 2:strcat(path,"\\*.png");break;
			case 3:strcat(path,"\\*.bmp");break;

		}

		bWorking = finder.FindFile(path);
		
		while (bWorking)
		{
			
			bWorking = finder.FindNextFile();
			compteur++;
		}

		finder.Close();

	}

	if (compteur != 0)
	{
		int compteurCourant = 1;
		
		for (i=0;i<4;i++)
		{
			strcpy(path,rep);
			
			switch(i)
			{
				case 0:strcat(path,"\\*.jpg");break;
				case 1:strcat(path,"\\*.tif");break;
				case 2:strcat(path,"\\*.png");break;
				case 3:strcat(path,"\\*.bmp");break;
			}

			bWorking = finder.FindFile(path);
			
			while (bWorking)
			{
				//((CMainFrame*)AfxGetMainWnd())->SetForegroundWindow();
				//((CMainFrame*)AfxGetMainWnd())->SetRedraw();
				avancement.Format("%d/%d",compteurCourant, compteur);
				((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(1, avancement);
				bWorking = finder.FindNextFile();

				if (!listeDocsLaboProj->IsEmpty())
				{
					pDocCur = (CMyAppDoc*)listeDocsLaboProj->GetTail();
					pAppTemp->DechargerDoc(pDocCur);
				}
				pAppTemp->OuvrirDocument(finder.GetFilePath(),LABOPROJET);

				compteurCourant++;
			}

			finder.Close();

		}
	}

	//charger le premier document de la liste
	pAppTemp->docCharge = false;
	pDocAAfficher = (CMyAppDoc*)listeDocsLaboProj->GetHead();
	pAppTemp->ChargerDoc(pDocAAfficher);


	pAppTemp->OnMenuAffBarreProjet();
	//affiche le scenario cr dans l'tape prcdente
	scenarioProj->Afficher();
}

void CLaboProjet::ApplicationScenarioProjet()
{
	//ICI : c'est ici qu'il faut crer une image lorsque l'on accde au document concern
	// et on la supprime une fois qu'on a fini d'appliquer le scenario dessus.
	//pour l'image courante, il faut la sauvegarder dans un dossier temporaire
	//qui sera supprim  la fermeture de l'application.
	clock_t start, finish;
    double  duree;
	int compteur=0;

	start = clock();
	compteur = listeDocsLaboProj->GetCount();

	POSITION posTemp = listeDocsLaboProj->GetHeadPosition();
	while (posTemp) {

		CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboProj->GetNext(posTemp);
		ASSERT_VALID(pDocTemp);
		if (pDocTemp->atelier->liste_de_zones->liste->IsEmpty())
		{
			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);
			
			scenarioProj->Executer(pDocTemp);

			//n'affiche pas les CC (bouton dsenfonc)
			pViewTemp->affiche_cc = false;
			pViewTemp->affiche_zone = true;
		}
		pDocTemp->DeleteContents();
	}

	if (!liste_permanente->get_liste()->IsEmpty())
	{
		liste_permanente->AmeliorerClassification ();
		liste_permanente->CreerFichierNbOccurence ();
	}

	finish = clock();
	duree = (double)(finish - start) / CLOCKS_PER_SEC /60;

	CString message;
	message.Format("%d image(s) traite(s) \n en %2.1f minutes", compteur, duree);
	((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0, message);
	//AfxMessageBox(message);

	//analyse effectue => autres actions possibles
	appliOuvrDone = true;
	exportDone = true;
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist4()->AfficherCacherBoutonsSupplementaires();
	((CMainFrame*)AfxGetMainWnd())->CacherProgressBar();
}

void CLaboProjet::ViderLabo()
{
	scenarioProj->EffacerTout();
	scenarioProj->Afficher();
	listeDocsLaboProj->RemoveAll();
	listeTypesClasse->RemoveAll();
	liste_permanente->get_liste()->RemoveAll();
}
