
#include "stdafx.h"
#include "MyApp.h"
#include ".\labotrait.h"
#include "TypeClasse.h"
#include "MainFrm.h"
#include "Regle.h"
#include "constante.h"


CLaboTrait::CLaboTrait(void)
{
	listeDocsLaboTrait = new CObList(10);
	listeTypesClasse = new CObList(10);
	scenarioTrait = new CScenario();
}

CLaboTrait::~CLaboTrait(void)
{
	delete listeDocsLaboTrait;
	delete listeTypesClasse;
	delete scenarioTrait;
}

void CLaboTrait::setScenarioTrait(CScenario* scenarIn)
{
	//recopier le scnarIn dans scenarioTrait, regle par regle
	POSITION posReg = scenarIn->getListeRegles()->GetHeadPosition();
	while (posReg)
	{
		CRegle* newReg = (CRegle*)scenarIn->getListeRegles()->GetNext(posReg);
		CString bal = newReg->getBalise();
		CRegle* a;

		if (bal == "TYPE")
		{

			a = (CRegleType*)newReg;

		}

		if (bal == "RCG")
		{

			a = (CRegleCG*)newReg;

		}

		if (bal == "RCV")
		{

			a = (CRegleCV*)newReg;

		}

		if (bal == "RCC")
		{

			a = (CRegleCC*)newReg;

		}

		if (bal == "FUS")
		{

			a = (CRegleFusion*)newReg;

		}

		if (bal == "RST")
		{

			a = (CRegleSupType*)newReg;

		}

		if (bal == "RBI")
		{

			a = (CRegleBin*)newReg;

		}

		if (bal == "RMO")
		{

			a = (CRegleMorph*)newReg;

		}

		if (bal == "RCO")
		{

			a = (CRegleContour*)newReg;

		}

		if (bal == "RIN")
		{

			a = (CRegleIntersection*)newReg;

		}

		if (bal == "RPL")
		{

			a = (CReglePlage*)newReg;

		}

		if (bal == "RPO")
		{

			a = (CReglePost*)newReg;

		}

		if (bal == "RSR")
		{

			a = (CRegleSR*)newReg;

		}

		if (bal == "TAO")
		{

			a = (CRegleTAO*)newReg;

		}

		if (bal == "RAF")
		{

			a = (CRegleAnalyseFine*)newReg;

		}

		if (bal == "RCAR")
		{

			a = (CRegleCarac*)newReg;

		}

		if (bal == "RCT")
		{

			a = (CRegleChangeType*)newReg;

		}

		scenarioTrait->Ajouter(a);
	}

}

void CLaboTrait::setListeDocuments(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeDocsLaboTrait->AddTail(listeIn->GetNext(posTemp));
	}
}


void CLaboTrait::addElemListeDocuments(CMyAppDoc* docIn)
{
	listeDocsLaboTrait->AddTail(docIn);
}

bool CLaboTrait::supprElemListeDocuments(CMyAppDoc* docIn)
{
	LVFINDINFO pFindInfo;
	pFindInfo.flags = LVFI_PARTIAL|LVFI_STRING;
	pFindInfo.psz = docIn->m_nom;
	int numPos = 0;
	numPos = ((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->m_ListThumbnail.FindItem(&pFindInfo);

	POSITION posTemp = listeDocsLaboTrait->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CMyAppDoc* docTmp = (CMyAppDoc*)listeDocsLaboTrait->GetNext(posTemp);
		if (docTmp == docIn)
		{
			((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->m_ListThumbnail.DeleteItem(numPos);
			listeDocsLaboTrait->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboTrait::supprAllListeDocuments()
{
	listeDocsLaboTrait->RemoveAll();
}


void CLaboTrait::setListeTypesClasse(CObList* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		listeTypesClasse->AddTail(listeIn->GetNext(posTemp));
	}
}


void CLaboTrait::addElemListeTypesClasse(CTypeClasse* typeIn)
{
	listeTypesClasse->AddTail(typeIn);
}

bool CLaboTrait::findElemListeTypesClasse(CString nom)
{
	if (!listeTypesClasse->IsEmpty())
	{
		POSITION pos = listeTypesClasse->GetHeadPosition();
		while (pos)
		{
			CTypeClasse *t = (CTypeClasse *)listeTypesClasse->GetNext(pos);

			if (t->getNomClasse() == nom)
			{
				return true;
			}
		}
	}
	return false;
}

bool CLaboTrait::supprElemListeTypesClasse(CTypeClasse* typeIn)
{
	POSITION posTemp = listeTypesClasse->GetHeadPosition();
	while (posTemp)
	{
		POSITION posDoc = posTemp;
		CTypeClasse* typeTmp = (CTypeClasse*)listeTypesClasse->GetNext(posTemp);
		if (typeTmp == typeIn)
		{
			listeTypesClasse->RemoveAt(posDoc);
			return true;
		}
	}
	return false;
}

void CLaboTrait::supprAllListeTypesClasse()
{
	listeTypesClasse->RemoveAll();
}

void CLaboTrait::ModeZoom()
{
	if (!listeDocsLaboTrait->IsEmpty())
	{

		POSITION posTemp = listeDocsLaboTrait->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboTrait->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pViewTemp->m_zoommode=!pViewTemp->m_zoommode;
			pViewTemp->m_selectionmode = false;
			pViewTemp->Invalidate(true);
			


			pDocTemp->DeleteContents();

		}
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_modeSelection = false;
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->m_ctrlAssist3BtnLabelC.SetState(false);
	}
}

void CLaboTrait::UpdateModeZoom(CCmdUI* pCmdUI)
{
	if (!listeDocsLaboTrait->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboTrait->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboTrait->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);


			pCmdUI->SetCheck(pViewTemp->m_zoommode);

			pDocTemp->DeleteContents();

		}
	}
}

void CLaboTrait::AfficherDocSuivant()
{
	if (!listeDocsLaboTrait->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboTrait::AfficherDocPrecedent()
{
	if (!listeDocsLaboTrait->IsEmpty())
	{
		((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIPrev();
		CMyAppDoc *pDoc = (CMyAppDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveFrame()->GetActiveDocument();
		((CMyAppApp*)AfxGetApp())->ChargerDoc(pDoc);
		RendreLeFocusALImageActive();
	}
}

void CLaboTrait::RendreLeFocusALImageActive()
{
	CMDIChildWnd * pChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pChild->SetFocus();
}

void CLaboTrait::MajMenu()
{
	if (!listeDocsLaboTrait->IsEmpty())
	{
		POSITION posTemp = listeDocsLaboTrait->GetHeadPosition();
		while (posTemp!=NULL) {

			CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboTrait->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);

			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);

			pViewTemp->DeGriserMenuTrait();
			pViewTemp->GriserMenuClassif();
			pViewTemp->GriserMenuProj();

		}
	}
}

void CLaboTrait::OuvrirImageLaboTrait()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CProjetParam *pPramProjTemp = pAppTemp->projet->getParamProj();

	CString nomIm;
	nomIm.Format("%s\\%s",pPramProjTemp->getM_repOuvrage(),pPramProjTemp->getM_imLaboTrait());
	pAppTemp->OuvrirDocument(nomIm,LABOTRAIT);
	pAppTemp->OnMenuAffBarreProjet();
	scenarioTrait->Afficher();
}

void CLaboTrait::TraitementsAuto()
{
	//recuperer le pointeur sur l'application :
	//CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	POSITION posTemp = listeDocsLaboTrait->GetHeadPosition();
	while (posTemp!=NULL) {

		CMyAppDoc* pDocTemp = (CMyAppDoc*)listeDocsLaboTrait->GetNext(posTemp);
		ASSERT_VALID(pDocTemp);
		if (pDocTemp->atelier->liste_de_zones->liste->IsEmpty())
		{
			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);
			//***********************************************************
			//pViewTemp->OnDraw(pViewTemp->GetDC());
			pViewTemp->OnDocTraitPret();
			pViewTemp->OnDocTraitCartendgHv();
			pViewTemp->OnDocTraitFusionGlob();
			pViewTemp->OnDocTraitRafraichCarac();
			//n'affiche pas les CC (bouton dsenfonc)
			pViewTemp->affiche_cc = false;
			pViewTemp->affiche_zone = true;
		}
		pDocTemp->DeleteContents();
	}
}

void CLaboTrait::ViderLabo()
{
	scenarioTrait->EffacerTout();
	scenarioTrait->Afficher();
	listeDocsLaboTrait->RemoveAll();
	listeTypesClasse->RemoveAll();
}

void CLaboTrait::RechargerDocument()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CProjetParam *pPramProjTemp = pAppTemp->projet->getParamProj();

	scenarioTrait->EffacerTout();
	scenarioTrait->Afficher();
	listeTypesClasse->RemoveAll();

	CMyAppDoc* pDoc = (CMyAppDoc*)listeDocsLaboTrait->GetHead();
	pDoc->OnCloseDocument();

	CString nomIm;
	nomIm.Format("%s\\%s",pPramProjTemp->getM_repOuvrage(),pPramProjTemp->getM_imLaboTrait());
	pAppTemp->OuvrirDocument(nomIm,LABOTRAIT);
	scenarioTrait->Afficher();

	//affiche les vignettes :
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
}
