// Ligne.h: interface for the CLigne class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGNE_H__A4A4D913_BD8A_4678_9A1D_E6D0951B34EB__INCLUDED_)
#define AFX_LIGNE_H__A4A4D913_BD8A_4678_9A1D_E6D0951B34EB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Mot.h"

class CLigne : public CObject 
{

private:

	CRect *rect;
	CRect *rectL;
	CObList *liste_mots;
	CObList *liste_elements;
	int ordonnee_minimale; // ordonnee minimale sur la ligne
	int ordonnee_maximale; // ordonne maximale sur la ligne
	int y_cdg_moyen;
	int espacement_moyen;
	bool liste_modifiee;
	int abscisse_minimale; // abscisse minimale sur la ligne
	int abscisse_maximale; // abscisse maximale sur la ligne

public:

	CObList* get_liste_elements ();
	CObList* get_liste_mots ();

	int get_y_cdg_moyen ();
	int get_ordonnee_minimale ();
	int get_ordonnee_maximale ();
	bool get_liste_modifiee ();

	void Calculer_cdg_moyen ();
	void Trouver_ordonnee_minimale ();
	void Trouver_ordonnee_maximale ();
	void Calculer_espacement_moyen ();

	bool Fusionner_lignes (CLigne* ligne);
	/*void Rejeter_elements_hors_ligne (CLigne* rejet);
	void Reclasser_rejet (CObList* lignes);*/
	void Ordonner_elements_sens_lecture ();
	void Supprimer_accentuation ();
	void Decomposer_en_mots ();

	/**************/
	/* PFE 2006 Deb
	/**************/


	void DetectionAnomalie(CImage *image, CDocument *pDoc, CString chemin_ligne, int numBloc, int numLigne, int hauteurImageCourante);
	void DetectionAnomalie2(CImage *image, CDocument *pDoc, CString chemin_ligne, int numBloc, int numLigne, int longueur_zone_virtuelle, int hauteurImageCourante);

	int CalculerLmoy(POSITION depart, int nbC);	
	int CalculerHmoy(POSITION depart, int nbC);
	int CalculerCdgMoyen(POSITION depart, int nbC);

	double CalculerEcartTypeLargeur(int moyenne,POSITION depart, int nbC);
	double CalculerEcartTypeHauteur(int moyenne,POSITION depart, int nbC);
	double CalculerEcartTypeCdg(int moyenne,POSITION depart, int nbC);

	int Creation_Histogramme_Y_Haut(int hauteurImageCourante,int ordonneeMin,int ordonneeMax,POSITION depart, int nbC);
	int Creation_Histogramme_Y_Bas(int hauteurImageCourante,int ordonneeMin,int ordonneeMax,POSITION depart, int nbC);

	void Trouver_abscisse_minimale ();
	void Trouver_abscisse_maximale ();
	int get_abscisse_minimale ();
	int get_abscisse_maximale ();

	int Trouver_abscisse_minimale_nbCC(POSITION depart, int nbC);
	int Trouver_abscisse_maximale_nbCC(POSITION depart, int nbC);
	int Trouver_ordonnee_minimale_nbCC(POSITION depart, int nbC);
	int Trouver_ordonnee_maximale_nbCC(POSITION depart, int nbC);
	
	CRect * getRect();
	void MiseAJourRectangle();
	int CalculerMoyenneEcartEntreCdg();
	double CalculerEcartTypeDistanceCdg(int moyenne);
	void MettreAJourParametreLigne();

	int get_ordonnee_minimale_virtuel(int nbC);
	int get_ordonnee_maximale_virtuel(int nbC);
	int get_abscisse_minimale_virtuel(int nbC);
	int get_abscisse_maximale_virtuel(int nbC);

	int Calculer_cdg_moyen_nbCC(int nbC);
	double Calculer_ecart_type_cdg_nbCC(int moyenne, int nbC);


	/**************/
	/* PFE 2006 Fin
	/**************/

public:

	CLigne();
	virtual ~CLigne();
	CLigne(const CLigne &ligne);

};

#endif // !defined(AFX_LIGNE_H__A4A4D913_BD8A_4678_9A1D_E6D0951B34EB__INCLUDED_)
