/****************************************************************/
// ListeCC.cpp: implementation of the CListeCC class.
//
// Gestion de la liste de composante connexe
// Permet de grer et manipuler une liste de CZones et notamment
// d'appliquer les fonctions de fusion et de recherche du plus proche
// voisin
//
/****************************************************************/

/***********************/
//  INCLUSION
/***********************/

#include "stdafx.h"
#include "myapp.h"
#include "MyAppDoc.h"
#include "ListeCC.h"
#include <direct.h>
#include "ComposanteConnexe.h"
#include "MainFrm.h"
#include <iostream>
#include <fstream>


/***********************/
//  PRECOMPILATION
/***********************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/***********************/
//  CONSTRUCTEUR
/***********************/


CListeCC::CListeCC()
{
	liste = new CObList(10);

	//liste_secondaire = new CObList(10);

	type_zone = "";

	num_fichierCC = 0;

	//qte_limite = 1000;

}


/***********************/
//  DESTRUCTEUR
/***********************/


CListeCC::~CListeCC()
{
	POSITION p1;

	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{

		CComposanteConnexe *cc = (CComposanteConnexe *)liste->GetNext(p1);
		delete cc;

	}

	liste->RemoveAll();
	delete liste;

	//liste_secondaire->RemoveAll();
	//delete liste_secondaire;

}


/***********************/
//  METHODES
/***********************/

/********************************************************************/
/* Nom mthode : Similaire                                     
/*                                                                  
/* Fonction : crer les objets CComposantesConnexes, 
/*            comparer deux CC,
/*            crer une classe ds lors qu'une nouvelle forme apparait
/*                                                                 
/* e : pointeur sur le CElement que l'on veut classer
/* pDoc : CDocument*                                
/*                     
/* entier reprsentant le numero de la classe dans laquelle l'lment est plac                   
/*                                                                 
/********************************************************************/


int CListeCC::Similaire (CElement *e, CDocument* pDoc)
{


	FILE *fp, *fp2;
	CString fic_newCC, fic_CC;

	// finalement ne sert pas a grand chose
	/*if (liste->GetCount () > qte_limite)
		AllegerListe ();*/

	// on recupere dans "image" le bitmap associ  "e"
	CImage *image = new CImage (e->getRect()->Width(), e->getRect()->Height(), 8);
	e->ExtraireElement (((CMyAppDoc *)pDoc)->atelier->getImageBinarisee(), image);
	


	POSITION p1;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		// on compare "image"  chaque image de la liste du moment que les tailles sont quivalentes
		CComposanteConnexe *cc_liste = (CComposanteConnexe *)liste->GetNext(p1);
		if (abs (cc_liste->get_image ()->getLargeur () - image->getLargeur ()) < 6
			&& abs (cc_liste->get_image ()->getHauteur () - image->getHauteur ()) < 6)
		{
			if (cc_liste->get_image()->Comparer (image, seuil))
			{
				cc_liste->set_nb_occurences (cc_liste->get_nb_occurences()+1);
				fic_CC.Format ("%s\\%s_FIN\\Formes\\forme%d.txt", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(),
												type_zone, cc_liste->get_numero ());

				fp = fopen (fic_CC, "a+");
				fprintf (fp, "%s\t%d\t%d\t%d\t%d\n",((CMyAppDoc *)pDoc)->m_nom_complet,
													e->getRect()->left,
													e->getRect()->top,
													e->getRect()->right,
													e->getRect()->bottom);
				fclose (fp);
				delete image;
				return cc_liste->get_numero();
			}
		}
	}

	// l'image n'a pas t classe, on cre alors une nouvelle classe et
	// une nouvelle ComposanteConnexe
	num_fichierCC++;
	fic_newCC.Format ("%s\\%s_FIN\\Formes\\forme%d.txt", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(),
										type_zone, num_fichierCC);
	fp2 = fopen (fic_newCC, "a+");
	fprintf (fp2, "%s\t%d\t%d\t%d\t%d\n", ((CMyAppDoc *)pDoc)->m_nom_complet,
											e->getRect()->left,
											e->getRect()->top,
											e->getRect()->right,
											e->getRect()->bottom);
	fclose(fp2);

	CComposanteConnexe *cc = new CComposanteConnexe(image, fic_newCC, num_fichierCC);
	liste->AddTail(cc);

	return num_fichierCC;
}


/*void CListeCC::AllegerListe ()
{
	// lorsque la liste compte qte_limite lments, on l'allge en enlevant
	// les classes ne comptant qu'une seule forme (on regarde les "fin" premires classes)

	int fin = liste->GetCount () - 200; // valeur a modifier selon l'initialisation de qte_limite

	POSITION p1, p2;
	p1 = liste->GetHeadPosition();
	
	for (int i=0; i < fin; i++)
	{
		p2 = p1;
		CComposanteConnexe *cc = (CComposanteConnexe *)liste->GetNext(p1);
		if (cc->get_nb_occurences () == 1)
		{
			liste->RemoveAt (p2);
			liste_secondaire->AddTail (cc);
		}
	}
	qte_limite = liste->GetCount () + 1000;// valeur a modifier selon l'initialisation de qte_limite

}*/



/********************************************************************/
/* Nom mthode : get_liste                                     
/*                                                                  
/* Fonction :                 
/*                                                                 
/********************************************************************/


CObList* CListeCC::get_liste ()
{

	return liste;

}


/*CObList* CListeCC::get_liste_secondaire ()
{
	return liste_secondaire;
}*/



/********************************************************************/
/* Nom mthode : set_type_zone                                     
/*                                                                  
/* Fonction :                 
/*                                                                 
/********************************************************************/

void CListeCC::set_type_zone (CString s)
{

	type_zone = s;

}



/********************************************************************/
/* Nom mthode : set_seuil                                     
/*                                                                  
/* Fonction :                 
/*                                                                 
/********************************************************************/


void CListeCC::set_seuil (double d)
{

	seuil = d;

}



/****************************************************************/
/* Nom mthode : AmeliorerClassification                        */
/*                                                              */  
/* Fonction : permet d'amliorer la classification en comparant */
/*            2  2 les composants connexes afin de fusionner   */
/*            les classes entre elles                           */  
/****************************************************************/



void CListeCC::AmeliorerClassification ()
{
	if (type_zone != "BRUIT")
	{
		// les CC de la liste sont compares 2  2 avec la mthode de Lebourgeois 
		// pour fusionner des classes

		POSITION p1, p2, p3;
		FILE *fp;
		CString fichier;

		// reconstitution d'une seule liste principale
		//liste->AddTail (liste_secondaire);
		
		int nbCC = liste->GetCount();
		int* regroupements = new int[nbCC];
		for (int i=0; i<nbCC; i++)
			regroupements[i] = -1;
	
		fichier.Format("%s\\%s_FIN\\Formes\\REGROUPEMENTS.txt",
											((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(), type_zone);
		fp = fopen(fichier, "a+");
		fprintf(fp, "%d\n", nbCC);
		fclose(fp);

		p1 = liste->GetHeadPosition();

		//CProgressBar pg("Amlioration de la classification (Lebourgeois)", liste->GetCount());
		((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Amlioration de la classification (Lebourgeois)",liste->GetCount());
		CWaitCursor wc;

		for (p1; p1 != NULL;)
		{
			CComposanteConnexe *cc = (CComposanteConnexe *)liste->GetNext(p1);
			CImage *img = cc->get_image ();
			p2 = p1;
			for (p2; p2 != NULL;)
			{
				p3 = p2;
				CComposanteConnexe *cc_courante = (CComposanteConnexe *)liste->GetNext(p2);

				if (abs (img->getLargeur() - cc_courante->get_image()->getLargeur()) < 6
					&& abs (img->getHauteur() - cc_courante->get_image()->getHauteur()) < 6)
				{
					if (img->Comparer_Lebourg(cc_courante->get_image(),
												cc_courante->get_image_dilatee(),
												cc->get_image_dilatee(), seuil))
					{
						regroupements[cc_courante->get_numero()-1] = cc->get_numero();
						//fusion des deux fichiers
						char c;
						FILE *fp_source, *fp_dest;

						fp_source = fopen (cc_courante->get_nom_fichier(), "r");
						fp_dest = fopen (cc->get_nom_fichier(), "a+");
						c = fgetc(fp_source);

						while (c != EOF)
						{
							fprintf(fp_dest, "%c", c);
							c = fgetc(fp_source);
						}
						
						fclose (fp_dest);
						fclose (fp_source);

						cc->set_nb_occurences(cc->get_nb_occurences() + 
															cc_courante->get_nb_occurences());
						remove(cc_courante->get_nom_fichier());
						liste->RemoveAt(p3);
						delete cc_courante;

						if (p1 == p3)
							p1 = p2;
					}
				}
			}
			//pg.m_progress.StepIt();
			((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
		}

		fp = fopen(fichier, "a+");
		for (i=0; i<nbCC-1; i++)
			fprintf(fp, "%d\t%d\n", i, regroupements[i]);
		fprintf(fp, "%d\t%d", i, regroupements[i]);
		fclose(fp);
	}
}




	
/****************************************************************/
/* Nom mthode : CreerFichierNbOccurence                        */
/*                                                              */  
/* Fonction : permet de creer le fichier NBOCCURENCES.txt       */
/*            dans lequel on trouve le nombre d'occurence       */
/*            de chaque classe                                  */  
/****************************************************************/



void CListeCC::CreerFichierNbOccurence ()
{
	// Cration d'un fichier associant  chaque classe (Formes\num.txt) le nb
	// d'occurence de la forme
	
	FILE *fp;
	POSITION p1;
	CString fichier;
	
	// on cre le fichier et on y crit le nombre d'occurences pour chaque classe
	fichier.Format ("%s\\%s_FIN\\Formes\\NB_OCCURENCES.txt", ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats(),
												type_zone);
	fp = fopen (fichier, "w");
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CComposanteConnexe *classe = (CComposanteConnexe *)liste->GetNext(p1);
		fprintf (fp, "%s\t%d\n", classe->get_nom_fichier(), classe->get_nb_occurences());
	}

	fclose (fp);
}