/****************************************************************/
// ListeZones.cpp: implementation of the CListeZones class.
//
// Cette classe permet de grer les diffrentes actions que l'on
// peut effectuer sur les zones
//
/****************************************************************/



/***********************/
//  INCLUSION
/***********************/

#include "stdafx.h"
#include "MyApp.h"
#include "MainFrm.h"

#include "MyAppDoc.h"
#include <direct.h>

#include "ListeZones.h"
#include "constante.h"
#include "typeclasse.h"

/***********************/
//  PRECOMPILATION
/***********************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/***********************/
//  CONSTRUCTEUR
/***********************/

CListeZones::CListeZones(CDocument *p)
{

	pDoc = (CMyAppDoc *)p;

	liste = new CObList(10);
	
}


/***********************/
//  DESTRUCTEUR
/***********************/


CListeZones::~CListeZones()
{


	POSITION p1;

	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		delete z;
	}

	liste->RemoveAll();
	delete liste;

}


/***********************/
//  METHODES
/***********************/


/********************************************************************/
/* Nom mthode : DetectionContours                                     
/*                                                                  
/* Fonction : extraction des contours de l'image P1 qui sont dessins 
/*            dans P2
/*            
/*                                                                 
/* P1 : image  traiter
/* P2 : image resultat                              
/*                     
/*                                                                 
/********************************************************************/


int CListeZones::DetectionContours(CImage *P1)
{

	CImage *P2=new CImage();
	P2->Copier(P1);

	for(int y=0;y<P1->getHauteur();y++)  // boucle sur la hauteur de l'image

		for(int x=0;x<P1->getLargeur();x++)	// boucle sur la largeur de l'image

			P2->setPixel(x,y,255);	// colorie avec la couleur 255 (blanc)



	int nopl=P1->getLargeur();  // largeur de l'image d'origine  traiter
	int nlt=P1->getHauteur();	// hauteur de l'image d'origine  traiter

	unsigned char 	flag1=V, flag2;	// drapeaux de test

	register unsigned char dir,ddir;

	int mx,cpt=0,lgt=0,nbcc=0,xcmin,xcmax,ycmin,ycmax;
	int xa,ya,x1,y1,xc,yc,dd,dx,dy,ddep,S,i,j,k=0;

	signed long xcc,ycc,xii,yii,xj_1,yj_1;
	signed char	t[8][2] = {{0,1},{-1,1},{-1,0},{-1,-1},{0,-1},{1,-1},{1,0},{1,1}};


	//CProgressBar pg("Dtection des contours...",(nlt-1)/2);	// Affichage dans la barre de progression
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Dtection des contours...",(nlt-1)/2);
	CWaitCursor wc;

	mx = (long)(nopl/**8*/)*(long)nlt ;
	mx = mx/14;

	for(j=1;j < nlt-1;j=j+2)	// boucle jusqu' (hauteur de P1)-1
	{
		for(i=1;i < (nopl/**8*/)-1;i=i+1)	// boucle jusqu' (largeur de P1)-1
		{
			if(P1->getPixel(i,j)==OBJET)	// Test si la valeur du pixel de P1 est de 0 (noir)
			{

				if(P2->getPixel(i,j)==OBJET) while(P1->getPixel(i++,j)==OBJET);	// Test si la valeur du pixel de P2 est de 0 (noir)
				else															// Tant que c vrai on incrmente x
				{
					// on a trouv un pixel qui n'est pas noir

					if ( (P1->getPixel(i-1,j) == FOND) && ((P1->getPixel(i,j+1) == OBJET)
					  || (P1->getPixel(i+1,j+1) == OBJET) 
					  || (P1->getPixel(i+1,j) == OBJET)
                      || (P1->getPixel(i+1,j-1) == OBJET)))
					{
					    S=0;ddir=6;
					    xa = i ; ya = j;        /* Pixel de depart */
					    xc = xa; yc = ya;       /* Pixel courant */
					    xj_1=xii=xc;
					    yj_1=yii=yc;
					    xcmin=xcmax=xc;
					    ycmin=ycmax=yc;

					    if(cpt >= mx) AfxMessageBox("Erreur(1)",MB_OK);

					    cpt = 0 ; 
					    lgt = cpt = 0;
					    dir = 6 ;
					    flag1 = F;
					}

				}

				while(flag1 == F && cpt < mx)
				{
					cpt++;lgt++;
					flag2 = F;
				
					if(xc > xcmax) xcmax = xc;
					else if(xc < xcmin) xcmin = xc;
					if(yc > ycmax) ycmax = yc;
					else if(yc < ycmin) ycmin = yc;

/* Approximation lineaire :    */

					xcc=(signed long)xc;ycc=(signed long)yc;
					
					ddir = k;
					
					if(xc != xj_1 || yc != yj_1)
					{
						k=0 ; dx=xc-xj_1 ; dy=yc-yj_1;
						while(dx != t[k][1] || dy != t[k][0]) k++;
					}

					if(xj_1 != xa || yj_1 != ya)
					{
						dd=(int)k-(int)ddir;
						dd=dd%8;

						if(dd>4) dd = dd - 8;

						if(dd<-3) dd = dd + 8;

						S = S + dd;

					}
					else
					{
						
						ddep = k;

					}

					xj_1=xc;
					yj_1=yc;

/***    fin approx.   ***/

					P2->setPixel(xc,yc,OBJET);
	

					while(flag2 == F)
					{
						x1 = xc + t[(dir+7)%8][1];
						y1 = yc + t[(dir+7)%8][0];

						if (P1->getPixel(x1,y1) == OBJET)
						{
							xc=x1;yc=y1;    /* nouveau pixel courant */
							dir = (dir + 6) % 8;
							flag2 = V;

						}
						else
						{
							x1 = xc + t[dir][1];
							y1 = yc + t[dir][0];

							if (P1->getPixel(x1,y1) ==  OBJET)
							{
								xc=x1;yc=y1;               /* nouveau pixel courant */
								flag2 = V;
							}
							else
							{
								x1 = xc + t[(dir+1)%8][1];
								y1 = yc + t[(dir+1)%8][0];

								if (P1->getPixel(x1,y1) == OBJET)
								{
									xc=x1 ; yc=y1;               /* nouveau pixel courant */
									flag2 = V;

								}
								else dir = (dir+2)%8;
							}

						}

					}



					if ((xc == xa) && (yc == ya))
					{
						flag1 = V;
					   	dd=(int)ddep-(int)k;
						dd=dd%8;
					
						if(dd>4) dd = dd - 8;
						if(dd<-3) dd = dd + 8;

						S = S + dd;

      					if(S >= 0)
						{
							nbcc++;
							AjouterZone(xcmin, ycmin, xcmax, ycmax);
						}
					}


				}

			}

		}	// fin du For 2

		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

	}	// fin du For 1

	delete P2;
	return nbcc;
}



/********************************************************************/
/* Nom mthode : Supprime_Pte_CC                                     
/*                                                                  
/* Fonction : Permet de supprimer les petites composantes considr 
/*            comme du bruit
/*                                                                 
/********************************************************************/



void CListeZones::Supprime_Pte_CC(CImage *image)
{
	//supprime les petites composantes
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Suppression petites CC en cours...",longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Suppression petites CC en cours...",longueurListe);
	CWaitCursor wc;
	POSITION p1;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		if (z->getClasse()->getNomClasse() == "BRUIT")
		{
			z->Colorier(image,BLANC);
			liste->RemoveAt(liste->Find(z));
			delete z;
		}
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
}



/********************************************************************/
/* Nom mthode : Affiche_CC                                     
/*                                                                  
/* Fonction : affiche le rectangle englobant de chaque composante
/*            connexe dtecte
/*
/* ecran : contexte de priphrique sur lequel afficher les rectangles
/* zoomcoeff : facteur de zoom utilis
/* k : numro de la CC  afficher, si -1 tout afficher                                                      
/*                                                           
/********************************************************************/


void CListeZones::Affiche_CC(CDC *ecran, double zoomcoeff, int k)
{
	if (k>=0)
	{
		//position dans la liste de zones
		POSITION pos_zone = liste->FindIndex(k);
		if (pos_zone == NULL) return;
		//pointeur sur la zone k
		CZone *z = (CZone *)liste->GetAt(pos_zone);
		z->Afficher_Elements(ecran,zoomcoeff);
	}
	else
	{
		//position dans la liste de zones
		POSITION pos_zone = liste->GetHeadPosition();
		while (pos_zone != NULL)
		{
			CZone *z = (CZone *)liste->GetNext(pos_zone);
			z->Afficher_Elements(ecran,zoomcoeff);
		}
	}
}




/********************************************************************/
/* Nom mthode : Affiche_Zone                                     
/*                                                                  
/* Fonction : permet l'affichage des zones  l'cran en
/*            fonction du facteur de zoom
/*            
/********************************************************************/


void CListeZones::Affiche_Zone(CDC *ecran, double zoomcoeff)
{
	//position dans la liste de zones
	POSITION pos_zone = liste->GetHeadPosition();
	while (pos_zone != NULL)
	{
		CZone *z = (CZone *)liste->GetNext(pos_zone);
		z->Afficher_Zones(ecran,zoomcoeff,z->getClasse()->getColor());
	}
	
}



/********************************************************************/
/* Nom mthode : Colorier                                     
/*                                                                  
/* Fonction : permet d'affecter une couleur  une zone
/*          
/*                                                                 
/********************************************************************/


void CListeZones::Colorier(CImage *im, CString type, UINT color)
{
	POSITION pos_zone = liste->GetHeadPosition();
	while (pos_zone != NULL)
	{
		CZone *z = (CZone *)liste->GetNext(pos_zone);
		if (z->getClasse()->getNomClasse() == type) z->Colorier(im,color);
	}
}



/********************************************************************/
/* Nom mthode : Supprime_inclusion_Gde_CC                                     
/*                                                                  
/* Fonction : permet de supprimer les zones qui sont contenues dans une 
/*            autre ce qui permet de garder les plus grandes zones possible
/*            
/*                                                                 
/********************************************************************/


void CListeZones::Supprime_inclusion_Gde_CC()
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	CObList *liste_types_classe;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}

	/* les zones totalement incluses dans une autre sont effaces*/
	POSITION p1;
	POSITION p2;
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Suppression Inclusion CC...",longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Suppression Inclusion CC...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			
			CRect *rr=new CRect();
			rr->IntersectRect(z->getRect(),zz->getRect());

			if (!rr->IsRectEmpty()&& zz!=z)
			{
				if (z->getClasse()->getNomClasse() == "IMAGE")
					if (zz->getClasse()->getNomClasse() == "TEXTE")
						zz->setClasse("TEXTEI",liste_types_classe);
			}

			delete rr;

		}
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
}



/********************************************************************/
/* Nom mthode : Supprime_Intersection                                     
/*                                                                  
/* Fonction : permet de supprimer les intersections qui peuvent exister
/*            entre les composantes connexes
/*                                                                 
/********************************************************************/


void CListeZones::Supprime_Intersection(CString type)
{
	POSITION p1, p2, p3;
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Suppression Intersection CC...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Suppression Intersection CC...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		p2 = p1;
		for (p2; p2 != NULL;)
		{
			p3 = p2;
			CZone *zz = (CZone *)liste->GetNext(p2);

			CRect *rr=new CRect();
			rr->IntersectRect(z->getRect(),zz->getRect());

			if (!rr->IsRectEmpty() && z->getClasse()->getNomClasse()==type 
				&& zz->getClasse()->getNomClasse()==type)
			{
				Renommer_CC(zz,z);
				if (p1 == p3)
					p1 = p2;
			}
				
			delete rr;
		}
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
}




/********************************************************************/
/* Nom mthode : Ppv_horizontal                                     
/*                                                                  
/* Fonction : 
/*            
/*            
/*                                                                 
/********************************************************************/


int CListeZones::Ppv_horizontal(CImage *dest, int seuil, CString type)
{
	
	int compteur=0;
	int delta_x,delta_y;
	double distance_min;
	double distance;

	bool trouve;

	CPoint P1,P2;

	//on recupere la position de la premiere zone de la liste
	POSITION p1;
	POSITION p2;
	
	POSITION pos_element_z;
	POSITION pos_element_zz;

	//pointeur sur la zone k
	
	
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Fusion horizontale...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Fusion horizontale...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		trouve = false;
		distance_min=20000;
		CZone *z = (CZone *)liste->GetNext(p1);
		
		
		CZone * p3;
		
		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			

			P1 = *(z->getCdg());
			P2 = *(zz->getCdg());
					
			delta_x = (P2.x - P1.x)*(P2.x - P1.x);
			delta_y = (P2.y - P1.y)*(P2.y - P1.y);
			distance = sqrt((double)delta_x + (double)delta_y);

			
			if ((z != zz) && (z->getZone() != zz->getZone()) && z->getClasse()->getNomClasse() == type && zz->getClasse()->getNomClasse() == type)// && !(r->IsRectEmpty()) )
			{
				//delete r;
				for (pos_element_z = z->get_liste_elements()->GetHeadPosition(); pos_element_z != NULL;)
				{
					CElement *e1 = (CElement *)z->get_liste_elements()->GetNext(pos_element_z);
					
					pos_element_zz = zz->get_liste_elements()->GetHeadPosition();
					while (pos_element_zz != NULL)
					{
						CElement *e2 = (CElement *)zz->get_liste_elements()->GetNext(pos_element_zz);

						P1 = *(e1->getCdg());
						P2 = *(e2->getCdg());
						
						delta_x = (P2.x - P1.x)*(P2.x - P1.x);
						delta_y = (P2.y - P1.y)*(P2.y - P1.y);
						distance = sqrt((double)delta_x + (double)delta_y);	

						if (distance < distance_min)
						{
							if (sqrt((double)delta_y) < z->get_hauteur_moyenne())
							{
								//if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,(distance*100)/dest->getLargeur()))
								if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,distance))
								{
									trouve = true;
									distance_min = distance;
									p3=zz;
									
								}
							}
						}

					}
				}
			}
			
		}

		if (trouve) 
		{
			if (liste->Find(p3) != p1) Renommer_CC(p3,z);
			else
			{
				CZone *zzz=z;
				CZone *z = (CZone *)liste->GetNext(p1);
				Renommer_CC(p3,zzz);
			}
			compteur++;
			
			
		}
		CString text;
		text.Format("%d fusions effectues %d zones restantes",compteur,liste->GetCount());
		//pg.SetWindowText(text);
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar(text);
		
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

	return compteur;
}



/********************************************************************/
/* Nom mthode : Ppv_horizontal_CDG                                     
/*                                                                  
/* Fonction : 
/*            
/*            
/********************************************************************/


int CListeZones::Ppv_horizontal_CDG(CImage *dest, int seuil)
{

	int compteur=0;
	int delta_x,delta_y;
	double distance_min;
	double distance;

	bool trouve;

	CPoint P1,P2;

	//on recupere la position de la premiere zone de la liste
	POSITION p1;
	POSITION p2;
	
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Fusion horizontale...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Fusion horizontale...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		trouve = false;
		distance_min=200000;
		CZone *z = (CZone *)liste->GetNext(p1);
		
		
		CZone * p3;
		
		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			

			P1 = *(z->getCdg());
			P2 = *(zz->getCdg());
					
			delta_x = (P2.x - P1.x)*(P2.x - P1.x);
			delta_y = (P2.y - P1.y)*(P2.y - P1.y);
			distance = sqrt((double)delta_x + (double)delta_y);

			if ((z != zz) && (z->getZone() != zz->getZone()) && z->getClasse()->getNomClasse() != "IMAGE" && zz->getClasse()->getNomClasse() != "IMAGE")
			{
				if (distance < distance_min)
				{
					if (sqrt((double)delta_y) < z->get_hauteur_moyenne())
					{
						if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,(distance*100)/dest->getLargeur()))
						{
							trouve = true;
							distance_min = distance;
							p3=zz;
										
						}
					}
				}
			}
		}

		if (trouve) 
		{
			if (liste->Find(p3) != p1) Renommer_CC(p3,z);
			else
			{
				CZone *zzz=z;
				CZone *z = (CZone *)liste->GetNext(p1);
				Renommer_CC(p3,zzz);
			}
			compteur++;
			
			
		}
		CString text;
		text.Format("%d fusions effectues %d zones restantes",compteur,liste->GetCount());
		//pg.SetWindowText(text);
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar(text);
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

	return compteur;
}



/********************************************************************/
/* Nom mthode : Ppv_vertical                                     
/*                                                                  
/* Fonction : 
/*            
/*            
/********************************************************************/


int CListeZones::Ppv_vertical(CImage *dest,int seuil, CString type)
{	
	int compteur=0;
	int delta_x,delta_y;
	double distance_min;
	double distance;

	bool trouve;

	CPoint P1,P2;

	//on recupere la position de la premiere zone de la liste
	POSITION p1;
	POSITION p2;
	
	POSITION pos_element_z;
	POSITION pos_element_zz;

	//pointeur sur la zone k
	
	int longueurListe = liste->GetCount();
	//CProgressBar pg("Fusion verticale...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Fusion verticale...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		trouve = false;
		distance_min=20000;
		CZone *z = (CZone *)liste->GetNext(p1);
		
		
		CZone * p3;
		
		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			

			P1 = *(z->getCdg());
			P2 = *(zz->getCdg());
					
			delta_x = (P2.x - P1.x)*(P2.x - P1.x);
			delta_y = (P2.y - P1.y)*(P2.y - P1.y);
			distance = sqrt((double)delta_x + (double)delta_y);

			if ((z != zz) && (z->getZone() != zz->getZone())&& z->getClasse()->getNomClasse() == type && zz->getClasse()->getNomClasse() == type)// && !(r->IsRectEmpty()) )
			{
				for (pos_element_z = z->get_liste_elements()->GetHeadPosition(); pos_element_z != NULL;)
				{
					CElement *e1 = (CElement *)z->get_liste_elements()->GetNext(pos_element_z);
					
					pos_element_zz = zz->get_liste_elements()->GetHeadPosition();
					while (pos_element_zz != NULL)
					{
						CElement *e2 = (CElement *)zz->get_liste_elements()->GetNext(pos_element_zz);

						P1 = *(e1->getCdg());
						P2 = *(e2->getCdg());
						
						delta_x = (P2.x - P1.x)*(P2.x - P1.x);
						delta_y = (P2.y - P1.y)*(P2.y - P1.y);
						distance = sqrt((double)delta_x + (double)delta_y);	

						if (distance < distance_min)
						{
							if (sqrt((double)delta_x) < z->get_largeur_moyenne())
							{
								//if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,(distance*100)/dest->getHauteur()))
								if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,distance))
								{
									trouve = true;
									distance_min = distance;
									p3=zz;
									
								}
							}
						}

					}
				}
			}
			
		}

		if (trouve) 
		{
			if (liste->Find(p3) != p1) Renommer_CC(p3,z);
			else
			{
				CZone *zzz=z;
				CZone *z = (CZone *)liste->GetNext(p1);
				Renommer_CC(p3,zzz);
			}
			compteur++;
			
			
		}
		CString text;
		text.Format("%d fusions effectues %d zones restantes",compteur,liste->GetCount());
		//pg.SetWindowText(text);
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar(text);
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

	return compteur;
}



/********************************************************************/
/* Nom mthode : Ppv_vertical_CDG                                     
/*                                                                  
/* Fonction : 
/*            
/********************************************************************/


int CListeZones::Ppv_vertical_CDG(CImage *dest,int seuil)
{
	
	int compteur=0;
	int delta_x,delta_y;
	double distance_min;
	double distance;

	bool trouve;

	CPoint P1,P2;

	//on recupere la position de la premiere zone de la liste
	POSITION p1;
	POSITION p2;

	int longueurListe = liste->GetCount();
	//CProgressBar pg("Fusion verticale...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Fusion verticale...",longueurListe);
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		trouve = false;
		distance_min=200000;
		CZone *z = (CZone *)liste->GetNext(p1);
		
		
		CZone * p3;
		
		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			

			P1 = *(z->getCdg());
			P2 = *(zz->getCdg());
					
			delta_x = (P2.x - P1.x)*(P2.x - P1.x);
			delta_y = (P2.y - P1.y)*(P2.y - P1.y);
			distance = sqrt((double)delta_x + (double)delta_y);

			if ((z != zz) && (z->getZone() != zz->getZone()))
			{
				if (distance < distance_min)
				{
					if (sqrt((double)delta_x) < z->get_largeur_moyenne())
					{
						if (Fusion(dest,P1.x,P1.y,P2.x,P2.y,seuil,distance))
						{
							trouve = true;
							distance_min = distance;
							p3=zz;
										
						}
					}
				}
			}
			
			
		}

		if (trouve) 
		{
			if (liste->Find(p3) != p1) Renommer_CC(p3,z);
			else
			{
				CZone *zzz=z;
				CZone *z = (CZone *)liste->GetNext(p1);
				Renommer_CC(p3,zzz);
			}
			compteur++;
			
			
		}
		CString text;
		text.Format("%d fusions effectues %d zones restantes",compteur,liste->GetCount());
		//pg.SetWindowText(text);
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar(text);
	}
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

	return compteur;
}




/********************************************************************/
/* Nom mthode : Fusion                                     
/*                                                                  
/* Fonction : dtermine si deux CC peuvent fusionner
/*            
/*            
/********************************************************************/


bool CListeZones::Fusion(CImage *img,int x,int y,int u,int v,int seuil,double distance)
{

	//ie si sue le chemin reliant les deux CC
	///il n'y a pas de pixel de ndg > param
	//renvoi true si la fusion est effectue
	//false sinon

	/*int ndg;
	ndg = bresenham(x,y,u,v,img);
	
	if (distance*(double)(255-ndg)>=seuil) return false;
	else return true;*/
	bool fusion;
	fusion = true;
	//int somme=0;
	if (y < v)
	{
		for(int yy=y;yy<=v;yy++)
			if (x < u)
			{
				for(int xx=x;xx<=u;xx++)
				{
					//somme+=(255-img->getPixel(xx,yy));
					double ndg = img->getPixel(xx,yy);
					if(distance*(double)(255-ndg)>=seuil) 
					{
						fusion=false;
						break;
					}
				}
					
			}
			else
			{
				for(int xx=u;xx<=x;xx++)
				{
					//somme+=(255-img->getPixel(xx,yy));
					double ndg = img->getPixel(xx,yy);
					if(distance*(double)(255-ndg)>=seuil) 
					{
						fusion=false;
						break;
					}
				}
			}
	}
	else
	{
		for(int yy=v;yy<=y;yy++)
			if (x < u)
			{			
				for(int xx=x;xx<=u;xx++)
				{
					//somme+=(255-img->getPixel(xx,yy));
					double ndg = img->getPixel(xx,yy);
					if(distance*(double)(255-ndg)>=seuil)
					{
						fusion=false;
						break;
					}
				}
			}
			else
			{
				for(int xx=u;xx<=x;xx++)
				{
					//somme+=(255-img->getPixel(xx,yy));
					double ndg = img->getPixel(xx,yy);
					if(distance*(double)(255-ndg)>=seuil) 
					{
						fusion=false;
						break;
					}
				}
			}
	}
	//if (somme >=seuil) fusion =false;
	return fusion;
}




/********************************************************************/
/* Nom mthode : bresenham                                     
/*                                                                  
/* Fonction : retourne la valeur de ndg la plus faible rencontree sur
/*            le chemin reliant le point (x1,y1) au point (x2,y2)
/*            
/********************************************************************/


int CListeZones::bresenham(int x1,int y1,int x2,int y2,CImage *image)
{

	int ndg = 255;
	
	/*
	int x;

	if (x1 < x2)
	{
		int  delta_x = x2 - x1;
		if (y1<y2)
		{
			int delta_y = y2 - y1;
			int y = y1;
			int e = 2*delta_y - delta_x;
			int horiz = 2*delta_y;
			int diago = 2*(delta_y-delta_x);
			for (x=x1;x<=x2;x++)
			{
				if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);

				if (e>0)
				{
					y++;
					e+=diago;
				}
				else
				{
					e+=horiz;
				}
			}
		}
		else
		{
			int delta_y = y1 - y2;

			int y = y1;
			int e = 2*delta_y - delta_x;
			int horiz = 2*delta_y;
			int diago = 2*(delta_y-delta_x);
			for (x=x1;x<=x2;x++)
			{
				if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);

				if (e>0)
				{
					y--;
					e+=diago;
				}
				else
				{
					e+=horiz;
				}
			}
		}
	}
	else
	{
		int  delta_x = x1 - x2;
		if (y1<y2)
		{
			int delta_y = y2 - y1;
			int y = y1;
			int e = 2*delta_y - delta_x;
			int horiz = 2*delta_y;
			int diago = 2*(delta_y-delta_x);
			for (x=x1;x>=x2;x--)
			{
				if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);

				if (e>0)
				{
					y++;
					e+=diago;
				}
				else
				{
					e+=horiz;
				}
			}
		}
		else
		{
			int delta_y = y1 - y2;

			int y = y1;
			int e = 2*delta_y - delta_x;
			int horiz = 2*delta_y;
			int diago = 2*(delta_y-delta_x);
			for (x=x1;x>=x2;x--)
			{
				if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);

				if (e>0)
				{
					y--;
					e+=diago;
				}
				else
				{
					e+=horiz;
				}
			}
		}
	}
	return ndg;*/




	int dx,dy,i,xinc,yinc,cumul,x,y ;
	x = x1 ;
	y = y1 ;
	dx = x2 - x1 ;
	dy = x2 - x1 ;
	xinc = ( dx > 0 ) ? 1 : -1 ;
	yinc = ( dy > 0 ) ? 1 : -1 ;
	dx = abs(dx) ;
	dy = abs(dy) ;
  //pixelTirete(x,y,c,n,m,0) ;
  if ( dx > dy ) {
    cumul = dx / 2 ;
    for ( i = 1 ; i <= dx ; i++ ) {
      x += xinc ;
      cumul += dy ;
      if (cumul >= dx) {
        cumul -= dx ;
        y += yinc ; }
      if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);
  } }
    else {
    cumul = dy / 2 ;
    for ( i = 1 ; i <= dy ; i++ ) {
      y += yinc ;
      cumul += dx ;
      if ( cumul >= dy ) {
        cumul -= dy ;
        x += xinc ; }
      if (image->getPixel(x,y) < ndg) ndg = image->getPixel(x,y);
	} }


	return ndg;
}



/********************************************************************/
/* Nom mthode : Renommer_CC                                     
/*                                                                  
/* Fonction : les elements contenus dans la zone "remplacer" sont 
/*            transferes dans la zone "par" puis la zone "remplacer"
/*            est effacee
/*
/********************************************************************/


void CListeZones::Renommer_CC(CZone *remplacer, CZone *par )
{
	
	POSITION pos_element = remplacer->get_liste_elements()->GetHeadPosition();
	while (pos_element != NULL)
	{	
		CElement *eb = (CElement *)remplacer->get_liste_elements()->GetNext(pos_element);
		par->Ajouter_Element(eb);
		remplacer->get_liste_elements()->RemoveAt(remplacer->get_liste_elements()->Find(eb));	
	}

	liste->RemoveAt(liste->Find(remplacer));
	delete remplacer;

		
}



/********************************************************************/
/* Nom mthode : MessageNbZone                                     
/*                                                                  
/* Fonction : permet l'affichage du nombre de zone
/*            
/*            
/********************************************************************/


void CListeZones::MessageNbZone()
{
	CString message;
	message.Empty();
	message.Format("Number of zones : %d \n ",liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0,message);
	AfxMessageBox(message,MB_OK);

}



/********************************************************************/
/* Nom mthode : CherchePoint                                     
/*                                                                  
/* Fonction : 
/*            
/*            
/********************************************************************/

void CListeZones::CherchePoint(CPoint *point,CDC *ecran, double zoomcoeff)
{
	POSITION p1,p2;
	/*
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		if (z->getRect()->PtInRect(*point))
		{
		/*
			int pvd=-1,pvg=-1,pvh=-1,pvb=-1,pvi=-1;
			double di=0;
			if (z->p_voisin_droite!=NULL) pvd=z->p_voisin_droite->getZone();
			if (z->p_voisin_gauche!=NULL) pvg=z->p_voisin_gauche->getZone();
			if (z->p_voisin_haut!=NULL) pvh=z->p_voisin_haut->getZone();
			if (z->p_voisin_bas!=NULL) pvb=z->p_voisin_bas->getZone();
			if (z->p_inclus_dans!=NULL) 
			{
				pvi=z->p_inclus_dans->getZone();
				di=z->getCaracCG()->getDegreInclusion();
			}
		
			CString message;
			message.Empty();
			
			message.Format("d %.02f | vd %d|vg %d|vh %d|vb %d|incluse dans: %d  %.02f %%|numro de zone: %d \n| lm: %d | hm: %d | classe: %s \n"
				,z->getDensite()
				,pvd
				,pvg
				,pvh
				,pvb
				,pvi
				,di
				,z->getZone()
				,z->get_largeur_moyenne()
				,z->get_hauteur_moyenne()
				,z->getClasse()->getNomClasse());
			

			message.Format("Rachit Agrawal");
			((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0,message);
			
			//z->Afficher_Zones(ecran,zoomcoeff,0,255,0);
			return;

		}	
	}
	*/
	// i think so as to have a visual look for each connected component we need to change this function
	// this for loop which currently works for the zone should go like
	// zone -> line -> word -> char or zone -> liste of elements !
		
		for (p1 = liste->GetHeadPosition();p1 != NULL;)
		{
			CZone *z = (CZone *)liste->GetNext(p1);
			if (z->getRect()->PtInRect(*point))
			{
				if (z->getClasse()->getNomClasse() == "TEXTE")
				{
					CBloc *bloc = new CBloc(z->get_liste_elements());
					for (p2 = z->get_liste_elements()->GetHeadPosition(); p2 != NULL;)
					{
							CElement *e = (CElement *)z->get_liste_elements()->GetNext(p2);

							if(e->getRect()->PtInRect(*point))
							{
								//AfxMessageBox("HI !");
								CString message;
								message.Empty();
														
								message.Format("line %d|word %d|char %d|class %d|left %d|right %d|top %d|bottom %d|Agora",
									e->GetLineNumber(),
									e->GetWordNumber(),
									e->GetCharNumber(),
									e->GetClassNumber(),
									e->getRect()->left,
									e->getRect()->right,
									e->getRect()->top,
									e->getRect()->bottom);

								((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0,message);
								AfxMessageBox("See Status Bar !");
								return;
							}
					}
				}
			}
		}

	((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0,"");
}




/********************************************************************/
/* Nom mthode : Generer_HTML                                     
/*                                                                  
/* Fonction : genere un fichier HTML reprsentant les diffrentes zones
/*            extraites
/*            
/*                                                                 
/********************************************************************/

void CListeZones::Generer_HTML(int delta, int mappage, int largeur_page, int hauteur_page)
{

	double rapport = (double)mappage / (double)largeur_page;		

	FILE *fhtml;
	CString fic,nom,num;

	//repertoire de stockage des rsultats
	CString chemin_resultat = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats()+"\\";
	//repertoire de stockage des pages html
	CString chemin_html = chemin_resultat+"html\\";
	if (!PathFileExists(chemin_html)) _mkdir(chemin_html);
	//nom du fichier seul
	CString nom_fichier=((CMyAppDoc*)pDoc)->m_nom;
	//extension du fichier
	CString extension=((CMyAppDoc*)pDoc)->m_extension;
	//nom complet du fichier html gnr
	CString strhtml=chemin_html+nom_fichier+".html";

	fhtml=fopen(strhtml,"w");
	if(!fhtml) return;

	fprintf(fhtml,"<HTML>\n<HEAD>\n<TITLE>\n</TITLE>\n</HEAD>\n<BODY>\n");
	
	POSITION p1;
	int compteur = 0;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		compteur++;

		if (z->getClasse()->getNomClasse() == "TEXTE")
		//if (z->couche == 0)
		{
			num.Format("%02d",compteur);

			int ZTLx = z->getRect()->TopLeft().x;
			int ZTLy = z->getRect()->TopLeft().y;
			int ZBRx = z->getRect()->BottomRight().x;
			int ZBRy = z->getRect()->BottomRight().y;

			if ((ZTLx - delta) < 0) ZTLx = 0;
			else ZTLx = ZTLx - delta;
			if ((ZTLy - delta) < 0) ZTLy = 0;
			else ZTLy = ZTLy - delta;
			if ((ZBRx + delta) > largeur_page) ZBRx = largeur_page;
			else ZBRx = ZBRx + delta;
			if ((ZBRy + delta) > hauteur_page) ZBRy = hauteur_page;
			else ZBRy = ZBRy + delta;
			int largeur=abs(ZBRx-ZTLx)*rapport;
			int hauteur=abs(ZBRy-ZTLy)*rapport;
			int xTL = (int)floor((ZTLx)*rapport);
			int yTL = (int)floor((ZTLy)*rapport);

			fprintf(fhtml,"<DIV STYLE=\"position :absolute; top:%d; left:%d;\">\n",yTL,xTL);
			nom=chemin_resultat+z->getClasse()->getNomClasse()+"\\"+nom_fichier+"_"+z->getClasse()->getNomClasse()+"_"+num+"."+extension;
			fprintf(fhtml,"<a href=\"%s\"><img src=\"%s\" width=%d height=%d border=1></a> ",nom,nom,largeur,hauteur);
			fprintf(fhtml,"</DIV>\n");
		}
	}
	
	compteur = 0;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		compteur++;

		if (z->getClasse()->getNomClasse() != "TEXTE")
		//if (z->couche == 1)
		{
			num.Format("%02d",compteur);

			int ZTLx = z->getRect()->TopLeft().x;
			int ZTLy = z->getRect()->TopLeft().y;
			int ZBRx = z->getRect()->BottomRight().x;
			int ZBRy = z->getRect()->BottomRight().y;

			if ((ZTLx - delta) < 0) ZTLx = 0;
			else ZTLx = ZTLx - delta;
			if ((ZTLy - delta) < 0) ZTLy = 0;
			else ZTLy = ZTLy - delta;
			if ((ZBRx + delta) > largeur_page) ZBRx = largeur_page;
			else ZBRx = ZBRx + delta;
			if ((ZBRy + delta) > hauteur_page) ZBRy = hauteur_page;
			else ZBRy = ZBRy + delta;
			int largeur=abs(ZBRx-ZTLx)*rapport;
			int hauteur=abs(ZBRy-ZTLy)*rapport;
			int xTL = (int)floor((ZTLx)*rapport);
			int yTL = (int)floor((ZTLy)*rapport);


			fprintf(fhtml,"<DIV STYLE=\"position :absolute; top:%d; left:%d;\">\n",yTL,xTL);
			nom=chemin_resultat+z->getClasse()->getNomClasse()+"\\"+nom_fichier+"_"+z->getClasse()->getNomClasse()+"_"+num+"."+extension;
			fprintf(fhtml,"<a href=\"%s\"><img src=\"%s\" width=%d height=%d border=1></a> ",nom,nom,largeur,hauteur);
			fprintf(fhtml,"</DIV>\n");
		}
	}


	fprintf(fhtml,"</BODY>\n</HTML>");
	fclose(fhtml);

}



/********************************************************************/
/* Nom mthode : DecoupageImages                                     
/*                                                                  
/* Fonction : Permet de decouper les diffrentes zones detecter sur
/*            l'image afin de les copier dans le repertoire resultat
/*            sous le repertoire qui porte le nom du type de zone
/*                                                                 
/********************************************************************/


void CListeZones::DecoupageImages(CImage *image, double rapport, int delta)
{
	if (image == NULL) return;

	FILE *f,*fmap,*fmapbis;
	int largeur,hauteur,compteur;

	//nom du fichier seul
	CString nom_fichier=((CMyAppDoc*)pDoc)->m_nom;
	//extension du fichier
	CString extension=((CMyAppDoc*)pDoc)->m_extension;


	//creation des noms de fichiers
	CString fic,coord,coordmap,coordmapbis,num,entier;

	CString chemin_images,chemin_coord;
	chemin_coord = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats()+"\\coord\\";
	
	if (!PathFileExists(chemin_coord)) _mkdir(chemin_coord);

	coord=chemin_coord+nom_fichier+"_xy.txt";
	coordmap=chemin_coord+nom_fichier+"_xy_map.txt";
	coordmapbis=chemin_coord+"xy_mapbis.txt";

	f=fopen(coord,"w");
	fmap=fopen(coordmap,"w");
	fmapbis=fopen(coordmapbis,"a");

	compteur=0;
	POSITION p1;
	//CProgressBar pg("Sauvegarde en cours...",liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Sauvegarde en cours...",liste->GetCount());
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		
		CImage *cour=new CImage();
		cour->Copier(image);


		POSITION p2;
		for (p2 = liste->GetHeadPosition();p2 != NULL;)
		{
			CZone *zz = (CZone *)liste->GetNext(p2);
			CRect *rr=new CRect();	
			rr->IntersectRect(z->getRect(),zz->getRect());
			
			
			if (!rr->IsRectEmpty() && z!=zz)
			{
				z->couche = 1;
				POSITION p3;
				for (p3 = zz->get_liste_elements()->GetHeadPosition();p3 != NULL;)
				{
					CElement *e = (CElement *)zz->get_liste_elements()->GetNext(p3);
					e->Colorier(cour,BLANC);
				}

			}
			delete rr;
		}




		compteur++;

		int ZTLx = z->getRect()->TopLeft().x;
		int ZTLy = z->getRect()->TopLeft().y;
		int ZBRx = z->getRect()->BottomRight().x;
		int ZBRy = z->getRect()->BottomRight().y;

		if ((ZTLx - delta) < 0) ZTLx = 0;
		else ZTLx = ZTLx - delta;
		if ((ZTLy - delta) < 0) ZTLy = 0;
		else ZTLy = ZTLy - delta;
		if ((ZBRx + delta) > image->getTaille().cx) ZBRx = image->getTaille().cx;
		else ZBRx = ZBRx + delta;
		if ((ZBRy + delta) > image->getTaille().cy) ZBRy = image->getTaille().cy;
		else ZBRy = ZBRy + delta;

		largeur=abs(ZBRx-ZTLx);
		hauteur=abs(ZBRy-ZTLy);

		PLFilterCrop filtre(ZTLx,ZTLy,ZBRx,ZBRy);
		CImage *tmp =new CImage();
		tmp->setTailleLxH(largeur,hauteur);

		try
		{
			filtre.Apply(cour->getPointeur(),tmp->getPointeur());
		}
		catch(PLTextException e)
		{
			CString message;
			message.Format("filter application error");
			AfxMessageBox(message);
			continue;
		}


		chemin_images = ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats()+"\\"+z->getClasse()->getNomClasse()+"\\";
		if (!PathFileExists(chemin_images)) _mkdir(chemin_images);
		fic=nom_fichier+"_"+z->getClasse()->getNomClasse()+"_";

		num.Empty();
		num.Format("%02d",compteur);
		entier.Empty();
		entier=chemin_images+fic+num+"."+extension;

		fprintf(f,"%s %d : %d %d %d %d \n",z->getClasse()->getNomClasse(),compteur,ZTLx,ZTLy,largeur,hauteur);
		fprintf(fmap,"%s %d : %d\t%d\t%d\t%d\t%s\n",z->getClasse()->getNomClasse(),compteur,(int)floor((double)(ZTLx)*rapport),(int)floor((double)(ZTLy)*rapport),(int)floor(largeur*rapport),(int)floor(hauteur*rapport),entier);
		
		//if (z->getClasse()->getNomClasse() == "IMAGE") 
		fprintf(fmapbis,"%s %s %d,%d,%d,%d\n",fic+num+"."+extension,z->getClasse()->getNomClasse(),(int)floor((ZTLx)*rapport),(int)floor((ZTLy)*rapport),(int)floor((ZBRx)*rapport),(int)floor((ZBRy)*rapport));

	
		try
		{
			tmp->Sauvegarder(extension,entier);
			delete tmp;
			delete cour;
		}
		catch(PLTextException e){
			CString message;
			message.Format("Error while loading file: %s",LPCTSTR(e),(LPCTSTR)e.GetCode());
			AfxMessageBox(message);
		}
		
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}	
	
	fclose(f);
	fclose(fmap);
	fclose(fmapbis);
}



/********************************************************************/
/* Nom mthode : Calcul_Densite                                     
/*                                                                  
/* Fonction : 
/*            
/*                                                                 
/********************************************************************/

int CListeZones::Calcul_Densite(CImage *im)
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	bool typeExiste = true;
	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		typeExiste = pAppTemp->projet->getLaboTrait()->findElemListeTypesClasse("BRUIT");
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		typeExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse("BRUIT");
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		typeExiste = pAppTemp->projet->getLaboProj()->findElemListeTypesClasse("BRUIT");
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}
	
	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;
	if (!typeExiste)
	{
		int indiceNewClasse = 0;
		if (!liste_types_classe->IsEmpty())
		{
			CTypeClasse *typeTemp = (CTypeClasse*)liste_types_classe->GetTail();
			indiceNewClasse = typeTemp->getNumClasse()+1;
		}
		CTypeClasse *bruit=new CTypeClasse("BRUIT",RGB(0,0,0),indiceNewClasse);
		liste_types_classe->AddTail(bruit);
	}

	//on recupere la position de la premiere zone de la liste
	POSITION p1;
	POSITION pos_element_z;
	
	//CProgressBar pg("Fusion horizontale...",liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Fusion horizontale...",liste->GetCount());
	CWaitCursor wc;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{	
		double sommeDensite = 0;
		CZone *z = (CZone *)liste->GetNext(p1);
		for (pos_element_z = z->get_liste_elements()->GetHeadPosition(); pos_element_z != NULL;)
		{
			CElement *e1 = (CElement *)z->get_liste_elements()->GetNext(pos_element_z);

			int hauteur = e1->getRect()->Height();
			int largeur = e1->getRect()->Width();
			int x,y;
			int compteur=0;
			for (y=e1->getRect()->top;y<=e1->getRect()->bottom;y++)
				for (x=e1->getRect()->left;x<=e1->getRect()->right;x++)
				{
					if (im->getPixel(x,y) == BLANC) compteur++;
					//else break;

					
				}
			
			e1->setDensite((double)compteur / (double)(hauteur*largeur));
			sommeDensite+=e1->getDensite();
			
		}
		
		int nb = z->getNbElements();
//		z->setDensite(sommeDensite / (double)nb);

		if (z->getDensite() > 0.1 && z->getClasse()->getNomClasse()=="TEXTEI")
		{
			z->setClasse("BRUIT",liste_types_classe);
		}
		
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}

	return 0;
}



/********************************************************************/
/* Nom mthode : Suppression_Zone_De_Type                                     
/*                                                                  
/* Fonction : on efface les zones de type "type" c'est  dire qu'on les
/*            enleve de la liste puis on les colorie en "couleur"
/*            sur l'image "im"
/*                                                                 
/*                                                                 
/********************************************************************/


void CListeZones::Suppression_Zone_De_Type(CString type, UINT couleur, bool suppression,CImage *im)
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}
	

	int longueurListe = liste->GetCount();
	//CProgressBar pg("Suppression des zones de type "+type+"...", longueurListe);
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Suppression des zones de type "+type+"...",longueurListe);
	CWaitCursor wc;
	POSITION p1;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		if (z->getClasse()->getNomClasse() == type)
		{
			z->Colorier(im,couleur);
			if (suppression)
			{
				liste->RemoveAt(liste->Find(z));
				delete z;
			}
		}
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}

	if (suppression) 
	{
		POSITION pt;
		for (pt = liste_types_classe->GetHeadPosition();pt != NULL;)
		{
			CTypeClasse *t = (CTypeClasse *)liste_types_classe->GetNext(pt);
			if (t->getNomClasse() == type)
			{
				liste_types_classe->RemoveAt(liste_types_classe->Find(t));
				delete t;
			}
		}
	}
	/*exemple : Suppression_Zone_De_Type("BRUIT",BLANC,Image_Courante,true)*/
	//while (pg.m_progress.GetPos() != longueurListe)
		//pg.m_progress.StepIt();
	while (((CMainFrame*)AfxGetMainWnd())->m_progBar.GetPos() != longueurListe)
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

}



/********************************************************************/
/* Nom mthode : AjouterZone                                     
/*                                                                  
/* Fonction : permet l'ajout d'une zone  la liste des zones
/*            
/*                                                                 
/********************************************************************/


bool CListeZones::AjouterZone(int xi, int yi, int xf, int yf)
{
	//cration d'un nouvel element initialis avec les coordonnes de la CC
	CElement *e =new CElement(xi,yi,xf,yf);
	if (e->getRect()->IsRectEmpty()) return false;
	//cration d'une nouvelle zone
	CZone *z = new CZone(liste->GetCount(), pDoc);
	//on ajoute la zone  la liste 
	liste->AddTail(z);
	//on ajoute l'element  la zone
	z->Ajouter_Element(e);

	return true;
}




/********************************************************************/
/* Nom mthode : EtiquetterZone                                     
/*                                                                  
/* Fonction : permet d'affecter un tiquette  une zone BRUIT, IMAGE, TEXTE
/*                     
/*                                                                 
/********************************************************************/

void CListeZones::EtiquetterZone(int PDX, int PDY, int GDX, int GDY)
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}
	

	int petitx = PDX;
	int petity = PDY;
	int grandx = GDX;
	int grandy = GDY;

	//CProgressBar pg("Etude de la taille des CC...",liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Etude de la taille des CC...",liste->GetCount());
	CWaitCursor wc;
	POSITION p1;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		
		if ((z->getRect()->Width() <= petitx)||(z->getRect()->Height() <= petity))
		{
			z->setClasse("BRUIT",liste_types_classe);	
		}
		else 
		if ((z->getRect()->Width() >= grandx)&&(z->getRect()->Height() >= grandy))
		{
			z->setClasse("IMAGE",liste_types_classe);
			
		}
		else z->setClasse("TEXTE",liste_types_classe);

		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
}

void CListeZones::AfficherZonesSelectionnees(CDC *ecran, double zoomcoeff, CDocument* pDocContenantZones)
{		
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	if (!classifTemp->getListeZonesSelectionnees()->IsEmpty())
	{
		POSITION posTemp;
		for (posTemp = classifTemp->getListeZonesSelectionnees()->GetHeadPosition();posTemp != NULL;)
		{
			CZone *ZoneTrouveeTemp = (CZone *)classifTemp->getListeZonesSelectionnees()->GetNext(posTemp);
			CMyAppDoc* pDocTemp = (CMyAppDoc*)ZoneTrouveeTemp->m_DocContenant;
			CMyAppDoc* pNewDocContenantZones = (CMyAppDoc*)pDocContenantZones;
			if (pDocTemp->m_nom_complet == pNewDocContenantZones->m_nom_complet)
			{
				ZoneTrouveeTemp->Afficher_Zones(ecran,zoomcoeff,RGB(190,255,60));
				//ZoneTrouveeTemp->Colorier(pDoc->imageOrigine->getImageOrigine(),123);
			}
		}
	}else
	{
		//MessageBox("Aucune zone trouve");
	}
}

void CListeZones::ChercherNumZonesSelectionnees(CRect *rectangleSelection)
{

	long i=0;
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
		

	POSITION p1;
	for (p1 = liste->GetHeadPosition();p1 != NULL;)
	{
		CZone *z = (CZone *)liste->GetNext(p1);
		if ((z->getCdg()->x > rectangleSelection->TopLeft().x) && (z->getCdg()->x < rectangleSelection->BottomRight().x) && (z->getCdg()->y > rectangleSelection->TopLeft().y) && (z->getCdg()->y < rectangleSelection->BottomRight().y))
		{
			if (classifTemp->getListeZonesSelectionnees()->Find(z) == NULL)
			{
				classifTemp->getListeZonesSelectionnees()->AddTail(z);
				CListBox *listTemp = (CListBox *)pFrmTemp->m_wndDlgAssistTab.getm_assist3()->GetDlgItem(IDC_LISTE_ZONES_SEL);
				CMyAppDoc *pDocContenantTemp = (CMyAppDoc *)z->m_DocContenant;
				CString nomImage = pDocContenantTemp->m_nom;
				CString texteZoneAAfficher;
				texteZoneAAfficher.Format( "Zone %i sur " + nomImage, z->getZone()) ;
				listTemp->AddString(texteZoneAAfficher); 

				pFrmTemp->m_wndDlgAssistTab.getm_assist3()->ActiverDesactiverBoutons();
			}
		}
	}
}