/****************************************************************/
//
// ListeCC.h: interface for the CListeZones class.
//
// Cette classe permet de grer les diffrentes actions que l'on
// peut effectuer sur les zones
//
/****************************************************************/

#if !defined(AFX_LISTECC_H__A1F92F46_1BED_4F95_B6D0_726287812A19__INCLUDED_)
#define AFX_LISTECC_H__A1F92F46_1BED_4F95_B6D0_726287812A19__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

#include "zone.h"
#include "image.h"

/***********************/
// CLASSE
/***********************/

class CListeZones  
{
private:
	CDocument *pDoc;
public:
	CObList *liste;

public:
	void EtiquetterZone(int PDX,int PDY, int GDX, int GDY);
	bool AjouterZone(int xi,int yi, int xf, int yf);
	void Suppression_Zone_De_Type(CString type, UINT couleur,bool suppression, CImage *im);
	void Colorier(CImage *im,CString type, UINT color);

	void Generer_HTML(int delta, int mappage, int largeur_page, int hauteur_page);
	
	void Supprime_Intersection(CString type);
	void DecoupageImages(CImage *image_origine,double rapport_mappage,int delta);
	void CherchePoint(CPoint *p,CDC *ecran, double zoomcoeff);
	void MessageNbZone();
	void Affiche_Zone(CDC *ecran, double zoomcoeff);
	void Supprime_inclusion_Gde_CC();
	void Affiche_CC(CDC *ecran, double zoomcoeff, int k);
	void Supprime_Pte_CC(CImage *im);
	int DetectionContours(CImage *ImageCourante);
	bool Fusion(CImage *img,int x,int y,int u,int v,int seuil,double distance);
	void Renommer_CC(CZone *remplacer, CZone *par );

	int Ppv_horizontal(CImage *dest, int seuil, CString type);
	int Ppv_vertical(CImage *dest, int seuil, CString type);

	int Ppv_horizontal_CDG(CImage *dest, int seuil);
	int Ppv_vertical_CDG(CImage *dest, int seuil);

	int bresenham(int x1,int y1,int x2,int y2,CImage *image);
	int Calcul_Densite(CImage *im);

	void ChercherNumZonesSelectionnees(CRect *rectangleSelection);
	void AfficherZonesSelectionnees(CDC *ecran, double zoomcoeff, CDocument *pDocContenantZones);

	CListeZones(CDocument *pDoc);
	virtual ~CListeZones();

};

#endif // !defined(AFX_LISTECC_H__A1F92F46_1BED_4F95_B6D0_726287812A19__INCLUDED_)
