/****************************************************************/
// MainFrm.cpp : implementation of the CMainFrame class
/****************************************************************/

#include "stdafx.h"
#include "MyApp.h"

#include "MainFrm.h"
#include "MyAppDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CMainFrame
/****************************************************************/

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_SYSCOMMAND()
	ON_WM_CREATE()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	//ON_UPDATE_COMMAND_UI_RANGE( ID_INDICATOR_IMG, ID_INDICATOR_IMG, OnUpdatePanels )
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_IMG,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/****************************************************************/
// CMainFrame construction/destruction
/****************************************************************/

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	MaxProgBar = 0;
}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::DoDataExchange(CDataExchange* pDX)
{
	CMDIFrameWnd::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainFrame)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

HCURSOR CMainFrame::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	EnableDocking(CBRS_ALIGN_ANY);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	
	
	if (!m_wndDlgAssistTab.Create(this, IDD_DIALOG_ASSIST_TAB,
		CBRS_LEFT|WS_CHILD |CBRS_TOOLTIPS|CBRS_FLYBY, IDD_DIALOG_ASSIST_TAB))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	
	if (!m_wndDlgTab.Create(this, IDD_DIALOG_TAB,
		CBRS_BOTTOM|WS_CHILD |CBRS_TOOLTIPS|CBRS_FLYBY, IDD_DIALOG_TAB))
	{

		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	
	
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	/*m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);*/


	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{

	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	 
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/****************************************************************/
// CMainFrame diagnostics
/****************************************************************/

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/****************************************************************/
// CMainFrame message handlers
/****************************************************************/

void CMainFrame::CreerProgressBar()
{
	//ajout de la progressBar dans la barre de status:
	RECT rc;
	// Rcuprer la taille du rectangle du premier index de la barre
	// d'tat (zone texte)
	m_wndStatusBar.GetItemRect(0,&rc); 
	// Position de la barre de progression (en fin de la zone texte)
	rc.left = rc.right-190;
	rc.right -= 5;
	// Cration de la barre de progression
	m_progBar.Create(WS_CHILD|WS_BORDER, rc, &m_wndStatusBar,
	IDC_PROGRESS_CTRL);
	m_progBar.ShowWindow(SW_HIDE);
}

void CMainFrame::DemarrerProgressBar(CString texte, int nbMax)
{
	RECT rcOrg;
	int x, y, width, height;
	m_wndStatusBar.GetItemRect(0,&rcOrg); 
	x = rcOrg.right-190;
	y = rcOrg.top-1;
	width = rcOrg.right-x-5;
	height = rcOrg.bottom - rcOrg.top;
	m_progBar.MoveWindow(x,y,width,height);

	MaxProgBar = nbMax;
	m_progBar.SetRange(0,MaxProgBar);
	m_progBar.SetStep(1);

	ChangeStatusText(0,texte);
	if (m_progBar.GetPos() != MaxProgBar) m_progBar.ShowWindow(SW_SHOW);
}

void CMainFrame::CacherProgressBar()
{
	m_progBar.ShowWindow(SW_HIDE);
}

void CMainFrame::IncrementerProgressBar(CString texte)
{
	if (texte == "")
	{
		m_progBar.StepIt();
	}else
	{
		m_progBar.StepIt();
		ChangeStatusText(0,texte);
	}
	
	if (m_progBar.GetPos() != MaxProgBar) m_progBar.ShowWindow(SW_SHOW);

	if (m_progBar.GetPos() == MaxProgBar)
	{
		m_progBar.ShowWindow(SW_HIDE);
		ChangeStatusText(0,"");

		//m_progBar.DestroyWindow();
		//delete m_progBar;
	}
}

void CMainFrame::ChangeStatusText(int pane,CString str,BOOL bupdate){

	//CString tmp;
	m_wndStatusBar.SetPaneText(pane,str,bupdate);
}

void CMainFrame::ChangeStatusStyle( int nIndex, UINT nID, UINT nStyle, int cxWidth ){

	m_wndStatusBar.SetPaneInfo(nIndex,nID,nStyle,cxWidth);
	
}

void CMainFrame::RecupStatusRect(int nIndex, LPRECT lpRect ){

	m_wndStatusBar.GetItemRect(nIndex,lpRect);
}


void CMainFrame::OnSysCommand(UINT nID, LPARAM lParam) 
{
    // Test sur la fermeture de l'application
	if(nID==SC_CLOSE)
	{
		if (((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_numEtapeAssist() != 0)
		{
			int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
			if (rep==IDYES)
			{
				//enregistrement :
				((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
				//suprimme les images temporaires
				((CMyAppApp*)AfxGetApp())->projet->SupprimerRepertoireImgCourantes();
			}
			if (rep==IDNO)
			{
				//pas d'enregistrement.
				//suprimme les images temporaires
				((CMyAppApp*)AfxGetApp())->projet->SupprimerRepertoireImgCourantes();
			}
			if (rep==IDCANCEL)
			{
				return ; // pas de fermeture
			}
		}
	}
	CMDIFrameWnd::OnSysCommand(nID, lParam);
} 

