/****************************************************************/
/* MyApp.cpp : Defines the class behaviors for the application. */
/****************************************************************/

#include "stdafx.h"
#include "MyApp.h"
#include <direct.h>
#include <iostream>

#include <fstream>
#include "MainFrm.h"
#include "ChildFrm.h"
#include "MyAppDoc.h"
#include "MyAppView.h"
#include <initguid.h>
#include "Repertoires.h"
#include ".\myapp.h"
#include "PathDialog.h"
#include "DialogParamProjet.h"
#include "constante.h"
#include "Scenario.h"
#include <stdio.h>
#include <stdlib.h>

using namespace std;
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/****************************************************************/
/* CMyAppApp                                                    */
/****************************************************************/

BEGIN_MESSAGE_MAP(CMyAppApp, CWinApp)
	//{{AFX_MSG_MAP(CMyAppApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_PRINC_Q_APROPOSDEAGORA, OnAppAbout)
	ON_COMMAND(ID_PRINC_PROJ_NEW, OnMenuProjNew)
	ON_COMMAND(ID_BUTTON_NEW_PROJET, OnMenuProjNew)
	ON_COMMAND(ID_PRINC_PROJ_OUVRIR, OnMenuProjOpen)
	ON_COMMAND(ID_BUTTON_OPEN_PROJET, OnMenuProjOpen)
	ON_COMMAND(ID_PRINC_PROJ_ENR, OnMenuProjSave)
	ON_COMMAND(ID_BUTTON_SAVE_PROJET, OnMenuProjSave)
	ON_UPDATE_COMMAND_UI(ID_PRINC_PROJ_ENR, OnUpdateMenuProjSave)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_SAVE_PROJET, OnUpdateMenuProjSave)
	ON_COMMAND(ID_PRINC_PROJ_QUITTER, OnMenuProjQuitter)
	ON_COMMAND(ID_AFF_ZOOM, OnMenuAffZoom)
	ON_UPDATE_COMMAND_UI(ID_AFF_ZOOM, OnUpdateMenuAffZoom)
	ON_COMMAND(ID_PRINC_AFFICHAGE_ZOOM, OnMenuAffZoom)
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_ZOOM, OnUpdateMenuAffZoom)
	ON_COMMAND(ID_PRINC_AFFICHAGE_BARREPROJET, OnMenuAffBarreProjet)
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_BARREPROJET, OnUpdateMenuAffBarreProjet)
	ON_COMMAND(ID_PRINC_AFFICHAGE_BARREDETAT, OnMenuAffBarreEtat)
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_BARREDETAT, OnUpdateMenuAffBarreEtat)
	ON_COMMAND(ID_PRINC_AFFICHAGE_BARREDOUTIL, OnMenuAffBarreOutils)
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_BARREDOUTIL, OnUpdateMenuAffBarreOutils)
	ON_COMMAND(ID_PRINC_AFFICHAGE_BARREASSISTANT, OnMenuAffBarreAssistant)
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_BARREASSISTANT, OnUpdateMenuAffBarreAssistant)
	ON_COMMAND(ID_PRINC_PROJ_PARAM, OnMenuProjParam)
	ON_UPDATE_COMMAND_UI(ID_PRINC_PROJ_PARAM, OnUpdateMenuProjParam)
	ON_COMMAND(ID_PRINC_PROJ_FERM, OnMenuProjFermer)
	ON_UPDATE_COMMAND_UI(ID_PRINC_PROJ_FERM, OnUpdateMenuProjFermer)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()


/****************************************************************/
/* Constructeur de CMyAppApp                                    */  
/****************************************************************/

CMyAppApp::CMyAppApp()
{

	// REMARQUE : Tous les constructeurs sont placs ici
	// Placer tout les initialisation significative dans InitInstance
	
	projet = new CProjet();
	

	m_boutonToolbarEnregistrer = false;
	m_boutonToolbarAddImages = false;
	m_boutonToolbarReconnaissance = false;
	m_boutonToolbarZoom = false;
	m_menuProjetParam = false;
	m_menuProjetFermer = false;
	m_menuAffichageBarreAssistant = false;
	m_menuAffichageBarreProjet = false;

	pDocCharge = NULL;
	docCharge = false;
}


/****************************************************************/
/* Cration du seul et unique object CMyAppApp                  */
/****************************************************************/

CMyAppApp theApp;


/****************************************************************/
/* Initialisation de CMyAppApp                                  */
/****************************************************************/

BOOL CMyAppApp::InitInstance()
{

	// Initialisation standard
	// Si vous n'avez pas besoin de tout cela et afin de rduire
	// la taille de votre code executable, vous pouvez supprimer
	// les routines d'initialisation dont vous n'avez pas besoin.


#ifdef _AFXDLL
	Enable3dControls();			// Appeler cela quand vous utilisez MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Appeler cela lorsque vous utilisez le linkage MFC statiquement
#endif


	// initialize GDI+
	GdiplusStartupInput gdiplusStartupInput;
	GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);

	// Change la registry key sous laquelle vos paramtre seront stock.
	// REMARQUE: Vous pouvez modifier ce string par quelque chose de plus appropri
	// comme le nom de votre entreprise ou organisation.


	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Chargement du fichier d'option INI standard (inclus MRU)




	// Register the application's document templates.  Document templates
	// serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MENU_DOCUMENT,
		RUNTIME_CLASS(CMyAppDoc),
		RUNTIME_CLASS(CChildFrame), // Personnalisation de MDI child frame
		RUNTIME_CLASS(CMyAppView));
	AddDocTemplate(pDocTemplate);



	// Cration de la fentre principale MDI Frame window

	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MENU_PRINCIPALE))
		return FALSE;
	m_pMainWnd = pMainFrame;




	// Parse command line for standard shell commands, DDE, file open

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		return TRUE;
	}



	// Pas de fentre document vide

	if (cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew)
	{
		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	}



	// Dispatch commands specified on the command line

	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// La fentre principale a t initialise, on l'affiche et la mets  jour

	pMainFrame->ShowWindow(SW_MAXIMIZE);
	pMainFrame->UpdateWindow();

	pMainFrame->CreerProgressBar();

	//pour les cacher des le debut
	OnMenuAffBarreAssistant();
	OnMenuAffBarreProjet();

	//met le titre du projet dans la barre de l'application
	((CMDIFrameWnd *)AfxGetMainWnd())->SetWindowText(_T("AGORA 5"));

	return TRUE;

}



/****************************************************************/
/* CAboutDlg dialog used for App About                          */
/****************************************************************/

class CAboutDlg : public CDialog
{

public:

	CAboutDlg();

// Dialog Data

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL




// Implementation

protected:

	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}



void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}




BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




// App command to run the dialog

void CMyAppApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}




/****************************************************************/
/* CMyAppApp message handlers                                   */
/****************************************************************/

int CMyAppApp::ExitInstance()
{

	// release GDI+ resource
	GdiplusShutdown(m_gdiplusToken);
	return CWinApp::ExitInstance();
	
}


/****************************************************************/
/* Nom mthode : isProjetOpen                                   */
/*                                                              */  
/* Fonction : permet de mettre a jour les boutons de la         */
/*              barre d'outils et des menus                     */
/*                                                              */  
/****************************************************************/
void CMyAppApp::isProjetOpen()
{
	std::cout<<"rachit is here"<<"\n";
	m_boutonToolbarEnregistrer = true;
	m_boutonToolbarAddImages = true;
	m_menuProjetParam = true;
	m_menuProjetFermer = true;
	m_menuAffichageBarreAssistant = true;
	OnMenuAffBarreAssistant();
}

/****************************************************************/
/* Nom mthode : isProjetClosed                                 */
/*                                                              */  
/* Fonction : permet de mettre a jour les boutons de la         */
/*              barre d'outils et des menus                     */
/*                                                              */  
/****************************************************************/
void CMyAppApp::isProjetClosed()
{
	m_boutonToolbarEnregistrer = false;
	m_boutonToolbarAddImages = false;
	m_menuProjetParam = false;
	m_menuProjetFermer = false;
	m_menuAffichageBarreAssistant = false;
	m_menuAffichageBarreProjet = false;
	docCharge = false;
	//efface le titre du projet dans la barre de l'application
	((CMDIFrameWnd *)AfxGetMainWnd())->SetTitle(LPCTSTR("AGORA"));
	OnMenuAffBarreAssistant();
}



/****************************************************************/
/* Nom mthode : OnMenuProjOpen                               */
/*                                                              */  
/* Fonction : permet d'ouvrir une image                         */
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnMenuProjOpen() 
{
	bool openOK = false;
	//vrifier si un projet n'est pas dj ouvert
	// si oui, proposer de l'enregistrer et le fermer
	if (projet->getParamProj()->getM_numEtapeAssist() > 1)
	{
		int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
		if (rep==IDYES)
		{
			//enregistrement :
			((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDNO)
		{
			//pas d'enregistrement.
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDCANCEL)
		{
			return ; // pas d'ouverture de projet
		}
	}else
	{
		if (projet->getParamProj()->getM_numEtapeAssist() == 1)
		{
			int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
			if (rep==IDYES)
			{
				//enregistrement :
				((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDNO)
			{
				//pas d'enregistrement.
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDCANCEL)
			{
				return ; // pas de fermeture du projet
			}
		}

	}

	static char BASED_CODE Filtre[] = "Fichier de projet Agora (*.xml)|*.xml|";
	
 	CFileDialog a(TRUE,".xml",NULL,OFN_EXPLORER,Filtre,NULL);
	a.m_ofn.lpstrInitialDir = projet->getParamProj()->getM_repOuvrage();
	a.m_ofn.lpstrTitle = "Ouvrir Projet";
	
 	if (a.DoModal()==IDCANCEL)
	{
		return ;
	}
	else
	{
		projet->getParamProj()->setM_ficXml(a.GetPathName());
		if (projet->LireFichierProjetXml(a.GetPathName()))
		{	
			//ouvre le fichier xml
			int numEtap = projet->getParamProj()->getM_numEtapeAssist();
			CString fichierScenar, nomOuvr;
			int reponse;

			switch (numEtap)
			{
			case 1:
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab1();
				openOK = true;
				break;
			case 2:
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab2A();
				//deja fait dans afficherTab
				//projet->getLaboTrait()->OuvrirImageLaboTrait();
				
				fichierScenar.Format("%s\\%s-scenario",projet->getParamProj()->getM_repTravail(),projet->getParamProj()->getM_nomProjet());
				if (PathFileExists(fichierScenar))
				{
					CScenario *scenarIn = new CScenario();
					scenarIn->Charger(fichierScenar,true);
					projet->getLaboTrait()->setScenarioTrait(scenarIn);
					projet->getLaboTrait()->getScenarioTrait()->Afficher();
					CMyAppDoc* pDocTrait = (CMyAppDoc*)projet->getLaboTrait()->getListeDocsLaboTrait()->GetHead();
					projet->getLaboTrait()->getScenarioTrait()->Executer(pDocTrait);
					delete scenarIn;
				}
				//passer en mode Perso:
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist2()->CocherCasePerso();
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist2()->OnBnClickedButtonAssist2ValA();
				openOK = true;
				break;
			case 3:
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab3A();
				//deja fait dans afficherTab
				//projet->getLaboClassif()->OuvrirImagesLaboClassif();
				
				fichierScenar.Format("%s\\%s-scenario",projet->getParamProj()->getM_repTravail(),projet->getParamProj()->getM_nomProjet());
				if (PathFileExists(fichierScenar))
				{
					CScenario *scenarIn = new CScenario();
					scenarIn->Charger(fichierScenar,true);
					projet->getLaboClassif()->setScenarioClassif(scenarIn);
					projet->getLaboClassif()->getScenarioClassif()->Afficher();
					POSITION posDocs = projet->getLaboClassif()->getListeDocsLaboClassif()->GetHeadPosition();
					while (posDocs)
					{
						CMyAppDoc* pDoc = (CMyAppDoc*)projet->getLaboClassif()->getListeDocsLaboClassif()->GetNext(posDocs);
						projet->getLaboClassif()->getScenarioClassif()->Executer(pDoc);
					}
					delete scenarIn;
				}
				//passer en mode Perso:
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->CocherCasePerso();
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->OnBnClickedButtonAssist3ValA();
				openOK = true;
				break;
			case 4:
				nomOuvr = projet->getParamProj()->getM_nomProjet();
				reponse = AfxMessageBox("Do you want to apply the  selected scenario on a work different from "+nomOuvr+"?", MB_YESNO);
				if (reponse==IDYES)
				{
					//Obtenir un pointeur sur l'objet contenant les paramtres du projet
					CProjetParam* paramProjTmp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();

					CPathDialog  dlg( TEXT("Choix de l'ouvrage"), 
						TEXT("Veuillez slectionner le rpertoire contenant les images de l'ouvrage :"),
									paramProjTmp->getM_repOuvrage());

					// show path dialog
					if ( dlg.DoModal() == IDOK )
					{
						paramProjTmp->setM_repOuvrage(dlg.GetPathName());
					}else
					{
						OnMenuProjFermer();
						return;
					}
				}
				if (reponse==IDNO)
				{
					//rien
				}
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab4();
				//deja fait dans afficherTab
				//projet->getLaboProj()->OuvrirTousDocsOuvrage();
				//grise les menus Trait et Classif :
				projet->getLaboProj()->MajMenu();
				((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist4()->AfficherCacherBoutonsSupplementaires();
				
				fichierScenar.Format("%s\\%s-scenario",projet->getParamProj()->getM_repTravail(),projet->getParamProj()->getM_nomProjet());
				if (PathFileExists(fichierScenar))
				{
					CScenario *scenarIn = new CScenario();
					scenarIn->Charger(fichierScenar,true);
					projet->getLaboProj()->setScenarioProj(scenarIn);
					delete scenarIn;
				}
				openOK = true;
				break;
			default :
				AfxMessageBox("Opennig failed.");
				openOK = false;
				break;
			}
			
			//met le titre du projet dans la barre de l'application
			((CMDIFrameWnd *)AfxGetMainWnd())->SetWindowText(_T("AGORA 5 - " + a.GetFileTitle()));
			((CMDIFrameWnd *)AfxGetMainWnd())->SetTitle(_T("AGORA 5 - " + a.GetFileTitle()));

			if (openOK) isProjetOpen();
		}else
		{
			AfxMessageBox("It's not an Agora file!");
		}
	}
	
}

void CMyAppApp::DechargerDoc(CMyAppDoc* pDocADecharger)
{
	pDocADecharger->atelier->DeCharger();
}

void CMyAppApp::ChargerDoc(CMyAppDoc* pDocACharger)
{
	if (pDocACharger != NULL)
	{
		if (docCharge)
		{
			if (pDocACharger->GetTitle() != pDocCharge->GetTitle())
			{
				pDocCharge->atelier->DeCharger();

				pDocACharger->atelier->ReCharger();
				pDocCharge = pDocACharger;
				docCharge = true;
			}
		}else
		{
			pDocACharger->atelier->ReCharger();
			pDocCharge = pDocACharger;
			docCharge = true;
		}
	}
}

void CMyAppApp::ChargerDocSelectionne()
{
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->RafficherDocSelectionne();
}

void CMyAppApp::OuvrirDocument(CString nomDoc, int typeLabo) 
{
	CMyAppDoc * pDoc = (CMyAppDoc*)CWinApp::OpenDocumentFile(nomDoc);
	ASSERT_VALID(pDoc);	
	switch (typeLabo)
	{
	case LABOTRAIT :
		projet->getLaboTrait()->getListeDocsLaboTrait()->AddTail(pDoc);
		m_menuAffichageBarreProjet = true;
		break;
	case LABOCLASSIF :
		projet->getLaboClassif()->getListeDocsLaboClassif()->AddTail(pDoc);
		m_menuAffichageBarreProjet = true;
		break;
	case LABOPROJET :
		projet->getLaboProj()->getListeDocsLaboProj()->AddTail(pDoc);
		m_menuAffichageBarreProjet = true;
		break;
	}
	
	m_boutonToolbarZoom = true;	//le mettre quand un doc est ouvert
}

bool CMyAppApp::FermerDocument(CMyAppDoc* pDocIn) 
{
	int typeLabo = 0;
	typeLabo = projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		if (projet->getLaboTrait()->supprElemListeDocuments(pDocIn))
		{
			docCharge = false;
			//recharge la liste de vignettes
			((CMainFrame *)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
			if (projet->getLaboTrait()->getListeDocsLaboTrait()->IsEmpty())
				m_menuAffichageBarreProjet = false;
			return true;
		}else
		{
			return false;
		}
		break;
	case LABOCLASSIF :
		if (projet->getLaboClassif()->supprElemListeDocuments(pDocIn))
		{
			docCharge = false;
			//recharge la liste de vignettes
			((CMainFrame *)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
			//deselectionne le doc dans la liste de l'onglet 3
			projet->getLaboClassif()->getClassifAuto()->setZoneSel(NULL);
			//vide l'affichage de la liste sur l'onglet 3
			CListBox *listTemp = (CListBox*)((CMainFrame *)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist3()->GetDlgItem(IDC_LISTE_ZONES_SEL);
			listTemp->SetSel(0,false);
			projet->getLaboClassif()->getClassifAuto()->EffacerListeZonesSelAvecDoc(listTemp,pDocIn);
			//supprime les elements de la liste de zones slectionnes de ce document
			projet->getLaboClassif()->getClassifAuto()->EffacerZonesSelAvecDoc(pDocIn);
			if (projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
				m_menuAffichageBarreProjet = false;
			return true;
		}else
		{
			return false;
		}
		break;
	case LABOPROJET :
		if (projet->getLaboProj()->supprElemListeDocuments(pDocIn))
		{
			docCharge = false;
			//recharge la liste de vignettes
			((CMainFrame *)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
			if (projet->getLaboProj()->getListeDocsLaboProj()->IsEmpty())
				m_menuAffichageBarreProjet = false;
			return true;
		}else
		{
			return false;
		}
		break;
	default :
		return false;
		break;
	}
}


void CMyAppApp::FermerTousDocuments() 
{
	int typeLabo = 0;
	typeLabo = projet->QuelLaboEnCours();
	switch (typeLabo)
	{
	case LABOTRAIT :
		//projet->getLaboTrait()->supprAllListeDocuments();
		//la suppression dans la liste est effectue lors de l'appel de OnCloseDocument de MyAppDoc
		//qui appelle ensuite FermerDocument de MyApp
		m_boutonToolbarZoom = false;	//le mettre quand les docs sont ferms
		break;
	case LABOCLASSIF :
		//projet->getLaboClassif()->supprAllListeDocuments();
		//idem
		m_boutonToolbarZoom = false;	//le mettre quand les docs sont ferms
		break;
	case LABOPROJET :
		//projet->getLaboProj()->supprAllListeDocuments();
		//idem
		m_boutonToolbarZoom = false;	//le mettre quand les docs sont ferms
		break;
	default:
		//AfxMessageBox("Erreur lors de la fermeture complte des fichiers.");
		//aucun document a fermer car l'utilisateur se trouve dans l'etape1 de l'assistant
		break;
	}
	CWinApp::CloseAllDocuments(false);
	docCharge = false;
	OnMenuAffBarreProjet();
}

/****************************************************************/
/* Nom mthode : OnMenuProjSave                             */
/*                                                              */  
/* Fonction : permet la sauvegarde du projet (fichier XML)      */
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnMenuProjSave() 
{

	//mettre  jour le fichier XML
	if (!projet->MaJFichierProjetXml())
	{
		AfxMessageBox("It's not an Agora file!");
	}

	CString nomFichierScenar;
	nomFichierScenar.Format("%s\\%s-scenario", projet->getParamProj()->getM_repTravail(),projet->getParamProj()->getM_nomProjet());
	
	projet->getParamProj()->setM_ficSauvegarde(nomFichierScenar);

	//sauvegarde du scenario
	int typeLabo = 0;
	typeLabo = projet->QuelLaboEnCours();
	switch (typeLabo)
	{
	case LABOTRAIT :
		projet->getLaboTrait()->getScenarioTrait()->Sauvegarder(nomFichierScenar);
		break;
	case LABOCLASSIF :
		projet->getLaboClassif()->getScenarioClassif()->Sauvegarder(nomFichierScenar);
		break;
	case LABOPROJET :
		projet->getLaboProj()->getScenarioProj()->Sauvegarder(nomFichierScenar);
		break;
	default:
		//l'utilisateur se situe dans l'tape 1 donc aucun scnario a sauvegarder
		break;
	}

	//remettre  jour le fichier XML a cause du fichier de sauvegarde
	if (!projet->MaJFichierProjetXml())
	{
		AfxMessageBox("It's not an Agora file!");
	}

}

/****************************************************************/
/* Nom mthode : OnUpdateMenuProjSave                         */
/*                                                              */  
/* Fonction : permet de activer/desactiver le bouton enregistrer*/
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnUpdateMenuProjSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_boutonToolbarEnregistrer);
}



/****************************************************************/
/* Nom mthode : OnMenuProjNew                                */
/*                                                              */  
/* Fonction : permet de crer un fichier de projet (fichier XML)*/
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnMenuProjNew() 
{
	//vrifier si un projet n'est pas dj ouvert
	// si oui, proposer de l'enregistrer et le fermer
	if (projet->getParamProj()->getM_numEtapeAssist() > 1)
	{
		int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
		if (rep==IDYES)
		{
			//enregistrement :
			((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDNO)
		{
			//pas d'enregistrement.
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDCANCEL)
		{
			return ; // pas de nouveau projet
		}
	}else
	{
		if (projet->getParamProj()->getM_numEtapeAssist() == 1)
		{
			int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
			if (rep==IDYES)
			{
				//enregistrement :
				((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDNO)
			{
				//pas d'enregistrement.
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDCANCEL)
			{
				return ; // pas de fermeture du projet
			}
		}

	}

	CFileDialog NewDlg(false,".xml",NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"Fichier de projet Agora (*.xml)|*.xml|",
						AfxGetMainWnd());

	//GetOpenFileName
	NewDlg.m_ofn.lpstrTitle = "Nouveau Projet";

	if(NewDlg.DoModal()==IDOK)
	{
		CString sNomFic=NewDlg.GetPathName();
		CString sExt=NewDlg.GetFileExt();

		projet->getParamProj()->InitialiserParamProj(NewDlg.GetFileTitle());

		projet->getParamProj()->setM_ficXml(sNomFic);
		projet->getParamProj()->setM_repTravail(sNomFic.Mid(0,sNomFic.ReverseFind('\\')));

		projet->CreerFichierProjetXml(sNomFic);
		projet->CreerStructureRep();

		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab1();
		
		//met le titre du projet dans la barre de l'application
		((CMDIFrameWnd *)AfxGetMainWnd())->SetWindowText(_T("AGORA 5 - " + NewDlg.GetFileTitle()));
		((CMDIFrameWnd *)AfxGetMainWnd())->SetTitle(_T("AGORA 5 - " + NewDlg.GetFileTitle()));

		isProjetOpen();
	}
	
}

void CMyAppApp::OnMenuProjQuitter()
{
	//enregistrer le projet avant de quitter
	//et suprimmer les images temporaires
	//effectus dans la recup du message onclose dans MainFrame
	AfxGetMainWnd()->PostMessage(WM_SYSCOMMAND,SC_CLOSE,0); 
}



/****************************************************************/
/* Nom mthode : OnMenuAffZoom                                  */
/*                                                              */  
/* Fonction : permet de zoomer                                  */
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnMenuAffZoom() 
{
	int typeLabo = 0;
	typeLabo = projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		projet->getLaboTrait()->ModeZoom();
		break;
	case LABOCLASSIF :
		projet->getLaboClassif()->ModeZoom();
		break;
	case LABOPROJET :
		projet->getLaboProj()->ModeZoom();
		break;
	default :
		AfxMessageBox("Error while zooming.");
		break;
	}
}



/****************************************************************/
/* Nom mthode : OnUpdateMenuAffZoom                            */
/*                                                              */  
/* Fonction : permet de activer/desactiver le zoom              */
/*                                                              */
/*                                                              */  
/****************************************************************/
void CMyAppApp::OnUpdateMenuAffZoom(CCmdUI* pCmdUI) 
{
	int typeLabo = 0;
	typeLabo = projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		projet->getLaboTrait()->UpdateModeZoom(pCmdUI);
		break;
	case LABOCLASSIF :
		projet->getLaboClassif()->UpdateModeZoom(pCmdUI);
		break;
	case LABOPROJET :
		projet->getLaboProj()->UpdateModeZoom(pCmdUI);
		break;
	default :
		//ne rien faire car au dmarrage, aucun document n'est charg
		//AfxMessageBox("Erreur lors du Zoom (update).");
		break;
	}
	pCmdUI->Enable(m_boutonToolbarZoom);
}

void CMyAppApp::OnMenuAffBarreProjet() 
{
	if( ((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.IsWindowVisible() )
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.ShowWindow(SW_HIDE);	
	else
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.ShowWindow(SW_SHOW);	
	((CMainFrame*)AfxGetMainWnd())->RecalcLayout(true);
	
}

void CMyAppApp::OnUpdateMenuAffBarreProjet(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.IsWindowVisible());
	pCmdUI->Enable(m_menuAffichageBarreProjet);
}

void CMyAppApp::OnMenuAffBarreEtat() 
{
	if( ((CMainFrame*)AfxGetMainWnd())->m_wndStatusBar.IsWindowVisible() )
		((CMainFrame*)AfxGetMainWnd())->m_wndStatusBar.ShowWindow(SW_HIDE);	
	else
		((CMainFrame*)AfxGetMainWnd())->m_wndStatusBar.ShowWindow(SW_SHOW);	
	((CMainFrame*)AfxGetMainWnd())->RecalcLayout(true);
	
}

void CMyAppApp::OnUpdateMenuAffBarreEtat(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CMainFrame*)AfxGetMainWnd())->m_wndStatusBar.IsWindowVisible());
}

void CMyAppApp::OnMenuAffBarreOutils() 
{
	if( ((CMainFrame*)AfxGetMainWnd())->m_wndToolBar.IsWindowVisible() )
		((CMainFrame*)AfxGetMainWnd())->m_wndToolBar.ShowWindow(SW_HIDE);	
	else
		((CMainFrame*)AfxGetMainWnd())->m_wndToolBar.ShowWindow(SW_SHOW);	
	((CMainFrame*)AfxGetMainWnd())->RecalcLayout(true);
	
}

void CMyAppApp::OnUpdateMenuAffBarreOutils(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CMainFrame*)AfxGetMainWnd())->m_wndToolBar.IsWindowVisible());
}

void CMyAppApp::OnMenuAffBarreAssistant() 
{
	if( ((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.IsWindowVisible() )
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.ShowWindow(SW_HIDE);	
	else
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.ShowWindow(SW_SHOW);	
	((CMainFrame*)AfxGetMainWnd())->RecalcLayout(true);
	
}

void CMyAppApp::OnUpdateMenuAffBarreAssistant(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.IsWindowVisible());
	pCmdUI->Enable(m_menuAffichageBarreAssistant);
}

void CMyAppApp::OnMenuProjParam() 
{
	CDialogParamProjet dlg;
	dlg.DoModal();
}

void CMyAppApp::OnUpdateMenuProjParam(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_menuProjetParam);
}

void CMyAppApp::OnMenuProjFermer()
{
	//proposer d'enregistrer le projet
	if (projet->getParamProj()->getM_numEtapeAssist() > 1)
	{
		int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
		if (rep==IDYES)
		{
			//enregistrement :
			((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDNO)
		{
			//pas d'enregistrement.
			//vider la variable projet :
			projet->ViderProjet();
			isProjetClosed();
		}
		if (rep==IDCANCEL)
		{
			return ; // pas de fermeture du projet
		}
	}else
	{
		if (projet->getParamProj()->getM_numEtapeAssist() == 1)
		{
			int rep = AfxMessageBox("Would you like to save the project before?", MB_YESNOCANCEL);
			if (rep==IDYES)
			{
				//enregistrement :
				((CMyAppApp*)AfxGetApp())->OnMenuProjSave();
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDNO)
			{
				//pas d'enregistrement.
				//vider la variable projet :
				projet->ViderProjetSansLabo();
				isProjetClosed();
				//pour la cacher (car elle est rappele dans InitInstance)
				OnMenuAffBarreProjet();
			}
			if (rep==IDCANCEL)
			{
				return ; // pas de fermeture du projet
			}
		}

	}

	//met le titre du projet dans la barre de l'application
	((CMDIFrameWnd *)AfxGetMainWnd())->SetWindowText(_T("AGORA 5"));
	
}

void CMyAppApp::OnUpdateMenuProjFermer(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_menuProjetFermer);
}
