/****************************************************************/
/* MyAppDoc.cpp : implementation of the CMyAppDoc class         */
/****************************************************************/


#include "stdafx.h"
#include "MyApp.h"
#include "MyAppDoc.h"
#include "MyAppView.h"
#include <direct.h>
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BLANC 255
#define NOIR 0

//#define NBMARGES 4

/****************************************************************/
/* CMyAppDoc                                                    */
/****************************************************************/

IMPLEMENT_DYNCREATE(CMyAppDoc, CDocument)

BEGIN_MESSAGE_MAP(CMyAppDoc, CDocument)
	//{{AFX_MSG_MAP(CMyAppDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
/* CMyAppDoc construction/destruction                           */
/****************************************************************/


CMyAppDoc::CMyAppDoc()
{
	// atelier = new CAtelier();
	atelier=NULL;

	m_isReconnue = false;

	menuTrait = false;
	menuClassif = false;
	menuProj = false;
}

CMyAppDoc::~CMyAppDoc()
{
	
	delete atelier;

	DeleteContents();
}



void CMyAppDoc::DeleteContents() 
{
	CDocument::DeleteContents();
}


/****************************************************************/
/* CMyAppDoc serialization                                      */
/****************************************************************/


void CMyAppDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}




/****************************************************************/
/* CMyAppDoc diagnostics                                        */
/****************************************************************/



#ifdef _DEBUG
void CMyAppDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMyAppDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG



/****************************************************************/
/* CMyAppDoc commands                                           */
/****************************************************************/


/****************************************************************/
/* Nom mthode : OnFileSaveAs                                   */
/*                                                              */  
/* Fonction : permet la sauvegarde d'une image                  */
/*                                                              */
/*                                                              */  
/****************************************************************/
/*
void CMyAppDoc::OnFileSaveAs() 
{
	CFileDialog SaveDlg(false,".jpg",NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"JPEG File (*.jpg)|*.jpg|Windows Bitmap (*.bmp)|*.bmp|TIFF File (*.tif)|*.tif|PNG File (*.png)|*.png|",
						AfxGetMainWnd());

	if(SaveDlg.DoModal()==IDOK)
	{
		CString sNomFic=SaveDlg.GetPathName();
		CString sExt=SaveDlg.GetFileExt();
		atelier->Sauvegarder(sExt,sNomFic);	
		
	}
}
*/


/****************************************************************/
/* Nom mthode : ChargeImage                                    */
/*                                                              */  
/* Fonction :                                                   */
/*                                                              */
/*                                                              */  
/****************************************************************/

bool CMyAppDoc::ChargeImage(CString path)
{	
	bool ok=true;
	m_extension = path.Right(path.GetLength() - path.ReverseFind('.') - 1);
	m_nom = path.Left(path.ReverseFind('.')).Right(path.Left(path.ReverseFind('.')).GetLength() - path.ReverseFind('\\') -1);
	m_nom_complet = path;

	if (atelier) 
	{
		delete atelier;Beep(500,200);
	}
	atelier = new CAtelier(this);
	atelier->Charger(path);
	
	return ok;
}



/****************************************************************/
/* Nom mthode : DonneInfo                                      */
/*                                                              */  
/* Fonction : permet la rcupration des infos de l'image et    */
/*            l'affichage dans la boite de dialogue affich par */
/*            la commande Informations du menu Affichage        */  
/****************************************************************/

void CMyAppDoc::DonneInfo()
{

	CString tmp;
	CString message;

	message.Empty();
	tmp.Format("Width : %d pixels\n",atelier->getImageCourante()->getLargeur());
	message+=tmp;
	tmp.Format("Height : %d pixels\n",atelier->getImageCourante()->getHauteur());
	message+=tmp;
	tmp.Format("bits per pixel : %d\n",atelier->getImageCourante()->getNbBitsParPixel());
	message+=tmp;

	AfxMessageBox(message,MB_OK);
}



/****************************************************************/
/* Nom mthode : SetAnnuler                                     */
/*                                                              */  
/* Fonction :                                                   */
/*                                                              */
/*                                                              */  
/****************************************************************/

void CMyAppDoc::SetAnnuler(){

	/*if(m_pUndo!=NULL) delete m_pUndo;

	try{
		m_pUndo=new PLWinBmp;
		m_pUndo->CreateCopy(*m_pBMP);

	}
	catch(PLTextException e){
		CString err;
		err.Format("Erreur SetAnnuler\n%s",e);
		AfxMessageBox(err,MB_OK);
	}
	m_Annuler=true;*/
}



/****************************************************************/
/* Nom mthode : Annuler                                        */
/*                                                              */  
/* Fonction :                                                   */
/*                                                              */
/*                                                              */  
/****************************************************************/

void CMyAppDoc::Annuler(){

	/*if(m_pUndo!=NULL){
		
		try{
			m_pBMP->CreateCopy(*m_pUndo);
			delete m_pUndo;
			m_pUndo=NULL;
		}
		catch(PLTextException e){
			CString err;
			err.Format("Erreur Annuler\n%s",e);
			AfxMessageBox(err,MB_OK);
		}
	}
	m_Annuler=false;*/
}



/****************************************************************/
/* Nom mthode : OnOpenDocument                                 */
/*                                                              */  
/* Fonction : Fonction appel lors de la l'ouverture d'une image*/
/*                                                              */
/*                                                              */  
/****************************************************************/

BOOL CMyAppDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	if(ChargeImage(lpszPathName)==true)
	{
		SetPathName(lpszPathName); //slt si surdef de open ou save
		SetModifiedFlag(false); //met icone save en gris
		return TRUE;
	}
	else 
	{
	
		return FALSE;
	}

}



/****************************************************************/
/* Nom mthode : OnCloseDocument                                */
/*                                                              */  
/* Fonction : Fonction appel lors de la fermeture d'une image  */
/*            afin de demander si il faut sauvegarder le        */
/*            dans le cas ou il a t modifi                   */  
/****************************************************************/

void CMyAppDoc::OnCloseDocument() 
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	if (pAppTemp->FermerDocument(this))
	{
		CDocument::OnCloseDocument();
		return;
	}

}

