// MyAppView.h : interface of the CMyAppView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYAPPVIEW_H__822EC879_DFBD_4DEC_852B_DB08479A027C__INCLUDED_)
#define AFX_MYAPPVIEW_H__822EC879_DFBD_4DEC_852B_DB08479A027C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define ZOOM_MAX 10
#define ZOOM_MIN 1/10

#include "zone.h"
#include "Bloc.h"

class CMyAppView : public CScrollView
{
public:
	CMyAppView();
protected: // create from serialization only
	
	DECLARE_DYNCREATE(CMyAppView)

// Attributes
public:
	CPoint P1;
	CPoint P2;
	bool track;

	CMyAppDoc* GetDocument();
	int index;
	bool affiche_cc;
	bool affiche_zone;

	int m_hauteur;
	int m_largeur;
	bool m_zoommode;
	bool m_selectionmode;
	double m_zoomcoeff;

	bool m_selectionDone;
	
	bool Courante_ou_Origine;
	bool Image_Copiee;


	HCURSOR m_curZoom;
	HCURSOR m_curLache;
	HCURSOR m_curPrend;




// Operations
public:

	bool IsSelection(){return m_selectionmode;}
	void SetSelectionMode(bool val){m_selectionmode=val;}
	bool IsZoom(){return m_zoommode;}
	void SetZoomMode(bool val){m_zoommode=val;}
	void IncZoomCoeff(bool val=true);

	void GriserMenuTrait();
	void GriserMenuClassif();
	void GriserMenuProj();
	void DeGriserMenuTrait();
	void DeGriserMenuClassif();
	void DeGriserMenuProj();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyAppView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMyAppView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CMyAppView)
	afx_msg void OnAffInfo();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnAfficheCC();
	afx_msg void OnUpdateAfficheCC(CCmdUI* pCmdUI);
	afx_msg void OnAffZone();
	afx_msg void OnUpdateAffZone(CCmdUI* pCmdUI);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnImageOrg();
	afx_msg void OnUpdateImageOrg(CCmdUI* pCmdUI);
	afx_msg void OnImageCourante();
	afx_msg void OnUpdateImageCourante(CCmdUI* pCmdUI);
	afx_msg void OnUpdateImageInd(CCmdUI*);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	
	afx_msg void OnDocEditRetablirImgOrigine();
	afx_msg void OnDocEditCopier();
	afx_msg void OnDocEditColler();
	afx_msg void OnDocTraitBin();
	afx_msg void OnDocTraitBinNiblack();
	afx_msg void OnDocTraitInv();
	afx_msg void OnDocTraitPret();
	afx_msg void OnDocTraitMorphEro();
	afx_msg void OnDocTraitMorphDil();
	afx_msg void OnDocTraitMorphOuv();
	afx_msg void OnDocTraitMorphFerm();
	afx_msg void OnDocTraitCartendgH();
	afx_msg void OnDocTraitCartendgV();
	afx_msg void OnDocTraitCartendgHv();
	afx_msg void OnDocTraitCalculCc();
	afx_msg void OnDocTraitFusionGlob();
	afx_msg void OnDocTraitFusFhNorm();
	afx_msg void OnDocTraitFusFhCdg();
	afx_msg void OnDocTraitFusFvNorm();
	afx_msg void OnDocTraitFusFvCdg();
	afx_msg void OnDocTraitRafraichCarac();
	afx_msg void OnDocClassifGeo();
	afx_msg void OnDocClassifVois();
	afx_msg void OnDocClassifCaracCc();
	afx_msg void OnDocClassifSuppZone();
	afx_msg void OnDocClassifSuppInterZone();
	afx_msg void OnDocClassifChangeType();
	afx_msg void OnDocOutilsApplOuvr();

	afx_msg void OnUpdateDocEditRetablirImgOrigine(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocEditCopier(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocEditColler(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitBin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitBinNiblack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitInv(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitPret(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitMorphEro(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitMorphDil(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitMorphOuv(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitMorphFerm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitCartendgH(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitCartendgV(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitCartendgHv(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitCalculCc(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitFusionGlob(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitFusFhNorm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitFusFhCdg(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitFusFvNorm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitFusFvCdg(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocTraitRafraichCarac(CCmdUI *pCmdUI);
	afx_msg void OnUpdateDocClassifGeo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocClassifVois(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocClassifCaracCc(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocClassifSuppZone(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocClassifSuppInterZone(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDocClassifChangeType(CCmdUI *pCmdUI);
	afx_msg void OnUpdateDocOutilsApplOuvr(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg void OnDisplayRamel();
};

#ifndef _DEBUG  // debug version in MyAppView.cpp
inline CMyAppDoc* CMyAppView::GetDocument()
   { return (CMyAppDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYAPPVIEW_H__822EC879_DFBD_4DEC_852B_DB08479A027C__INCLUDED_)
