
#include "stdafx.h"
#include "ParamCarac.h"
#include "MyApp.h"
#include "constante.h"

CParamCarac::CParamCarac(CString nomACreer, int numeroCarac)
{
	nomCarac = nomACreer;
	listeValeurs = new CList<double>();
	numCarac = numeroCarac;
}

CParamCarac::~CParamCarac(void)
{
	delete listeValeurs;
}

void CParamCarac::DeterminerBornes(int numeroCarac)
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	int borne[2];
	switch(numeroCarac)
	{
	case RAPPORTLSURH :
		borneInf = 0;
		borneSup = 100;
		break;
	case NBELEMENTS : //est dterminer selon la classe
		borneInf = classifTemp->getClasseSynthetisee()->getNbElementsBorneInf();
		borneSup = classifTemp->getClasseSynthetisee()->getNbElementsBorneSup();
		break;
	case RAPPORTHSURHMOYCC :
		borneInf = 0;
		borneSup = 100;
		break;
	case LARGEURZONE : //est dterminer selon la classe
		borneInf = classifTemp->getClasseSynthetisee()->getLargeurZoneBorneInf();
		borneSup = classifTemp->getClasseSynthetisee()->getLargeurZoneBorneSup();
		break;
	case HAUTEURZONE : //est dterminer selon la classe
		borneInf = classifTemp->getClasseSynthetisee()->getHauteurZoneBorneInf();
		borneSup = classifTemp->getClasseSynthetisee()->getHauteurZoneBorneSup();
		break;
	case DENSITEPIXBLANC :
		borneInf = 0;
		borneSup = 1;
		break;
	case DENSITENDGSURNBPIX :
		borneInf = 0;
		borneSup = 255;
		break;
	case DEGREGAUCHE :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGREDROITE :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGREHAUT :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGREBAS :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGRECENTREP :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGRECENTREL :
		borneInf = 0;
		borneSup = 1;
		break;
	case DEGRECENTREH :
		borneInf = 0;
		borneSup = 1;
		break;

	default :
		borneInf = 0;
		borneSup = 0;
		break;
	}
}

int CParamCarac::CalculerClasseMajeure()
{
	// on parcourt la liste des valeurs pour crer une liste contenant
	// uniquement les chiffres diffrents
	CList<double> *listeChifDif = new CList<double>();
	listeChifDif->AddTail((double)listeValeurs->GetHead());

	POSITION posVal = listeValeurs->GetHeadPosition();
	while (posVal)
	{
		double valTemp = (double)listeValeurs->GetNext(posVal);
		POSITION posChif = listeChifDif->GetHeadPosition();
		while (posChif)
		{
			double chifTemp = (double)listeChifDif->GetNext(posChif);
			if (valTemp != chifTemp) listeChifDif->AddTail(valTemp);
		}
	}

	//on parcourt la liste de chiffres diffrents pour comparer avec la liste
	// de valeurs pour pouvoir compter le nombre de fois que chaque valeur dif 
	// est prsente dans la liste de valeurs
	int n2 = 0;
	double valMaj = 0;
	POSITION posChif2 = listeChifDif->GetHeadPosition();
	while (posChif2)
	{
		int n1 = 0;
		double chifTemp2 = (double)listeChifDif->GetNext(posChif2);
		POSITION posVal2 = listeValeurs->GetHeadPosition();
		while (posVal2)
		{
			double valTemp2 = (double)listeValeurs->GetNext(posVal2);
			if (valTemp2 == chifTemp2) n1++;
		}
		if (n1 > n2)
		{
			n2 = n1;
			valMaj = chifTemp2;
		}
	}

	//on trouve maintenant la classe majeure : la valeur la plus presente (valMaj)
	return (int)valMaj;
}

void CParamCarac::ToutCalculer()
{
	DeterminerBornes(numCarac);
	mini = CalculerMini(listeValeurs);
	maxi = CalculerMaxi(listeValeurs);
	CList<double> *listeValeursNorm = new CList<double>();
	listeValeursNorm = NormaliserValeurs(listeValeurs, mini, maxi); //normaliser avant les calculs
	moyenne = CalculerMoyenne(listeValeursNorm); //la moyenne avant la variance
	variance = CalculerVariance(listeValeursNorm, moyenne);
	ecartType = CalculerEcartType(variance);//les valeurs normes servent seulement  dterminer l'cart type
	moyenne = CalculerMoyenne(listeValeurs); //recalcul de la moyenne car valeur non norme utilise dans les regles
	mediane = CalculerMediane(listeValeurs);

	delete listeValeursNorm;
}


double CParamCarac::CalculerMini(CList<double> *listeACalculer)
{
	double minimum;
	if (!listeACalculer->IsEmpty())
	{
		POSITION posMini = listeACalculer->GetHeadPosition();
		minimum = 10000000000;
		while(posMini)
		{
			double temp = (double)listeACalculer->GetNext(posMini);
			if (temp < minimum) minimum = temp;
		}
	}else
	{
		minimum = 0;
	}
	return minimum;
}

double CParamCarac::CalculerMaxi(CList<double> *listeACalculer)
{
	double maximum;
	if (!listeACalculer->IsEmpty())
	{
		POSITION posMaxi = listeACalculer->GetHeadPosition();
		maximum = -10000000000;
		while(posMaxi)
		{
			double temp = (double)listeACalculer->GetNext(posMaxi);
			if (temp > maximum) maximum = temp;
		}
	}else
	{
		maximum = 0;
	}
	return maximum;
}

double CParamCarac::CalculerVariance(CList<double> *listeACalculer, double moyCalculee)
{
	double var;
	if (!listeACalculer->IsEmpty())
	{
		double nb = (double)listeACalculer->GetCount();
		double somme = 0;
		POSITION posVariance = listeACalculer->GetHeadPosition();
		while(posVariance)
		{
			double temp = (double)listeACalculer->GetNext(posVariance);
			double calcul = (temp - moyCalculee)*(temp - moyCalculee);
			somme += calcul;
		}
		var = somme / nb;
	}else
	{
		var = 0;
	}
	return var;
}

double CParamCarac::CalculerEcartType(double varianceCalculee)
{
	double eT;
	if (varianceCalculee != 0)
	{
		eT = sqrt(varianceCalculee);
	}else
	{
		eT = 0;
	}
	return eT;
}

double CParamCarac::CalculerMoyenne(CList<double> *listeACalculer)
{
	double moy;
	if (!listeACalculer->IsEmpty())
	{
		double nb = (double)listeACalculer->GetCount();
		double somme = 0;
		POSITION posMoyenne = listeACalculer->GetHeadPosition();
		while(posMoyenne)
		{
			double temp = (double)listeACalculer->GetNext(posMoyenne);
			somme += temp;
		}
		moy = somme / nb;
	}else
	{
		moy = 0;
	}
	return moy;
}

double CParamCarac::CalculerMediane(CList<double> *listeACalculer)
{
	double med;
	if (!listeACalculer->IsEmpty())
	{
		//trier par ordre croissant
		int nb = listeACalculer->GetCount();
		//on utilise un tableau car pour effectuer le tri de la liste par
		//  ordre croissant, on a besoin des indices numriques des valeurs
		//  (dans une liste, les indices sont des POSITION)
		double tabATrier[10000];
		POSITION posTab = listeACalculer->GetHeadPosition();
		int i = 0;
		while(posTab)
		{
			tabATrier[i] = (double)listeACalculer->GetNext(posTab);
			i++;
		}
		QuickSort(tabATrier, 0, nb-1);

		//choper l'indice de la valeur qui est au milieu de la liste
		int indiceMilieu = 0;
		if (nb%2 == 0)
		{
			//le nb d'lments dans la liste est pair
			indiceMilieu = nb/2;
		}else
		{
			//le nb d'lments dans la liste n'est pas pair
			indiceMilieu = (nb+1)/2;
		}
		med = tabATrier[indiceMilieu-1];
	}else
	{
		med = 0;
	}
	return med;
}

CList<double>* CParamCarac::NormaliserValeurs(CList<double> *listeACalculer, double miniCalcule, double maxiCalcule)
{
	miniNorm = CalculNormalisation(miniCalcule);
	maxiNorm = CalculNormalisation(maxiCalcule);

	CList<double> *listeValeursNorm = new CList<double>();
	if (!listeACalculer->IsEmpty())
	{
		POSITION posNorm = listeACalculer->GetHeadPosition();
		while(posNorm)
		{
			double temp = (double)listeACalculer->GetNext(posNorm);
			double tempNorm = CalculNormalisation(temp);
			listeValeursNorm->AddTail(tempNorm);
		}
	}
	return listeValeursNorm;
}

double CParamCarac::CalculNormalisation(double valeurANormaliser)
{
	double resultat = 0;

	if (/*(borneInf != 0)&&(borneSup != 0)&&*/(borneInf != borneSup))
	{
		resultat = (((valeurANormaliser - borneInf) * 100)/(borneSup - borneInf));
	}
	return resultat;
}

void CParamCarac::QuickSort(double tabATrier[], int minimum, int maximum)
{
        int q;
        if(minimum<maximum)
		{
			q = Partitionner(tabATrier, minimum, maximum);
			QuickSort(tabATrier, minimum, q);
			QuickSort(tabATrier, q+1, maximum);
        }
}
int CParamCarac::Partitionner(double tabATrier[], int minimum, int maximum)
{
        double pivot = tabATrier[minimum];
		int i = minimum-1;
		int j = maximum+1;
        double temp;
        while(1) {
                do
                        j--;
                while(tabATrier[j] > pivot);
                do
                        i++;
                while(tabATrier[i] < pivot);
                if(i<j) {
                        temp = tabATrier[i];
                        tabATrier[i] = tabATrier[j];
                        tabATrier[j] = temp;
                }
                else
                        return j;
        }
        return j;
 }

void CParamCarac::ViderParam()
{
	if (!listeValeurs->IsEmpty()) listeValeurs->RemoveAll();
	mini = 0;
	maxi = 0;
	variance = 0;
	ecartType = 0;
	moyenne = 0;
	mediane = 0;
	miniNorm = 0;
	maxiNorm = 0;
}
