
#include "stdafx.h"
#include "ParamClasse.h"
#include "MyApp.h"
#include "constante.h"

CParamClasse::CParamClasse(CString nomACreer, int numeroCarac)
{
	nomCarac = nomACreer;
	listeValeurs = new CList<int>();
	listeClasses = new CList<CString,CString>();
	numCarac = numeroCarac;
	pourcentageClasse = 0;
}

CParamClasse::~CParamClasse(void)
{
	delete listeValeurs;
	delete listeClasses;
}



int CParamClasse::CalculerClasseMajeure()
{
	// on parcourt la liste des valeurs pour crer une liste contenant
	// uniquement les chiffres diffrents
	CList<int> *listeChifDif = new CList<int>();
	listeChifDif->AddTail((int)listeValeurs->GetHead());

	POSITION posVal = listeValeurs->GetHeadPosition();
	while (posVal)
	{
		int valTemp = (int)listeValeurs->GetNext(posVal);
		POSITION posChif = listeChifDif->GetHeadPosition();
		while (posChif)
		{
			int chifTemp = (int)listeChifDif->GetNext(posChif);
			if (valTemp != chifTemp) listeChifDif->AddTail(valTemp);
		}
	}

	nbClasses = listeChifDif->GetCount();

	//on parcoourt la liste de chiffres diffrents pour comparer avec la liste
	// de valeurs pour pouvoir compter le nombre de fois que chaque valeur dif 
	// est prsente dans la liste de valeurs
	int n2 = 0;
	int valMaj = 0;
	POSITION posChif2 = listeChifDif->GetHeadPosition();
	while (posChif2)
	{
		int n1 = 0;
		int chifTemp2 = (int)listeChifDif->GetNext(posChif2);
		POSITION posVal2 = listeValeurs->GetHeadPosition();
		while (posVal2)
		{
			int valTemp2 = (int)listeValeurs->GetNext(posVal2);
			if (valTemp2 == chifTemp2) n1++;
		}
		if (n1 > n2)
		{
			n2 = n1;
			valMaj = chifTemp2;
		}
	}

	//on trouve maintenant la classe majeure : la valeur la plus presente (valMaj)
	return valMaj;
}

CTypeClasse* CParamClasse::TrouverClasse(int numClasse)
{
	CTypeClasse *classeTrouvee;

	if (numClasse == -1) 
	{
		classeTrouvee = NULL;
		return classeTrouvee;
	}

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types.");
		break;
	}
	POSITION posClasse = liste_types_classe->GetHeadPosition();
	while(posClasse)
	{
		CTypeClasse *classeTemp = (CTypeClasse *)liste_types_classe->GetNext(posClasse);
		if (classeTemp->getNumClasse() == numClasse)
		{
			classeTrouvee = classeTemp;
			return classeTrouvee;
		}
	}
	return classeTrouvee;
}

double CParamClasse::CalculerPourcentage()
{
	//parcourir la liste de valeurs et compter combien de fois il y a le num de la classe choisie
	//faire le pourcentage par rapport au nombre total de classes
	int nbFoisClasse = 0;
	int nbreClasses = 0;
	double pourcentage = 0;

	if (classeChoisie != NULL)
	{
		POSITION posVal = listeValeurs->GetHeadPosition();
		while(posVal)
		{
			int valTemp = (int)listeValeurs->GetNext(posVal);
			if (valTemp == classeChoisie->getNumClasse())
			{
				nbFoisClasse++;
			}
			
		}
		nbreClasses = listeValeurs->GetCount();

		if (nbFoisClasse != 0)
			pourcentage = (((double)nbFoisClasse/(double)nbreClasses)*100);
	}else
	{
		pourcentage = 0;
	}
	return pourcentage;
	
}

void CParamClasse::RemplirListeClasses(CObList* listeTypesClasse)
{
	//on parcourt la liste des num de classes
	POSITION posVal = listeValeurs->GetHeadPosition();
	while(posVal)
	{
		int valTemp = (int)listeValeurs->GetNext(posVal);

		//on parcourt la liste des noms des classes et trouver la correspondance et l'ajouter a listeClasses
		POSITION posClasse = listeTypesClasse->GetHeadPosition();
		while(posClasse)
		{
			CTypeClasse *classeTemp = (CTypeClasse *)listeTypesClasse->GetNext(posClasse);
			if (classeTemp->getNumClasse() == valTemp)
			{
				if (listeClasses->Find(classeTemp->getNomClasse()) == NULL)
				{
					CString nomClasseTemp = classeTemp->getNomClasse();
					listeClasses->AddTail(nomClasseTemp);
				}
			}
		}

	}

}

void CParamClasse::ToutCalculer(CObList* listeTypesClasse)
{
	int numClasseChoisie = CalculerClasseMajeure();
	classeChoisie = TrouverClasse(numClasseChoisie);
	RemplirListeClasses(listeTypesClasse);
	pourcentageClasse = CalculerPourcentage();
}

void CParamClasse::ViderParam()
{
	if (!listeValeurs->IsEmpty()) listeValeurs->RemoveAll();
	if (!listeClasses->IsEmpty()) listeClasses->RemoveAll();
	pourcentageClasse = 0;
}