/****************************************************************/
// Projet.cpp: implementation of the CProjet class.
//
// La classe CProjet regroupe les differentes images ouvertes.
// 
//
/****************************************************************/

/********************/
// INCLUSION
/********************/
#include "stdafx.h"
#include "MyApp.h"
#include "Projet.h"
#include "MyAppDoc.h" //a commenter si il y a un CMyAppDoc dans le .h
#include "MyAppView.h"
#include "ListeZones.h"
#include <fstream>
#include <io.h>
#include <direct.h>
#include "MainFrm.h"
#include "RegleCV.h"
#include "TypeClasse.h"
#include "Markup.h"
#include "constante.h"
#include <shellapi.h>
 
#include <iostream>
using namespace std;

/***********************/
//  PRECOMPILATION
/***********************/




/********************/
// CONSTRUCTEUR
/********************/
CProjet::CProjet()
{

	paramProj = new CProjetParam();
	laboTrait = new CLaboTrait();	//apres l'tape 2 recopier le scenario cr dans scenario de laboClassif
	laboClassif = new CLaboClassif();	//aprs l'tape 3 recopier le scenario cr dans scenario de laboProj
	laboProj = new CLaboProjet();
}

/********************/
// DESTRUCTEUR
/********************/

CProjet::~CProjet(void)
{
	delete paramProj; 
	if (laboTrait) delete laboTrait;
	if (laboClassif) delete laboClassif;
	if (laboProj) delete laboProj;
}

/********************/
// METHODES
/********************/

void CProjet::CreerFichierProjetXml(CString chFic)
{
	CMarkup ficXml;
	int numEtape = -1;

	numEtape = QuelLaboEnCours();

	CString strSeuilBin, strBinAuto, strGdeCcLarg, strGdeCcHaut, strPteCcLarg, strPteCcHaut;
	CString strSeuilH, strSeuilV, strRappMapp, strDeltaDecoup, strTraitText;
	CString strNumEtap, strExportDone;
	strSeuilBin.Format("%i",getParamProj()->getM_seuilBinarisation());
	strBinAuto.Format("%i",getParamProj()->getM_binAuto());
	strGdeCcLarg.Format("%i",getParamProj()->getM_gdeCcLarg());
	strGdeCcHaut.Format("%i",getParamProj()->getM_gdeCcHaut());
	strPteCcLarg.Format("%i",getParamProj()->getM_pteCcLarg());
	strPteCcHaut.Format("%i",getParamProj()->getM_pteCcHaut());
	strSeuilH.Format("%i",getParamProj()->getM_seuilH());
	strSeuilV.Format("%i",getParamProj()->getM_seuilV());
	strRappMapp.Format("%i",getParamProj()->getM_rapportMappage());
	strDeltaDecoup.Format("%i",getParamProj()->getM_deltaDecoup());
	strTraitText.Format("%i",getParamProj()->getM_traitTexte());
	strNumEtap.Format("%i",getParamProj()->getM_numEtapeAssist());
	strExportDone.Format("%i",laboProj->exportDone);

	CString strDate;
	COleDateTime date=COleDateTime::GetCurrentTime();
	strDate.Format("%i/%i/%i",date.GetDay(),date.GetMonth(),date.GetYear());
	
	ficXml.SetDoc( "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\r\n" );
	ficXml.AddElem( "AGORA" );
	ficXml.SetAttrib( "version", "5.0" );
	ficXml.SetAttrib( "date", strDate );
	ficXml.IntoElem();
    ficXml.AddElem( "PARAMETRES" );
	ficXml.IntoElem();
	ficXml.AddElem( "DEPENDANCES" );
	ficXml.IntoElem();
	ficXml.AddElem( "NOM_PROJET", getParamProj()->getM_nomProjet() );
	ficXml.AddElem( "REPERTOIRE_TRAVAIL", getParamProj()->getM_repTravail() );
	ficXml.AddElem( "REPERTOIRE_OUVRAGE", getParamProj()->getM_repOuvrage() );
	ficXml.AddElem( "REPERTOIRE_RESULTATS", getParamProj()->getM_repResultats() );
	ficXml.AddElem( "FICHIER_SAUVEGARDE", getParamProj()->getM_ficSauvegarde() );
	ficXml.OutOfElem();
	ficXml.AddElem( "VALEURS" );
	ficXml.IntoElem();
	ficXml.AddElem( "SEUIL_BINARISATION", strSeuilBin );
	ficXml.AddElem( "BINARISATION_AUTO", strBinAuto );
	ficXml.AddElem( "GDE_CC_LARGEUR", strGdeCcLarg );
	ficXml.AddElem( "GDE_CC_HAUTEUR", strGdeCcHaut );
	ficXml.AddElem( "PTE_CC_LARGEUR", strPteCcLarg );
	ficXml.AddElem( "PTE_CC_HAUTEUR", strPteCcHaut );
	ficXml.AddElem( "SEUIL_H", strSeuilH );
	ficXml.AddElem( "SEUIL_V", strSeuilV );
	ficXml.AddElem( "RAPPORT_MAPPAGE", strRappMapp );
	ficXml.AddElem( "DELTA_DECOUPAGE", strDeltaDecoup );
	ficXml.AddElem( "TRAIT_TEXTE", strTraitText );
	ficXml.OutOfElem();
	ficXml.AddElem( "ASSISTANT" );
	ficXml.IntoElem();
	ficXml.AddElem( "NUM_ETAPE", strNumEtap );
	ficXml.AddElem( "IMG_LABO_TRAIT", getParamProj()->getM_imLaboTrait() );
	if (!getParamProj()->getM_listeImageClassif()->IsEmpty())
	{
		POSITION pos = getParamProj()->getM_listeImageClassif()->GetHeadPosition();
		while (pos)
		{
			ficXml.AddElem( "IMG_LABO_CLASSIF", getParamProj()->getM_listeImageClassif()->GetNext(pos) );
		}
	}
	ficXml.OutOfElem();
	ficXml.OutOfElem();
	ficXml.AddElem( "CALCULS" );
	ficXml.IntoElem();
	ficXml.AddElem( "EXPORT_EFFECTUE", strExportDone );
	if (numEtape == LABOPROJET)
	{
		CObList* liste = laboProj->getListeTypesClasse();
		POSITION pos = liste->GetHeadPosition();
		while (pos)
		{
			CTypeClasse* clTmp = (CTypeClasse*)liste->GetNext(pos);
			ficXml.AddElem( "CLASSE", clTmp->getNomClasse() );
		}
	}
	ficXml.OutOfElem();
	ficXml.OutOfElem();

	//crer le fichier XML
	FILE *fp;
	fp = fopen (chFic, "w");
	fprintf(fp,ficXml.GetDoc());
	fclose(fp);
}

CString CProjet::RecupererCStringXmlFichier(CString chFic)
{
	CString csText;
	CFile file;
	if ( ! file.Open( chFic, CFile::modeRead ) )
	{
		return "";
	}
	int nFileLen = (int)file.GetLength();

	// Allocate buffer for binary file data
	unsigned char* pBuffer = new unsigned char[nFileLen + 2];
	nFileLen = file.Read( pBuffer, nFileLen );
	file.Close();
	pBuffer[nFileLen] = '\0';
	pBuffer[nFileLen+1] = '\0'; // in case 2-byte encoded

	// Windows Unicode file is detected if starts with FEFF
	if ( pBuffer[0] == 0xff && pBuffer[1] == 0xfe )
	{
		// Contains byte order mark, so assume wide char content
		// non _UNICODE builds should perform UCS-2 (wide char) to UTF-8 conversion here
		csText = (LPCWSTR)(&pBuffer[2]);
	}
	else
	{
		// _UNICODE builds should perform UTF-8 to UCS-2 (wide char) conversion here
		csText = (LPCSTR)pBuffer;
	}

	return csText;
}


bool CProjet::LireFichierProjetXml(CString chFic)
{
	CString csText = RecupererCStringXmlFichier(chFic);

	CMarkup ficXml;
	ficXml.SetDoc( csText );
	ficXml.FindElem("AGORA");
	ficXml.IntoElem();
	ficXml.FindElem("PARAMETRES");
	ficXml.IntoElem();

	if(ficXml.FindElem("DEPENDANCES"))
	{
		if (ficXml.FindChildElem( "NOM_PROJET" ))
		{
			paramProj->setM_nomProjet(ficXml.GetChildData());
		}
		else return false;
		if (ficXml.FindChildElem( "REPERTOIRE_TRAVAIL" ))
		{
			paramProj->setM_repTravail(ficXml.GetChildData());
		}
		else return false;
		if (ficXml.FindChildElem( "REPERTOIRE_OUVRAGE" ))
		{
			paramProj->setM_repOuvrage(ficXml.GetChildData());
		}
		else return false;
		if (ficXml.FindChildElem( "REPERTOIRE_RESULTATS" ))
		{
			paramProj->setM_repResultats(ficXml.GetChildData());
		}
		else return false;
		if (ficXml.FindChildElem( "FICHIER_SAUVEGARDE" ))
		{
			paramProj->setM_ficSauvegarde(ficXml.GetChildData());
		}
		else return false;
	}else return false;

	if(ficXml.FindElem("VALEURS"))
	{
		if (ficXml.FindChildElem( "SEUIL_BINARISATION" ))
		{
			paramProj->setM_seuilBinarisation(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "BINARISATION_AUTO" ))
		{
			paramProj->setM_binAuto(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "GDE_CC_LARGEUR" ))
		{
			paramProj->setM_gdeCcLarg(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "GDE_CC_HAUTEUR" ))
		{
			paramProj->setM_gdeCcHaut(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "PTE_CC_LARGEUR" ))
		{
			paramProj->setM_pteCcLarg(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "PTE_CC_HAUTEUR" ))
		{
			paramProj->setM_pteCcHaut(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "SEUIL_H" ))
		{
			paramProj->setM_seuilH(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "SEUIL_V" ))
		{
			paramProj->setM_seuilV(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "RAPPORT_MAPPAGE" ))
		{
			paramProj->setM_rapportMappage(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "DELTA_DECOUPAGE" ))
		{
			paramProj->setM_deltaDecoup(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "TRAIT_TEXTE" ))
		{
			paramProj->setM_traitTexte(atoi(ficXml.GetChildData()));
		}
		else return false;
	}else return false;

	if(ficXml.FindElem("ASSISTANT"))
	{
		if (ficXml.FindChildElem( "NUM_ETAPE" ))
		{
			paramProj->setM_numEtapeAssist(atoi(ficXml.GetChildData()));
		}
		else return false;
		if (ficXml.FindChildElem( "IMG_LABO_TRAIT" ))
		{
			paramProj->setM_imLaboTrait(ficXml.GetChildData());
		}
		else return false;
		while (ficXml.FindChildElem( "IMG_LABO_CLASSIF" ))
		{
			paramProj->addM_listeImageClassif(ficXml.GetChildData());
		}
	}else return false;

	ficXml.OutOfElem();
	if(ficXml.FindElem("CALCULS"))
	{
		if (ficXml.FindChildElem( "EXPORT_EFFECTUE" ))
		{
			laboProj->exportDone = atoi(ficXml.GetChildData());
		}
		else return false;
		int i=0;
		while (ficXml.FindChildElem( "CLASSE" ))
		{
			CTypeClasse *clTmp = new CTypeClasse(ficXml.GetChildData(),0,i);
			laboProj->addElemListeTypesClasse(clTmp);
			i++;
		}
	}else return false;

	return true;
}

bool CProjet::MaJFichierProjetXml()
{
	CreerFichierProjetXml(paramProj->getM_ficXml());

	return true;

}

void CProjet::CreerStructureRep()
{
	if (paramProj->getM_repResultats() == "Non spcifi")
	{
		paramProj->setM_repResultats(paramProj->getM_repTravail()+"\\Rsultats");
		_mkdir(paramProj->getM_repResultats());

		_mkdir(paramProj->getM_repResultats()+"\\Coord");// Cration du rpertoire coord
		_mkdir(paramProj->getM_repResultats()+"\\Html");// Cration du rpertoire html

		//*****************TEMPORAIRE**********************
		_mkdir(paramProj->getM_repResultats()+"\\tests");// Cration du rpertoire tests
		//*************************************************
	}else
	{
		CString strRepRes = paramProj->getM_repResultats();
		if (PathFileExists(strRepRes))
		{
			if (!PathFileExists(strRepRes + "\\Coord"))
				_mkdir(strRepRes + "\\Coord");
			if (!PathFileExists(strRepRes + "\\Html"))
				_mkdir(strRepRes + "\\Html");

			//*****************TEMPORAIRE**********************
			if (!PathFileExists(strRepRes + "\\tests"))
				_mkdir(strRepRes + "\\tests");
			//*************************************************

		}else
		{
			AfxMessageBox("XML path folders are unvalid");
		}
	}
}

bool CProjet::SupprimerRepertoireImgCourantes()
{
	((CMainFrame*)AfxGetMainWnd())->ChangeStatusText(0,"Suppression des fichiers temporaires...");

	LPCTSTR repertoire;
	CString dir;
	dir.Format("%s\\imgTmp",paramProj->getM_repTravail());
	repertoire = dir;
    int s = strlen(repertoire);
    TCHAR * rep = new TCHAR[strlen(repertoire)+2];
    strcpy(rep, repertoire);
    rep[strlen(repertoire)+1] = '\0';
    SHFILEOPSTRUCT sh;
    sh.hwnd = NULL;
    sh.wFunc = FO_DELETE;
    sh.pFrom = rep;
    sh.pTo = NULL;
    sh.fFlags = FOF_NOCONFIRMATION|FOF_SILENT;
	//pour une suppression non dfinitive :
    //sh.fFlags |= FOF_ALLOWUNDO;
    sh.fAnyOperationsAborted = FALSE;
    sh.lpszProgressTitle = NULL;
    sh.hNameMappings = NULL;
    
    //delete [] rep;
    return (SHFileOperation(&sh)==0);
}

void CProjet::ViderProjet()
{
	//fermer tous les docs ouverts
	((CMyAppApp*)AfxGetApp())->FermerTousDocuments();
	//supprime le repertoire des img courantes:
	SupprimerRepertoireImgCourantes();
	//vider les labos
	laboTrait->ViderLabo();
	laboClassif->ViderLabo();
	laboProj->ViderLabo();
	//vide les paramtres et valeurs du projet
	paramProj->ViderParamProj();	
}

void CProjet::ViderProjetSansLabo()
{
	//fermer tous les docs ouverts
	((CMyAppApp*)AfxGetApp())->FermerTousDocuments();
	//supprime le repertoire des img courantes:
	SupprimerRepertoireImgCourantes();
	//vide les paramtres et valeurs du projet
	paramProj->ViderParamProj();	
}

int CProjet::QuelLaboEnCours()
{
	int typeLabo = 0;
	int numEtap = 0;
	numEtap = paramProj->getM_numEtapeAssist();
	switch(numEtap)
	{
	case 0:
		typeLabo = 0;
		break;
	case 1:
		typeLabo = 0;
		break;
	case 2 :
		typeLabo = LABOTRAIT;
		break;
	case 3 :
		typeLabo = LABOCLASSIF;
		break;
	case 4 :
		typeLabo = LABOPROJET;
		break;
	default :
		AfxMessageBox("Error while loading LABO (wrong number).");
		break;
	}
	
	return typeLabo;
}