/****************************************************************/
// RegleBin.cpp: implementation of the CRegleBin class.
//
// Permet de scnariser les traitements de binarisation et
// de binarisatoion automatique
//
/**********************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "RegleBin.h"
#include "myappdoc.h"
#include "myappview.h"


/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/


CRegleBin::CRegleBin()
{
	balise = "RBI";
}

CRegleBin::CRegleBin(int s)
{
	balise = "RBI";
	seuil = s;
}




/*****************/
// DESTRUCTEUR
/*****************/

CRegleBin::~CRegleBin()
{

}

/*****************/
// METHODES
/*****************/



/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleBin::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;


	if (seuil != -1) pAtelier->getImageCourante()->Binariser(seuil);
	
	else pAtelier->getImageCourante()->Binariser(pAtelier->getImageCourante()->Binariser_Niblack(false));
	

	((CMyAppDoc *)pDoc)->atelier->getImageBinarisee()->Copier(((CMyAppDoc *)pDoc)->atelier->getImageCourante());

}

/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/


void CRegleBin::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{

		ar<<seuil;

	}
	else
	{

		ar>>seuil;

	}
}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/


CString CRegleBin::getDescription()
{

	CString desc;

	if (seuil == -1) desc.Format("Effectuer une binarisation automatique (image courante modifie)");

	else desc.Format("Effectuer une binarisation avec un seuil de : %d (image courante modifie)",seuil);

	return desc; 

}
