/****************************************************************/
// RegleCG.cpp: implementation of the CRegleCG class.
//
// Permet la gestion des rgles de classification gographique
//
/*************************************************************/


/*****************/
// INCLUSION
/*****************/


#include "stdafx.h"
#include "myapp.h"
#include "RegleCG.h"
#include "myappdoc.h"
#include "myappview.h"
#include "MainFrm.h"
#include "constante.h"



/*****************/
// PRECOMPILATION
/*****************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/



CRegleCG::CRegleCG()
{
	balise="RCG";
}

CRegleCG::CRegleCG(CString o, char di,int p, CString dsi, CString dsinon)
{
	org = o;
	dir = di;
	dest_si = dsi;
	dest_sinon = dsinon;
	balise="RCG";
	pourcent = p;
}




/*****************/
// DESTRUCTEUR
/*****************/

CRegleCG::~CRegleCG()
{

}



/*****************/
// METHODES
/*****************/



/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleCG::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	Classification_Geographique(pDoc,org,dir,pourcent,dest_si,dest_sinon);
}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleCG::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<dest_si<<dest_sinon<<dir<<org<<pourcent;

	}
	else
	{

		ar>>dest_si>>dest_sinon>>dir>>org>>pourcent;

	}

}




/********************************************************************/
/* Nom mthode : Classification_Geographique                                     
/*                                                                  
/* Fonction : 
/*                                                               
/* 
/*                                                           
/********************************************************************/

void CRegleCG::Classification_Geographique(CDocument *pDoc, CString classe_source,char pos,int valeur, CString dest_si, CString dest_sinon)
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	//changer toutes les zones de classe : classe_source
	//si elles sont  la position pos (Gauche,Droite,Haut,Bas)
	//un nouveau type de classe : classe_dest
	
	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;
	CObList *liste = (CObList *)pAtelier->liste_de_zones->liste;
	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types.");
		break;
	}

	double value = 1.0 - ((double)valeur / 50.0);
	double valuec = ((double)valeur / 100.0);

	//CProgressBar pg("Classification geographique en cours...",liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Classification gographique en cours...",liste->GetCount());
	CWaitCursor wc;
	POSITION pos_zone = liste->GetHeadPosition();

	while (pos_zone != NULL)
	{

		CZone *z = (CZone *)liste->GetNext(pos_zone);

		if ( z->getClasse()->getNomClasse() == classe_source)
		{

			switch(pos)
			{

				case 'G':
					if (z->getCaracCG()->getDegreGauche() > value )
							z->setClasse(dest_si,liste_types_classe);

						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'D':
						if (z->getCaracCG()->getDegreDroite() > value )
							z->setClasse(dest_si,liste_types_classe);	

						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'H':
						if (z->getCaracCG()->getDegreHaut() > value )
							z->setClasse(dest_si,liste_types_classe);	

						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'B':
						if (z->getCaracCG()->getDegreBas() > value )
							z->setClasse(dest_si,liste_types_classe);	

						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'O':
						if (z->getCaracCG()->getDegreGauche() <valuec && z->getCaracCG()->getDegreDroite() < valuec)
							z->setClasse(dest_si,liste_types_classe);	

						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'E':
						if (z->getCaracCG()->getDegreHaut() <valuec && z->getCaracCG()->getDegreBas() <valuec)
							z->setClasse(dest_si,liste_types_classe);
						
						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				case 'C':
						if (z->getCaracCG()->getDegreHaut() <valuec && z->getCaracCG()->getDegreBas() <valuec && z->getCaracCG()->getDegreGauche() <valuec && z->getCaracCG()->getDegreDroite() <valuec)
							z->setClasse(dest_si,liste_types_classe);
						
						else z->setClasse(dest_sinon,liste_types_classe);

						break;

				default:;

			}
		}
			
		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
}




/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleCG::getDescription()
{
	CString d;

	switch (dir)
	{

		case 'G': d=" GAUCHE";break;
		case 'D': d=" DROITE";break;
		case 'H': d="en HAUT";break;
		case 'B': d="en BAS";break;
		case 'C': d="au CENTRE de la page";break;
		case 'O': d="au CENTRE de la largeur de la page";break;
		case 'E': d="au CENTRE de la hauteur de la page";break;

	}

	CString desc;

	desc.Format("le type %s devient de type %s s'il se trouve %s  (%d%%) sinon il devient de type %s",org,dest_si,d,pourcent,dest_sinon);

	return desc;

}
