/*******************************************************/
// RegleCV.h: interface for the CRegleCV class.
//
// Permet la gestion des rgles de classification selon les
// relations de voisinage
//
/*******************************************************/

#if !defined(AFX_REGLECV_H__F6FA9458_D776_40C3_837B_59A452736BC9__INCLUDED_)
#define AFX_REGLECV_H__F6FA9458_D776_40C3_837B_59A452736BC9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Regle.h"
#include <afxtempl.h>

/******************/
// CLASSE
/******************/

class CRegleCV : public CRegle  
{

public:

	CString getDescription();
	
	CRegleCV();
	CRegleCV(CString type_org, CList<CString,CString> *vg, CList<CString,CString> *vd, CList<CString,CString> *vh, CList<CString,CString> *vb, CList<CString,CString> *vi, CString type_dest, CString type_sinon);
	virtual ~CRegleCV();
	void Serialize(CArchive& ar);
	void Executer(CDocument *pDoc);

private:

	void Cherche_Voisins(CDocument *pDoc);
	void Classification_Voisinage(CDocument *pDoc, CString type_org, CList<CString,CString> *vg, CList<CString,CString> *vd, CList<CString,CString> *vh, CList<CString,CString> *vb, CList<CString,CString> *vi, CString type_dest, CString type_sinon);

private:

	CList<CString,CString>  * liste_g;
	CList<CString,CString>  * liste_d;
	CList<CString,CString>  * liste_h;
	CList<CString,CString>  * liste_b;
	CList<CString,CString>  * liste_i;
	CString org;
	CString dest_sinon;
	CString dest_si;

};



#endif // !defined(AFX_REGLECV_H__F6FA9458_D776_40C3_837B_59A452736BC9__INCLUDED_)
