/****************************************************************/
// RegleCarac.cpp: implementation of the CRegleCarac class.
//
// Permet la gestion des rgles de classification gographique
//
/*************************************************************/


/*****************/
// INCLUSION
/*****************/


#include "stdafx.h"
#include "myapp.h"
#include "RegleCarac.h"
#include "myappdoc.h"
#include "myappview.h"
#include "MainFrm.h"




/*****************/
// PRECOMPILATION
/*****************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/


CRegleCarac::CRegleCarac()
{
	balise="RCAR";
}




/*****************/
// DESTRUCTEUR
/*****************/

CRegleCarac::~CRegleCarac()
{

}



/*****************/
// METHODES
/*****************/



/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleCarac::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CalculerCaracteristiques(pDoc);
}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleCarac::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		//ar<<dest_si<<dest_sinon<<dir<<org<<pourcent;
	}
	else
	{
		//ar>>dest_si>>dest_sinon>>dir>>org>>pourcent;
	}
}




/********************************************************************/
/* Nom mthode : CalculerCaracteristiques                                     
/*                                                                  
/* Fonction : 
/*                                                               
/* 
/*                                                           
/********************************************************************/

void CRegleCarac::CalculerCaracteristiques(CDocument *pDoc)
{
	CObList* liste_de_zones = ((CMyAppDoc*)pDoc)->atelier->liste_de_zones->liste;


	//CProgressBar pg("Calcul des caractristiques...",liste_de_zones->liste->GetCount());
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Calcul des caractristiques...",liste_de_zones->GetCount());
	CWaitCursor wc;

	POSITION pos;
	for (pos = liste_de_zones->GetHeadPosition();pos != NULL;) // pour chaque zone
	{
		CZone *z = (CZone *)(liste_de_zones->GetNext(pos)); 

		z->calculerCaracteristiques();

		//pg.m_progress.StepIt();
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}
}




/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleCarac::getDescription()
{
	CString desc;

	desc.Format("Calcul des caractristiques (CC, CG et CV)");

	return desc;

}
