/****************************************************************/
// RegleChangeType.cpp: implementation of the CRegleChangeType class.
//
// Permet de scnariser les traitements de changement/suppression
// d'un type de zone
//
/**************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleChangeType.h"
#include "constante.h"


/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*****************/
// CONSTRUCTEUR
/*****************/

CRegleChangeType::CRegleChangeType()
{
	balise="RCT";
}


CRegleChangeType::CRegleChangeType(CString pTypeOrg, CString pTypeDest, bool pSuppressionTypeOrg)
{
	balise="RCT";
	typeOrg = pTypeOrg;
	typeDest = pTypeDest;
	suppressionTypeOrg = pSuppressionTypeOrg;
}

/*****************/
// DESTRUCTEUR
/*****************/

CRegleChangeType::~CRegleChangeType()
{

}



/*****************/
// METHODES
/*****************/

/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleChangeType::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;
	CObList *listeTypesClasse;
	CObList *listeZones;
	
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		listeTypesClasse = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		listeTypesClasse = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		listeTypesClasse = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types.");
		break;
	}

	listeZones = pAtelier->liste_de_zones->liste;
	POSITION posZone = listeZones->GetHeadPosition();
	while(posZone)
	{
		CZone *pZoneTemp = (CZone *)listeZones->GetNext(posZone);
		if (pZoneTemp->getClasse()->getNomClasse() == typeOrg)
		{
			pZoneTemp->setClasse(typeDest,listeTypesClasse);
		}
	}

	if (suppressionTypeOrg)
	{
		POSITION posTypes = listeTypesClasse->GetHeadPosition();
		while (posTypes)
		{
			POSITION posSuppr = posTypes;
			CTypeClasse *typeTemp = (CTypeClasse*)listeTypesClasse->GetNext(posTypes);
			if (typeTemp->getNomClasse() == typeOrg)
				listeTypesClasse->RemoveAt(posSuppr);
		}
	}

}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleChangeType::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<typeOrg<<typeDest<<suppressionTypeOrg;

	}
	else
	{

		ar>>typeOrg>>typeDest>>suppressionTypeOrg;

	}

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleChangeType::getDescription()
{

	CString desc;

	if (suppressionTypeOrg)
		desc.Format("Les zones de type %s sont tiquetes de type %s et le type %s est supprim",typeOrg,typeDest,typeOrg);
	else
		desc.Format("Les zones de type %s sont tiquetes de type %s",typeOrg,typeDest);

	return desc;

}
