/****************************************************************/
// RegleFusion.cpp: implementation of the CRegleFusion class.
//
// Permet de scnariser les traitements de fusion des composantes
// connexes dans le sens horizontal ou vertical
//
/********************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleFusion.h"



/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*****************/
// CONSTRUCTEUR
/*****************/


CRegleFusion::CRegleFusion()
{
	balise="FUS";
}

CRegleFusion::CRegleFusion(char dir, int s, bool m_fusCdg, CString t/*=""*/)
{
	balise="FUS";
	direction = dir;
	if (t) type = t;
	else type = "";
	seuil = s;
	fusCdg = m_fusCdg;
}





/*****************/
// DESTRUCTEUR
/*****************/

CRegleFusion::~CRegleFusion()
{

}



/*****************/
// METHODES
/*****************/


/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleFusion::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;

	if (fusCdg)
	{
		if (direction == 'H') pAtelier->FusionHorizontaleCDG(seuil);
		if (direction == 'V') pAtelier->FusionVerticaleCDG(seuil);

		//calcul de la densit
		pAtelier->liste_de_zones->Calcul_Densite(pAtelier->getImageCourante());
	}else
	{
		if (direction == 'H') pAtelier->FusionHorizontale(seuil,type);
		if (direction == 'V') pAtelier->FusionVerticale(seuil,type);
		
		//calcul de la densit
		pAtelier->liste_de_zones->Calcul_Densite(pAtelier->getImageCourante());
	}
}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleFusion::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar<<direction<<type<<fusCdg<<seuil;
	}
	else
	{
		ar>>direction>>type>>fusCdg>>seuil;
	}
}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleFusion::getDescription()
{
	CString d;
	switch (direction)
	{
	case 'H': d="horizontale";break;
	case 'V': d="verticale";break;
	}

	CString desc;
	desc.Format("Fusion des zones de type %s dans la direction %s avec un seuil de %d",type,d,seuil);
	return desc;
}