/****************************************************************/
// RegleIntersection.cpp: implementation of the CRegleIntersection class.
//
// Permet de scnariser les traitements de fusion des zone d'un certain
// type qui ont une intersection non vide
/********************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleIntersection.h"



/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



/*****************/
// CONSTRUCTEUR
/*****************/

CRegleIntersection::CRegleIntersection()
{
	balise="RIN";
}

CRegleIntersection::CRegleIntersection(CString t)
{
	balise="RIN";
	type = t;
}




/*****************/
// DESTRUCTEUR
/*****************/


CRegleIntersection::~CRegleIntersection()
{

}



/*****************/
// METHODES
/*****************/


/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleIntersection::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;
	pAtelier->liste_de_zones->Supprime_Intersection(type);

}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleIntersection::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{

		ar<<type;

	}
	else
	{

		ar>>type;

	}

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleIntersection::getDescription()
{

	CString desc;
	desc.Format("les zones de type : %s ayant une intersection non vide sont fusionnes",type);
	return desc;

}
