/****************************************************************/
// RegleMorph.cpp: implementation of the CRegleMorph class.
//
// Permet de scnariser les traitements dits morphologiques tels que
// ouverture, fermeture, erosion, dilatation, inversion
//
/****************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleMorph.h"



/*****************/
// PRECOMPILATION
/*****************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/


CRegleMorph::CRegleMorph()
{
	balise="RMO";
}

CRegleMorph::CRegleMorph(CString op)
{
	balise="RMO";
	operation = op;
}



/*****************/
// DESTRUCTEUR
/*****************/

CRegleMorph::~CRegleMorph()
{

}


/*****************/
// METHODES
/*****************/



/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleMorph::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;

	if (operation == "OUVERTURE")	pAtelier->getImageCourante()->Ouverture();

	if (operation == "FERMETURE")	pAtelier->getImageCourante()->Fermeture();

	if (operation == "EROSION")		pAtelier->getImageCourante()->Eroder();

	if (operation == "DILATATION")	pAtelier->getImageCourante()->Dilater();

	if (operation == "INVERSION")	pAtelier->getImageCourante()->Inverser();

}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleMorph::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{

		ar<<operation;

	}
	else
	{

		ar>>operation;

	}
}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleMorph::getDescription()
{

	CString desc;
	desc.Format("application de l'opration suivante : %s  (image courante modifie)",operation);
	return desc;

}
