/****************************************************************/
// ReglePost.cpp: implementation of the CReglePost class.
//
// Permet de scnariser les post traitements tels que la sauvegarde
// des diffrentes zones dtectes ainsi que la gnration de la
// page HTML
//
/********************************************************/

/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "ReglePost.h"


/*****************/
// PRECOMPILATION
/*****************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*****************/
// CONSTRUCTEUR
/*****************/

CReglePost::CReglePost()
{
	balise="RPO";
}

CReglePost::CReglePost(CString o, int p, int m)
{
	balise="RPO";
	operation = o;
	nb_pixels = p;
	mappage = m;
}


/*****************/
// DESTRUCTEUR
/*****************/

CReglePost::~CReglePost()
{

}



/*****************/
// METHODES
/*****************/


/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CReglePost::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;

	if (operation == "SAUVEGARDE_O") pAtelier->Sauvegarder_Images(mappage,nb_pixels,0);

	if (operation == "SAUVEGARDE_C") pAtelier->Sauvegarder_Images(mappage,nb_pixels,1);

	if (operation == "SAUVEGARDE_T") pAtelier->Sauvegarder_Images(mappage,nb_pixels,2);

	if (operation == "HTML") pAtelier->liste_de_zones->Generer_HTML(nb_pixels,mappage,pAtelier->getImageOrigine()->getLargeur(),pAtelier->getImageOrigine()->getHauteur());

	/**************/
	/* PFE 2006 Deb
	/**************/

	if (operation == "SAUVEGARDE_LIGNES_O") pAtelier->Sauvegarder_Images_lignes(mappage,nb_pixels, 0);

	if (operation == "SAUVEGARDE_LIGNES_C") pAtelier->Sauvegarder_Images_lignes(mappage,nb_pixels, 1);

	if (operation == "SAUVEGARDE_LIGNES_T") pAtelier->Sauvegarder_Images_lignes(mappage,nb_pixels, 2);

	/**************/
	/* PFE 2006 Fin
	/**************/

}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CReglePost::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<operation<<nb_pixels<<mappage;

	}
	else
	{

		ar>>operation>>nb_pixels>>mappage;

	}

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CReglePost::getDescription()
{

	CString desc;

	if (operation == "SAUVEGARDE_O") desc.Format("Sauvegarde de l'ensemble des zones en utilisant l'image d'origine, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	if (operation == "SAUVEGARDE_C") desc.Format("Sauvegarde de l'ensemble des zones en utilisant l'image courante, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	if (operation == "SAUVEGARDE_T") desc.Format("Sauvegarde de l'ensemble des zones en utilisant l'image temporaire, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	if (operation == "HTML") desc.Format("gnration de la page html");

	/**************/
	/* PFE 2006 Deb
	/**************/

	if (operation == "SAUVEGARDE_LIGNES_O") desc.Format("Sauvegarde de l'ensemble des lignes en utilisant l'image d'origine, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	if (operation == "SAUVEGARDE_LIGNES_C") desc.Format("Sauvegarde de l'ensemble des lignes en utilisant l'image courante, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	if (operation == "SAUVEGARDE_LIGNES_T") desc.Format("Sauvegarde de l'ensemble des lignes en utilisant l'image temporaire, un rapport de mappage de  : %d et un delta de decoupage de : %d",mappage,nb_pixels);

	/**************/
	/* PFE 2006 Fin
	/**************/

	return desc;

}
