/****************************************************************/
// RegleSR.cpp: implementation of the CRegleSR class.
//
// Permet de scnariser les traitements de sauvegarde et de restauration
// de l'image courante
//
//s = 0 --> copie l'image courante dans l'image temporaire
//
//s = 1 --> colle l'image temporaire dans l'image courante
//
//s = 2 --> colle l'image d'origine dans l'image courante
//
//
/************************************************************************/


/*****************/
// INCLUSION
/*****************/


#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleSR.h"


/*****************/
// PRECOMPILATION
/*****************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/

CRegleSR::CRegleSR()
{
	balise="RSR";
}



CRegleSR::CRegleSR(int s)
{
	balise="RSR";
	typeAction = s;
}



/*****************/
// DESTRUCTEUR
/*****************/


CRegleSR::~CRegleSR()
{

}



/*****************/
// METHODES
/*****************/

/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleSR::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;

	switch (typeAction)
	{
	case 0:
		pAtelier->getImageTemporaire()->Copier(pAtelier->getImageCourante());
		break;
	case 1:
		pAtelier->getImageCourante()->Copier(pAtelier->getImageTemporaire());
		break;
	case 2:
		pAtelier->getImageCourante()->Copier(pAtelier->getImageOrigine());
		break;
	default:
		break;
	}
		
}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleSR::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<typeAction;

	}
	else
	{

		ar>>typeAction;

	}

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleSR::getDescription()
{
	CString desc;

	switch (typeAction)
	{
	case 0:
		desc.Format("Copier l'image courante dans l'image temporaire");
		break;
	case 1:
		desc.Format("Coller l'image temporaire dans l'image courante");
		break;
	case 2:
		desc.Format("Coller l'image d'origine dans l'image courante");
		break;
	default:
		break;
	}

	return desc;

}
