/****************************************************************/
// RegleSupType.cpp: implementation of the CRegleSupType class.
//
// Permet de scnariser les traitements de suppression et/ou coloriage
// d'un type de zone
//
/**************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleSupType.h"
#include "constante.h"


/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*****************/
// CONSTRUCTEUR
/*****************/

CRegleSupType::CRegleSupType()
{
	balise="RST";
}


CRegleSupType::CRegleSupType(CString t, UINT c, int s)
{
	balise="RST";
	type = t;
	color = c;
	suppression = s;
}

/*****************/
// DESTRUCTEUR
/*****************/

CRegleSupType::~CRegleSupType()
{

}



/*****************/
// METHODES
/*****************/

/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleSupType::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *atelier = ((CMyAppDoc *)pDoc)->atelier;
	atelier->liste_de_zones->Suppression_Zone_De_Type(type,color,suppression,atelier->getImageCourante());

}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleSupType::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<type<<color<<suppression;

	}
	else
	{

		ar>>type>>color>>suppression;

	}

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleSupType::getDescription()
{

	CString desc;
	CString couleur;
	CString sup;

	if (color==NOIR) couleur="sont colories en NOIR (image courante modifie)";

	if (color==BLANC) couleur="sont colories en BLANC (image courante modifie)";

	if (color==INCOLOR) couleur="ne sont pas colories";

	if (suppression) sup="sont supprimes et "; else sup="";


	desc.Format("les zones de type %s %s %s",type,sup,couleur);
	return desc;

}
