/****************************************************************/
// RegleTAO.cpp: implementation of the RegleTAO class.
//
// Permet de scnariser le traitement de TAO
//
/******************************************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "RegleTAO.h"
#include <iostream>
#include <fstream>
using namespace std;

/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif




/*****************/
// CONSTRUCTEUR
/*****************/

CRegleTAO::CRegleTAO()
{
	balise = "TAO";
	type_zone = "";
	seuil_dico = 0.0;
}

CRegleTAO::CRegleTAO(CString tz, double seuil)
{
	balise = "TAO";
	type_zone = tz;
	seuil_dico = seuil;
}


/*****************/
// DESTRUCTEUR
/*****************/

CRegleTAO::~CRegleTAO()
{

}


/*****************/
// METHODES
/*****************/


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleTAO::getDescription()
{

	CString desc;
	desc.Format ("Effectue la TAO sur les zones de type %s avec un seuil de %.2f", type_zone, seuil_dico);
	return desc;

}


/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleTAO::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	((CMyAppDoc *)pDoc)->atelier->GenererDicoEtXML (type_zone, seuil_dico);

}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleTAO::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<type_zone<<seuil_dico;

	}
	else
	{

		ar>>type_zone>>seuil_dico;

	}

}