/****************************************************************/
// RegleType.cpp: implementation of the CRegleType class.
//
// Permet de scnariser les traitements de cration d'un 
// nouveau type de zone
/*******************************************************/

/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "RegleType.h"
#include "typeclasse.h"
#include "myappdoc.h"
#include "myappview.h"
#include "constante.h"

/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*****************/
// CONSTRUCTEUR
/*****************/

CRegleType::CRegleType()
{
	balise="TYPE";
}


CRegleType::CRegleType(CString n, UINT c)
{
	nom=n;
	color=c;
	balise="TYPE";
}


/*****************/
// DESTRUCTEUR
/*****************/

CRegleType::~CRegleType()
{

}


/*****************/
// METHODES
/*****************/



/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleType::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	bool existeDeja;

	existeDeja = false;

	CObList *liste_types_classe;

	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste_types_classe = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		existeDeja = pAppTemp->projet->getLaboTrait()->findElemListeTypesClasse(nom);
		break;
	case LABOCLASSIF :
		liste_types_classe = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		existeDeja = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(nom);
		break;
	case LABOPROJET :
		liste_types_classe = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		existeDeja = pAppTemp->projet->getLaboProj()->findElemListeTypesClasse(nom);
		break;
	default :
		AfxMessageBox("Error while loading types.");
		break;
	}

	int indiceNewClasse = 0;
	if (!existeDeja)
	{
		if (!liste_types_classe->IsEmpty())
		{
			CTypeClasse *typeTemp = (CTypeClasse*)liste_types_classe->GetTail();
			indiceNewClasse = typeTemp->getNumClasse()+1;
		}

		CTypeClasse *t=new CTypeClasse(nom,color,indiceNewClasse);
		liste_types_classe->AddTail(t);
	}

}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CRegleType::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{

		ar<<nom<<color;

	}
	else
	{

		ar>>nom>>color;

	}

}


/********************************************************************/
/* Nom mthode : getNom                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleType::getNom()
{

	return nom;

}



/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegleType::getDescription()
{

	CString desc;
	desc.Format("cration du type : %s",nom);
	return desc;

}
