/****************************************************************/
// Repertoires.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "MyApp.h"
#include "Repertoires.h"
#include <direct.h>
#include "PathDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CRepertoires dialog
/****************************************************************/

CRepertoires::CRepertoires(CWnd* pParent /*=NULL*/)
	: CDialog(CRepertoires::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRepertoires)
	m_repOuvrage = _T("");
	m_repResultats = _T("");
	m_ficSauvegarde = _T("");
	//}}AFX_DATA_INIT
}


void CRepertoires::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRepertoires)
	DDX_Text(pDX, IDC_CHEM_REP_OUVR, m_repOuvrage);
	DDX_Text(pDX, IDC_CHEM_REP_RES, m_repResultats);
	DDX_Text(pDX, IDC_CHEM_FIC_SAUV, m_ficSauvegarde);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRepertoires, CDialog)
	//{{AFX_MSG_MAP(CRepertoires)
	ON_BN_CLICKED(IDC_CHARGE_OUVRAGE, OnChargeOuvrage)
	ON_BN_CLICKED(IDC_CHARGE_RESULTATS, OnChargeResultats)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CRepertoires message handlers
/****************************************************************/

BOOL CRepertoires::OnInitDialog() 
{	
	m_repOuvrage = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_repOuvrage();
	m_repResultats = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_repResultats();
	m_ficSauvegarde = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_ficSauvegarde();

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRepertoires::OnChargeOuvrage() 
{
	CPathDialog  dlg( TEXT("Choix de l'ouvrage"), 
		TEXT("Veuillez slectionner le rpertoire contenant les images de l'ouvrage :"),
					  ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repOuvrage());

	// show path dialog
	if ( dlg.DoModal() == IDOK )
	{
		SetDlgItemText(IDC_CHEM_REP_OUVR,dlg.GetPathName());
	}
}

void CRepertoires::OnChargeResultats() 
{
	CPathDialog  dlg( TEXT("Choix du rpertoire contenant les rsultats"), 
		TEXT("Veuillez slectionner le rpertoire contenant les rsultats des traitements :"),
					  ((CMyAppApp*)(AfxGetApp()))->projet->getParamProj()->getM_repResultats());

	// show path dialog
	if ( dlg.DoModal() == IDOK )
	{
		SetDlgItemText(IDC_CHEM_REP_RES,dlg.GetPathName());
	}
	
}

