/*********************************************************************/
// Scenario.h: interface for the CScenario class.
//
// Cette classe est prvue pour grer une liste d'objet de type Cregle.
// Un objet scenario contient donc une liste d'objets "rgles".
// Cette classe permet la gestion d'un scnario et permet notamment
// d'ajouter une rgle, d'effacer une ragle, de dplacer une rgle au sein
// du scnario, de sauvegarder et de charger le scnario
/*********************************************************************/


#if !defined(AFX_SCENARIO_H__34006872_1223_438A_9821_3662E804C1BC__INCLUDED_)
#define AFX_SCENARIO_H__34006872_1223_438A_9821_3662E804C1BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*****************************/
// INCLUSION
/*****************************/

#include "Regle.h"
#include "regletype.h"
#include "reglecg.h"
#include "reglecv.h"
#include "reglecc.h"
#include "reglefusion.h"
#include "reglesuptype.h"
#include "reglebin.h"
#include "reglemorph.h"
#include "reglecontour.h"
#include "regleintersection.h"
#include "regleplage.h"
#include "reglepost.h"
#include "reglesr.h"
#include "regletao.h"
#include "RegleCarac.h"
#include "RegleChangeType.h"

#include "regleanalysefine.h"
/*****************************/
// CLASSE
/*****************************/

class CScenario  
{

	CObList *regles;

public:

	int Ouvrir(bool ecrase);
	bool EffacerTout();
	bool Effacer(int indexderegle);
	void Afficher();
	bool Echanger(int pos1, int pos2);
	int getNbRegles();
	int Executer(CDocument *pDoc);
	int Charger(CString nom, bool ecrase);
	void Ajouter(CRegle *r);
	void AjouterScenario(CScenario *scenarIn);
	bool Sauvegarder(CString nomCompletFichier);
	CObList* getListeRegles(){return regles;}
	bool regleDejaPresente(CString balise);
	
	CScenario();
	virtual ~CScenario();

	bool modif;

private:
	
	int lire_numero(FILE *f);
	CString lire_libelle(FILE *f);

};




#endif // !defined(AFX_SCENARIO_H__34006872_1223_438A_9821_3662E804C1BC__INCLUDED_)
