/*******************************************************************/
// Zone.h: interface for the CZone class.
//
// Classe destine  regrouper un ensemble de CElements.
// Permet de manipuler la liste des CElements contenus dans cette zone
// Elle permet galement d'obtenir certaine statistiques sur les lements
// contenus (hauteur moyenne, largeur moyenne, ...)
// Elle possde un pointeur sur les zones voisines (gauche, droite, haut, bas)
//
/*******************************************************************/


#if !defined(AFX_ZONE_H__20E65A1A_961E_42B6_8CE5_172BAF6AB7A8__INCLUDED_)
#define AFX_ZONE_H__20E65A1A_961E_42B6_8CE5_172BAF6AB7A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/***********************/
//  INCLUSION
/***********************/

//#include "MyApp.h"
//#include "MyAppDoc.h"
#include "element.h"
//#include "concept.h"
#include "typeclasse.h"
#include "Image.h"
#include "CaracCC.h"
#include "CaracCG.h"
#include "CaracCV.h"

/***********************/
//  CLASSE
/***********************/

class CZone : public CObject  
{

public:

	CDocument *m_DocContenant;

	CZone *p_voisin_gauche;
	CZone *p_voisin_droite;
	CZone *p_voisin_haut;
	CZone *p_voisin_bas;
	CZone *p_inclus_dans;

	
private:

	int zone;
	CPoint *cdg;
	CRect *rect;
	CObList *liste_elements;

	int largeur_moyenne;
	int hauteur_moyenne;
	double densite;

	CCaracCC* caracCC;
	CCaracCG* caracCG;
	CCaracCV* caracCV;

private:

	CTypeClasse *classe;
	void Entourer(CImage *,int);

public:

	void Colorier(CImage *, int);
	
	
public:

	double CalculDensite(CImage *im);
	int couche;
	double getDensite();
	int getNbElements();
	void Calcul_Largeur_Moyenne();
	void Calcul_Hauteur_Moyenne();
	void Afficher_Elements(CDC* ecran, double zoomcoeff);
	void Afficher_Zones(CDC* ecran, double zoomcoeff,UINT color);
	void setZone(int);
	int getZone();
	CTypeClasse * getClasse();
	void setClasse(CString,CObList *liste_types_classe);
	CRect * getRect();
	int get_largeur_moyenne();
	int get_hauteur_moyenne();
	
	CPoint * getCdg();
	CObList * get_liste_elements();
	void Ajouter_Element(CElement *);

	void calculerCaracteristiques();

	CCaracCC* getCaracCC(){return caracCC;}
	CCaracCG* getCaracCG(){return caracCG;}
	CCaracCV* getCaracCV(){return caracCV;}

	void SurlignerZone(CDC* ecran, double zoomcoeff,UINT color, CPoint* offset);

	//CZone(CDocument* pDocContenant);
	CZone(int z, CDocument* pDocContenant);
	virtual ~CZone();

};




#endif // !defined(AFX_ZONE_H__20E65A1A_961E_42B6_8CE5_172BAF6AB7A8__INCLUDED_)
